/* application-main-window.c generated by valac 0.56.3, the Vala compiler
 * generated from application-main-window.vala, do not modify */

/*
 * Copyright © 2016 Software Freedom Conservancy Inc.
 * Copyright © 2016, 2019-2021 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-client-43.0.h"
#include "geary-engine.h"
#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <handy.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <cairo-gobject.h>

#define APPLICATION_MAIN_WINDOW_INNER_LEAFLET "inner_leaflet"
#define APPLICATION_MAIN_WINDOW_FOLDER_LIST "folder_list"
#define APPLICATION_MAIN_WINDOW_CONVERSATION_LIST "conversation_list"
#define APPLICATION_MAIN_WINDOW_CONVERSATION_VIEWER "conversation_viewer"
#define APPLICATION_MAIN_WINDOW_STATUS_BAR_HEIGHT 18
#define APPLICATION_MAIN_WINDOW_UPDATE_UI_INTERVAL 60
#define APPLICATION_MAIN_WINDOW_MIN_CONVERSATION_COUNT 50
#define CONVERSATION_EMAIL_REQUIRED_FOR_CONSTRUCT ((GEARY_EMAIL_FIELD_ENVELOPE | GEARY_EMAIL_FIELD_PREVIEW) | GEARY_EMAIL_FIELD_FLAGS)

#define APPLICATION_TYPE_CONTROLLER (application_controller_get_type ())
#define APPLICATION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLICATION_TYPE_CONTROLLER, ApplicationController))
#define APPLICATION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APPLICATION_TYPE_CONTROLLER, ApplicationControllerClass))
#define APPLICATION_IS_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLICATION_TYPE_CONTROLLER))
#define APPLICATION_IS_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLICATION_TYPE_CONTROLLER))
#define APPLICATION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLICATION_TYPE_CONTROLLER, ApplicationControllerClass))

typedef struct _ApplicationController ApplicationController;
typedef struct _ApplicationControllerClass ApplicationControllerClass;
enum  {
	APPLICATION_MAIN_WINDOW_0_PROPERTY,
	APPLICATION_MAIN_WINDOW_APPLICATION_PROPERTY,
	APPLICATION_MAIN_WINDOW_SELECTED_ACCOUNT_PROPERTY,
	APPLICATION_MAIN_WINDOW_SELECTED_FOLDER_PROPERTY,
	APPLICATION_MAIN_WINDOW_CONVERSATIONS_PROPERTY,
	APPLICATION_MAIN_WINDOW_IS_FOLDER_LIST_SHOWN_PROPERTY,
	APPLICATION_MAIN_WINDOW_IS_CONVERSATION_LIST_SHOWN_PROPERTY,
	APPLICATION_MAIN_WINDOW_IS_CONVERSATION_VIEWER_SHOWN_PROPERTY,
	APPLICATION_MAIN_WINDOW_ATTACHMENTS_PROPERTY,
	APPLICATION_MAIN_WINDOW_SELECTED_FOLDER_SUPPORTS_TRASH_PROPERTY,
	APPLICATION_MAIN_WINDOW_HAS_COMPOSER_PROPERTY,
	APPLICATION_MAIN_WINDOW_IS_SHIFT_DOWN_PROPERTY,
	APPLICATION_MAIN_WINDOW_WINDOW_WIDTH_PROPERTY,
	APPLICATION_MAIN_WINDOW_WINDOW_HEIGHT_PROPERTY,
	APPLICATION_MAIN_WINDOW_WINDOW_MAXIMIZED_PROPERTY,
	APPLICATION_MAIN_WINDOW_FOLDER_LIST_PROPERTY,
	APPLICATION_MAIN_WINDOW_MAIN_TOOLBAR_PROPERTY,
	APPLICATION_MAIN_WINDOW_SEARCH_BAR_PROPERTY,
	APPLICATION_MAIN_WINDOW_CONVERSATION_LIST_VIEW_PROPERTY,
	APPLICATION_MAIN_WINDOW_CONVERSATION_VIEWER_PROPERTY,
	APPLICATION_MAIN_WINDOW_CONVERSATION_LIST_INFO_BARS_PROPERTY,
	APPLICATION_MAIN_WINDOW_STATUS_BAR_PROPERTY,
	APPLICATION_MAIN_WINDOW_NUM_PROPERTIES
};
static GParamSpec* application_main_window_properties[APPLICATION_MAIN_WINDOW_NUM_PROPERTIES];
typedef enum  {
	APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_NONE,
	APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_SINGLE,
	APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_MULTIPLE
} ApplicationMainWindowConversationCount;

#define APPLICATION_MAIN_WINDOW_TYPE_CONVERSATION_COUNT (application_main_window_conversation_count_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block14Data Block14Data;

#define APPLICATION_TYPE_ACCOUNT_INTERFACE (application_account_interface_get_type ())
#define APPLICATION_ACCOUNT_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLICATION_TYPE_ACCOUNT_INTERFACE, ApplicationAccountInterface))
#define APPLICATION_IS_ACCOUNT_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLICATION_TYPE_ACCOUNT_INTERFACE))
#define APPLICATION_ACCOUNT_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), APPLICATION_TYPE_ACCOUNT_INTERFACE, ApplicationAccountInterfaceIface))

typedef struct _ApplicationAccountInterface ApplicationAccountInterface;
typedef struct _ApplicationAccountInterfaceIface ApplicationAccountInterfaceIface;
typedef struct _ApplicationMainWindowSelectFolderData ApplicationMainWindowSelectFolderData;
typedef struct _ApplicationMainWindowShowConversationsData ApplicationMainWindowShowConversationsData;
typedef struct _ApplicationMainWindowShowEmailData ApplicationMainWindowShowEmailData;
typedef struct _Block15Data Block15Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ApplicationMainWindowRemoveAccountData ApplicationMainWindowRemoveAccountData;

#define TYPE_ALERT_DIALOG (alert_dialog_get_type ())
#define ALERT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALERT_DIALOG, AlertDialog))
#define ALERT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALERT_DIALOG, AlertDialogClass))
#define IS_ALERT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALERT_DIALOG))
#define IS_ALERT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALERT_DIALOG))
#define ALERT_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALERT_DIALOG, AlertDialogClass))

typedef struct _AlertDialog AlertDialog;
typedef struct _AlertDialogClass AlertDialogClass;

#define TYPE_CONFIRMATION_DIALOG (confirmation_dialog_get_type ())
#define CONFIRMATION_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIRMATION_DIALOG, ConfirmationDialog))
#define CONFIRMATION_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIRMATION_DIALOG, ConfirmationDialogClass))
#define IS_CONFIRMATION_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIRMATION_DIALOG))
#define IS_CONFIRMATION_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIRMATION_DIALOG))
#define CONFIRMATION_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIRMATION_DIALOG, ConfirmationDialogClass))

typedef struct _ConfirmationDialog ConfirmationDialog;
typedef struct _ConfirmationDialogClass ConfirmationDialogClass;
typedef struct _Block16Data Block16Data;
typedef struct _ApplicationMainWindowUndoData ApplicationMainWindowUndoData;
typedef struct _Block17Data Block17Data;
typedef struct _ApplicationMainWindowRedoData ApplicationMainWindowRedoData;
typedef struct _ApplicationMainWindowLoadConversationsForEmailData ApplicationMainWindowLoadConversationsForEmailData;

#define COMPOSER_TYPE_APPLICATION_INTERFACE (composer_application_interface_get_type ())
#define COMPOSER_APPLICATION_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), COMPOSER_TYPE_APPLICATION_INTERFACE, ComposerApplicationInterface))
#define COMPOSER_IS_APPLICATION_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), COMPOSER_TYPE_APPLICATION_INTERFACE))
#define COMPOSER_APPLICATION_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), COMPOSER_TYPE_APPLICATION_INTERFACE, ComposerApplicationInterfaceIface))

typedef struct _ComposerApplicationInterface ComposerApplicationInterface;
typedef struct _ComposerApplicationInterfaceIface ComposerApplicationInterfaceIface;
typedef struct _ApplicationMainWindowSelectConversationsData ApplicationMainWindowSelectConversationsData;
typedef struct _Block18Data Block18Data;
typedef struct _ApplicationMainWindowOpenConversationMonitorData ApplicationMainWindowOpenConversationMonitorData;
typedef struct _Block19Data Block19Data;
typedef struct _ApplicationMainWindowCreateComposerData ApplicationMainWindowCreateComposerData;
typedef struct _ApplicationMainWindowCreateComposerFromViewerData ApplicationMainWindowCreateComposerFromViewerData;
typedef struct _ApplicationMainWindowUpdateContextDependentActionsData ApplicationMainWindowUpdateContextDependentActionsData;
typedef struct _Block20Data Block20Data;
typedef struct _Block21Data Block21Data;
typedef struct _Block22Data Block22Data;
typedef struct _Block23Data Block23Data;
typedef struct _Block24Data Block24Data;
typedef struct _Block25Data Block25Data;
typedef struct _Block26Data Block26Data;
typedef struct _Block27Data Block27Data;
typedef struct _Block28Data Block28Data;
typedef struct _Block29Data Block29Data;
typedef struct _Block30Data Block30Data;
typedef struct _Block31Data Block31Data;
typedef struct _Block32Data Block32Data;
typedef struct _Block33Data Block33Data;
#define _g_type_class_unref0(var) ((var == NULL) ? NULL : (var = (g_type_class_unref (var), NULL)))
enum  {
	APPLICATION_MAIN_WINDOW_RETRY_SERVICE_PROBLEM_SIGNAL,
	APPLICATION_MAIN_WINDOW_REPLY_CONVERSATION_SENDER_SIGNAL,
	APPLICATION_MAIN_WINDOW_REPLY_CONVERSATION_ALL_SIGNAL,
	APPLICATION_MAIN_WINDOW_FORWARD_CONVERSATION_SIGNAL,
	APPLICATION_MAIN_WINDOW_MARK_CONVERSATIONS_READ_SIGNAL,
	APPLICATION_MAIN_WINDOW_MARK_CONVERSATIONS_STARRED_SIGNAL,
	APPLICATION_MAIN_WINDOW_SHOW_COPY_MENU_SIGNAL,
	APPLICATION_MAIN_WINDOW_SHOW_MOVE_MENU_SIGNAL,
	APPLICATION_MAIN_WINDOW_ARCHIVE_CONVERSATIONS_SIGNAL,
	APPLICATION_MAIN_WINDOW_JUNK_CONVERSATIONS_SIGNAL,
	APPLICATION_MAIN_WINDOW_TRASH_CONVERSATIONS_SIGNAL,
	APPLICATION_MAIN_WINDOW_DELETE_CONVERSATIONS_SIGNAL,
	APPLICATION_MAIN_WINDOW_SEARCH_SIGNAL,
	APPLICATION_MAIN_WINDOW_FIND_SIGNAL,
	APPLICATION_MAIN_WINDOW_NAVIGATE_SIGNAL,
	APPLICATION_MAIN_WINDOW_NUM_SIGNALS
};
static guint application_main_window_signals[APPLICATION_MAIN_WINDOW_NUM_SIGNALS] = {0};

struct _ApplicationMainWindowPrivate {
	GearyAccount* _selected_account;
	GearyFolder* _selected_folder;
	GearyAppConversationMonitor* _conversations;
	ApplicationAttachmentManager* _attachments;
	gboolean _is_shift_down;
	gint _window_width;
	gint _window_height;
	gboolean _window_maximized;
	FolderListTree* _folder_list;
	ComponentsMainToolbar* _main_toolbar;
	SearchBar* _search_bar;
	ConversationListView* _conversation_list_view;
	ConversationViewer* _conversation_viewer;
	ComponentsInfoBarStack* _conversation_list_info_bars;
	StatusBar* _status_bar;
	ApplicationController* controller;
	MonitoredSpinner* spinner;
	GeeSet* accounts;
	GSimpleActionGroup* edit_actions;
	gboolean previous_selection_was_interactive;
	GearyFolder* previous_non_search_folder;
	GearyAggregateProgressMonitor* progress_monitor;
	GCancellable* action_update_cancellable;
	GCancellable* folder_open;
	GearyTimeoutManager* update_ui_timeout;
	gint64 update_ui_last;
	GtkBox* main_layout;
	HdyLeaflet* outer_leaflet;
	HdyLeaflet* inner_leaflet;
	GtkBox* folder_box;
	GtkScrolledWindow* folder_list_scrolled;
	GtkBox* conversation_list_box;
	GtkScrolledWindow* conversation_list_scrolled;
	GtkRevealer* conversation_list_actions_revealer;
	ComponentsConversationActions* conversation_list_actions;
	GtkBox* conversation_viewer_box;
	GtkRevealer* conversation_viewer_actions_revealer;
	GtkSizeGroup* folder_size_group;
	GtkSizeGroup* folder_separator_size_group;
	GtkSizeGroup* conversations_size_group;
	GtkSizeGroup* conversations_separator_size_group;
	GtkSizeGroup* conversation_size_group;
	HdySwipeGroup* conversations_swipe_group;
	HdySwipeGroup* conversation_swipe_group;
	GtkOverlay* overlay;
	ComponentsConversationActions** folder_conversation_actions;
	gint folder_conversation_actions_length1;
	gint _folder_conversation_actions_size_;
	FolderPopover** folder_popovers;
	gint folder_popovers_length1;
	gint _folder_popovers_size_;
	ComponentsInfoBarStack* info_bars;
	ComponentsInfoBar* offline_infobar;
	ComponentsInfoBar* cert_problem_infobar;
	ComponentsInfoBar* auth_problem_infobar;
	ComponentsProblemReportInfoBar* service_problem_infobar;
};

struct _Block14Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	ApplicationClient* application;
};

struct _ApplicationAccountInterfaceIface {
	GTypeInterface parent_iface;
	ApplicationAccountContext* (*get_context_for_account) (ApplicationAccountInterface* self, GearyAccountInformation* account);
	GeeCollection* (*get_account_contexts) (ApplicationAccountInterface* self);
};

struct _ApplicationMainWindowSelectFolderData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationMainWindow* self;
	GearyFolder* to_select;
	gboolean is_interactive;
	gboolean inhibit_autoselect;
	GearyFolder* _tmp0_;
	GCancellable* _tmp1_;
	GCancellable* cancellable;
	GCancellable* _tmp2_;
	GCancellable* _tmp3_;
	GCancellable* _tmp4_;
	GearyFolder* _tmp5_;
	FolderPopover** _tmp6_;
	gint _tmp6__length1;
	FolderPopover** menu_collection;
	gint menu_collection_length1;
	gint _menu_collection_size_;
	gint menu_it;
	FolderPopover* _tmp7_;
	FolderPopover* menu;
	FolderPopover* _tmp8_;
	GearyFolder* _tmp9_;
	GearyAggregateProgressMonitor* _tmp10_;
	GearyFolder* _tmp11_;
	GearyProgressMonitor* _tmp12_;
	GearyProgressMonitor* _tmp13_;
	GearyFolder* _tmp14_;
	GearyFolderProperties* _tmp15_;
	GearyFolderProperties* _tmp16_;
	guint _tmp17_;
	GearyAppConversationMonitor* _tmp18_;
	GearyAggregateProgressMonitor* _tmp19_;
	GearyAppConversationMonitor* _tmp20_;
	GearyProgressMonitor* _tmp21_;
	GearyProgressMonitor* _tmp22_;
	GearyAppConversationMonitor* _tmp23_;
	ConversationListStore* conversations_model;
	ConversationListView* _tmp24_;
	ConversationListStore* _tmp25_;
	ConversationListStore* _tmp26_;
	GearyAggregateProgressMonitor* _tmp27_;
	ConversationListStore* _tmp28_;
	GearyProgressMonitor* _tmp29_;
	GearyProgressMonitor* _tmp30_;
	ConversationListView* _tmp31_;
	ComponentsInfoBarStack* _tmp32_;
	GearyAccount* _tmp33_;
	GearyAccount* _tmp34_;
	GearyAccount* _tmp35_;
	gboolean _tmp36_;
	gboolean _tmp37_;
	GearyFolderSpecialUse _tmp38_;
	GearyFolderSpecialUse _tmp39_;
	FolderListTree* _tmp40_;
	GearyAccount* _tmp41_;
	GearyAccount* _tmp42_;
	FolderListTree* _tmp43_;
	FolderListTree* _tmp44_;
	ConversationViewer* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	GearyAggregateProgressMonitor* _tmp49_;
	GearyProgressMonitor* _tmp50_;
	GearyProgressMonitor* _tmp51_;
	GearyFolderProperties* _tmp52_;
	GearyFolderProperties* _tmp53_;
	GearyAppConversationMonitor* _tmp54_;
	GearyAppConversationMonitor* _tmp55_;
	GearyAggregateProgressMonitor* _tmp56_;
	GearyAppConversationMonitor* _tmp57_;
	GearyProgressMonitor* _tmp58_;
	GearyProgressMonitor* _tmp59_;
	GearyAppConversationMonitor* _tmp60_;
	ApplicationClient* _tmp61_;
	ApplicationClient* _tmp62_;
	ApplicationConfiguration* _tmp63_;
	ApplicationConfiguration* _tmp64_;
	ConversationListStore* _tmp65_;
	GearyAggregateProgressMonitor* _tmp66_;
	ConversationListStore* _tmp67_;
	GearyProgressMonitor* _tmp68_;
	GearyProgressMonitor* _tmp69_;
	ConversationListView* _tmp70_;
	ConversationListView* _tmp71_;
	ConversationListStore* _tmp72_;
	FolderPopover** _tmp73_;
	gint _tmp73__length1;
	FolderPopover** _vala1_menu_collection;
	gint _vala1_menu_collection_length1;
	gint __vala1_menu_collection_size_;
	gint _vala1_menu_it;
	FolderPopover* _tmp74_;
	FolderPopover* _vala1_menu;
	FolderPopover* _tmp75_;
	GearyAppConversationMonitor* _tmp76_;
	GCancellable* _tmp77_;
	ApplicationController* _tmp78_;
};

struct _ApplicationMainWindowShowConversationsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationMainWindow* self;
	GearyFolder* location;
	GeeCollection* to_show;
	gboolean is_interactive;
	gboolean inhibit_autoselect;
	GearyFolder* _tmp0_;
	GearyFolder* _tmp1_;
	GeeHashSet* latest_email;
	GeeHashSet* _tmp2_;
	GeeIterator* _stale_it;
	GeeIterator* _tmp3_;
	GeeIterator* _tmp4_;
	GearyAppConversation* stale;
	GeeIterator* _tmp5_;
	gpointer _tmp6_;
	GearyEmail* first;
	GearyAppConversation* _tmp7_;
	GearyEmail* _tmp8_;
	GearyEmail* _tmp9_;
	GeeHashSet* _tmp10_;
	GearyEmail* _tmp11_;
	GearyEmailIdentifier* _tmp12_;
	GearyEmailIdentifier* _tmp13_;
	GeeCollection* loaded;
	GeeHashSet* _tmp14_;
	GeeCollection* _tmp15_;
	GeeCollection* _tmp16_;
	gboolean _tmp17_;
	gboolean _tmp18_;
	GeeCollection* _tmp19_;
	GeeCollection* _tmp20_;
	GeeCollection* _tmp21_;
};

struct _ApplicationMainWindowShowEmailData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationMainWindow* self;
	GearyFolder* location;
	GeeCollection* to_show;
	gboolean is_interactive;
	gboolean inhibit_autoselect;
	GearyFolder* _tmp0_;
	GearyFolder* _tmp1_;
	GeeCollection* loaded;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GearyAppConversation* target;
	GeeCollection* _tmp6_;
	gpointer _tmp7_;
	ConversationListBox* current_list;
	ConversationViewer* _tmp8_;
	ConversationListBox* _tmp9_;
	ConversationListBox* _tmp10_;
	ConversationListBox* _tmp11_;
	gboolean _tmp12_;
	ConversationListBox* _tmp13_;
	ConversationListBox* _tmp14_;
	GearyAppConversation* _tmp15_;
	GearyAppConversation* _tmp16_;
	GearyAppConversation* _tmp17_;
	ConversationListBox* _tmp18_;
	GeeCollection* _tmp19_;
	GeeCollection* _tmp20_;
	gboolean _tmp21_;
	gboolean _tmp22_;
	GeeCollection* _tmp23_;
	GeeCollection* _tmp24_;
	GeeCollection* _tmp25_;
};

struct _Block15Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GeeCollection* referrants;
};

struct _ApplicationMainWindowRemoveAccountData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationMainWindow* self;
	ApplicationAccountContext* to_remove;
	GearyFolder* to_select;
	GeeSet* _tmp0_;
	gboolean _tmp1_;
	GearyFolder* _tmp2_;
	GearyFolder* _tmp3_;
	GearyAccount* _tmp4_;
	GearyAccount* _tmp5_;
	GearyAccount* _tmp6_;
	GearyAccount* _tmp7_;
	gboolean is_account_search_active;
	GearyFolder* _tmp8_;
	GearyFolderSpecialUse _tmp9_;
	GearyFolderSpecialUse _tmp10_;
	SearchBar* _tmp11_;
	GtkSearchEntry* _tmp12_;
	GtkSearchEntry* _tmp13_;
	SearchBar* _tmp14_;
	ApplicationCommandStack* _tmp15_;
	ApplicationCommandStack* _tmp16_;
	guint _tmp17_;
	ApplicationCommandStack* _tmp18_;
	ApplicationCommandStack* _tmp19_;
	guint _tmp20_;
	ApplicationCommandStack* _tmp21_;
	ApplicationCommandStack* _tmp22_;
	guint _tmp23_;
	guint _tmp24_;
	guint _tmp25_;
	GearyAggregateProgressMonitor* _tmp26_;
	GearyAccount* _tmp27_;
	GearyAccount* _tmp28_;
	GearyProgressMonitor* _tmp29_;
	GearyProgressMonitor* _tmp30_;
	GearySmtpClientService* smtp;
	GearyAccount* _tmp31_;
	GearyAccount* _tmp32_;
	GearyClientService* _tmp33_;
	GearyClientService* _tmp34_;
	GearySmtpClientService* _tmp35_;
	GearySmtpClientService* _tmp36_;
	GearyAggregateProgressMonitor* _tmp37_;
	GearySmtpClientService* _tmp38_;
	GearyProgressMonitor* _tmp39_;
	GearyProgressMonitor* _tmp40_;
	GeeCollection* _tmp41_;
	GeeCollection* _tmp42_;
	FolderListTree* _tmp43_;
	GearyAccount* _tmp44_;
	GearyAccount* _tmp45_;
	GeeSet* _tmp46_;
};

struct _Block16Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	ApplicationAccountContext* selected;
	gpointer _async_data_;
};

struct _ApplicationMainWindowUndoData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationMainWindow* self;
	Block16Data* _data16_;
	ApplicationAccountContext* _tmp0_;
	ApplicationAccountContext* _tmp1_;
	ApplicationAccountContext* _tmp2_;
	ApplicationCommandStack* _tmp3_;
	ApplicationCommandStack* _tmp4_;
	ApplicationAccountContext* _tmp5_;
	GCancellable* _tmp6_;
	GCancellable* _tmp7_;
};

struct _Block17Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	ApplicationAccountContext* selected;
	gpointer _async_data_;
};

struct _ApplicationMainWindowRedoData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationMainWindow* self;
	Block17Data* _data17_;
	ApplicationAccountContext* _tmp0_;
	ApplicationAccountContext* _tmp1_;
	ApplicationAccountContext* _tmp2_;
	ApplicationCommandStack* _tmp3_;
	ApplicationCommandStack* _tmp4_;
	ApplicationAccountContext* _tmp5_;
	GCancellable* _tmp6_;
	GCancellable* _tmp7_;
};

struct _ApplicationMainWindowLoadConversationsForEmailData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationMainWindow* self;
	GearyFolder* location;
	GeeCollection* to_load;
	GeeCollection* result;
	gboolean was_loaded;
	gboolean _tmp0_;
	GearyAppConversationMonitor* _tmp1_;
	GearyAppConversationMonitor* _tmp2_;
	GearyFolder* _tmp3_;
	GearyFolder* _tmp4_;
	GearyAppConversationMonitor* _tmp5_;
	GCancellable* _tmp6_;
	GError* err;
	GError* _tmp7_;
	const gchar* _tmp8_;
	GeeHashSet* loaded;
	GeeHashSet* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	GearyAppConversationMonitor* _tmp12_;
	GearyAppConversationMonitor* _tmp13_;
	GearyFolder* _tmp14_;
	GearyFolder* _tmp15_;
	GeeIterator* _id_it;
	GeeIterator* _tmp16_;
	GeeIterator* _tmp17_;
	GearyEmailIdentifier* id;
	GeeIterator* _tmp18_;
	gpointer _tmp19_;
	GearyAppConversation* conversation;
	GearyAppConversationMonitor* _tmp20_;
	GearyEmailIdentifier* _tmp21_;
	GearyAppConversation* _tmp22_;
	GearyAppConversation* _tmp23_;
	GeeHashSet* _tmp24_;
	GearyAppConversation* _tmp25_;
	GError* _inner_error0_;
};

struct _ComposerApplicationInterfaceIface {
	GTypeInterface parent_iface;
	void (*report_problem) (ComposerApplicationInterface* self, GearyProblemReport* report);
	void (*send_composed_email) (ComposerApplicationInterface* self, ComposerWidget* composer, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*send_composed_email_finish) (ComposerApplicationInterface* self, GAsyncResult* _res_);
	void (*save_composed_email) (ComposerApplicationInterface* self, ComposerWidget* composer, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*save_composed_email_finish) (ComposerApplicationInterface* self, GAsyncResult* _res_);
	void (*discard_composed_email) (ComposerApplicationInterface* self, ComposerWidget* composer, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*discard_composed_email_finish) (ComposerApplicationInterface* self, GAsyncResult* _res_);
};

struct _ApplicationMainWindowSelectConversationsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationMainWindow* self;
	GeeCollection* to_select;
	GeeCollection* scroll_to;
	gboolean is_interactive;
	gboolean _tmp0_;
	gboolean start_mark_timer;
	ConversationListView* _tmp1_;
	ComponentsConversationActions* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	ComponentsMainToolbar* _tmp5_;
	ComponentsConversationActions* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	ComponentsMainToolbar* _tmp9_;
	ComponentsConversationActions* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gboolean _tmp13_;
	GearyFolder* _tmp14_;
	gboolean _tmp15_;
	gboolean _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	ConversationViewer* _tmp19_;
	GearyAppConversation* convo;
	gpointer _tmp20_;
	ApplicationAccountContext* context;
	ApplicationAccountContext* _tmp21_;
	gboolean _tmp22_;
	ApplicationAccountContext* _tmp23_;
	GearyAppConversation* _tmp24_;
	ConversationViewer* _tmp25_;
	GearyAppConversation* _tmp26_;
	ApplicationAccountContext* _tmp27_;
	GearyAppEmailStore* _tmp28_;
	GearyAppEmailStore* _tmp29_;
	ApplicationAccountContext* _tmp30_;
	ApplicationContactStore* _tmp31_;
	ApplicationContactStore* _tmp32_;
	GError* err;
	GearyAppConversation* _tmp33_;
	GError* _tmp34_;
	const gchar* _tmp35_;
	GearyAppConversation* _tmp36_;
	GearyFolder* _tmp37_;
	GearyFolder* _tmp38_;
	GearyAccount* _tmp39_;
	GearyAccount* _tmp40_;
	GearyAccountInformation* _tmp41_;
	GearyAccountInformation* _tmp42_;
	GError* _tmp43_;
	GError* _vala1_err;
	GearyAppConversation* _tmp44_;
	GearyFolder* _tmp45_;
	GearyFolder* _tmp46_;
	GearyAccount* _tmp47_;
	GearyAccount* _tmp48_;
	GearyAccountInformation* _tmp49_;
	GearyAccountInformation* _tmp50_;
	GError* _tmp51_;
	ConversationViewer* _tmp52_;
	GError* _inner_error0_;
};

struct _Block18Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyAppConversationMonitor* to_open;
	gpointer _async_data_;
};

struct _ApplicationMainWindowOpenConversationMonitorData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationMainWindow* self;
	GearyAppConversationMonitor* to_open;
	GCancellable* cancellable;
	Block18Data* _data18_;
};

struct _Block19Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyAppConversationMonitor* to_close;
};

struct _ApplicationMainWindowCreateComposerData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationMainWindow* self;
	GearyAccount* send_context;
	ComposerWidgetContextType type;
	GearyEmail* context;
	gchar* quote;
	const gchar* _tmp0_;
	ComposerWidget* composer;
	ApplicationController* _tmp1_;
	ApplicationController* _tmp2_;
	GearyAccountInformation* _tmp3_;
	GearyAccountInformation* _tmp4_;
	ApplicationAccountContext* _tmp5_;
	ApplicationAccountContext* _tmp6_;
	ComposerWidget* _tmp7_;
	ComposerWidget* _tmp8_;
	ApplicationController* _tmp9_;
};

struct _ApplicationMainWindowCreateComposerFromViewerData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationMainWindow* self;
	ComposerWidgetContextType type;
	GearyAccount* account;
	GearyAccount* _tmp0_;
	GearyAccount* _tmp1_;
	ConversationEmail* email_view;
	ConversationListBox* list_view;
	ConversationViewer* _tmp2_;
	ConversationListBox* _tmp3_;
	ConversationListBox* _tmp4_;
	ConversationListBox* _tmp5_;
	ConversationListBox* _tmp6_;
	ConversationListBox* _tmp7_;
	ConversationEmail* _tmp8_;
	gboolean _tmp9_;
	GearyAccount* _tmp10_;
	ConversationEmail* _tmp11_;
	gchar* quote;
	ConversationEmail* _tmp12_;
	gchar* _tmp13_;
	GearyAccount* _tmp14_;
	ConversationEmail* _tmp15_;
	GearyEmail* _tmp16_;
	GearyEmail* _tmp17_;
	const gchar* _tmp18_;
};

struct _ApplicationMainWindowUpdateContextDependentActionsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationMainWindow* self;
	gboolean sensitive;
	GCancellable* _tmp0_;
	GCancellable* cancellable;
	GCancellable* _tmp1_;
	GCancellable* _tmp2_;
	GCancellable* _tmp3_;
	GeeMultiMap* selected_operations;
	GearyFolder* _tmp4_;
	ApplicationAccountContext* context;
	ApplicationController* _tmp5_;
	GearyFolder* _tmp6_;
	GearyAccount* _tmp7_;
	GearyAccount* _tmp8_;
	GearyAccountInformation* _tmp9_;
	GearyAccountInformation* _tmp10_;
	ApplicationAccountContext* _tmp11_;
	ApplicationAccountContext* _tmp12_;
	GeeCollection* ids;
	GeeLinkedList* _tmp13_;
	GeeIterator* _convo_it;
	ConversationListView* _tmp14_;
	GeeSet* _tmp15_;
	GeeSet* _tmp16_;
	GeeIterator* _tmp17_;
	GeeIterator* _tmp18_;
	GeeIterator* _tmp19_;
	GearyAppConversation* convo;
	GeeIterator* _tmp20_;
	gpointer _tmp21_;
	GeeCollection* _tmp22_;
	GearyAppConversation* _tmp23_;
	GeeCollection* _tmp24_;
	GeeCollection* _tmp25_;
	GeeMultiMap* _tmp26_;
	ApplicationAccountContext* _tmp27_;
	GearyAppEmailStore* _tmp28_;
	GearyAppEmailStore* _tmp29_;
	GeeCollection* _tmp30_;
	GCancellable* _tmp31_;
	GeeMultiMap* _tmp32_;
	GeeMultiMap* _tmp33_;
	GError* e;
	GError* _tmp34_;
	const gchar* _tmp35_;
	GCancellable* _tmp36_;
	GeeHashSet* supported_operations;
	GeeHashSet* _tmp37_;
	GeeMultiMap* _tmp38_;
	GeeHashSet* _tmp39_;
	GeeMultiMap* _tmp40_;
	GeeCollection* _tmp41_;
	GeeCollection* _tmp42_;
	gboolean _tmp43_;
	GeeHashSet* _tmp44_;
	GSimpleAction* _tmp45_;
	GSimpleAction* _tmp46_;
	gboolean _tmp47_;
	GeeHashSet* _tmp48_;
	GSimpleAction* _tmp49_;
	GSimpleAction* _tmp50_;
	GError* _inner_error0_;
};

struct _Block20Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyFolder* location;
};

struct _Block21Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyFolder* location;
};

struct _Block22Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyFolder* location;
};

struct _Block23Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyFolder* location;
};

struct _Block24Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyFolder* location;
};

struct _Block25Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyFolder* source;
};

struct _Block26Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyFolderSupportMove* source;
};

struct _Block27Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyFolderSupportCopy* source;
};

struct _Block28Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyFolder* source;
};

struct _Block29Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyFolder* source;
};

struct _Block30Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyFolderSupportRemove* target;
};

struct _Block31Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyFolder* location;
};

struct _Block32Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyFolder* source;
};

struct _Block33Data {
	int _ref_count_;
	ApplicationMainWindow* self;
	GearyFolderSupportRemove* source;
};

static gint ApplicationMainWindow_private_offset;
static gpointer application_main_window_parent_class = NULL;
static GearyBaseInterfaceIface * application_main_window_geary_base_interface_parent_iface = NULL;

VALA_EXTERN GType application_controller_get_type (void) G_GNUC_CONST ;
static GType application_main_window_conversation_count_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static ApplicationMainWindowConversationCount application_main_window_conversation_count_for_size (gint size);
static void application_main_window_on_undo (ApplicationMainWindow* self);
static void _application_main_window_on_undo_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self);
static void application_main_window_on_redo (ApplicationMainWindow* self);
static void _application_main_window_on_redo_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self);
static void application_main_window_on_close (ApplicationMainWindow* self);
static void _application_main_window_on_close_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self);
static void application_main_window_on_show_help_overlay (ApplicationMainWindow* self);
static void _application_main_window_on_show_help_overlay_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                     GVariant* parameter,
                                                                                     gpointer self);
static void application_main_window_on_show_window_menu (ApplicationMainWindow* self);
static void _application_main_window_on_show_window_menu_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                    GVariant* parameter,
                                                                                    gpointer self);
static void application_main_window_on_find_in_conversation_action (ApplicationMainWindow* self);
static void _application_main_window_on_find_in_conversation_action_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                               GVariant* parameter,
                                                                                               gpointer self);
static void application_main_window_on_search_activated (ApplicationMainWindow* self);
static void _application_main_window_on_search_activated_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                    GVariant* parameter,
                                                                                    gpointer self);
static void application_main_window_on_select_inbox (ApplicationMainWindow* self,
                                              GSimpleAction* action,
                                              GVariant* parameter);
static void _application_main_window_on_select_inbox_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                GVariant* parameter,
                                                                                gpointer self);
static void application_main_window_focus_previous_pane (ApplicationMainWindow* self);
static void _application_main_window_focus_previous_pane_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                    GVariant* parameter,
                                                                                    gpointer self);
static void application_main_window_on_reply_conversation (ApplicationMainWindow* self);
static void _application_main_window_on_reply_conversation_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                      GVariant* parameter,
                                                                                      gpointer self);
static void application_main_window_on_reply_all_conversation (ApplicationMainWindow* self);
static void _application_main_window_on_reply_all_conversation_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                          GVariant* parameter,
                                                                                          gpointer self);
static void application_main_window_on_forward_conversation (ApplicationMainWindow* self);
static void _application_main_window_on_forward_conversation_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                        GVariant* parameter,
                                                                                        gpointer self);
static void application_main_window_on_archive_conversation (ApplicationMainWindow* self);
static void _application_main_window_on_archive_conversation_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                        GVariant* parameter,
                                                                                        gpointer self);
static void application_main_window_on_trash_conversation (ApplicationMainWindow* self);
static void _application_main_window_on_trash_conversation_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                      GVariant* parameter,
                                                                                      gpointer self);
static void application_main_window_on_delete_conversation (ApplicationMainWindow* self);
static void _application_main_window_on_delete_conversation_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                       GVariant* parameter,
                                                                                       gpointer self);
static void application_main_window_on_show_copy_menu (ApplicationMainWindow* self);
static void _application_main_window_on_show_copy_menu_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                  GVariant* parameter,
                                                                                  gpointer self);
static void application_main_window_on_show_move_menu (ApplicationMainWindow* self);
static void _application_main_window_on_show_move_menu_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                  GVariant* parameter,
                                                                                  gpointer self);
static void application_main_window_on_conversation_up (ApplicationMainWindow* self);
static void _application_main_window_on_conversation_up_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                   GVariant* parameter,
                                                                                   gpointer self);
static void application_main_window_on_conversation_down (ApplicationMainWindow* self);
static void _application_main_window_on_conversation_down_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                     GVariant* parameter,
                                                                                     gpointer self);
static void application_main_window_on_mark_as_read (ApplicationMainWindow* self);
static void _application_main_window_on_mark_as_read_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                GVariant* parameter,
                                                                                gpointer self);
static void application_main_window_on_mark_as_unread (ApplicationMainWindow* self);
static void _application_main_window_on_mark_as_unread_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                  GVariant* parameter,
                                                                                  gpointer self);
static void application_main_window_on_mark_as_starred (ApplicationMainWindow* self);
static void _application_main_window_on_mark_as_starred_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                   GVariant* parameter,
                                                                                   gpointer self);
static void application_main_window_on_mark_as_unstarred (ApplicationMainWindow* self);
static void _application_main_window_on_mark_as_unstarred_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                     GVariant* parameter,
                                                                                     gpointer self);
static void application_main_window_on_mark_as_junk_toggle (ApplicationMainWindow* self);
static void _application_main_window_on_mark_as_junk_toggle_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                       GVariant* parameter,
                                                                                       gpointer self);
static void application_main_window_on_zoom (ApplicationMainWindow* self,
                                      GSimpleAction* action,
                                      GVariant* parameter);
static void _application_main_window_on_zoom_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self);
static void application_main_window_set_selected_account (ApplicationMainWindow* self,
                                                   GearyAccount* value);
static void application_main_window_set_selected_folder (ApplicationMainWindow* self,
                                                  GearyFolder* value);
static void application_main_window_set_conversations (ApplicationMainWindow* self,
                                                GearyAppConversationMonitor* value);
static void application_main_window_set_attachments (ApplicationMainWindow* self,
                                              ApplicationAttachmentManager* value);
VALA_EXTERN gboolean application_controller_does_folder_support_trash (GearyFolder* target);
static void application_main_window_set_is_shift_down (ApplicationMainWindow* self,
                                                gboolean value);
static void application_main_window_set_folder_list (ApplicationMainWindow* self,
                                              FolderListTree* value);
static void application_main_window_set_main_toolbar (ApplicationMainWindow* self,
                                               ComponentsMainToolbar* value);
static void application_main_window_set_search_bar (ApplicationMainWindow* self,
                                             SearchBar* value);
static void application_main_window_set_conversation_list_view (ApplicationMainWindow* self,
                                                         ConversationListView* value);
static void application_main_window_set_conversation_viewer (ApplicationMainWindow* self,
                                                      ConversationViewer* value);
static void application_main_window_set_conversation_list_info_bars (ApplicationMainWindow* self,
                                                              ComponentsInfoBarStack* value);
static void application_main_window_set_status_bar (ApplicationMainWindow* self,
                                             StatusBar* value);
static void application_main_window_real_reply_conversation_sender (ApplicationMainWindow* self);
static void application_main_window_activate_action (ApplicationMainWindow* self,
                                              GAction* action);
static GSimpleAction* application_main_window_get_window_action (ApplicationMainWindow* self,
                                                          const gchar* name);
static void application_main_window_real_reply_conversation_all (ApplicationMainWindow* self);
static void application_main_window_real_forward_conversation (ApplicationMainWindow* self);
static void application_main_window_real_mark_conversations_read (ApplicationMainWindow* self,
                                                           gboolean prefer_read);
static void application_main_window_real_mark_conversations_starred (ApplicationMainWindow* self,
                                                              gboolean prefer_starred);
static void application_main_window_real_show_copy_menu (ApplicationMainWindow* self);
static void application_main_window_real_show_move_menu (ApplicationMainWindow* self);
static void application_main_window_real_archive_conversations (ApplicationMainWindow* self);
static void application_main_window_real_junk_conversations (ApplicationMainWindow* self);
static void application_main_window_real_trash_conversations (ApplicationMainWindow* self);
static void application_main_window_real_delete_conversations (ApplicationMainWindow* self);
static void application_main_window_real_search (ApplicationMainWindow* self);
static void application_main_window_real_find (ApplicationMainWindow* self);
static void application_main_window_real_navigate (ApplicationMainWindow* self,
                                            GtkScrollType type);
static void application_main_window_focus_next_pane (ApplicationMainWindow* self);
VALA_EXTERN ApplicationMainWindow* application_main_window_new (ApplicationClient* application);
VALA_EXTERN ApplicationMainWindow* application_main_window_construct (GType object_type,
                                                          ApplicationClient* application);
static Block14Data* block14_data_ref (Block14Data* _data14_);
static void block14_data_unref (void * _userdata_);
VALA_EXTERN ApplicationController* application_client_get_controller (ApplicationClient* self);
static void application_main_window_load_config (ApplicationMainWindow* self,
                                          ApplicationConfiguration* config);
static void application_main_window_restore_saved_window_state (ApplicationMainWindow* self);
static gboolean __lambda193_ (Block14Data* _data14_,
                       GtkWidget* w,
                       GdkEventFocus* e);
VALA_EXTERN void application_controller_window_focus_in (ApplicationController* self);
static gboolean ___lambda193__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                  GdkEventFocus* event,
                                                  gpointer self);
static gboolean __lambda194_ (Block14Data* _data14_,
                       GtkWidget* w,
                       GdkEventFocus* e);
VALA_EXTERN void application_controller_window_focus_out (ApplicationController* self);
static gboolean ___lambda194__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                   GdkEventFocus* event,
                                                   gpointer self);
static void application_main_window_setup_layout (ApplicationMainWindow* self,
                                           ApplicationConfiguration* config);
static void application_main_window_update_command_actions (ApplicationMainWindow* self);
static void application_main_window_update_conversation_actions (ApplicationMainWindow* self,
                                                          ApplicationMainWindowConversationCount count);
static void application_main_window_on_update_ui_timeout (ApplicationMainWindow* self);
static void _application_main_window_on_update_ui_timeout_geary_timeout_manager_timeout_func (GearyTimeoutManager* manager,
                                                                                       gpointer self);
VALA_EXTERN GType application_account_interface_get_type (void) G_GNUC_CONST ;
static void application_main_window_on_account_available (ApplicationMainWindow* self,
                                                   ApplicationAccountContext* account);
static void _application_main_window_on_account_available_application_account_interface_account_available (ApplicationAccountInterface* _sender,
                                                                                                    ApplicationAccountContext* context,
                                                                                                    gboolean is_startup,
                                                                                                    gpointer self);
static void application_main_window_on_account_unavailable (ApplicationMainWindow* self,
                                                     ApplicationAccountContext* account,
                                                     gboolean is_shutdown);
static void _application_main_window_on_account_unavailable_application_account_interface_account_unavailable (ApplicationAccountInterface* _sender,
                                                                                                        ApplicationAccountContext* context,
                                                                                                        gboolean is_shutdown,
                                                                                                        gpointer self);
VALA_EXTERN GeeCollection* application_account_interface_get_account_contexts (ApplicationAccountInterface* self);
static void application_main_window_add_account (ApplicationMainWindow* self,
                                          ApplicationAccountContext* to_add);
static void application_main_window_on_offline_infobar_response (ApplicationMainWindow* self);
static void _application_main_window_on_offline_infobar_response_components_info_bar_response (ComponentsInfoBar* _sender,
                                                                                        gint response_id,
                                                                                        gpointer self);
static void application_main_window_on_auth_problem_retry (ApplicationMainWindow* self);
static void _application_main_window_on_auth_problem_retry_gtk_button_clicked (GtkButton* _sender,
                                                                        gpointer self);
static void application_main_window_on_cert_problem_retry (ApplicationMainWindow* self);
static void _application_main_window_on_cert_problem_retry_gtk_button_clicked (GtkButton* _sender,
                                                                        gpointer self);
static void application_main_window_on_show_mark_menu (ApplicationMainWindow* self);
static void _application_main_window_on_show_mark_menu_components_conversation_actions_mark_message_button_toggled (ComponentsConversationActions* _sender,
                                                                                                             gpointer self);
static void application_main_window_real_destroy (GtkWidget* base);
static ApplicationAccountContext* application_main_window_get_selected_account_context (ApplicationMainWindow* self);
static void application_main_window_on_service_problem_retry (ApplicationMainWindow* self);
static void _application_main_window_on_service_problem_retry_components_problem_report_info_bar_retry (ComponentsProblemReportInfoBar* _sender,
                                                                                                 gpointer self);
static void application_main_window_select_folder_data_free (gpointer _data);
static gboolean application_main_window_select_folder_co (ApplicationMainWindowSelectFolderData* _data_);
static void application_main_window_update_headerbar (ApplicationMainWindow* self);
static void _application_main_window_update_headerbar_g_object_notify (GObject* _sender,
                                                                GParamSpec* pspec,
                                                                gpointer self);
static void application_main_window_close_conversation_monitor (ApplicationMainWindow* self,
                                                         GearyAppConversationMonitor* to_close);
static void application_main_window_select_account (ApplicationMainWindow* self,
                                             GearyAccount* account);
static void application_main_window_update_trash_action (ApplicationMainWindow* self);
static void application_main_window_open_conversation_monitor (ApplicationMainWindow* self,
                                                        GearyAppConversationMonitor* to_open,
                                                        GCancellable* cancellable,
                                                        GAsyncReadyCallback _callback_,
                                                        gpointer _user_data_);
static void application_main_window_open_conversation_monitor_finish (ApplicationMainWindow* self,
                                                               GAsyncResult* _res_);
static void application_main_window_select_folder_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_);
VALA_EXTERN void application_controller_process_pending_composers (ApplicationController* self,
                                                       GAsyncReadyCallback _callback_,
                                                       gpointer _user_data_);
VALA_EXTERN void application_controller_process_pending_composers_finish (ApplicationController* self,
                                                              GAsyncResult* _res_);
static void application_main_window_show_conversations_data_free (gpointer _data);
static gboolean application_main_window_show_conversations_co (ApplicationMainWindowShowConversationsData* _data_);
static void application_main_window_show_conversations_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_);
static void application_main_window_load_conversations_for_email (ApplicationMainWindow* self,
                                                           GearyFolder* location,
                                                           GeeCollection* to_load,
                                                           GAsyncReadyCallback _callback_,
                                                           gpointer _user_data_);
static GeeCollection* application_main_window_load_conversations_for_email_finish (ApplicationMainWindow* self,
                                                                            GAsyncResult* _res_);
static void application_main_window_select_conversations (ApplicationMainWindow* self,
                                                   GeeCollection* to_select,
                                                   GeeCollection* scroll_to,
                                                   gboolean is_interactive,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
static void application_main_window_select_conversations_finish (ApplicationMainWindow* self,
                                                          GAsyncResult* _res_);
static void application_main_window_show_email_data_free (gpointer _data);
static gboolean application_main_window_show_email_co (ApplicationMainWindowShowEmailData* _data_);
static void application_main_window_show_email_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
VALA_EXTERN void application_main_window_show_composer (ApplicationMainWindow* self,
                                            ComposerWidget* composer);
static Block15Data* block15_data_ref (Block15Data* _data15_);
static void block15_data_unref (void * _userdata_);
static gboolean ____lambda161_ (Block15Data* _data15_,
                         GearyEmail* email);
static gboolean _____lambda161__gee_predicate (gconstpointer g,
                                        gpointer self);
VALA_EXTERN gboolean application_main_window_close_composer (ApplicationMainWindow* self,
                                                 gboolean should_prompt,
                                                 gboolean is_shutdown);
VALA_EXTERN void application_main_window_start_search (ApplicationMainWindow* self,
                                           const gchar* query_text,
                                           gboolean is_interactive);
static inline void application_main_window_handle_error (ApplicationMainWindow* self,
                                           GearyAccountInformation* account,
                                           GError* _error_);
VALA_EXTERN void application_main_window_stop_search (ApplicationMainWindow* self,
                                          gboolean is_interactive);
VALA_EXTERN gboolean application_main_window_select_first_inbox (ApplicationMainWindow* self,
                                                     gboolean is_interactive);
static GearyFolder* application_main_window_get_first_inbox (ApplicationMainWindow* self);
static void application_main_window_on_folders_available (ApplicationMainWindow* self,
                                                   GeeCollection* available);
static void _application_main_window_on_folders_available_application_account_context_folders_available (ApplicationAccountContext* _sender,
                                                                                                  GeeCollection* available,
                                                                                                  gpointer self);
static void application_main_window_on_folders_unavailable (ApplicationMainWindow* self,
                                                     GeeCollection* unavailable);
static void _application_main_window_on_folders_unavailable_application_account_context_folders_unavailable (ApplicationAccountContext* _sender,
                                                                                                      GeeCollection* unavailable,
                                                                                                      gpointer self);
static void application_main_window_on_command_execute (ApplicationMainWindow* self,
                                                 ApplicationCommand* command);
static void _application_main_window_on_command_execute_application_command_stack_executed (ApplicationCommandStack* _sender,
                                                                                     ApplicationCommand* command,
                                                                                     gpointer self);
static void application_main_window_on_command_undo (ApplicationMainWindow* self,
                                              ApplicationCommand* command);
static void _application_main_window_on_command_undo_application_command_stack_undone (ApplicationCommandStack* _sender,
                                                                                ApplicationCommand* command,
                                                                                gpointer self);
static void application_main_window_on_command_redo (ApplicationMainWindow* self,
                                              ApplicationCommand* command);
static void _application_main_window_on_command_redo_application_command_stack_redone (ApplicationCommandStack* _sender,
                                                                                ApplicationCommand* command,
                                                                                gpointer self);
static void application_main_window_add_folders (ApplicationMainWindow* self,
                                          GeeCollection* to_add);
static void application_main_window_remove_account_data_free (gpointer _data);
static void application_main_window_remove_account (ApplicationMainWindow* self,
                                             ApplicationAccountContext* to_remove,
                                             GearyFolder* to_select,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
static void application_main_window_remove_account_finish (ApplicationMainWindow* self,
                                                    GAsyncResult* _res_);
static gboolean application_main_window_remove_account_co (ApplicationMainWindowRemoveAccountData* _data_);
static void application_main_window_remove_account_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_);
static void _application_main_window_on_folders_unavailable_application_account_context_folders_available (ApplicationAccountContext* _sender,
                                                                                                    GeeCollection* available,
                                                                                                    gpointer self);
static void application_main_window_remove_folders (ApplicationMainWindow* self,
                                             GeeCollection* to_remove,
                                             gboolean update_selecton);
static void application_main_window_on_use_changed (ApplicationMainWindow* self,
                                             GearyFolder* folder,
                                             GearyFolderSpecialUse old_type,
                                             GearyFolderSpecialUse new_type);
static void _application_main_window_on_use_changed_geary_folder_use_changed (GearyFolder* _sender,
                                                                       GearyFolderSpecialUse old_use,
                                                                       GearyFolderSpecialUse new_use,
                                                                       gpointer self);
VALA_EXTERN ApplicationAccountContext* application_account_interface_get_context_for_account (ApplicationAccountInterface* self,
                                                                                  GearyAccountInformation* account);
static gboolean application_main_window_real_window_state_event (GtkWidget* base,
                                                          GdkEventWindowState* event);
static void application_main_window_real_size_allocate (GtkWidget* base,
                                                 GtkAllocation* allocation);
static void application_main_window_on_has_toplevel_focus (ApplicationMainWindow* self);
static void _application_main_window_on_has_toplevel_focus_g_object_notify (GObject* _sender,
                                                                     GParamSpec* pspec,
                                                                     gpointer self);
static void application_main_window_on_search (ApplicationMainWindow* self,
                                        const gchar* text);
static void _application_main_window_on_search_search_bar_search_text_changed (SearchBar* _sender,
                                                                        const gchar* search_text,
                                                                        gpointer self);
static void application_main_window_on_folder_selected (ApplicationMainWindow* self,
                                                 GearyFolder* folder);
static void _application_main_window_on_folder_selected_folder_list_tree_folder_selected (FolderListTree* _sender,
                                                                                   GearyFolder* folder,
                                                                                   gpointer self);
static void application_main_window_on_move_conversation (ApplicationMainWindow* self,
                                                   GearyFolder* destination);
static void _application_main_window_on_move_conversation_folder_list_tree_move_conversation (FolderListTree* _sender,
                                                                                       GearyFolder* folder,
                                                                                       gpointer self);
static void application_main_window_on_copy_conversation (ApplicationMainWindow* self,
                                                   GearyFolder* destination);
static void _application_main_window_on_copy_conversation_folder_list_tree_copy_conversation (FolderListTree* _sender,
                                                                                       GearyFolder* folder,
                                                                                       gpointer self);
static void application_main_window_on_folder_activated (ApplicationMainWindow* self,
                                                  GearyFolder* folder);
static void _application_main_window_on_folder_activated_folder_list_tree_folder_activated (FolderListTree* _sender,
                                                                                     GearyFolder* folder,
                                                                                     gpointer self);
static void application_main_window_on_load_more (ApplicationMainWindow* self);
static void _application_main_window_on_load_more_conversation_list_view_load_more (ConversationListView* _sender,
                                                                             gpointer self);
static void application_main_window_on_mark_conversations (ApplicationMainWindow* self,
                                                    GeeCollection* conversations,
                                                    GearyNamedFlag* flag);
static void _application_main_window_on_mark_conversations_conversation_list_view_mark_conversations (ConversationListView* _sender,
                                                                                               GeeCollection* conversations,
                                                                                               GearyNamedFlag* flag,
                                                                                               gpointer self);
static void application_main_window_on_conversations_selected (ApplicationMainWindow* self,
                                                        GeeSet* selected);
static void _application_main_window_on_conversations_selected_conversation_list_view_conversations_selected (ConversationListView* _sender,
                                                                                                       GeeSet* selected,
                                                                                                       gpointer self);
static void application_main_window_on_conversation_activated (ApplicationMainWindow* self,
                                                        GearyAppConversation* activated,
                                                        gboolean single);
static void _application_main_window_on_conversation_activated_conversation_list_view_conversation_activated (ConversationListView* _sender,
                                                                                                       GearyAppConversation* activated,
                                                                                                       gboolean single,
                                                                                                       gpointer self);
static void application_main_window_on_visible_conversations_changed (ApplicationMainWindow* self,
                                                               GeeSet* visible);
static void _application_main_window_on_visible_conversations_changed_conversation_list_view_visible_conversations_changed (ConversationListView* _sender,
                                                                                                                     GeeSet* visible,
                                                                                                                     gpointer self);
static void application_main_window_on_conversation_view_added (ApplicationMainWindow* self,
                                                         ConversationListBox* list);
static void _application_main_window_on_conversation_view_added_conversation_viewer_conversation_added (ConversationViewer* _sender,
                                                                                                 ConversationListBox* list,
                                                                                                 gpointer self);
static void __lambda201_ (ApplicationMainWindow* self);
static void ___lambda201__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static void _vala_array_add8 (FolderPopover** * array,
                       gint* length,
                       gint* size,
                       FolderPopover* value);
static void _application_main_window_on_move_conversation_folder_popover_folder_selected (FolderPopover* _sender,
                                                                                   GearyFolder* folder,
                                                                                   gpointer self);
static void _vala_array_add9 (FolderPopover** * array,
                       gint* length,
                       gint* size,
                       FolderPopover* value);
static void _application_main_window_on_copy_conversation_folder_popover_folder_selected (FolderPopover* _sender,
                                                                                   GearyFolder* folder,
                                                                                   gpointer self);
static gboolean application_main_window_real_key_press_event (GtkWidget* base,
                                                       GdkEventKey* event);
static inline void application_main_window_check_shift_event (ApplicationMainWindow* self,
                                                GdkEventKey* event);
static gboolean application_main_window_real_key_release_event (GtkWidget* base,
                                                         GdkEventKey* event);
VALA_EXTERN gboolean application_main_window_prompt_empty_folder (ApplicationMainWindow* self,
                                                      GearyFolderSpecialUse type);
VALA_EXTERN GType alert_dialog_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType confirmation_dialog_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ConfirmationDialog* confirmation_dialog_new (GtkWindow* parent,
                                             const gchar* title,
                                             const gchar* description,
                                             const gchar* ok_button,
                                             const gchar* ok_action_type);
VALA_EXTERN ConfirmationDialog* confirmation_dialog_construct (GType object_type,
                                                   GtkWindow* parent,
                                                   const gchar* title,
                                                   const gchar* description,
                                                   const gchar* ok_button,
                                                   const gchar* ok_action_type);
VALA_EXTERN void alert_dialog_use_secondary_markup (AlertDialog* self,
                                        gboolean markup);
VALA_EXTERN void alert_dialog_set_focus_response (AlertDialog* self,
                                      GtkResponseType response);
VALA_EXTERN GtkResponseType alert_dialog_run (AlertDialog* self);
static void application_main_window_undo_data_free (gpointer _data);
static void application_main_window_undo (ApplicationMainWindow* self,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
static void application_main_window_undo_finish (ApplicationMainWindow* self,
                                          GAsyncResult* _res_);
static gboolean application_main_window_undo_co (ApplicationMainWindowUndoData* _data_);
static Block16Data* block16_data_ref (Block16Data* _data16_);
static void block16_data_unref (void * _userdata_);
static void ___lambda183_ (Block16Data* _data16_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda183__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static void application_main_window_redo_data_free (gpointer _data);
static void application_main_window_redo (ApplicationMainWindow* self,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
static void application_main_window_redo_finish (ApplicationMainWindow* self,
                                          GAsyncResult* _res_);
static gboolean application_main_window_redo_co (ApplicationMainWindowRedoData* _data_);
static Block17Data* block17_data_ref (Block17Data* _data17_);
static void block17_data_unref (void * _userdata_);
static void ___lambda184_ (Block17Data* _data17_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda184__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static GSimpleAction* application_main_window_get_edit_action (ApplicationMainWindow* self,
                                                        const gchar* name);
static gboolean application_main_window_prompt_delete_conversations (ApplicationMainWindow* self,
                                                              gint count);
static gboolean application_main_window_prompt_delete_messages (ApplicationMainWindow* self,
                                                         gint count);
static void application_main_window_load_conversations_for_email_data_free (gpointer _data);
static gboolean application_main_window_load_conversations_for_email_co (ApplicationMainWindowLoadConversationsForEmailData* _data_);
static void application_main_window_load_conversations_for_email_ready (GObject* source_object,
                                                                 GAsyncResult* _res_,
                                                                 gpointer _user_data_);
VALA_EXTERN GType composer_application_interface_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void composer_application_interface_report_problem (ComposerApplicationInterface* self,
                                                    GearyProblemReport* report);
static void application_main_window_update_ui (ApplicationMainWindow* self);
static void application_main_window_select_conversations_data_free (gpointer _data);
static gboolean application_main_window_select_conversations_co (ApplicationMainWindowSelectConversationsData* _data_);
static void application_main_window_select_conversations_ready (GObject* source_object,
                                                         GAsyncResult* _res_,
                                                         gpointer _user_data_);
static void application_main_window_open_conversation_monitor_data_free (gpointer _data);
static gboolean application_main_window_open_conversation_monitor_co (ApplicationMainWindowOpenConversationMonitorData* _data_);
static Block18Data* block18_data_ref (Block18Data* _data18_);
static void block18_data_unref (void * _userdata_);
static void application_main_window_on_scan_completed (ApplicationMainWindow* self,
                                                GearyAppConversationMonitor* monitor);
static void _application_main_window_on_scan_completed_geary_app_conversation_monitor_scan_completed (GearyAppConversationMonitor* _sender,
                                                                                               gpointer self);
static void application_main_window_on_scan_error (ApplicationMainWindow* self,
                                            GearyAppConversationMonitor* monitor,
                                            GError* err);
static void _application_main_window_on_scan_error_geary_app_conversation_monitor_scan_error (GearyAppConversationMonitor* _sender,
                                                                                       GError* err,
                                                                                       gpointer self);
static void application_main_window_on_conversation_count_changed (ApplicationMainWindow* self);
static void _application_main_window_on_conversation_count_changed_geary_app_conversation_monitor_scan_completed (GearyAppConversationMonitor* _sender,
                                                                                                           gpointer self);
static void _application_main_window_on_conversation_count_changed_geary_app_conversation_monitor_conversations_added (GearyAppConversationMonitor* _sender,
                                                                                                                GeeCollection* conversations,
                                                                                                                gpointer self);
static void _application_main_window_on_conversation_count_changed_geary_app_conversation_monitor_conversations_removed (GearyAppConversationMonitor* _sender,
                                                                                                                  GeeCollection* conversations,
                                                                                                                  gpointer self);
static void __lambda160_ (Block18Data* _data18_,
                   GObject* obj,
                   GAsyncResult* res);
static void ___lambda160__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static Block19Data* block19_data_ref (Block19Data* _data19_);
static void block19_data_unref (void * _userdata_);
static void __lambda158_ (Block19Data* _data19_,
                   GObject* obj,
                   GAsyncResult* res);
static void ___lambda158__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void application_main_window_create_composer_data_free (gpointer _data);
static void application_main_window_create_composer (ApplicationMainWindow* self,
                                              GearyAccount* send_context,
                                              ComposerWidgetContextType type,
                                              GearyEmail* context,
                                              const gchar* quote,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_);
static void application_main_window_create_composer_finish (ApplicationMainWindow* self,
                                                     GAsyncResult* _res_);
static gboolean application_main_window_create_composer_co (ApplicationMainWindowCreateComposerData* _data_);
VALA_EXTERN void application_controller_compose_with_context (ApplicationController* self,
                                                  ApplicationAccountContext* send_context,
                                                  ComposerWidgetContextType type,
                                                  GearyEmail* context,
                                                  const gchar* quote,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_);
VALA_EXTERN ComposerWidget* application_controller_compose_with_context_finish (ApplicationController* self,
                                                                    GAsyncResult* _res_);
static void application_main_window_create_composer_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_);
VALA_EXTERN void application_controller_present_composer (ApplicationController* self,
                                              ComposerWidget* composer);
static void application_main_window_create_composer_from_viewer_data_free (gpointer _data);
static void application_main_window_create_composer_from_viewer (ApplicationMainWindow* self,
                                                          ComposerWidgetContextType type,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_);
static void application_main_window_create_composer_from_viewer_finish (ApplicationMainWindow* self,
                                                                 GAsyncResult* _res_);
static gboolean application_main_window_create_composer_from_viewer_co (ApplicationMainWindowCreateComposerFromViewerData* _data_);
static void application_main_window_create_composer_from_viewer_ready (GObject* source_object,
                                                                GAsyncResult* _res_,
                                                                gpointer _user_data_);
static void application_main_window_load_more (ApplicationMainWindow* self);
static void application_main_window_update_context_dependent_actions (ApplicationMainWindow* self,
                                                               gboolean sensitive,
                                                               GAsyncReadyCallback _callback_,
                                                               gpointer _user_data_);
static void application_main_window_update_context_dependent_actions_finish (ApplicationMainWindow* self,
                                                                      GAsyncResult* _res_);
static void application_main_window_update_context_dependent_actions_data_free (gpointer _data);
static gboolean application_main_window_update_context_dependent_actions_co (ApplicationMainWindowUpdateContextDependentActionsData* _data_);
static void application_main_window_update_context_dependent_actions_ready (GObject* source_object,
                                                                     GAsyncResult* _res_,
                                                                     gpointer _user_data_);
static void application_main_window_set_shift_key_down (ApplicationMainWindow* self,
                                                 gboolean down);
static void application_main_window_on_map (ApplicationMainWindow* self);
static void _application_main_window_on_map_gtk_widget_map (GtkWidget* _sender,
                                                     gpointer self);
static void application_main_window_on_unmap (ApplicationMainWindow* self);
static void _application_main_window_on_unmap_gtk_widget_unmap (GtkWidget* _sender,
                                                         gpointer self);
static gboolean application_main_window_on_focus_event (ApplicationMainWindow* self);
static gboolean _application_main_window_on_focus_event_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                             GdkEventFocus* event,
                                                                             gpointer self);
static gboolean application_main_window_on_delete_event (ApplicationMainWindow* self);
static void ___lambda202_ (ApplicationMainWindow* self,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda202__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static gboolean _application_main_window_on_delete_event_gtk_widget_delete_event (GtkWidget* _sender,
                                                                           GdkEventAny* event,
                                                                           gpointer self);
static void application_main_window_on_outer_leaflet_changed (ApplicationMainWindow* self);
static void _application_main_window_on_outer_leaflet_changed_g_object_notify (GObject* _sender,
                                                                        GParamSpec* pspec,
                                                                        gpointer self);
static void application_main_window_on_inner_leaflet_changed (ApplicationMainWindow* self);
static void _application_main_window_on_inner_leaflet_changed_g_object_notify (GObject* _sender,
                                                                        GParamSpec* pspec,
                                                                        gpointer self);
static void application_main_window_on_email_loaded (ApplicationMainWindow* self,
                                              ConversationListBox* view,
                                              GearyEmail* loaded);
static void _application_main_window_on_email_loaded_conversation_list_box_email_loaded (ConversationListBox* _sender,
                                                                                  GearyEmail* email,
                                                                                  gpointer self);
static void application_main_window_on_email_mark (ApplicationMainWindow* self,
                                            ConversationListBox* view,
                                            GeeCollection* messages,
                                            GearyNamedFlag* to_add,
                                            GearyNamedFlag* to_remove);
static void _application_main_window_on_email_mark_conversation_list_box_mark_email (ConversationListBox* _sender,
                                                                              GeeCollection* email,
                                                                              GearyNamedFlag* to_add,
                                                                              GearyNamedFlag* to_remove,
                                                                              gpointer self);
static void application_main_window_on_email_reply_to_all (ApplicationMainWindow* self,
                                                    GearyEmail* target,
                                                    const gchar* quote);
static void _application_main_window_on_email_reply_to_all_conversation_list_box_reply_to_all_email (ConversationListBox* _sender,
                                                                                              GearyEmail* email,
                                                                                              const gchar* quote,
                                                                                              gpointer self);
static void application_main_window_on_email_reply_to_sender (ApplicationMainWindow* self,
                                                       GearyEmail* target,
                                                       const gchar* quote);
static void _application_main_window_on_email_reply_to_sender_conversation_list_box_reply_to_sender_email (ConversationListBox* _sender,
                                                                                                    GearyEmail* email,
                                                                                                    const gchar* quote,
                                                                                                    gpointer self);
static void application_main_window_on_email_forward (ApplicationMainWindow* self,
                                               GearyEmail* target,
                                               const gchar* quote);
static void _application_main_window_on_email_forward_conversation_list_box_forward_email (ConversationListBox* _sender,
                                                                                    GearyEmail* email,
                                                                                    const gchar* quote,
                                                                                    gpointer self);
static void application_main_window_on_email_trash (ApplicationMainWindow* self,
                                             ConversationListBox* view,
                                             GearyEmail* target);
static void _application_main_window_on_email_trash_conversation_list_box_trash_email (ConversationListBox* _sender,
                                                                                GearyEmail* email,
                                                                                gpointer self);
static void application_main_window_on_email_delete (ApplicationMainWindow* self,
                                              ConversationListBox* view,
                                              GearyEmail* target);
static void _application_main_window_on_email_delete_conversation_list_box_delete_email (ConversationListBox* _sender,
                                                                                  GearyEmail* email,
                                                                                  gpointer self);
VALA_EXTERN void application_controller_clear_new_messages (ApplicationController* self,
                                                GearyFolder* source,
                                                GeeSet* visible);
static Block20Data* block20_data_ref (Block20Data* _data20_);
static void block20_data_unref (void * _userdata_);
VALA_EXTERN void application_controller_mark_conversations (ApplicationController* self,
                                                GearyFolder* location,
                                                GeeCollection* conversations,
                                                GearyNamedFlag* flag,
                                                gboolean prefer_adding,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
VALA_EXTERN void application_controller_mark_conversations_finish (ApplicationController* self,
                                                       GAsyncResult* _res_,
                                                       GError** error);
static void ___lambda197_ (Block20Data* _data20_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda197__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static Block21Data* block21_data_ref (Block21Data* _data21_);
static void block21_data_unref (void * _userdata_);
static void ___lambda188_ (Block21Data* _data21_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda188__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static Block22Data* block22_data_ref (Block22Data* _data22_);
static void block22_data_unref (void * _userdata_);
static void ___lambda189_ (Block22Data* _data22_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda189__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static Block23Data* block23_data_ref (Block23Data* _data23_);
static void block23_data_unref (void * _userdata_);
static void ___lambda190_ (Block23Data* _data23_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda190__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static Block24Data* block24_data_ref (Block24Data* _data24_);
static void block24_data_unref (void * _userdata_);
static void ___lambda191_ (Block24Data* _data24_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda191__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static Block25Data* block25_data_ref (Block25Data* _data25_);
static void block25_data_unref (void * _userdata_);
VALA_EXTERN void application_controller_move_conversations_special (ApplicationController* self,
                                                        GearyFolder* source,
                                                        GearyFolderSpecialUse destination,
                                                        GeeCollection* conversations,
                                                        GAsyncReadyCallback _callback_,
                                                        gpointer _user_data_);
VALA_EXTERN void application_controller_move_conversations_special_finish (ApplicationController* self,
                                                               GAsyncResult* _res_,
                                                               GError** error);
static void ___lambda192_ (Block25Data* _data25_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda192__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static Block26Data* block26_data_ref (Block26Data* _data26_);
static void block26_data_unref (void * _userdata_);
VALA_EXTERN void application_controller_move_conversations (ApplicationController* self,
                                                GearyFolderSupportMove* source,
                                                GearyFolder* destination,
                                                GeeCollection* conversations,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
VALA_EXTERN void application_controller_move_conversations_finish (ApplicationController* self,
                                                       GAsyncResult* _res_,
                                                       GError** error);
static void ___lambda195_ (Block26Data* _data26_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda195__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static Block27Data* block27_data_ref (Block27Data* _data27_);
static void block27_data_unref (void * _userdata_);
VALA_EXTERN void application_controller_copy_conversations (ApplicationController* self,
                                                GearyFolderSupportCopy* source,
                                                GearyFolder* destination,
                                                GeeCollection* conversations,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
VALA_EXTERN void application_controller_copy_conversations_finish (ApplicationController* self,
                                                       GAsyncResult* _res_,
                                                       GError** error);
static void ___lambda196_ (Block27Data* _data27_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda196__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static Block28Data* block28_data_ref (Block28Data* _data28_);
static void block28_data_unref (void * _userdata_);
static void ___lambda185_ (Block28Data* _data28_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda185__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static Block29Data* block29_data_ref (Block29Data* _data29_);
static void block29_data_unref (void * _userdata_);
static void ___lambda186_ (Block29Data* _data29_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda186__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static Block30Data* block30_data_ref (Block30Data* _data30_);
static void block30_data_unref (void * _userdata_);
VALA_EXTERN void application_controller_delete_conversations (ApplicationController* self,
                                                  GearyFolderSupportRemove* target,
                                                  GeeCollection* conversations,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_);
VALA_EXTERN void application_controller_delete_conversations_finish (ApplicationController* self,
                                                         GAsyncResult* _res_,
                                                         GError** error);
static void ___lambda187_ (Block30Data* _data30_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda187__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
VALA_EXTERN void application_controller_email_loaded (ApplicationController* self,
                                          GearyAccountInformation* account,
                                          GearyEmail* loaded);
static Block31Data* block31_data_ref (Block31Data* _data31_);
static void block31_data_unref (void * _userdata_);
VALA_EXTERN void application_controller_mark_messages (ApplicationController* self,
                                           GearyFolder* location,
                                           GeeCollection* conversations,
                                           GeeCollection* messages,
                                           GearyEmailFlags* to_add,
                                           GearyEmailFlags* to_remove,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
VALA_EXTERN void application_controller_mark_messages_finish (ApplicationController* self,
                                                  GAsyncResult* _res_,
                                                  GError** error);
static void ___lambda198_ (Block31Data* _data31_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda198__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static Block32Data* block32_data_ref (Block32Data* _data32_);
static void block32_data_unref (void * _userdata_);
VALA_EXTERN void application_controller_move_messages_special (ApplicationController* self,
                                                   GearyFolder* source,
                                                   GearyFolderSpecialUse destination,
                                                   GeeCollection* conversations,
                                                   GeeCollection* messages,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
VALA_EXTERN void application_controller_move_messages_special_finish (ApplicationController* self,
                                                          GAsyncResult* _res_,
                                                          GError** error);
static void ___lambda199_ (Block32Data* _data32_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda199__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static Block33Data* block33_data_ref (Block33Data* _data33_);
static void block33_data_unref (void * _userdata_);
VALA_EXTERN void application_controller_delete_messages (ApplicationController* self,
                                             GearyFolderSupportRemove* target,
                                             GeeCollection* conversations,
                                             GeeCollection* messages,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
VALA_EXTERN void application_controller_delete_messages_finish (ApplicationController* self,
                                                    GAsyncResult* _res_,
                                                    GError** error);
static void ___lambda200_ (Block33Data* _data33_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda200__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static void application_main_window_finalize (GObject * obj);
static GType application_main_window_get_type_once (void);
static void _vala_application_main_window_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_application_main_window_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const GActionEntry APPLICATION_MAIN_WINDOW_EDIT_ACTIONS[2] = {{ACTION_EDIT_UNDO, _application_main_window_on_undo_gsimple_action_activate_callback}, {ACTION_EDIT_REDO, _application_main_window_on_redo_gsimple_action_activate_callback}};
static const GActionEntry APPLICATION_MAIN_WINDOW_WINDOW_ACTIONS[23] = {{ACTION_WINDOW_CLOSE, _application_main_window_on_close_gsimple_action_activate_callback}, {ACTION_WINDOW_SHOW_HELP_OVERLAY, _application_main_window_on_show_help_overlay_gsimple_action_activate_callback}, {ACTION_WINDOW_SHOW_MENU, _application_main_window_on_show_window_menu_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_FIND_IN_CONVERSATION, _application_main_window_on_find_in_conversation_action_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_SEARCH, _application_main_window_on_search_activated_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_SELECT_INBOX, _application_main_window_on_select_inbox_gsimple_action_activate_callback, "i"}, {APPLICATION_MAIN_WINDOW_ACTION_NAVIGATION_BACK, _application_main_window_focus_previous_pane_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_REPLY_CONVERSATION, _application_main_window_on_reply_conversation_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_REPLY_ALL_CONVERSATION, _application_main_window_on_reply_all_conversation_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_FORWARD_CONVERSATION, _application_main_window_on_forward_conversation_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_ARCHIVE_CONVERSATION, _application_main_window_on_archive_conversation_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_TRASH_CONVERSATION, _application_main_window_on_trash_conversation_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_DELETE_CONVERSATION, _application_main_window_on_delete_conversation_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_SHOW_COPY_MENU, _application_main_window_on_show_copy_menu_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_SHOW_MOVE_MENU, _application_main_window_on_show_move_menu_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_CONVERSATION_UP, _application_main_window_on_conversation_up_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_CONVERSATION_DOWN, _application_main_window_on_conversation_down_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_MARK_AS_READ, _application_main_window_on_mark_as_read_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_MARK_AS_UNREAD, _application_main_window_on_mark_as_unread_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_MARK_AS_STARRED, _application_main_window_on_mark_as_starred_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_MARK_AS_UNSTARRED, _application_main_window_on_mark_as_unstarred_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_TOGGLE_JUNK, _application_main_window_on_mark_as_junk_toggle_gsimple_action_activate_callback}, {APPLICATION_MAIN_WINDOW_ACTION_ZOOM, _application_main_window_on_zoom_gsimple_action_activate_callback, "s"}};

static inline gpointer
application_main_window_get_instance_private (ApplicationMainWindow* self)
{
	return G_STRUCT_MEMBER_P (self, ApplicationMainWindow_private_offset);
}

static ApplicationMainWindowConversationCount
application_main_window_conversation_count_for_size (gint size)
{
	ApplicationMainWindowConversationCount _tmp0_ = 0;
	ApplicationMainWindowConversationCount result;
#line 267 "../src/client/application/application-main-window.vala"
	if (size == 0) {
#line 269 "../src/client/application/application-main-window.vala"
		_tmp0_ = APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_NONE;
#line 1798 "application-main-window.c"
	} else {
		ApplicationMainWindowConversationCount _tmp1_ = 0;
#line 270 "../src/client/application/application-main-window.vala"
		if (size == 1) {
#line 271 "../src/client/application/application-main-window.vala"
			_tmp1_ = APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_SINGLE;
#line 1805 "application-main-window.c"
		} else {
#line 272 "../src/client/application/application-main-window.vala"
			_tmp1_ = APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_MULTIPLE;
#line 1809 "application-main-window.c"
		}
#line 270 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp1_;
#line 1813 "application-main-window.c"
	}
#line 267 "../src/client/application/application-main-window.vala"
	result = _tmp0_;
#line 267 "../src/client/application/application-main-window.vala"
	return result;
#line 1819 "application-main-window.c"
}

static GType
application_main_window_conversation_count_get_type_once (void)
{
	static const GEnumValue values[] = {{APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_NONE, "APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_NONE", "none"}, {APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_SINGLE, "APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_SINGLE", "single"}, {APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_MULTIPLE, "APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_MULTIPLE", "multiple"}, {0, NULL, NULL}};
	GType application_main_window_conversation_count_type_id;
	application_main_window_conversation_count_type_id = g_enum_register_static ("ApplicationMainWindowConversationCount", values);
	return application_main_window_conversation_count_type_id;
}

static GType
application_main_window_conversation_count_get_type (void)
{
	static volatile gsize application_main_window_conversation_count_type_id__once = 0;
	if (g_once_init_enter (&application_main_window_conversation_count_type_id__once)) {
		GType application_main_window_conversation_count_type_id;
		application_main_window_conversation_count_type_id = application_main_window_conversation_count_get_type_once ();
		g_once_init_leave (&application_main_window_conversation_count_type_id__once, application_main_window_conversation_count_type_id);
	}
	return application_main_window_conversation_count_type_id__once;
}

static void
_application_main_window_on_undo_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self)
{
#line 36 "../src/client/application/application-main-window.vala"
	application_main_window_on_undo ((ApplicationMainWindow*) self);
#line 1850 "application-main-window.c"
}

static void
_application_main_window_on_redo_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self)
{
#line 36 "../src/client/application/application-main-window.vala"
	application_main_window_on_redo ((ApplicationMainWindow*) self);
#line 1860 "application-main-window.c"
}

static void
_application_main_window_on_close_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self)
{
#line 41 "../src/client/application/application-main-window.vala"
	application_main_window_on_close ((ApplicationMainWindow*) self);
#line 1870 "application-main-window.c"
}

static void
_application_main_window_on_show_help_overlay_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                GVariant* parameter,
                                                                                gpointer self)
{
#line 41 "../src/client/application/application-main-window.vala"
	application_main_window_on_show_help_overlay ((ApplicationMainWindow*) self);
#line 1880 "application-main-window.c"
}

static void
_application_main_window_on_show_window_menu_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self)
{
#line 41 "../src/client/application/application-main-window.vala"
	application_main_window_on_show_window_menu ((ApplicationMainWindow*) self);
#line 1890 "application-main-window.c"
}

static void
_application_main_window_on_find_in_conversation_action_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                          GVariant* parameter,
                                                                                          gpointer self)
{
#line 41 "../src/client/application/application-main-window.vala"
	application_main_window_on_find_in_conversation_action ((ApplicationMainWindow*) self);
#line 1900 "application-main-window.c"
}

static void
_application_main_window_on_search_activated_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self)
{
#line 41 "../src/client/application/application-main-window.vala"
	application_main_window_on_search_activated ((ApplicationMainWindow*) self);
#line 1910 "application-main-window.c"
}

static void
_application_main_window_on_select_inbox_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self)
{
#line 41 "../src/client/application/application-main-window.vala"
	application_main_window_on_select_inbox ((ApplicationMainWindow*) self, action, parameter);
#line 1920 "application-main-window.c"
}

static void
_application_main_window_focus_previous_pane_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self)
{
#line 41 "../src/client/application/application-main-window.vala"
	application_main_window_focus_previous_pane ((ApplicationMainWindow*) self);
#line 1930 "application-main-window.c"
}

static void
_application_main_window_on_reply_conversation_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                 GVariant* parameter,
                                                                                 gpointer self)
{
#line 41 "../src/client/application/application-main-window.vala"
	application_main_window_on_reply_conversation ((ApplicationMainWindow*) self);
#line 1940 "application-main-window.c"
}

static void
_application_main_window_on_reply_all_conversation_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                     GVariant* parameter,
                                                                                     gpointer self)
{
#line 41 "../src/client/application/application-main-window.vala"
	application_main_window_on_reply_all_conversation ((ApplicationMainWindow*) self);
#line 1950 "application-main-window.c"
}

static void
_application_main_window_on_forward_conversation_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                   GVariant* parameter,
                                                                                   gpointer self)
{
#line 41 "../src/client/application/application-main-window.vala"
	application_main_window_on_forward_conversation ((ApplicationMainWindow*) self);
#line 1960 "application-main-window.c"
}

static void
_application_main_window_on_archive_conversation_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                   GVariant* parameter,
                                                                                   gpointer self)
{
#line 41 "../src/client/application/application-main-window.vala"
	application_main_window_on_archive_conversation ((ApplicationMainWindow*) self);
#line 1970 "application-main-window.c"
}

static void
_application_main_window_on_trash_conversation_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                 GVariant* parameter,
                                                                                 gpointer self)
{
#line 41 "../src/client/application/application-main-window.vala"
	application_main_window_on_trash_conversation ((ApplicationMainWindow*) self);
#line 1980 "application-main-window.c"
}

static void
_application_main_window_on_delete_conversation_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                  GVariant* parameter,
                                                                                  gpointer self)
{
#line 41 "../src/client/application/application-main-window.vala"
	application_main_window_on_delete_conversation ((ApplicationMainWindow*) self);
#line 1990 "application-main-window.c"
}

static void
_application_main_window_on_show_copy_menu_gsimple_action_activate_callback (GSimpleAction* action,
                                                                             GVariant* parameter,
                                                                             gpointer self)
{
#line 41 "../src/client/application/application-main-window.vala"
	application_main_window_on_show_copy_menu ((ApplicationMainWindow*) self);
#line 2000 "application-main-window.c"
}

static void
_application_main_window_on_show_move_menu_gsimple_action_activate_callback (GSimpleAction* action,
                                                                             GVariant* parameter,
                                                                             gpointer self)
{
#line 41 "../src/client/application/application-main-window.vala"
	application_main_window_on_show_move_menu ((ApplicationMainWindow*) self);
#line 2010 "application-main-window.c"
}

static void
_application_main_window_on_conversation_up_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self)
{
#line 41 "../src/client/application/application-main-window.vala"
	application_main_window_on_conversation_up ((ApplicationMainWindow*) self);
#line 2020 "application-main-window.c"
}

static void
_application_main_window_on_conversation_down_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                GVariant* parameter,
                                                                                gpointer self)
{
#line 41 "../src/client/application/application-main-window.vala"
	application_main_window_on_conversation_down ((ApplicationMainWindow*) self);
#line 2030 "application-main-window.c"
}

static void
_application_main_window_on_mark_as_read_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self)
{
#line 41 "../src/client/application/application-main-window.vala"
	application_main_window_on_mark_as_read ((ApplicationMainWindow*) self);
#line 2040 "application-main-window.c"
}

static void
_application_main_window_on_mark_as_unread_gsimple_action_activate_callback (GSimpleAction* action,
                                                                             GVariant* parameter,
                                                                             gpointer self)
{
#line 41 "../src/client/application/application-main-window.vala"
	application_main_window_on_mark_as_unread ((ApplicationMainWindow*) self);
#line 2050 "application-main-window.c"
}

static void
_application_main_window_on_mark_as_starred_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self)
{
#line 41 "../src/client/application/application-main-window.vala"
	application_main_window_on_mark_as_starred ((ApplicationMainWindow*) self);
#line 2060 "application-main-window.c"
}

static void
_application_main_window_on_mark_as_unstarred_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                GVariant* parameter,
                                                                                gpointer self)
{
#line 41 "../src/client/application/application-main-window.vala"
	application_main_window_on_mark_as_unstarred ((ApplicationMainWindow*) self);
#line 2070 "application-main-window.c"
}

static void
_application_main_window_on_mark_as_junk_toggle_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                  GVariant* parameter,
                                                                                  gpointer self)
{
#line 41 "../src/client/application/application-main-window.vala"
	application_main_window_on_mark_as_junk_toggle ((ApplicationMainWindow*) self);
#line 2080 "application-main-window.c"
}

static void
_application_main_window_on_zoom_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self)
{
#line 41 "../src/client/application/application-main-window.vala"
	application_main_window_on_zoom ((ApplicationMainWindow*) self, action, parameter);
#line 2090 "application-main-window.c"
}

void
application_main_window_add_accelerators (ApplicationClient* owner)
{
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar** _tmp11_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	gchar* _tmp13_;
	gchar** _tmp14_;
	gchar** _tmp15_;
	gint _tmp15__length1;
	gchar* _tmp16_;
	gchar** _tmp17_;
	gchar** _tmp18_;
	gint _tmp18__length1;
#line 243 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (owner));
#line 2111 "application-main-window.c"
	{
		gint i = 0;
#line 244 "../src/client/application/application-main-window.vala"
		i = 1;
#line 2116 "application-main-window.c"
		{
			gboolean _tmp0_ = FALSE;
#line 244 "../src/client/application/application-main-window.vala"
			_tmp0_ = TRUE;
#line 244 "../src/client/application/application-main-window.vala"
			while (TRUE) {
#line 2123 "application-main-window.c"
				gchar* _tmp2_;
				gchar* _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				gchar* _tmp6_;
				gchar** _tmp7_;
				gchar** _tmp8_;
				gint _tmp8__length1;
#line 244 "../src/client/application/application-main-window.vala"
				if (!_tmp0_) {
#line 2134 "application-main-window.c"
					gint _tmp1_;
#line 244 "../src/client/application/application-main-window.vala"
					_tmp1_ = i;
#line 244 "../src/client/application/application-main-window.vala"
					i = _tmp1_ + 1;
#line 2140 "application-main-window.c"
				}
#line 244 "../src/client/application/application-main-window.vala"
				_tmp0_ = FALSE;
#line 244 "../src/client/application/application-main-window.vala"
				if (!(i <= 9)) {
#line 244 "../src/client/application/application-main-window.vala"
					break;
#line 2148 "application-main-window.c"
				}
#line 245 "../src/client/application/application-main-window.vala"
				_tmp2_ = g_strdup_printf ("(%d)", i - 1);
#line 245 "../src/client/application/application-main-window.vala"
				_tmp3_ = _tmp2_;
#line 245 "../src/client/application/application-main-window.vala"
				_tmp4_ = g_strconcat (APPLICATION_MAIN_WINDOW_ACTION_SELECT_INBOX, _tmp3_, NULL);
#line 245 "../src/client/application/application-main-window.vala"
				_tmp5_ = _tmp4_;
#line 245 "../src/client/application/application-main-window.vala"
				_tmp6_ = g_strdup_printf ("<ALT>%d", i);
#line 245 "../src/client/application/application-main-window.vala"
				_tmp7_ = g_new0 (gchar*, 1 + 1);
#line 245 "../src/client/application/application-main-window.vala"
				_tmp7_[0] = _tmp6_;
#line 245 "../src/client/application/application-main-window.vala"
				_tmp8_ = _tmp7_;
#line 245 "../src/client/application/application-main-window.vala"
				_tmp8__length1 = 1;
#line 245 "../src/client/application/application-main-window.vala"
				application_client_add_window_accelerators (owner, _tmp5_, _tmp8_, (gint) 1, NULL);
#line 245 "../src/client/application/application-main-window.vala"
				_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 245 "../src/client/application/application-main-window.vala"
				_g_free0 (_tmp5_);
#line 245 "../src/client/application/application-main-window.vala"
				_g_free0 (_tmp3_);
#line 2176 "application-main-window.c"
			}
		}
	}
#line 251 "../src/client/application/application-main-window.vala"
	_tmp9_ = g_strdup ("<Ctrl>equal");
#line 251 "../src/client/application/application-main-window.vala"
	_tmp10_ = g_strdup ("<Ctrl>plus");
#line 251 "../src/client/application/application-main-window.vala"
	_tmp11_ = g_new0 (gchar*, 2 + 1);
#line 251 "../src/client/application/application-main-window.vala"
	_tmp11_[0] = _tmp9_;
#line 251 "../src/client/application/application-main-window.vala"
	_tmp11_[1] = _tmp10_;
#line 251 "../src/client/application/application-main-window.vala"
	_tmp12_ = _tmp11_;
#line 251 "../src/client/application/application-main-window.vala"
	_tmp12__length1 = 2;
#line 251 "../src/client/application/application-main-window.vala"
	application_client_add_window_accelerators (owner, APPLICATION_MAIN_WINDOW_ACTION_ZOOM "('in')", _tmp12_, (gint) 2, NULL);
#line 251 "../src/client/application/application-main-window.vala"
	_tmp12_ = (_vala_array_free (_tmp12_, _tmp12__length1, (GDestroyNotify) g_free), NULL);
#line 254 "../src/client/application/application-main-window.vala"
	_tmp13_ = g_strdup ("<Ctrl>minus");
#line 254 "../src/client/application/application-main-window.vala"
	_tmp14_ = g_new0 (gchar*, 1 + 1);
#line 254 "../src/client/application/application-main-window.vala"
	_tmp14_[0] = _tmp13_;
#line 254 "../src/client/application/application-main-window.vala"
	_tmp15_ = _tmp14_;
#line 254 "../src/client/application/application-main-window.vala"
	_tmp15__length1 = 1;
#line 254 "../src/client/application/application-main-window.vala"
	application_client_add_window_accelerators (owner, APPLICATION_MAIN_WINDOW_ACTION_ZOOM "('out')", _tmp15_, (gint) 1, NULL);
#line 254 "../src/client/application/application-main-window.vala"
	_tmp15_ = (_vala_array_free (_tmp15_, _tmp15__length1, (GDestroyNotify) g_free), NULL);
#line 257 "../src/client/application/application-main-window.vala"
	_tmp16_ = g_strdup ("<Ctrl>0");
#line 257 "../src/client/application/application-main-window.vala"
	_tmp17_ = g_new0 (gchar*, 1 + 1);
#line 257 "../src/client/application/application-main-window.vala"
	_tmp17_[0] = _tmp16_;
#line 257 "../src/client/application/application-main-window.vala"
	_tmp18_ = _tmp17_;
#line 257 "../src/client/application/application-main-window.vala"
	_tmp18__length1 = 1;
#line 257 "../src/client/application/application-main-window.vala"
	application_client_add_window_accelerators (owner, APPLICATION_MAIN_WINDOW_ACTION_ZOOM "('normal')", _tmp18_, (gint) 1, NULL);
#line 257 "../src/client/application/application-main-window.vala"
	_tmp18_ = (_vala_array_free (_tmp18_, _tmp18__length1, (GDestroyNotify) g_free), NULL);
#line 2226 "application-main-window.c"
}

ApplicationClient*
application_main_window_get_application (ApplicationMainWindow* self)
{
	ApplicationClient* result;
	GtkApplication* _tmp0_;
#line 280 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), NULL);
#line 280 "../src/client/application/application-main-window.vala"
	_tmp0_ = gtk_window_get_application (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, hdy_application_window_get_type (), HdyApplicationWindow), gtk_window_get_type (), GtkWindow));
#line 280 "../src/client/application/application-main-window.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, APPLICATION_TYPE_CLIENT, ApplicationClient);
#line 280 "../src/client/application/application-main-window.vala"
	return result;
#line 2242 "application-main-window.c"
}

void
application_main_window_set_application (ApplicationMainWindow* self,
                                         ApplicationClient* value)
{
#line 281 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 281 "../src/client/application/application-main-window.vala"
	gtk_window_set_application (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, hdy_application_window_get_type (), HdyApplicationWindow), gtk_window_get_type (), GtkWindow), G_TYPE_CHECK_INSTANCE_CAST (value, gtk_application_get_type (), GtkApplication));
#line 281 "../src/client/application/application-main-window.vala"
	g_object_notify_by_pspec ((GObject *) self, application_main_window_properties[APPLICATION_MAIN_WINDOW_APPLICATION_PROPERTY]);
#line 2255 "application-main-window.c"
}

GearyAccount*
application_main_window_get_selected_account (ApplicationMainWindow* self)
{
	GearyAccount* result;
	GearyAccount* _tmp0_;
#line 285 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), NULL);
#line 285 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_account;
#line 285 "../src/client/application/application-main-window.vala"
	result = _tmp0_;
#line 285 "../src/client/application/application-main-window.vala"
	return result;
#line 2271 "application-main-window.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 285 "../src/client/application/application-main-window.vala"
	return self ? g_object_ref (self) : NULL;
#line 2279 "application-main-window.c"
}

static void
application_main_window_set_selected_account (ApplicationMainWindow* self,
                                              GearyAccount* value)
{
	GearyAccount* old_value;
#line 285 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 285 "../src/client/application/application-main-window.vala"
	old_value = application_main_window_get_selected_account (self);
#line 285 "../src/client/application/application-main-window.vala"
	if (old_value != value) {
#line 2293 "application-main-window.c"
		GearyAccount* _tmp0_;
#line 285 "../src/client/application/application-main-window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 285 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self->priv->_selected_account);
#line 285 "../src/client/application/application-main-window.vala"
		self->priv->_selected_account = _tmp0_;
#line 285 "../src/client/application/application-main-window.vala"
		g_object_notify_by_pspec ((GObject *) self, application_main_window_properties[APPLICATION_MAIN_WINDOW_SELECTED_ACCOUNT_PROPERTY]);
#line 2303 "application-main-window.c"
	}
}

GearyFolder*
application_main_window_get_selected_folder (ApplicationMainWindow* self)
{
	GearyFolder* result;
	GearyFolder* _tmp0_;
#line 288 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), NULL);
#line 288 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 288 "../src/client/application/application-main-window.vala"
	result = _tmp0_;
#line 288 "../src/client/application/application-main-window.vala"
	return result;
#line 2320 "application-main-window.c"
}

static void
application_main_window_set_selected_folder (ApplicationMainWindow* self,
                                             GearyFolder* value)
{
	GearyFolder* old_value;
#line 288 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 288 "../src/client/application/application-main-window.vala"
	old_value = application_main_window_get_selected_folder (self);
#line 288 "../src/client/application/application-main-window.vala"
	if (old_value != value) {
#line 2334 "application-main-window.c"
		GearyFolder* _tmp0_;
#line 288 "../src/client/application/application-main-window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 288 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self->priv->_selected_folder);
#line 288 "../src/client/application/application-main-window.vala"
		self->priv->_selected_folder = _tmp0_;
#line 288 "../src/client/application/application-main-window.vala"
		g_object_notify_by_pspec ((GObject *) self, application_main_window_properties[APPLICATION_MAIN_WINDOW_SELECTED_FOLDER_PROPERTY]);
#line 2344 "application-main-window.c"
	}
}

GearyAppConversationMonitor*
application_main_window_get_conversations (ApplicationMainWindow* self)
{
	GearyAppConversationMonitor* result;
	GearyAppConversationMonitor* _tmp0_;
#line 292 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), NULL);
#line 292 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_conversations;
#line 292 "../src/client/application/application-main-window.vala"
	result = _tmp0_;
#line 292 "../src/client/application/application-main-window.vala"
	return result;
#line 2361 "application-main-window.c"
}

static void
application_main_window_set_conversations (ApplicationMainWindow* self,
                                           GearyAppConversationMonitor* value)
{
	GearyAppConversationMonitor* old_value;
#line 292 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 292 "../src/client/application/application-main-window.vala"
	old_value = application_main_window_get_conversations (self);
#line 292 "../src/client/application/application-main-window.vala"
	if (old_value != value) {
#line 2375 "application-main-window.c"
		GearyAppConversationMonitor* _tmp0_;
#line 292 "../src/client/application/application-main-window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 292 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self->priv->_conversations);
#line 292 "../src/client/application/application-main-window.vala"
		self->priv->_conversations = _tmp0_;
#line 292 "../src/client/application/application-main-window.vala"
		g_object_notify_by_pspec ((GObject *) self, application_main_window_properties[APPLICATION_MAIN_WINDOW_CONVERSATIONS_PROPERTY]);
#line 2385 "application-main-window.c"
	}
}

gboolean
application_main_window_get_is_folder_list_shown (ApplicationMainWindow* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	HdyLeaflet* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 297 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), FALSE);
#line 299 "../src/client/application/application-main-window.vala"
	_tmp2_ = self->priv->outer_leaflet;
#line 299 "../src/client/application/application-main-window.vala"
	_tmp3_ = hdy_leaflet_get_folded (_tmp2_);
#line 299 "../src/client/application/application-main-window.vala"
	_tmp4_ = _tmp3_;
#line 299 "../src/client/application/application-main-window.vala"
	if (!_tmp4_) {
#line 299 "../src/client/application/application-main-window.vala"
		_tmp1_ = TRUE;
#line 2410 "application-main-window.c"
	} else {
		HdyLeaflet* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 300 "../src/client/application/application-main-window.vala"
		_tmp5_ = self->priv->outer_leaflet;
#line 300 "../src/client/application/application-main-window.vala"
		_tmp6_ = hdy_leaflet_get_visible_child_name (_tmp5_);
#line 300 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 300 "../src/client/application/application-main-window.vala"
		_tmp1_ = g_strcmp0 (_tmp7_, APPLICATION_MAIN_WINDOW_INNER_LEAFLET) == 0;
#line 2423 "application-main-window.c"
	}
#line 298 "../src/client/application/application-main-window.vala"
	if (_tmp1_) {
#line 2427 "application-main-window.c"
		gboolean _tmp8_ = FALSE;
		HdyLeaflet* _tmp9_;
		gboolean _tmp10_;
		gboolean _tmp11_;
#line 301 "../src/client/application/application-main-window.vala"
		_tmp9_ = self->priv->inner_leaflet;
#line 301 "../src/client/application/application-main-window.vala"
		_tmp10_ = hdy_leaflet_get_folded (_tmp9_);
#line 301 "../src/client/application/application-main-window.vala"
		_tmp11_ = _tmp10_;
#line 301 "../src/client/application/application-main-window.vala"
		if (!_tmp11_) {
#line 301 "../src/client/application/application-main-window.vala"
			_tmp8_ = TRUE;
#line 2442 "application-main-window.c"
		} else {
			HdyLeaflet* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
#line 302 "../src/client/application/application-main-window.vala"
			_tmp12_ = self->priv->inner_leaflet;
#line 302 "../src/client/application/application-main-window.vala"
			_tmp13_ = hdy_leaflet_get_visible_child_name (_tmp12_);
#line 302 "../src/client/application/application-main-window.vala"
			_tmp14_ = _tmp13_;
#line 302 "../src/client/application/application-main-window.vala"
			_tmp8_ = g_strcmp0 (_tmp14_, APPLICATION_MAIN_WINDOW_FOLDER_LIST) == 0;
#line 2455 "application-main-window.c"
		}
#line 301 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp8_;
#line 2459 "application-main-window.c"
	} else {
#line 299 "../src/client/application/application-main-window.vala"
		_tmp0_ = FALSE;
#line 2463 "application-main-window.c"
	}
#line 298 "../src/client/application/application-main-window.vala"
	result = _tmp0_;
#line 298 "../src/client/application/application-main-window.vala"
	return result;
#line 2469 "application-main-window.c"
}

gboolean
application_main_window_get_is_conversation_list_shown (ApplicationMainWindow* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	HdyLeaflet* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 309 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), FALSE);
#line 311 "../src/client/application/application-main-window.vala"
	_tmp2_ = self->priv->outer_leaflet;
#line 311 "../src/client/application/application-main-window.vala"
	_tmp3_ = hdy_leaflet_get_folded (_tmp2_);
#line 311 "../src/client/application/application-main-window.vala"
	_tmp4_ = _tmp3_;
#line 311 "../src/client/application/application-main-window.vala"
	if (!_tmp4_) {
#line 311 "../src/client/application/application-main-window.vala"
		_tmp1_ = TRUE;
#line 2493 "application-main-window.c"
	} else {
		HdyLeaflet* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 312 "../src/client/application/application-main-window.vala"
		_tmp5_ = self->priv->outer_leaflet;
#line 312 "../src/client/application/application-main-window.vala"
		_tmp6_ = hdy_leaflet_get_visible_child_name (_tmp5_);
#line 312 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 312 "../src/client/application/application-main-window.vala"
		_tmp1_ = g_strcmp0 (_tmp7_, APPLICATION_MAIN_WINDOW_INNER_LEAFLET) == 0;
#line 2506 "application-main-window.c"
	}
#line 310 "../src/client/application/application-main-window.vala"
	if (_tmp1_) {
#line 2510 "application-main-window.c"
		gboolean _tmp8_ = FALSE;
		HdyLeaflet* _tmp9_;
		gboolean _tmp10_;
		gboolean _tmp11_;
#line 313 "../src/client/application/application-main-window.vala"
		_tmp9_ = self->priv->inner_leaflet;
#line 313 "../src/client/application/application-main-window.vala"
		_tmp10_ = hdy_leaflet_get_folded (_tmp9_);
#line 313 "../src/client/application/application-main-window.vala"
		_tmp11_ = _tmp10_;
#line 313 "../src/client/application/application-main-window.vala"
		if (!_tmp11_) {
#line 313 "../src/client/application/application-main-window.vala"
			_tmp8_ = TRUE;
#line 2525 "application-main-window.c"
		} else {
			HdyLeaflet* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
#line 314 "../src/client/application/application-main-window.vala"
			_tmp12_ = self->priv->inner_leaflet;
#line 314 "../src/client/application/application-main-window.vala"
			_tmp13_ = hdy_leaflet_get_visible_child_name (_tmp12_);
#line 314 "../src/client/application/application-main-window.vala"
			_tmp14_ = _tmp13_;
#line 314 "../src/client/application/application-main-window.vala"
			_tmp8_ = g_strcmp0 (_tmp14_, APPLICATION_MAIN_WINDOW_CONVERSATION_LIST) == 0;
#line 2538 "application-main-window.c"
		}
#line 313 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp8_;
#line 2542 "application-main-window.c"
	} else {
#line 311 "../src/client/application/application-main-window.vala"
		_tmp0_ = FALSE;
#line 2546 "application-main-window.c"
	}
#line 310 "../src/client/application/application-main-window.vala"
	result = _tmp0_;
#line 310 "../src/client/application/application-main-window.vala"
	return result;
#line 2552 "application-main-window.c"
}

gboolean
application_main_window_get_is_conversation_viewer_shown (ApplicationMainWindow* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	HdyLeaflet* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 321 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), FALSE);
#line 323 "../src/client/application/application-main-window.vala"
	_tmp2_ = self->priv->outer_leaflet;
#line 323 "../src/client/application/application-main-window.vala"
	_tmp3_ = hdy_leaflet_get_folded (_tmp2_);
#line 323 "../src/client/application/application-main-window.vala"
	_tmp4_ = _tmp3_;
#line 323 "../src/client/application/application-main-window.vala"
	if (!_tmp4_) {
#line 323 "../src/client/application/application-main-window.vala"
		_tmp1_ = TRUE;
#line 2576 "application-main-window.c"
	} else {
		HdyLeaflet* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 324 "../src/client/application/application-main-window.vala"
		_tmp5_ = self->priv->outer_leaflet;
#line 324 "../src/client/application/application-main-window.vala"
		_tmp6_ = hdy_leaflet_get_visible_child_name (_tmp5_);
#line 324 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 324 "../src/client/application/application-main-window.vala"
		_tmp1_ = g_strcmp0 (_tmp7_, APPLICATION_MAIN_WINDOW_CONVERSATION_VIEWER) == 0;
#line 2589 "application-main-window.c"
	}
#line 322 "../src/client/application/application-main-window.vala"
	if (_tmp1_) {
#line 2593 "application-main-window.c"
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 325 "../src/client/application/application-main-window.vala"
		_tmp8_ = application_main_window_get_has_composer (self);
#line 325 "../src/client/application/application-main-window.vala"
		_tmp9_ = _tmp8_;
#line 325 "../src/client/application/application-main-window.vala"
		_tmp0_ = !_tmp9_;
#line 2602 "application-main-window.c"
	} else {
#line 323 "../src/client/application/application-main-window.vala"
		_tmp0_ = FALSE;
#line 2606 "application-main-window.c"
	}
#line 322 "../src/client/application/application-main-window.vala"
	result = _tmp0_;
#line 322 "../src/client/application/application-main-window.vala"
	return result;
#line 2612 "application-main-window.c"
}

ApplicationAttachmentManager*
application_main_window_get_attachments (ApplicationMainWindow* self)
{
	ApplicationAttachmentManager* result;
	ApplicationAttachmentManager* _tmp0_;
#line 331 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), NULL);
#line 331 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_attachments;
#line 331 "../src/client/application/application-main-window.vala"
	result = _tmp0_;
#line 331 "../src/client/application/application-main-window.vala"
	return result;
#line 2628 "application-main-window.c"
}

static void
application_main_window_set_attachments (ApplicationMainWindow* self,
                                         ApplicationAttachmentManager* value)
{
	ApplicationAttachmentManager* old_value;
#line 331 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 331 "../src/client/application/application-main-window.vala"
	old_value = application_main_window_get_attachments (self);
#line 331 "../src/client/application/application-main-window.vala"
	if (old_value != value) {
#line 2642 "application-main-window.c"
		ApplicationAttachmentManager* _tmp0_;
#line 331 "../src/client/application/application-main-window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 331 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self->priv->_attachments);
#line 331 "../src/client/application/application-main-window.vala"
		self->priv->_attachments = _tmp0_;
#line 331 "../src/client/application/application-main-window.vala"
		g_object_notify_by_pspec ((GObject *) self, application_main_window_properties[APPLICATION_MAIN_WINDOW_ATTACHMENTS_PROPERTY]);
#line 2652 "application-main-window.c"
	}
}

gboolean
application_main_window_get_selected_folder_supports_trash (ApplicationMainWindow* self)
{
	gboolean result;
	GearyFolder* _tmp0_;
#line 335 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), FALSE);
#line 336 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 336 "../src/client/application/application-main-window.vala"
	result = application_controller_does_folder_support_trash (_tmp0_);
#line 336 "../src/client/application/application-main-window.vala"
	return result;
#line 2669 "application-main-window.c"
}

gboolean
application_main_window_get_has_composer (ApplicationMainWindow* self)
{
	gboolean result;
	ConversationViewer* _tmp0_;
	ComposerWidget* _tmp1_;
	ComposerWidget* _tmp2_;
#line 342 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), FALSE);
#line 343 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_conversation_viewer;
#line 343 "../src/client/application/application-main-window.vala"
	_tmp1_ = conversation_viewer_get_current_composer (_tmp0_);
#line 343 "../src/client/application/application-main-window.vala"
	_tmp2_ = _tmp1_;
#line 343 "../src/client/application/application-main-window.vala"
	result = _tmp2_ != NULL;
#line 343 "../src/client/application/application-main-window.vala"
	return result;
#line 2691 "application-main-window.c"
}

gboolean
application_main_window_get_is_shift_down (ApplicationMainWindow* self)
{
	gboolean result;
#line 348 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), FALSE);
#line 348 "../src/client/application/application-main-window.vala"
	result = self->priv->_is_shift_down;
#line 348 "../src/client/application/application-main-window.vala"
	return result;
#line 2704 "application-main-window.c"
}

static void
application_main_window_set_is_shift_down (ApplicationMainWindow* self,
                                           gboolean value)
{
	gboolean old_value;
#line 348 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 348 "../src/client/application/application-main-window.vala"
	old_value = application_main_window_get_is_shift_down (self);
#line 348 "../src/client/application/application-main-window.vala"
	if (old_value != value) {
#line 348 "../src/client/application/application-main-window.vala"
		self->priv->_is_shift_down = value;
#line 348 "../src/client/application/application-main-window.vala"
		g_object_notify_by_pspec ((GObject *) self, application_main_window_properties[APPLICATION_MAIN_WINDOW_IS_SHIFT_DOWN_PROPERTY]);
#line 2722 "application-main-window.c"
	}
}

gint
application_main_window_get_window_width (ApplicationMainWindow* self)
{
	gint result;
#line 351 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), 0);
#line 351 "../src/client/application/application-main-window.vala"
	result = self->priv->_window_width;
#line 351 "../src/client/application/application-main-window.vala"
	return result;
#line 2736 "application-main-window.c"
}

void
application_main_window_set_window_width (ApplicationMainWindow* self,
                                          gint value)
{
	gint old_value;
#line 351 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 351 "../src/client/application/application-main-window.vala"
	old_value = application_main_window_get_window_width (self);
#line 351 "../src/client/application/application-main-window.vala"
	if (old_value != value) {
#line 351 "../src/client/application/application-main-window.vala"
		self->priv->_window_width = value;
#line 351 "../src/client/application/application-main-window.vala"
		g_object_notify_by_pspec ((GObject *) self, application_main_window_properties[APPLICATION_MAIN_WINDOW_WINDOW_WIDTH_PROPERTY]);
#line 2754 "application-main-window.c"
	}
}

gint
application_main_window_get_window_height (ApplicationMainWindow* self)
{
	gint result;
#line 352 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), 0);
#line 352 "../src/client/application/application-main-window.vala"
	result = self->priv->_window_height;
#line 352 "../src/client/application/application-main-window.vala"
	return result;
#line 2768 "application-main-window.c"
}

void
application_main_window_set_window_height (ApplicationMainWindow* self,
                                           gint value)
{
	gint old_value;
#line 352 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 352 "../src/client/application/application-main-window.vala"
	old_value = application_main_window_get_window_height (self);
#line 352 "../src/client/application/application-main-window.vala"
	if (old_value != value) {
#line 352 "../src/client/application/application-main-window.vala"
		self->priv->_window_height = value;
#line 352 "../src/client/application/application-main-window.vala"
		g_object_notify_by_pspec ((GObject *) self, application_main_window_properties[APPLICATION_MAIN_WINDOW_WINDOW_HEIGHT_PROPERTY]);
#line 2786 "application-main-window.c"
	}
}

gboolean
application_main_window_get_window_maximized (ApplicationMainWindow* self)
{
	gboolean result;
#line 353 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), FALSE);
#line 353 "../src/client/application/application-main-window.vala"
	result = self->priv->_window_maximized;
#line 353 "../src/client/application/application-main-window.vala"
	return result;
#line 2800 "application-main-window.c"
}

void
application_main_window_set_window_maximized (ApplicationMainWindow* self,
                                              gboolean value)
{
	gboolean old_value;
#line 353 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 353 "../src/client/application/application-main-window.vala"
	old_value = application_main_window_get_window_maximized (self);
#line 353 "../src/client/application/application-main-window.vala"
	if (old_value != value) {
#line 353 "../src/client/application/application-main-window.vala"
		self->priv->_window_maximized = value;
#line 353 "../src/client/application/application-main-window.vala"
		g_object_notify_by_pspec ((GObject *) self, application_main_window_properties[APPLICATION_MAIN_WINDOW_WINDOW_MAXIMIZED_PROPERTY]);
#line 2818 "application-main-window.c"
	}
}

FolderListTree*
application_main_window_get_folder_list (ApplicationMainWindow* self)
{
	FolderListTree* result;
	FolderListTree* _tmp0_;
#line 356 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), NULL);
#line 356 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_folder_list;
#line 356 "../src/client/application/application-main-window.vala"
	result = _tmp0_;
#line 356 "../src/client/application/application-main-window.vala"
	return result;
#line 2835 "application-main-window.c"
}

static void
application_main_window_set_folder_list (ApplicationMainWindow* self,
                                         FolderListTree* value)
{
	FolderListTree* old_value;
#line 356 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 356 "../src/client/application/application-main-window.vala"
	old_value = application_main_window_get_folder_list (self);
#line 356 "../src/client/application/application-main-window.vala"
	if (old_value != value) {
#line 2849 "application-main-window.c"
		FolderListTree* _tmp0_;
#line 356 "../src/client/application/application-main-window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 356 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self->priv->_folder_list);
#line 356 "../src/client/application/application-main-window.vala"
		self->priv->_folder_list = _tmp0_;
#line 356 "../src/client/application/application-main-window.vala"
		g_object_notify_by_pspec ((GObject *) self, application_main_window_properties[APPLICATION_MAIN_WINDOW_FOLDER_LIST_PROPERTY]);
#line 2859 "application-main-window.c"
	}
}

ComponentsMainToolbar*
application_main_window_get_main_toolbar (ApplicationMainWindow* self)
{
	ComponentsMainToolbar* result;
	ComponentsMainToolbar* _tmp0_;
#line 357 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), NULL);
#line 357 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_main_toolbar;
#line 357 "../src/client/application/application-main-window.vala"
	result = _tmp0_;
#line 357 "../src/client/application/application-main-window.vala"
	return result;
#line 2876 "application-main-window.c"
}

static void
application_main_window_set_main_toolbar (ApplicationMainWindow* self,
                                          ComponentsMainToolbar* value)
{
	ComponentsMainToolbar* old_value;
#line 357 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 357 "../src/client/application/application-main-window.vala"
	old_value = application_main_window_get_main_toolbar (self);
#line 357 "../src/client/application/application-main-window.vala"
	if (old_value != value) {
#line 2890 "application-main-window.c"
		ComponentsMainToolbar* _tmp0_;
#line 357 "../src/client/application/application-main-window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 357 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self->priv->_main_toolbar);
#line 357 "../src/client/application/application-main-window.vala"
		self->priv->_main_toolbar = _tmp0_;
#line 357 "../src/client/application/application-main-window.vala"
		g_object_notify_by_pspec ((GObject *) self, application_main_window_properties[APPLICATION_MAIN_WINDOW_MAIN_TOOLBAR_PROPERTY]);
#line 2900 "application-main-window.c"
	}
}

SearchBar*
application_main_window_get_search_bar (ApplicationMainWindow* self)
{
	SearchBar* result;
	SearchBar* _tmp0_;
#line 358 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), NULL);
#line 358 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_search_bar;
#line 358 "../src/client/application/application-main-window.vala"
	result = _tmp0_;
#line 358 "../src/client/application/application-main-window.vala"
	return result;
#line 2917 "application-main-window.c"
}

static void
application_main_window_set_search_bar (ApplicationMainWindow* self,
                                        SearchBar* value)
{
	SearchBar* old_value;
#line 358 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 358 "../src/client/application/application-main-window.vala"
	old_value = application_main_window_get_search_bar (self);
#line 358 "../src/client/application/application-main-window.vala"
	if (old_value != value) {
#line 2931 "application-main-window.c"
		SearchBar* _tmp0_;
#line 358 "../src/client/application/application-main-window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 358 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self->priv->_search_bar);
#line 358 "../src/client/application/application-main-window.vala"
		self->priv->_search_bar = _tmp0_;
#line 358 "../src/client/application/application-main-window.vala"
		g_object_notify_by_pspec ((GObject *) self, application_main_window_properties[APPLICATION_MAIN_WINDOW_SEARCH_BAR_PROPERTY]);
#line 2941 "application-main-window.c"
	}
}

ConversationListView*
application_main_window_get_conversation_list_view (ApplicationMainWindow* self)
{
	ConversationListView* result;
	ConversationListView* _tmp0_;
#line 359 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), NULL);
#line 359 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_conversation_list_view;
#line 359 "../src/client/application/application-main-window.vala"
	result = _tmp0_;
#line 359 "../src/client/application/application-main-window.vala"
	return result;
#line 2958 "application-main-window.c"
}

static void
application_main_window_set_conversation_list_view (ApplicationMainWindow* self,
                                                    ConversationListView* value)
{
	ConversationListView* old_value;
#line 359 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 359 "../src/client/application/application-main-window.vala"
	old_value = application_main_window_get_conversation_list_view (self);
#line 359 "../src/client/application/application-main-window.vala"
	if (old_value != value) {
#line 2972 "application-main-window.c"
		ConversationListView* _tmp0_;
#line 359 "../src/client/application/application-main-window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 359 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self->priv->_conversation_list_view);
#line 359 "../src/client/application/application-main-window.vala"
		self->priv->_conversation_list_view = _tmp0_;
#line 359 "../src/client/application/application-main-window.vala"
		g_object_notify_by_pspec ((GObject *) self, application_main_window_properties[APPLICATION_MAIN_WINDOW_CONVERSATION_LIST_VIEW_PROPERTY]);
#line 2982 "application-main-window.c"
	}
}

ConversationViewer*
application_main_window_get_conversation_viewer (ApplicationMainWindow* self)
{
	ConversationViewer* result;
	ConversationViewer* _tmp0_;
#line 360 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), NULL);
#line 360 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_conversation_viewer;
#line 360 "../src/client/application/application-main-window.vala"
	result = _tmp0_;
#line 360 "../src/client/application/application-main-window.vala"
	return result;
#line 2999 "application-main-window.c"
}

static void
application_main_window_set_conversation_viewer (ApplicationMainWindow* self,
                                                 ConversationViewer* value)
{
	ConversationViewer* old_value;
#line 360 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 360 "../src/client/application/application-main-window.vala"
	old_value = application_main_window_get_conversation_viewer (self);
#line 360 "../src/client/application/application-main-window.vala"
	if (old_value != value) {
#line 3013 "application-main-window.c"
		ConversationViewer* _tmp0_;
#line 360 "../src/client/application/application-main-window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 360 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self->priv->_conversation_viewer);
#line 360 "../src/client/application/application-main-window.vala"
		self->priv->_conversation_viewer = _tmp0_;
#line 360 "../src/client/application/application-main-window.vala"
		g_object_notify_by_pspec ((GObject *) self, application_main_window_properties[APPLICATION_MAIN_WINDOW_CONVERSATION_VIEWER_PROPERTY]);
#line 3023 "application-main-window.c"
	}
}

ComponentsInfoBarStack*
application_main_window_get_conversation_list_info_bars (ApplicationMainWindow* self)
{
	ComponentsInfoBarStack* result;
	ComponentsInfoBarStack* _tmp0_;
#line 363 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), NULL);
#line 363 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_conversation_list_info_bars;
#line 363 "../src/client/application/application-main-window.vala"
	result = _tmp0_;
#line 363 "../src/client/application/application-main-window.vala"
	return result;
#line 3040 "application-main-window.c"
}

static void
application_main_window_set_conversation_list_info_bars (ApplicationMainWindow* self,
                                                         ComponentsInfoBarStack* value)
{
	ComponentsInfoBarStack* old_value;
#line 363 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 363 "../src/client/application/application-main-window.vala"
	old_value = application_main_window_get_conversation_list_info_bars (self);
#line 363 "../src/client/application/application-main-window.vala"
	if (old_value != value) {
#line 3054 "application-main-window.c"
		ComponentsInfoBarStack* _tmp0_;
#line 363 "../src/client/application/application-main-window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 363 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self->priv->_conversation_list_info_bars);
#line 363 "../src/client/application/application-main-window.vala"
		self->priv->_conversation_list_info_bars = _tmp0_;
#line 363 "../src/client/application/application-main-window.vala"
		g_object_notify_by_pspec ((GObject *) self, application_main_window_properties[APPLICATION_MAIN_WINDOW_CONVERSATION_LIST_INFO_BARS_PROPERTY]);
#line 3064 "application-main-window.c"
	}
}

StatusBar*
application_main_window_get_status_bar (ApplicationMainWindow* self)
{
	StatusBar* result;
	StatusBar* _tmp0_;
#line 366 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), NULL);
#line 366 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_status_bar;
#line 366 "../src/client/application/application-main-window.vala"
	result = _tmp0_;
#line 366 "../src/client/application/application-main-window.vala"
	return result;
#line 3081 "application-main-window.c"
}

static void
application_main_window_set_status_bar (ApplicationMainWindow* self,
                                        StatusBar* value)
{
	StatusBar* old_value;
#line 366 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 366 "../src/client/application/application-main-window.vala"
	old_value = application_main_window_get_status_bar (self);
#line 366 "../src/client/application/application-main-window.vala"
	if (old_value != value) {
#line 3095 "application-main-window.c"
		StatusBar* _tmp0_;
#line 366 "../src/client/application/application-main-window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 366 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self->priv->_status_bar);
#line 366 "../src/client/application/application-main-window.vala"
		self->priv->_status_bar = _tmp0_;
#line 366 "../src/client/application/application-main-window.vala"
		g_object_notify_by_pspec ((GObject *) self, application_main_window_properties[APPLICATION_MAIN_WINDOW_STATUS_BAR_PROPERTY]);
#line 3105 "application-main-window.c"
	}
}

static void
application_main_window_real_reply_conversation_sender (ApplicationMainWindow* self)
{
	GSimpleAction* _tmp0_;
	GSimpleAction* _tmp1_;
#line 442 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_REPLY_CONVERSATION);
#line 442 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 442 "../src/client/application/application-main-window.vala"
	application_main_window_activate_action (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_action_get_type (), GAction));
#line 442 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp1_);
#line 3122 "application-main-window.c"
}

static void
application_main_window_real_reply_conversation_all (ApplicationMainWindow* self)
{
	GSimpleAction* _tmp0_;
	GSimpleAction* _tmp1_;
#line 448 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_REPLY_ALL_CONVERSATION);
#line 448 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 448 "../src/client/application/application-main-window.vala"
	application_main_window_activate_action (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_action_get_type (), GAction));
#line 448 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp1_);
#line 3138 "application-main-window.c"
}

static void
application_main_window_real_forward_conversation (ApplicationMainWindow* self)
{
	GSimpleAction* _tmp0_;
	GSimpleAction* _tmp1_;
#line 454 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_FORWARD_CONVERSATION);
#line 454 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 454 "../src/client/application/application-main-window.vala"
	application_main_window_activate_action (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_action_get_type (), GAction));
#line 454 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp1_);
#line 3154 "application-main-window.c"
}

static void
application_main_window_real_mark_conversations_read (ApplicationMainWindow* self,
                                                      gboolean prefer_read)
{
	GSimpleAction* _tmp0_ = NULL;
#line 461 "../src/client/application/application-main-window.vala"
	if (prefer_read) {
#line 3164 "application-main-window.c"
		GSimpleAction* _tmp1_;
#line 462 "../src/client/application/application-main-window.vala"
		_tmp1_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_MARK_AS_READ);
#line 462 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp0_);
#line 462 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp1_;
#line 3172 "application-main-window.c"
	} else {
		GSimpleAction* _tmp2_;
#line 463 "../src/client/application/application-main-window.vala"
		_tmp2_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_MARK_AS_UNREAD);
#line 463 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp0_);
#line 463 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp2_;
#line 3181 "application-main-window.c"
	}
#line 460 "../src/client/application/application-main-window.vala"
	application_main_window_activate_action (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_action_get_type (), GAction));
#line 459 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp0_);
#line 3187 "application-main-window.c"
}

static void
application_main_window_real_mark_conversations_starred (ApplicationMainWindow* self,
                                                         gboolean prefer_starred)
{
	GSimpleAction* _tmp0_ = NULL;
#line 471 "../src/client/application/application-main-window.vala"
	if (prefer_starred) {
#line 3197 "application-main-window.c"
		GSimpleAction* _tmp1_;
#line 472 "../src/client/application/application-main-window.vala"
		_tmp1_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_MARK_AS_STARRED);
#line 472 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp0_);
#line 472 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp1_;
#line 3205 "application-main-window.c"
	} else {
		GSimpleAction* _tmp2_;
#line 473 "../src/client/application/application-main-window.vala"
		_tmp2_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_MARK_AS_UNSTARRED);
#line 473 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp0_);
#line 473 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp2_;
#line 3214 "application-main-window.c"
	}
#line 470 "../src/client/application/application-main-window.vala"
	application_main_window_activate_action (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_action_get_type (), GAction));
#line 469 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp0_);
#line 3220 "application-main-window.c"
}

static void
application_main_window_real_show_copy_menu (ApplicationMainWindow* self)
{
	GSimpleAction* _tmp0_;
	GSimpleAction* _tmp1_;
#line 480 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_SHOW_COPY_MENU);
#line 480 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 480 "../src/client/application/application-main-window.vala"
	application_main_window_activate_action (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_action_get_type (), GAction));
#line 480 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp1_);
#line 3236 "application-main-window.c"
}

static void
application_main_window_real_show_move_menu (ApplicationMainWindow* self)
{
	GSimpleAction* _tmp0_;
	GSimpleAction* _tmp1_;
#line 486 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_SHOW_MOVE_MENU);
#line 486 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 486 "../src/client/application/application-main-window.vala"
	application_main_window_activate_action (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_action_get_type (), GAction));
#line 486 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp1_);
#line 3252 "application-main-window.c"
}

static void
application_main_window_real_archive_conversations (ApplicationMainWindow* self)
{
	GSimpleAction* _tmp0_;
	GSimpleAction* _tmp1_;
#line 492 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_ARCHIVE_CONVERSATION);
#line 492 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 492 "../src/client/application/application-main-window.vala"
	application_main_window_activate_action (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_action_get_type (), GAction));
#line 492 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp1_);
#line 3268 "application-main-window.c"
}

static void
application_main_window_real_junk_conversations (ApplicationMainWindow* self)
{
	GSimpleAction* _tmp0_;
	GSimpleAction* _tmp1_;
#line 498 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_TOGGLE_JUNK);
#line 498 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 498 "../src/client/application/application-main-window.vala"
	application_main_window_activate_action (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_action_get_type (), GAction));
#line 498 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp1_);
#line 3284 "application-main-window.c"
}

static void
application_main_window_real_trash_conversations (ApplicationMainWindow* self)
{
	GSimpleAction* _tmp0_ = NULL;
	gboolean _tmp1_;
#line 507 "../src/client/application/application-main-window.vala"
	_tmp1_ = self->priv->_is_shift_down;
#line 507 "../src/client/application/application-main-window.vala"
	if (!_tmp1_) {
#line 3296 "application-main-window.c"
		GSimpleAction* _tmp2_;
#line 508 "../src/client/application/application-main-window.vala"
		_tmp2_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_TRASH_CONVERSATION);
#line 508 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp0_);
#line 508 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp2_;
#line 3304 "application-main-window.c"
	} else {
		GSimpleAction* _tmp3_;
#line 509 "../src/client/application/application-main-window.vala"
		_tmp3_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_DELETE_CONVERSATION);
#line 509 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp0_);
#line 509 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp3_;
#line 3313 "application-main-window.c"
	}
#line 506 "../src/client/application/application-main-window.vala"
	application_main_window_activate_action (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_action_get_type (), GAction));
#line 503 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp0_);
#line 3319 "application-main-window.c"
}

static void
application_main_window_real_delete_conversations (ApplicationMainWindow* self)
{
	GSimpleAction* _tmp0_;
	GSimpleAction* _tmp1_;
#line 516 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_DELETE_CONVERSATION);
#line 516 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 516 "../src/client/application/application-main-window.vala"
	application_main_window_activate_action (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_action_get_type (), GAction));
#line 516 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp1_);
#line 3335 "application-main-window.c"
}

static void
application_main_window_real_search (ApplicationMainWindow* self)
{
	GSimpleAction* _tmp0_;
	GSimpleAction* _tmp1_;
#line 522 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_SEARCH);
#line 522 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 522 "../src/client/application/application-main-window.vala"
	application_main_window_activate_action (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_action_get_type (), GAction));
#line 522 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp1_);
#line 3351 "application-main-window.c"
}

static void
application_main_window_real_find (ApplicationMainWindow* self)
{
	GSimpleAction* _tmp0_;
	GSimpleAction* _tmp1_;
#line 528 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_FIND_IN_CONVERSATION);
#line 528 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 528 "../src/client/application/application-main-window.vala"
	application_main_window_activate_action (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_action_get_type (), GAction));
#line 528 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp1_);
#line 3367 "application-main-window.c"
}

static void
application_main_window_real_navigate (ApplicationMainWindow* self,
                                       GtkScrollType type)
{
#line 534 "../src/client/application/application-main-window.vala"
	switch (type) {
#line 534 "../src/client/application/application-main-window.vala"
		case GTK_SCROLL_PAGE_LEFT:
#line 3378 "application-main-window.c"
		{
#line 536 "../src/client/application/application-main-window.vala"
			if (gtk_widget_get_direction (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget)) != GTK_TEXT_DIR_RTL) {
#line 537 "../src/client/application/application-main-window.vala"
				application_main_window_focus_previous_pane (self);
#line 3384 "application-main-window.c"
			} else {
#line 539 "../src/client/application/application-main-window.vala"
				application_main_window_focus_next_pane (self);
#line 3388 "application-main-window.c"
			}
#line 541 "../src/client/application/application-main-window.vala"
			break;
#line 3392 "application-main-window.c"
		}
#line 534 "../src/client/application/application-main-window.vala"
		case GTK_SCROLL_PAGE_RIGHT:
#line 3396 "application-main-window.c"
		{
#line 543 "../src/client/application/application-main-window.vala"
			if (gtk_widget_get_direction (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget)) != GTK_TEXT_DIR_RTL) {
#line 544 "../src/client/application/application-main-window.vala"
				application_main_window_focus_next_pane (self);
#line 3402 "application-main-window.c"
			} else {
#line 546 "../src/client/application/application-main-window.vala"
				application_main_window_focus_previous_pane (self);
#line 3406 "application-main-window.c"
			}
#line 548 "../src/client/application/application-main-window.vala"
			break;
#line 3410 "application-main-window.c"
		}
#line 534 "../src/client/application/application-main-window.vala"
		case GTK_SCROLL_STEP_UP:
#line 3414 "application-main-window.c"
		{
			GSimpleAction* _tmp0_;
			GSimpleAction* _tmp1_;
#line 550 "../src/client/application/application-main-window.vala"
			_tmp0_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_CONVERSATION_UP);
#line 550 "../src/client/application/application-main-window.vala"
			_tmp1_ = _tmp0_;
#line 550 "../src/client/application/application-main-window.vala"
			application_main_window_activate_action (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_action_get_type (), GAction));
#line 550 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (_tmp1_);
#line 551 "../src/client/application/application-main-window.vala"
			break;
#line 3428 "application-main-window.c"
		}
#line 534 "../src/client/application/application-main-window.vala"
		case GTK_SCROLL_STEP_DOWN:
#line 3432 "application-main-window.c"
		{
			GSimpleAction* _tmp2_;
			GSimpleAction* _tmp3_;
#line 553 "../src/client/application/application-main-window.vala"
			_tmp2_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_CONVERSATION_DOWN);
#line 553 "../src/client/application/application-main-window.vala"
			_tmp3_ = _tmp2_;
#line 553 "../src/client/application/application-main-window.vala"
			application_main_window_activate_action (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_action_get_type (), GAction));
#line 553 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (_tmp3_);
#line 554 "../src/client/application/application-main-window.vala"
			break;
#line 3446 "application-main-window.c"
		}
		default:
		{
#line 556 "../src/client/application/application-main-window.vala"
			gtk_widget_error_bell (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 557 "../src/client/application/application-main-window.vala"
			break;
#line 3454 "application-main-window.c"
		}
	}
}

static Block14Data*
block14_data_ref (Block14Data* _data14_)
{
#line 562 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data14_->_ref_count_);
#line 562 "../src/client/application/application-main-window.vala"
	return _data14_;
#line 3466 "application-main-window.c"
}

static void
block14_data_unref (void * _userdata_)
{
	Block14Data* _data14_;
	_data14_ = (Block14Data*) _userdata_;
#line 562 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data14_->_ref_count_)) {
#line 3476 "application-main-window.c"
		ApplicationMainWindow* self;
#line 562 "../src/client/application/application-main-window.vala"
		self = _data14_->self;
#line 562 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data14_->application);
#line 562 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 562 "../src/client/application/application-main-window.vala"
		g_slice_free (Block14Data, _data14_);
#line 3486 "application-main-window.c"
	}
}

static gboolean
__lambda193_ (Block14Data* _data14_,
              GtkWidget* w,
              GdkEventFocus* e)
{
	ApplicationMainWindow* self;
	ApplicationController* _tmp0_;
	ApplicationController* _tmp1_;
	gboolean result;
#line 598 "../src/client/application/application-main-window.vala"
	self = _data14_->self;
#line 598 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (w, gtk_widget_get_type ()), FALSE);
#line 598 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 599 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_client_get_controller (_data14_->application);
#line 599 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 599 "../src/client/application/application-main-window.vala"
	application_controller_window_focus_in (_tmp1_);
#line 600 "../src/client/application/application-main-window.vala"
	result = FALSE;
#line 600 "../src/client/application/application-main-window.vala"
	return result;
#line 3515 "application-main-window.c"
}

static gboolean
___lambda193__gtk_widget_focus_in_event (GtkWidget* _sender,
                                         GdkEventFocus* event,
                                         gpointer self)
{
	gboolean result;
	result = __lambda193_ (self, _sender, event);
#line 598 "../src/client/application/application-main-window.vala"
	return result;
#line 3527 "application-main-window.c"
}

static gboolean
__lambda194_ (Block14Data* _data14_,
              GtkWidget* w,
              GdkEventFocus* e)
{
	ApplicationMainWindow* self;
	ApplicationController* _tmp0_;
	ApplicationController* _tmp1_;
	gboolean result;
#line 602 "../src/client/application/application-main-window.vala"
	self = _data14_->self;
#line 602 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (w, gtk_widget_get_type ()), FALSE);
#line 602 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 603 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_client_get_controller (_data14_->application);
#line 603 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 603 "../src/client/application/application-main-window.vala"
	application_controller_window_focus_out (_tmp1_);
#line 604 "../src/client/application/application-main-window.vala"
	result = FALSE;
#line 604 "../src/client/application/application-main-window.vala"
	return result;
#line 3555 "application-main-window.c"
}

static gboolean
___lambda194__gtk_widget_focus_out_event (GtkWidget* _sender,
                                          GdkEventFocus* event,
                                          gpointer self)
{
	gboolean result;
	result = __lambda194_ (self, _sender, event);
#line 602 "../src/client/application/application-main-window.vala"
	return result;
#line 3567 "application-main-window.c"
}

static void
_application_main_window_on_update_ui_timeout_geary_timeout_manager_timeout_func (GearyTimeoutManager* manager,
                                                                                  gpointer self)
{
#line 615 "../src/client/application/application-main-window.vala"
	application_main_window_on_update_ui_timeout ((ApplicationMainWindow*) self);
#line 3576 "application-main-window.c"
}

static void
_application_main_window_on_account_available_application_account_interface_account_available (ApplicationAccountInterface* _sender,
                                                                                               ApplicationAccountContext* context,
                                                                                               gboolean is_startup,
                                                                                               gpointer self)
{
#line 621 "../src/client/application/application-main-window.vala"
	application_main_window_on_account_available ((ApplicationMainWindow*) self, context);
#line 3587 "application-main-window.c"
}

static void
_application_main_window_on_account_unavailable_application_account_interface_account_unavailable (ApplicationAccountInterface* _sender,
                                                                                                   ApplicationAccountContext* context,
                                                                                                   gboolean is_shutdown,
                                                                                                   gpointer self)
{
#line 624 "../src/client/application/application-main-window.vala"
	application_main_window_on_account_unavailable ((ApplicationMainWindow*) self, context, is_shutdown);
#line 3598 "application-main-window.c"
}

static void
_application_main_window_on_offline_infobar_response_components_info_bar_response (ComponentsInfoBar* _sender,
                                                                                   gint response_id,
                                                                                   gpointer self)
{
#line 639 "../src/client/application/application-main-window.vala"
	application_main_window_on_offline_infobar_response ((ApplicationMainWindow*) self);
#line 3608 "application-main-window.c"
}

static void
_application_main_window_on_auth_problem_retry_gtk_button_clicked (GtkButton* _sender,
                                                                   gpointer self)
{
#line 654 "../src/client/application/application-main-window.vala"
	application_main_window_on_auth_problem_retry ((ApplicationMainWindow*) self);
#line 3617 "application-main-window.c"
}

static void
_application_main_window_on_cert_problem_retry_gtk_button_clicked (GtkButton* _sender,
                                                                   gpointer self)
{
#line 670 "../src/client/application/application-main-window.vala"
	application_main_window_on_cert_problem_retry ((ApplicationMainWindow*) self);
#line 3626 "application-main-window.c"
}

static void
_application_main_window_on_show_mark_menu_components_conversation_actions_mark_message_button_toggled (ComponentsConversationActions* _sender,
                                                                                                        gpointer self)
{
#line 676 "../src/client/application/application-main-window.vala"
	application_main_window_on_show_mark_menu ((ApplicationMainWindow*) self);
#line 3635 "application-main-window.c"
}

ApplicationMainWindow*
application_main_window_construct (GType object_type,
                                   ApplicationClient* application)
{
	ApplicationMainWindow * self = NULL;
	Block14Data* _data14_;
	ApplicationClient* _tmp0_;
	ApplicationController* _tmp1_;
	ApplicationController* _tmp2_;
	ApplicationController* _tmp3_;
	GtkWindowGroup* group = NULL;
	GtkWindowGroup* _tmp4_;
	GtkWindowGroup* _tmp5_;
	ApplicationConfiguration* _tmp6_;
	ApplicationConfiguration* _tmp7_;
	ComponentsInfoBarStack* _tmp9_;
	ComponentsInfoBarStack* _tmp10_;
	GSimpleActionGroup* _tmp11_;
	GSimpleActionGroup* _tmp12_;
	ApplicationConfiguration* _tmp13_;
	ApplicationConfiguration* _tmp14_;
	GtkBox* _tmp15_;
	StatusBar* _tmp16_;
	ApplicationAttachmentManager* _tmp17_;
	ApplicationAttachmentManager* _tmp18_;
	GearyTimeoutManager* _tmp19_;
	GearyTimeoutManager* _tmp20_;
	ApplicationController* _tmp21_;
	ApplicationController* _tmp22_;
	ComponentsInfoBar* _tmp32_;
	ComponentsInfoBar* _tmp33_;
	ComponentsInfoBar* _tmp34_;
	ComponentsInfoBar* _tmp35_;
	GtkButton* auth_retry = NULL;
	GtkButton* _tmp36_;
	GtkButton* _tmp37_;
	GtkButton* _tmp38_;
	GtkButton* _tmp39_;
	ComponentsInfoBar* _tmp40_;
	GtkBox* _tmp41_;
	GtkBox* _tmp42_;
	GtkButton* _tmp43_;
	ComponentsInfoBar* _tmp44_;
	GtkButton* cert_retry = NULL;
	GtkButton* _tmp45_;
	GtkButton* _tmp46_;
	GtkButton* _tmp47_;
	GtkButton* _tmp48_;
	ComponentsInfoBar* _tmp49_;
	GtkBox* _tmp50_;
	GtkBox* _tmp51_;
	GtkButton* _tmp52_;
	ConversationListView* _tmp53_;
	ComponentsConversationActions** _tmp54_;
	gint _tmp54__length1;
#line 562 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_CLIENT (application), NULL);
#line 562 "../src/client/application/application-main-window.vala"
	_data14_ = g_slice_new0 (Block14Data);
#line 562 "../src/client/application/application-main-window.vala"
	_data14_->_ref_count_ = 1;
#line 562 "../src/client/application/application-main-window.vala"
	_tmp0_ = _g_object_ref0 (application);
#line 562 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data14_->application);
#line 562 "../src/client/application/application-main-window.vala"
	_data14_->application = _tmp0_;
#line 563 "../src/client/application/application-main-window.vala"
	self = (ApplicationMainWindow*) g_object_new (object_type, "application", _data14_->application, "show-menubar", FALSE, NULL);
#line 563 "../src/client/application/application-main-window.vala"
	_data14_->self = g_object_ref (self);
#line 567 "../src/client/application/application-main-window.vala"
	geary_base_interface_base_ref (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_BASE_INTERFACE, GearyBaseInterface));
#line 573 "../src/client/application/application-main-window.vala"
	_tmp1_ = application_client_get_controller (_data14_->application);
#line 573 "../src/client/application/application-main-window.vala"
	_tmp2_ = _tmp1_;
#line 573 "../src/client/application/application-main-window.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 573 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->controller);
#line 573 "../src/client/application/application-main-window.vala"
	self->priv->controller = _tmp3_;
#line 578 "../src/client/application/application-main-window.vala"
	_tmp4_ = gtk_window_group_new ();
#line 578 "../src/client/application/application-main-window.vala"
	group = _tmp4_;
#line 579 "../src/client/application/application-main-window.vala"
	_tmp5_ = group;
#line 579 "../src/client/application/application-main-window.vala"
	gtk_window_group_add_window (_tmp5_, G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow));
#line 581 "../src/client/application/application-main-window.vala"
	_tmp6_ = application_client_get_config (_data14_->application);
#line 581 "../src/client/application/application-main-window.vala"
	_tmp7_ = _tmp6_;
#line 581 "../src/client/application/application-main-window.vala"
	application_main_window_load_config (self, _tmp7_);
#line 582 "../src/client/application/application-main-window.vala"
	application_main_window_restore_saved_window_state (self);
#line 584 "../src/client/application/application-main-window.vala"
	if (g_strcmp0 (_PROFILE, APPLICATION_CLIENT_PROFILE_RELEASE) != 0) {
#line 3739 "application-main-window.c"
		GtkStyleContext* _tmp8_;
#line 585 "../src/client/application/application-main-window.vala"
		_tmp8_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 585 "../src/client/application/application-main-window.vala"
		gtk_style_context_add_class (_tmp8_, "devel");
#line 3745 "application-main-window.c"
	}
#line 588 "../src/client/application/application-main-window.vala"
	_tmp9_ = self->priv->info_bars;
#line 588 "../src/client/application/application-main-window.vala"
	gtk_frame_set_shadow_type (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_frame_get_type (), GtkFrame), GTK_SHADOW_IN);
#line 589 "../src/client/application/application-main-window.vala"
	_tmp10_ = self->priv->_conversation_list_info_bars;
#line 589 "../src/client/application/application-main-window.vala"
	gtk_frame_set_shadow_type (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_frame_get_type (), GtkFrame), GTK_SHADOW_IN);
#line 592 "../src/client/application/application-main-window.vala"
	_tmp11_ = self->priv->edit_actions;
#line 592 "../src/client/application/application-main-window.vala"
	g_action_map_add_action_entries (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, g_action_map_get_type (), GActionMap), APPLICATION_MAIN_WINDOW_EDIT_ACTIONS, (gint) G_N_ELEMENTS (APPLICATION_MAIN_WINDOW_EDIT_ACTIONS), self);
#line 593 "../src/client/application/application-main-window.vala"
	_tmp12_ = self->priv->edit_actions;
#line 593 "../src/client/application/application-main-window.vala"
	gtk_widget_insert_action_group (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), ACTION_EDIT_GROUP_NAME, G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, g_action_group_get_type (), GActionGroup));
#line 596 "../src/client/application/application-main-window.vala"
	g_action_map_add_action_entries (G_TYPE_CHECK_INSTANCE_CAST (self, g_action_map_get_type (), GActionMap), APPLICATION_MAIN_WINDOW_WINDOW_ACTIONS, (gint) G_N_ELEMENTS (APPLICATION_MAIN_WINDOW_WINDOW_ACTIONS), self);
#line 598 "../src/client/application/application-main-window.vala"
	g_signal_connect_data (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "focus-in-event", (GCallback) ___lambda193__gtk_widget_focus_in_event, block14_data_ref (_data14_), (GClosureNotify) block14_data_unref, 0);
#line 602 "../src/client/application/application-main-window.vala"
	g_signal_connect_data (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "focus-out-event", (GCallback) ___lambda194__gtk_widget_focus_out_event, block14_data_ref (_data14_), (GClosureNotify) block14_data_unref, 0);
#line 607 "../src/client/application/application-main-window.vala"
	_tmp13_ = application_client_get_config (_data14_->application);
#line 607 "../src/client/application/application-main-window.vala"
	_tmp14_ = _tmp13_;
#line 607 "../src/client/application/application-main-window.vala"
	application_main_window_setup_layout (self, _tmp14_);
#line 608 "../src/client/application/application-main-window.vala"
	_tmp15_ = self->priv->folder_box;
#line 608 "../src/client/application/application-main-window.vala"
	_tmp16_ = self->priv->_status_bar;
#line 608 "../src/client/application/application-main-window.vala"
	gtk_box_pack_start (_tmp15_, G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_widget_get_type (), GtkWidget), FALSE, FALSE, (guint) 0);
#line 610 "../src/client/application/application-main-window.vala"
	application_main_window_update_command_actions (self);
#line 611 "../src/client/application/application-main-window.vala"
	application_main_window_update_conversation_actions (self, APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_NONE);
#line 613 "../src/client/application/application-main-window.vala"
	_tmp17_ = application_attachment_manager_new (self);
#line 613 "../src/client/application/application-main-window.vala"
	_tmp18_ = _tmp17_;
#line 613 "../src/client/application/application-main-window.vala"
	application_main_window_set_attachments (self, _tmp18_);
#line 613 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp18_);
#line 615 "../src/client/application/application-main-window.vala"
	_tmp19_ = geary_timeout_manager_new_seconds ((guint) APPLICATION_MAIN_WINDOW_UPDATE_UI_INTERVAL, _application_main_window_on_update_ui_timeout_geary_timeout_manager_timeout_func, self);
#line 615 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->update_ui_timeout);
#line 615 "../src/client/application/application-main-window.vala"
	self->priv->update_ui_timeout = _tmp19_;
#line 618 "../src/client/application/application-main-window.vala"
	_tmp20_ = self->priv->update_ui_timeout;
#line 618 "../src/client/application/application-main-window.vala"
	_tmp20_->repetition = GEARY_TIMEOUT_MANAGER_REPEAT_FOREVER;
#line 621 "../src/client/application/application-main-window.vala"
	_tmp21_ = self->priv->controller;
#line 621 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, APPLICATION_TYPE_ACCOUNT_INTERFACE, ApplicationAccountInterface), "account-available", (GCallback) _application_main_window_on_account_available_application_account_interface_account_available, self, 0);
#line 624 "../src/client/application/application-main-window.vala"
	_tmp22_ = self->priv->controller;
#line 624 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, APPLICATION_TYPE_ACCOUNT_INTERFACE, ApplicationAccountInterface), "account-unavailable", (GCallback) _application_main_window_on_account_unavailable_application_account_interface_account_unavailable, self, 0);
#line 3811 "application-main-window.c"
	{
		GeeIterator* _context_it = NULL;
		ApplicationController* _tmp23_;
		GeeCollection* _tmp24_;
		GeeCollection* _tmp25_;
		GeeIterator* _tmp26_;
		GeeIterator* _tmp27_;
#line 627 "../src/client/application/application-main-window.vala"
		_tmp23_ = self->priv->controller;
#line 627 "../src/client/application/application-main-window.vala"
		_tmp24_ = application_account_interface_get_account_contexts (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, APPLICATION_TYPE_ACCOUNT_INTERFACE, ApplicationAccountInterface));
#line 627 "../src/client/application/application-main-window.vala"
		_tmp25_ = _tmp24_;
#line 627 "../src/client/application/application-main-window.vala"
		_tmp26_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, GEE_TYPE_ITERABLE, GeeIterable));
#line 627 "../src/client/application/application-main-window.vala"
		_tmp27_ = _tmp26_;
#line 627 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp25_);
#line 627 "../src/client/application/application-main-window.vala"
		_context_it = _tmp27_;
#line 627 "../src/client/application/application-main-window.vala"
		while (TRUE) {
#line 3835 "application-main-window.c"
			GeeIterator* _tmp28_;
			ApplicationAccountContext* context = NULL;
			GeeIterator* _tmp29_;
			gpointer _tmp30_;
			ApplicationAccountContext* _tmp31_;
#line 627 "../src/client/application/application-main-window.vala"
			_tmp28_ = _context_it;
#line 627 "../src/client/application/application-main-window.vala"
			if (!gee_iterator_next (_tmp28_)) {
#line 627 "../src/client/application/application-main-window.vala"
				break;
#line 3847 "application-main-window.c"
			}
#line 627 "../src/client/application/application-main-window.vala"
			_tmp29_ = _context_it;
#line 627 "../src/client/application/application-main-window.vala"
			_tmp30_ = gee_iterator_get (_tmp29_);
#line 627 "../src/client/application/application-main-window.vala"
			context = (ApplicationAccountContext*) _tmp30_;
#line 629 "../src/client/application/application-main-window.vala"
			_tmp31_ = context;
#line 629 "../src/client/application/application-main-window.vala"
			application_main_window_add_account (self, _tmp31_);
#line 627 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (context);
#line 3861 "application-main-window.c"
		}
#line 627 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_context_it);
#line 3865 "application-main-window.c"
	}
#line 632 "../src/client/application/application-main-window.vala"
	_tmp32_ = components_info_bar_new (_ ("Working offline"), _ ("You will not be able to send or receive email until re-connected."));
#line 632 "../src/client/application/application-main-window.vala"
	g_object_ref_sink (_tmp32_);
#line 632 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->offline_infobar);
#line 632 "../src/client/application/application-main-window.vala"
	self->priv->offline_infobar = _tmp32_;
#line 638 "../src/client/application/application-main-window.vala"
	_tmp33_ = self->priv->offline_infobar;
#line 638 "../src/client/application/application-main-window.vala"
	components_info_bar_set_show_close_button (_tmp33_, TRUE);
#line 639 "../src/client/application/application-main-window.vala"
	_tmp34_ = self->priv->offline_infobar;
#line 639 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_tmp34_, "response", (GCallback) _application_main_window_on_offline_infobar_response_components_info_bar_response, self, 0);
#line 641 "../src/client/application/application-main-window.vala"
	_tmp35_ = components_info_bar_new (_ ("Login problem"), _ ("An account has reported an incorrect login or password."));
#line 641 "../src/client/application/application-main-window.vala"
	g_object_ref_sink (_tmp35_);
#line 641 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->auth_problem_infobar);
#line 641 "../src/client/application/application-main-window.vala"
	self->priv->auth_problem_infobar = _tmp35_;
#line 648 "../src/client/application/application-main-window.vala"
	_tmp36_ = (GtkButton*) gtk_button_new_with_label (_ ("Login"));
#line 648 "../src/client/application/application-main-window.vala"
	g_object_ref_sink (_tmp36_);
#line 648 "../src/client/application/application-main-window.vala"
	auth_retry = _tmp36_;
#line 649 "../src/client/application/application-main-window.vala"
	_tmp37_ = auth_retry;
#line 649 "../src/client/application/application-main-window.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, gtk_widget_get_type (), GtkWidget));
#line 651 "../src/client/application/application-main-window.vala"
	_tmp38_ = auth_retry;
#line 651 "../src/client/application/application-main-window.vala"
	gtk_widget_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, gtk_widget_get_type (), GtkWidget), _ ("Retry login, you will be prompted for your password"));
#line 654 "../src/client/application/application-main-window.vala"
	_tmp39_ = auth_retry;
#line 654 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_tmp39_, "clicked", (GCallback) _application_main_window_on_auth_problem_retry_gtk_button_clicked, self, 0);
#line 655 "../src/client/application/application-main-window.vala"
	_tmp40_ = self->priv->auth_problem_infobar;
#line 655 "../src/client/application/application-main-window.vala"
	_tmp41_ = components_info_bar_get_action_area (_tmp40_);
#line 655 "../src/client/application/application-main-window.vala"
	_tmp42_ = _tmp41_;
#line 655 "../src/client/application/application-main-window.vala"
	_tmp43_ = auth_retry;
#line 655 "../src/client/application/application-main-window.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp43_, gtk_widget_get_type (), GtkWidget));
#line 655 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp42_);
#line 657 "../src/client/application/application-main-window.vala"
	_tmp44_ = components_info_bar_new (_ ("Security problem"), _ ("An account has reported an untrusted server."));
#line 657 "../src/client/application/application-main-window.vala"
	g_object_ref_sink (_tmp44_);
#line 657 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->cert_problem_infobar);
#line 657 "../src/client/application/application-main-window.vala"
	self->priv->cert_problem_infobar = _tmp44_;
#line 664 "../src/client/application/application-main-window.vala"
	_tmp45_ = (GtkButton*) gtk_button_new_with_label (_ ("Check"));
#line 664 "../src/client/application/application-main-window.vala"
	g_object_ref_sink (_tmp45_);
#line 664 "../src/client/application/application-main-window.vala"
	cert_retry = _tmp45_;
#line 665 "../src/client/application/application-main-window.vala"
	_tmp46_ = cert_retry;
#line 665 "../src/client/application/application-main-window.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, gtk_widget_get_type (), GtkWidget));
#line 667 "../src/client/application/application-main-window.vala"
	_tmp47_ = cert_retry;
#line 667 "../src/client/application/application-main-window.vala"
	gtk_widget_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, gtk_widget_get_type (), GtkWidget), _ ("Check the security details for the connection"));
#line 670 "../src/client/application/application-main-window.vala"
	_tmp48_ = cert_retry;
#line 670 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_tmp48_, "clicked", (GCallback) _application_main_window_on_cert_problem_retry_gtk_button_clicked, self, 0);
#line 671 "../src/client/application/application-main-window.vala"
	_tmp49_ = self->priv->cert_problem_infobar;
#line 671 "../src/client/application/application-main-window.vala"
	_tmp50_ = components_info_bar_get_action_area (_tmp49_);
#line 671 "../src/client/application/application-main-window.vala"
	_tmp51_ = _tmp50_;
#line 671 "../src/client/application/application-main-window.vala"
	_tmp52_ = cert_retry;
#line 671 "../src/client/application/application-main-window.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp51_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, gtk_widget_get_type (), GtkWidget));
#line 671 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp51_);
#line 673 "../src/client/application/application-main-window.vala"
	_tmp53_ = self->priv->_conversation_list_view;
#line 673 "../src/client/application/application-main-window.vala"
	gtk_widget_grab_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp53_, gtk_widget_get_type (), GtkWidget));
#line 675 "../src/client/application/application-main-window.vala"
	_tmp54_ = self->priv->folder_conversation_actions;
#line 675 "../src/client/application/application-main-window.vala"
	_tmp54__length1 = self->priv->folder_conversation_actions_length1;
#line 3967 "application-main-window.c"
	{
		ComponentsConversationActions** actions_collection = NULL;
		gint actions_collection_length1 = 0;
		gint _actions_collection_size_ = 0;
		gint actions_it = 0;
#line 675 "../src/client/application/application-main-window.vala"
		actions_collection = _tmp54_;
#line 675 "../src/client/application/application-main-window.vala"
		actions_collection_length1 = _tmp54__length1;
#line 675 "../src/client/application/application-main-window.vala"
		for (actions_it = 0; actions_it < actions_collection_length1; actions_it = actions_it + 1) {
#line 3979 "application-main-window.c"
			ComponentsConversationActions* _tmp55_;
			ComponentsConversationActions* actions = NULL;
#line 675 "../src/client/application/application-main-window.vala"
			_tmp55_ = _g_object_ref0 (actions_collection[actions_it]);
#line 675 "../src/client/application/application-main-window.vala"
			actions = _tmp55_;
#line 3986 "application-main-window.c"
			{
				ComponentsConversationActions* _tmp56_;
#line 676 "../src/client/application/application-main-window.vala"
				_tmp56_ = actions;
#line 676 "../src/client/application/application-main-window.vala"
				g_signal_connect_object (_tmp56_, "mark-message-button-toggled", (GCallback) _application_main_window_on_show_mark_menu_components_conversation_actions_mark_message_button_toggled, self, 0);
#line 675 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (actions);
#line 3995 "application-main-window.c"
			}
		}
	}
#line 562 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (cert_retry);
#line 562 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (auth_retry);
#line 562 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (group);
#line 562 "../src/client/application/application-main-window.vala"
	block14_data_unref (_data14_);
#line 562 "../src/client/application/application-main-window.vala"
	_data14_ = NULL;
#line 562 "../src/client/application/application-main-window.vala"
	return self;
#line 4011 "application-main-window.c"
}

ApplicationMainWindow*
application_main_window_new (ApplicationClient* application)
{
#line 562 "../src/client/application/application-main-window.vala"
	return application_main_window_construct (APPLICATION_TYPE_MAIN_WINDOW, application);
#line 4019 "application-main-window.c"
}

/** {@inheritDoc} */
static void
application_main_window_real_destroy (GtkWidget* base)
{
	ApplicationMainWindow * self;
	ApplicationClient* _tmp0_;
	ApplicationClient* _tmp1_;
	GearyTimeoutManager* _tmp6_;
#line 685 "../src/client/application/application-main-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, APPLICATION_TYPE_MAIN_WINDOW, ApplicationMainWindow);
#line 686 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_application (self);
#line 686 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 686 "../src/client/application/application-main-window.vala"
	if (_tmp1_ != NULL) {
#line 4038 "application-main-window.c"
		ApplicationController* _tmp2_;
		guint _tmp3_;
		ApplicationController* _tmp4_;
		guint _tmp5_;
#line 687 "../src/client/application/application-main-window.vala"
		_tmp2_ = self->priv->controller;
#line 687 "../src/client/application/application-main-window.vala"
		g_signal_parse_name ("account-available", APPLICATION_TYPE_ACCOUNT_INTERFACE, &_tmp3_, NULL, FALSE);
#line 687 "../src/client/application/application-main-window.vala"
		g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, APPLICATION_TYPE_ACCOUNT_INTERFACE, ApplicationAccountInterface), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _application_main_window_on_account_available_application_account_interface_account_available, self);
#line 690 "../src/client/application/application-main-window.vala"
		_tmp4_ = self->priv->controller;
#line 690 "../src/client/application/application-main-window.vala"
		g_signal_parse_name ("account-unavailable", APPLICATION_TYPE_ACCOUNT_INTERFACE, &_tmp5_, NULL, FALSE);
#line 690 "../src/client/application/application-main-window.vala"
		g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, APPLICATION_TYPE_ACCOUNT_INTERFACE, ApplicationAccountInterface), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _application_main_window_on_account_unavailable_application_account_interface_account_unavailable, self);
#line 4055 "application-main-window.c"
	}
#line 694 "../src/client/application/application-main-window.vala"
	_tmp6_ = self->priv->update_ui_timeout;
#line 694 "../src/client/application/application-main-window.vala"
	geary_timeout_manager_reset (_tmp6_);
#line 695 "../src/client/application/application-main-window.vala"
	GTK_WIDGET_CLASS (application_main_window_parent_class)->destroy (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, hdy_application_window_get_type (), HdyApplicationWindow), gtk_widget_get_type (), GtkWidget));
#line 4063 "application-main-window.c"
}

/** Updates the window's title and headerbar titles. */
void
application_main_window_update_title (ApplicationMainWindow* self)
{
	ApplicationAccountContext* account = NULL;
	ApplicationAccountContext* _tmp0_;
	ApplicationFolderContext* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	ApplicationAccountContext* _tmp3_;
	ApplicationFolderContext* folder = NULL;
	ApplicationFolderContext* _tmp8_;
	gchar* title = NULL;
	gchar* _tmp9_;
	gchar* account_name = NULL;
	gchar* folder_name = NULL;
	gboolean _tmp10_ = FALSE;
	ApplicationAccountContext* _tmp11_;
	const gchar* _tmp28_;
	const gchar* _tmp29_ = NULL;
	const gchar* _tmp30_;
	ComponentsMainToolbar* _tmp31_;
	const gchar* _tmp32_ = NULL;
	const gchar* _tmp33_;
	ComponentsMainToolbar* _tmp34_;
#line 699 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 700 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_selected_account_context (self);
#line 700 "../src/client/application/application-main-window.vala"
	account = _tmp0_;
#line 702 "../src/client/application/application-main-window.vala"
	_tmp3_ = account;
#line 702 "../src/client/application/application-main-window.vala"
	if (_tmp3_ != NULL) {
#line 4100 "application-main-window.c"
		GearyFolder* _tmp4_;
#line 702 "../src/client/application/application-main-window.vala"
		_tmp4_ = self->priv->_selected_folder;
#line 702 "../src/client/application/application-main-window.vala"
		_tmp2_ = _tmp4_ != NULL;
#line 4106 "application-main-window.c"
	} else {
#line 702 "../src/client/application/application-main-window.vala"
		_tmp2_ = FALSE;
#line 4110 "application-main-window.c"
	}
#line 701 "../src/client/application/application-main-window.vala"
	if (_tmp2_) {
#line 4114 "application-main-window.c"
		ApplicationAccountContext* _tmp5_;
		GearyFolder* _tmp6_;
		ApplicationFolderContext* _tmp7_;
#line 703 "../src/client/application/application-main-window.vala"
		_tmp5_ = account;
#line 703 "../src/client/application/application-main-window.vala"
		_tmp6_ = self->priv->_selected_folder;
#line 703 "../src/client/application/application-main-window.vala"
		_tmp7_ = application_account_context_get_folder (_tmp5_, _tmp6_);
#line 703 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp1_);
#line 703 "../src/client/application/application-main-window.vala"
		_tmp1_ = _tmp7_;
#line 4128 "application-main-window.c"
	} else {
#line 704 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp1_);
#line 704 "../src/client/application/application-main-window.vala"
		_tmp1_ = NULL;
#line 4134 "application-main-window.c"
	}
#line 701 "../src/client/application/application-main-window.vala"
	_tmp8_ = _g_object_ref0 (_tmp1_);
#line 701 "../src/client/application/application-main-window.vala"
	folder = _tmp8_;
#line 706 "../src/client/application/application-main-window.vala"
	_tmp9_ = g_strdup (_ ("Geary"));
#line 706 "../src/client/application/application-main-window.vala"
	title = _tmp9_;
#line 707 "../src/client/application/application-main-window.vala"
	account_name = NULL;
#line 708 "../src/client/application/application-main-window.vala"
	folder_name = NULL;
#line 709 "../src/client/application/application-main-window.vala"
	_tmp11_ = account;
#line 709 "../src/client/application/application-main-window.vala"
	if (_tmp11_ != NULL) {
#line 4152 "application-main-window.c"
		ApplicationFolderContext* _tmp12_;
#line 709 "../src/client/application/application-main-window.vala"
		_tmp12_ = folder;
#line 709 "../src/client/application/application-main-window.vala"
		_tmp10_ = _tmp12_ != NULL;
#line 4158 "application-main-window.c"
	} else {
#line 709 "../src/client/application/application-main-window.vala"
		_tmp10_ = FALSE;
#line 4162 "application-main-window.c"
	}
#line 709 "../src/client/application/application-main-window.vala"
	if (_tmp10_) {
#line 4166 "application-main-window.c"
		ApplicationAccountContext* _tmp13_;
		GearyAccount* _tmp14_;
		GearyAccount* _tmp15_;
		GearyAccountInformation* _tmp16_;
		GearyAccountInformation* _tmp17_;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		ApplicationFolderContext* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		gchar* _tmp27_;
#line 710 "../src/client/application/application-main-window.vala"
		_tmp13_ = account;
#line 710 "../src/client/application/application-main-window.vala"
		_tmp14_ = application_account_context_get_account (_tmp13_);
#line 710 "../src/client/application/application-main-window.vala"
		_tmp15_ = _tmp14_;
#line 710 "../src/client/application/application-main-window.vala"
		_tmp16_ = geary_account_get_information (_tmp15_);
#line 710 "../src/client/application/application-main-window.vala"
		_tmp17_ = _tmp16_;
#line 710 "../src/client/application/application-main-window.vala"
		_tmp18_ = geary_account_information_get_display_name (_tmp17_);
#line 710 "../src/client/application/application-main-window.vala"
		_tmp19_ = _tmp18_;
#line 710 "../src/client/application/application-main-window.vala"
		_tmp20_ = g_strdup (_tmp19_);
#line 710 "../src/client/application/application-main-window.vala"
		_g_free0 (account_name);
#line 710 "../src/client/application/application-main-window.vala"
		account_name = _tmp20_;
#line 711 "../src/client/application/application-main-window.vala"
		_tmp21_ = folder;
#line 711 "../src/client/application/application-main-window.vala"
		_tmp22_ = application_folder_context_get_display_name (_tmp21_);
#line 711 "../src/client/application/application-main-window.vala"
		_tmp23_ = _tmp22_;
#line 711 "../src/client/application/application-main-window.vala"
		_tmp24_ = g_strdup (_tmp23_);
#line 711 "../src/client/application/application-main-window.vala"
		_g_free0 (folder_name);
#line 711 "../src/client/application/application-main-window.vala"
		folder_name = _tmp24_;
#line 715 "../src/client/application/application-main-window.vala"
		_tmp25_ = folder_name;
#line 715 "../src/client/application/application-main-window.vala"
		_tmp26_ = account_name;
#line 715 "../src/client/application/application-main-window.vala"
		_tmp27_ = g_strdup_printf (_ ("%s — %s"), _tmp25_, _tmp26_);
#line 715 "../src/client/application/application-main-window.vala"
		_g_free0 (title);
#line 715 "../src/client/application/application-main-window.vala"
		title = _tmp27_;
#line 4224 "application-main-window.c"
	}
#line 717 "../src/client/application/application-main-window.vala"
	_tmp28_ = title;
#line 717 "../src/client/application/application-main-window.vala"
	gtk_window_set_title (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), _tmp28_);
#line 718 "../src/client/application/application-main-window.vala"
	_tmp30_ = account_name;
#line 718 "../src/client/application/application-main-window.vala"
	_tmp29_ = _tmp30_;
#line 718 "../src/client/application/application-main-window.vala"
	if (_tmp29_ == NULL) {
#line 718 "../src/client/application/application-main-window.vala"
		_tmp29_ = "";
#line 4238 "application-main-window.c"
	}
#line 718 "../src/client/application/application-main-window.vala"
	_tmp31_ = self->priv->_main_toolbar;
#line 718 "../src/client/application/application-main-window.vala"
	components_main_toolbar_set_account (_tmp31_, _tmp29_);
#line 719 "../src/client/application/application-main-window.vala"
	_tmp33_ = folder_name;
#line 719 "../src/client/application/application-main-window.vala"
	_tmp32_ = _tmp33_;
#line 719 "../src/client/application/application-main-window.vala"
	if (_tmp32_ == NULL) {
#line 719 "../src/client/application/application-main-window.vala"
		_tmp32_ = "";
#line 4252 "application-main-window.c"
	}
#line 719 "../src/client/application/application-main-window.vala"
	_tmp34_ = self->priv->_main_toolbar;
#line 719 "../src/client/application/application-main-window.vala"
	components_main_toolbar_set_folder (_tmp34_, _tmp32_);
#line 699 "../src/client/application/application-main-window.vala"
	_g_free0 (folder_name);
#line 699 "../src/client/application/application-main-window.vala"
	_g_free0 (account_name);
#line 699 "../src/client/application/application-main-window.vala"
	_g_free0 (title);
#line 699 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (folder);
#line 699 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp1_);
#line 699 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (account);
#line 4270 "application-main-window.c"
}

/** Updates the window's account status info bars. */
static void
_application_main_window_on_service_problem_retry_components_problem_report_info_bar_retry (ComponentsProblemReportInfoBar* _sender,
                                                                                            gpointer self)
{
#line 748 "../src/client/application/application-main-window.vala"
	application_main_window_on_service_problem_retry ((ApplicationMainWindow*) self);
#line 4280 "application-main-window.c"
}

void
application_main_window_update_account_status (ApplicationMainWindow* self,
                                               GearyAccountStatus status,
                                               gboolean has_auth_error,
                                               gboolean has_cert_error,
                                               GearyAccount* problem_source)
{
#line 723 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 723 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((problem_source == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (problem_source, GEARY_TYPE_ACCOUNT));
#line 733 "../src/client/application/application-main-window.vala"
	if (!geary_account_status_is_online (status)) {
#line 4296 "application-main-window.c"
		ComponentsInfoBarStack* _tmp0_;
		ComponentsInfoBar* _tmp1_;
#line 734 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->info_bars;
#line 734 "../src/client/application/application-main-window.vala"
		_tmp1_ = self->priv->offline_infobar;
#line 734 "../src/client/application/application-main-window.vala"
		components_info_bar_stack_add (_tmp0_, _tmp1_);
#line 4305 "application-main-window.c"
	} else {
#line 735 "../src/client/application/application-main-window.vala"
		if (geary_account_status_has_service_problem (status)) {
#line 4309 "application-main-window.c"
			GearyClientService* _tmp2_ = NULL;
			GearyClientService* _tmp3_;
			GearyClientService* _tmp4_;
			GearyErrorContext* _tmp5_;
			GearyErrorContext* _tmp6_;
			GearyClientService* service = NULL;
			GearyClientService* _tmp11_;
			GearyAccountInformation* _tmp12_;
			GearyAccountInformation* _tmp13_;
			GearyClientService* _tmp14_;
			GearyServiceInformation* _tmp15_;
			GearyServiceInformation* _tmp16_;
			GearyClientService* _tmp17_;
			GearyErrorContext* _tmp18_;
			GearyErrorContext* _tmp19_;
			GError* _tmp20_;
			GError* _tmp21_;
			GearyServiceProblemReport* _tmp22_;
			GearyServiceProblemReport* _tmp23_;
			ComponentsProblemReportInfoBar* _tmp24_;
			ComponentsProblemReportInfoBar* _tmp25_;
			ComponentsInfoBarStack* _tmp26_;
			ComponentsProblemReportInfoBar* _tmp27_;
#line 736 "../src/client/application/application-main-window.vala"
			_tmp3_ = geary_account_get_incoming (problem_source);
#line 736 "../src/client/application/application-main-window.vala"
			_tmp4_ = _tmp3_;
#line 736 "../src/client/application/application-main-window.vala"
			_tmp5_ = geary_client_service_get_last_error (_tmp4_);
#line 736 "../src/client/application/application-main-window.vala"
			_tmp6_ = _tmp5_;
#line 736 "../src/client/application/application-main-window.vala"
			if (_tmp6_ != NULL) {
#line 4343 "application-main-window.c"
				GearyClientService* _tmp7_;
				GearyClientService* _tmp8_;
#line 738 "../src/client/application/application-main-window.vala"
				_tmp7_ = geary_account_get_incoming (problem_source);
#line 738 "../src/client/application/application-main-window.vala"
				_tmp8_ = _tmp7_;
#line 738 "../src/client/application/application-main-window.vala"
				_tmp2_ = _tmp8_;
#line 4352 "application-main-window.c"
			} else {
				GearyClientService* _tmp9_;
				GearyClientService* _tmp10_;
#line 739 "../src/client/application/application-main-window.vala"
				_tmp9_ = geary_account_get_outgoing (problem_source);
#line 739 "../src/client/application/application-main-window.vala"
				_tmp10_ = _tmp9_;
#line 739 "../src/client/application/application-main-window.vala"
				_tmp2_ = _tmp10_;
#line 4362 "application-main-window.c"
			}
#line 736 "../src/client/application/application-main-window.vala"
			_tmp11_ = _g_object_ref0 (_tmp2_);
#line 736 "../src/client/application/application-main-window.vala"
			service = _tmp11_;
#line 741 "../src/client/application/application-main-window.vala"
			_tmp12_ = geary_account_get_information (problem_source);
#line 741 "../src/client/application/application-main-window.vala"
			_tmp13_ = _tmp12_;
#line 741 "../src/client/application/application-main-window.vala"
			_tmp14_ = service;
#line 741 "../src/client/application/application-main-window.vala"
			_tmp15_ = geary_client_service_get_configuration (_tmp14_);
#line 741 "../src/client/application/application-main-window.vala"
			_tmp16_ = _tmp15_;
#line 741 "../src/client/application/application-main-window.vala"
			_tmp17_ = service;
#line 741 "../src/client/application/application-main-window.vala"
			_tmp18_ = geary_client_service_get_last_error (_tmp17_);
#line 741 "../src/client/application/application-main-window.vala"
			_tmp19_ = _tmp18_;
#line 741 "../src/client/application/application-main-window.vala"
			_tmp20_ = geary_error_context_get_thrown (_tmp19_);
#line 741 "../src/client/application/application-main-window.vala"
			_tmp21_ = _tmp20_;
#line 741 "../src/client/application/application-main-window.vala"
			_tmp22_ = geary_service_problem_report_new (_tmp13_, _tmp16_, _tmp21_);
#line 741 "../src/client/application/application-main-window.vala"
			_tmp23_ = _tmp22_;
#line 741 "../src/client/application/application-main-window.vala"
			_tmp24_ = components_problem_report_info_bar_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEARY_TYPE_PROBLEM_REPORT, GearyProblemReport));
#line 741 "../src/client/application/application-main-window.vala"
			g_object_ref_sink (_tmp24_);
#line 741 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (self->priv->service_problem_infobar);
#line 741 "../src/client/application/application-main-window.vala"
			self->priv->service_problem_infobar = _tmp24_;
#line 741 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (_tmp23_);
#line 748 "../src/client/application/application-main-window.vala"
			_tmp25_ = self->priv->service_problem_infobar;
#line 748 "../src/client/application/application-main-window.vala"
			g_signal_connect_object (_tmp25_, "retry", (GCallback) _application_main_window_on_service_problem_retry_components_problem_report_info_bar_retry, self, 0);
#line 749 "../src/client/application/application-main-window.vala"
			_tmp26_ = self->priv->info_bars;
#line 749 "../src/client/application/application-main-window.vala"
			_tmp27_ = self->priv->service_problem_infobar;
#line 749 "../src/client/application/application-main-window.vala"
			components_info_bar_stack_add (_tmp26_, G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, COMPONENTS_TYPE_INFO_BAR, ComponentsInfoBar));
#line 735 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (service);
#line 4414 "application-main-window.c"
		} else {
#line 750 "../src/client/application/application-main-window.vala"
			if (has_cert_error) {
#line 4418 "application-main-window.c"
				ComponentsInfoBarStack* _tmp28_;
				ComponentsInfoBar* _tmp29_;
#line 751 "../src/client/application/application-main-window.vala"
				_tmp28_ = self->priv->info_bars;
#line 751 "../src/client/application/application-main-window.vala"
				_tmp29_ = self->priv->cert_problem_infobar;
#line 751 "../src/client/application/application-main-window.vala"
				components_info_bar_stack_add (_tmp28_, _tmp29_);
#line 4427 "application-main-window.c"
			} else {
#line 752 "../src/client/application/application-main-window.vala"
				if (has_auth_error) {
#line 4431 "application-main-window.c"
					ComponentsInfoBarStack* _tmp30_;
					ComponentsInfoBar* _tmp31_;
#line 753 "../src/client/application/application-main-window.vala"
					_tmp30_ = self->priv->info_bars;
#line 753 "../src/client/application/application-main-window.vala"
					_tmp31_ = self->priv->auth_problem_infobar;
#line 753 "../src/client/application/application-main-window.vala"
					components_info_bar_stack_add (_tmp30_, _tmp31_);
#line 4440 "application-main-window.c"
				} else {
					ComponentsInfoBarStack* _tmp32_;
#line 755 "../src/client/application/application-main-window.vala"
					_tmp32_ = self->priv->info_bars;
#line 755 "../src/client/application/application-main-window.vala"
					components_info_bar_stack_remove_all (_tmp32_);
#line 4447 "application-main-window.c"
				}
			}
		}
	}
}

static void
application_main_window_select_folder_data_free (gpointer _data)
{
	ApplicationMainWindowSelectFolderData* _data_;
	_data_ = _data;
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->to_select);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/client/application/application-main-window.vala"
	g_slice_free (ApplicationMainWindowSelectFolderData, _data_);
#line 4465 "application-main-window.c"
}

void
application_main_window_select_folder (ApplicationMainWindow* self,
                                       GearyFolder* to_select,
                                       gboolean is_interactive,
                                       gboolean inhibit_autoselect,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	ApplicationMainWindowSelectFolderData* _data_;
	ApplicationMainWindow* _tmp0_;
	GearyFolder* _tmp1_;
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((to_select == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (to_select, GEARY_TYPE_FOLDER));
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_slice_new0 (ApplicationMainWindowSelectFolderData);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 10 "../src/client/application/application-main-window.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_main_window_select_folder_data_free);
#line 10 "../src/client/application/application-main-window.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->self = _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (to_select);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->to_select);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->to_select = _tmp1_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_->is_interactive = is_interactive;
#line 10 "../src/client/application/application-main-window.vala"
	_data_->inhibit_autoselect = inhibit_autoselect;
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_select_folder_co (_data_);
#line 4505 "application-main-window.c"
}

void
application_main_window_select_folder_finish (ApplicationMainWindow* self,
                                              GAsyncResult* _res_)
{
	ApplicationMainWindowSelectFolderData* _data_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 4515 "application-main-window.c"
}

/**
     * Selects and open the given folder.
     *
     * If is_interactive is true, the selection is treated as being
     * caused directly by human request (e.g. clicking on a folder in
     * the folder list), as opposed to some side effect.
     */
static void
_application_main_window_update_headerbar_g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self)
{
#line 783 "../src/client/application/application-main-window.vala"
	application_main_window_update_headerbar ((ApplicationMainWindow*) self);
#line 4532 "application-main-window.c"
}

static void
application_main_window_select_folder_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_)
{
	ApplicationMainWindowSelectFolderData* _data_;
#line 865 "../src/client/application/application-main-window.vala"
	_data_ = _user_data_;
#line 865 "../src/client/application/application-main-window.vala"
	_data_->_source_object_ = source_object;
#line 865 "../src/client/application/application-main-window.vala"
	_data_->_res_ = _res_;
#line 865 "../src/client/application/application-main-window.vala"
	application_main_window_select_folder_co (_data_);
#line 4549 "application-main-window.c"
}

static gboolean
application_main_window_select_folder_co (ApplicationMainWindowSelectFolderData* _data_)
{
#line 766 "../src/client/application/application-main-window.vala"
	switch (_data_->_state_) {
#line 766 "../src/client/application/application-main-window.vala"
		case 0:
#line 4559 "application-main-window.c"
		goto _state_0;
#line 766 "../src/client/application/application-main-window.vala"
		case 1:
#line 4563 "application-main-window.c"
		goto _state_1;
#line 766 "../src/client/application/application-main-window.vala"
		case 2:
#line 4567 "application-main-window.c"
		goto _state_2;
		default:
#line 766 "../src/client/application/application-main-window.vala"
		g_assert_not_reached ();
#line 4572 "application-main-window.c"
	}
	_state_0:
#line 769 "../src/client/application/application-main-window.vala"
	_data_->_tmp0_ = _data_->self->priv->_selected_folder;
#line 769 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp0_ != _data_->to_select) {
#line 771 "../src/client/application/application-main-window.vala"
		_data_->_tmp1_ = _data_->self->priv->folder_open;
#line 771 "../src/client/application/application-main-window.vala"
		g_cancellable_cancel (_data_->_tmp1_);
#line 772 "../src/client/application/application-main-window.vala"
		_data_->_tmp2_ = g_cancellable_new ();
#line 772 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data_->self->priv->folder_open);
#line 772 "../src/client/application/application-main-window.vala"
		_data_->self->priv->folder_open = _data_->_tmp2_;
#line 772 "../src/client/application/application-main-window.vala"
		_data_->_tmp3_ = _data_->self->priv->folder_open;
#line 772 "../src/client/application/application-main-window.vala"
		_data_->_tmp4_ = _g_object_ref0 (_data_->_tmp3_);
#line 772 "../src/client/application/application-main-window.vala"
		_data_->cancellable = _data_->_tmp4_;
#line 777 "../src/client/application/application-main-window.vala"
		_data_->_tmp5_ = _data_->self->priv->_selected_folder;
#line 777 "../src/client/application/application-main-window.vala"
		if (_data_->_tmp5_ != NULL) {
#line 778 "../src/client/application/application-main-window.vala"
			_data_->_tmp6_ = _data_->self->priv->folder_popovers;
#line 778 "../src/client/application/application-main-window.vala"
			_data_->_tmp6__length1 = _data_->self->priv->folder_popovers_length1;
#line 4603 "application-main-window.c"
			{
#line 778 "../src/client/application/application-main-window.vala"
				_data_->menu_collection_length1 = 0;
#line 778 "../src/client/application/application-main-window.vala"
				_data_->_menu_collection_size_ = 0;
#line 778 "../src/client/application/application-main-window.vala"
				_data_->menu_collection = _data_->_tmp6_;
#line 778 "../src/client/application/application-main-window.vala"
				_data_->menu_collection_length1 = _data_->_tmp6__length1;
#line 778 "../src/client/application/application-main-window.vala"
				for (_data_->menu_it = 0; _data_->menu_it < _data_->menu_collection_length1; _data_->menu_it = _data_->menu_it + 1) {
#line 778 "../src/client/application/application-main-window.vala"
					_data_->_tmp7_ = _g_object_ref0 (_data_->menu_collection[_data_->menu_it]);
#line 778 "../src/client/application/application-main-window.vala"
					_data_->menu = _data_->_tmp7_;
#line 4619 "application-main-window.c"
					{
#line 779 "../src/client/application/application-main-window.vala"
						_data_->_tmp8_ = _data_->menu;
#line 779 "../src/client/application/application-main-window.vala"
						_data_->_tmp9_ = _data_->self->priv->_selected_folder;
#line 779 "../src/client/application/application-main-window.vala"
						folder_popover_enable_disable_folder (_data_->_tmp8_, _data_->_tmp9_, TRUE);
#line 778 "../src/client/application/application-main-window.vala"
						_g_object_unref0 (_data_->menu);
#line 4629 "application-main-window.c"
					}
				}
			}
#line 782 "../src/client/application/application-main-window.vala"
			_data_->_tmp10_ = _data_->self->priv->progress_monitor;
#line 782 "../src/client/application/application-main-window.vala"
			_data_->_tmp11_ = _data_->self->priv->_selected_folder;
#line 782 "../src/client/application/application-main-window.vala"
			_data_->_tmp12_ = geary_folder_get_opening_monitor (_data_->_tmp11_);
#line 782 "../src/client/application/application-main-window.vala"
			_data_->_tmp13_ = _data_->_tmp12_;
#line 782 "../src/client/application/application-main-window.vala"
			geary_aggregate_progress_monitor_remove (_data_->_tmp10_, _data_->_tmp13_);
#line 783 "../src/client/application/application-main-window.vala"
			_data_->_tmp14_ = _data_->self->priv->_selected_folder;
#line 783 "../src/client/application/application-main-window.vala"
			_data_->_tmp15_ = geary_folder_get_properties (_data_->_tmp14_);
#line 783 "../src/client/application/application-main-window.vala"
			_data_->_tmp16_ = _data_->_tmp15_;
#line 783 "../src/client/application/application-main-window.vala"
			g_signal_parse_name ("notify", G_TYPE_OBJECT, &_data_->_tmp17_, NULL, FALSE);
#line 783 "../src/client/application/application-main-window.vala"
			g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp16_, G_TYPE_OBJECT, GObject), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _data_->_tmp17_, 0, NULL, (GCallback) _application_main_window_update_headerbar_g_object_notify, _data_->self);
#line 784 "../src/client/application/application-main-window.vala"
			application_main_window_set_selected_folder (_data_->self, NULL);
#line 4655 "application-main-window.c"
		}
#line 786 "../src/client/application/application-main-window.vala"
		_data_->_tmp18_ = _data_->self->priv->_conversations;
#line 786 "../src/client/application/application-main-window.vala"
		if (_data_->_tmp18_ != NULL) {
#line 787 "../src/client/application/application-main-window.vala"
			_data_->_tmp19_ = _data_->self->priv->progress_monitor;
#line 787 "../src/client/application/application-main-window.vala"
			_data_->_tmp20_ = _data_->self->priv->_conversations;
#line 787 "../src/client/application/application-main-window.vala"
			_data_->_tmp21_ = geary_app_conversation_monitor_get_progress_monitor (_data_->_tmp20_);
#line 787 "../src/client/application/application-main-window.vala"
			_data_->_tmp22_ = _data_->_tmp21_;
#line 787 "../src/client/application/application-main-window.vala"
			geary_aggregate_progress_monitor_remove (_data_->_tmp19_, _data_->_tmp22_);
#line 788 "../src/client/application/application-main-window.vala"
			_data_->_tmp23_ = _data_->self->priv->_conversations;
#line 788 "../src/client/application/application-main-window.vala"
			application_main_window_close_conversation_monitor (_data_->self, _data_->_tmp23_);
#line 789 "../src/client/application/application-main-window.vala"
			application_main_window_set_conversations (_data_->self, NULL);
#line 4677 "application-main-window.c"
		}
#line 791 "../src/client/application/application-main-window.vala"
		_data_->_tmp24_ = _data_->self->priv->_conversation_list_view;
#line 791 "../src/client/application/application-main-window.vala"
		_data_->_tmp25_ = conversation_list_view_get_model (_data_->_tmp24_);
#line 791 "../src/client/application/application-main-window.vala"
		_data_->conversations_model = _data_->_tmp25_;
#line 792 "../src/client/application/application-main-window.vala"
		_data_->_tmp26_ = _data_->conversations_model;
#line 792 "../src/client/application/application-main-window.vala"
		if (_data_->_tmp26_ != NULL) {
#line 793 "../src/client/application/application-main-window.vala"
			_data_->_tmp27_ = _data_->self->priv->progress_monitor;
#line 793 "../src/client/application/application-main-window.vala"
			_data_->_tmp28_ = _data_->conversations_model;
#line 793 "../src/client/application/application-main-window.vala"
			_data_->_tmp29_ = conversation_list_store_get_preview_monitor (_data_->_tmp28_);
#line 793 "../src/client/application/application-main-window.vala"
			_data_->_tmp30_ = _data_->_tmp29_;
#line 793 "../src/client/application/application-main-window.vala"
			geary_aggregate_progress_monitor_remove (_data_->_tmp27_, _data_->_tmp30_);
#line 794 "../src/client/application/application-main-window.vala"
			_data_->_tmp31_ = _data_->self->priv->_conversation_list_view;
#line 794 "../src/client/application/application-main-window.vala"
			conversation_list_view_set_model (_data_->_tmp31_, NULL);
#line 4703 "application-main-window.c"
		}
#line 797 "../src/client/application/application-main-window.vala"
		_data_->_tmp32_ = _data_->self->priv->_conversation_list_info_bars;
#line 797 "../src/client/application/application-main-window.vala"
		components_info_bar_stack_remove_all (_data_->_tmp32_);
#line 802 "../src/client/application/application-main-window.vala"
		if (_data_->to_select != NULL) {
#line 802 "../src/client/application/application-main-window.vala"
			_data_->_tmp34_ = geary_folder_get_account (_data_->to_select);
#line 802 "../src/client/application/application-main-window.vala"
			_data_->_tmp35_ = _data_->_tmp34_;
#line 802 "../src/client/application/application-main-window.vala"
			_data_->_tmp33_ = _data_->_tmp35_;
#line 4717 "application-main-window.c"
		} else {
#line 802 "../src/client/application/application-main-window.vala"
			_data_->_tmp33_ = NULL;
#line 4721 "application-main-window.c"
		}
#line 802 "../src/client/application/application-main-window.vala"
		application_main_window_select_account (_data_->self, _data_->_tmp33_);
#line 803 "../src/client/application/application-main-window.vala"
		application_main_window_set_selected_folder (_data_->self, _data_->to_select);
#line 809 "../src/client/application/application-main-window.vala"
		if (_data_->to_select != NULL) {
#line 812 "../src/client/application/application-main-window.vala"
			if (_data_->is_interactive) {
#line 812 "../src/client/application/application-main-window.vala"
				_data_->_tmp36_ = TRUE;
#line 4733 "application-main-window.c"
			} else {
#line 813 "../src/client/application/application-main-window.vala"
				_data_->_tmp38_ = geary_folder_get_used_as (_data_->to_select);
#line 813 "../src/client/application/application-main-window.vala"
				_data_->_tmp39_ = _data_->_tmp38_;
#line 813 "../src/client/application/application-main-window.vala"
				if (_data_->_tmp39_ != GEARY_FOLDER_SPECIAL_USE_INBOX) {
#line 813 "../src/client/application/application-main-window.vala"
					_data_->_tmp37_ = TRUE;
#line 4743 "application-main-window.c"
				} else {
#line 814 "../src/client/application/application-main-window.vala"
					_data_->_tmp40_ = _data_->self->priv->_folder_list;
#line 814 "../src/client/application/application-main-window.vala"
					_data_->_tmp41_ = geary_folder_get_account (_data_->to_select);
#line 814 "../src/client/application/application-main-window.vala"
					_data_->_tmp42_ = _data_->_tmp41_;
#line 814 "../src/client/application/application-main-window.vala"
					_data_->_tmp37_ = !folder_list_tree_select_inbox (_data_->_tmp40_, _data_->_tmp42_);
#line 4753 "application-main-window.c"
				}
#line 813 "../src/client/application/application-main-window.vala"
				_data_->_tmp36_ = _data_->_tmp37_;
#line 4757 "application-main-window.c"
			}
#line 812 "../src/client/application/application-main-window.vala"
			if (_data_->_tmp36_) {
#line 815 "../src/client/application/application-main-window.vala"
				_data_->_tmp43_ = _data_->self->priv->_folder_list;
#line 815 "../src/client/application/application-main-window.vala"
				folder_list_tree_select_folder (_data_->_tmp43_, _data_->to_select);
#line 4765 "application-main-window.c"
			}
		} else {
#line 818 "../src/client/application/application-main-window.vala"
			_data_->_tmp44_ = _data_->self->priv->_folder_list;
#line 818 "../src/client/application/application-main-window.vala"
			folder_list_tree_deselect_folder (_data_->_tmp44_);
#line 4772 "application-main-window.c"
		}
#line 821 "../src/client/application/application-main-window.vala"
		application_main_window_update_title (_data_->self);
#line 822 "../src/client/application/application-main-window.vala"
		application_main_window_update_conversation_actions (_data_->self, APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_NONE);
#line 823 "../src/client/application/application-main-window.vala"
		application_main_window_update_trash_action (_data_->self);
#line 825 "../src/client/application/application-main-window.vala"
		_data_->_tmp45_ = _data_->self->priv->_conversation_viewer;
#line 825 "../src/client/application/application-main-window.vala"
		conversation_viewer_show_loading (_data_->_tmp45_);
#line 826 "../src/client/application/application-main-window.vala"
		_data_->self->priv->previous_selection_was_interactive = _data_->is_interactive;
#line 829 "../src/client/application/application-main-window.vala"
		if (_data_->to_select != NULL) {
#line 829 "../src/client/application/application-main-window.vala"
			_data_->_tmp47_ = geary_logging_source_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->to_select, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 829 "../src/client/application/application-main-window.vala"
			_g_free0 (_data_->_tmp46_);
#line 829 "../src/client/application/application-main-window.vala"
			_data_->_tmp46_ = _data_->_tmp47_;
#line 4794 "application-main-window.c"
		} else {
#line 829 "../src/client/application/application-main-window.vala"
			_data_->_tmp48_ = g_strdup ("(null)");
#line 829 "../src/client/application/application-main-window.vala"
			_g_free0 (_data_->_tmp46_);
#line 829 "../src/client/application/application-main-window.vala"
			_data_->_tmp46_ = _data_->_tmp48_;
#line 4802 "application-main-window.c"
		}
#line 828 "../src/client/application/application-main-window.vala"
		g_debug ("application-main-window.vala:828: Folder selected: %s", _data_->_tmp46_);
#line 834 "../src/client/application/application-main-window.vala"
		if (_data_->to_select != NULL) {
#line 835 "../src/client/application/application-main-window.vala"
			_data_->_tmp49_ = _data_->self->priv->progress_monitor;
#line 835 "../src/client/application/application-main-window.vala"
			_data_->_tmp50_ = geary_folder_get_opening_monitor (_data_->to_select);
#line 835 "../src/client/application/application-main-window.vala"
			_data_->_tmp51_ = _data_->_tmp50_;
#line 835 "../src/client/application/application-main-window.vala"
			geary_aggregate_progress_monitor_add (_data_->_tmp49_, _data_->_tmp51_);
#line 836 "../src/client/application/application-main-window.vala"
			_data_->_tmp52_ = geary_folder_get_properties (_data_->to_select);
#line 836 "../src/client/application/application-main-window.vala"
			_data_->_tmp53_ = _data_->_tmp52_;
#line 836 "../src/client/application/application-main-window.vala"
			g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp53_, G_TYPE_OBJECT, GObject), "notify", (GCallback) _application_main_window_update_headerbar_g_object_notify, _data_->self, 0);
#line 838 "../src/client/application/application-main-window.vala"
			_data_->_tmp54_ = geary_app_conversation_monitor_new (_data_->to_select, (CONVERSATION_LIST_STORE_REQUIRED_FIELDS | CONVERSATION_LIST_BOX_REQUIRED_FIELDS) | CONVERSATION_EMAIL_REQUIRED_FOR_CONSTRUCT, APPLICATION_MAIN_WINDOW_MIN_CONVERSATION_COUNT);
#line 838 "../src/client/application/application-main-window.vala"
			_data_->_tmp55_ = _data_->_tmp54_;
#line 838 "../src/client/application/application-main-window.vala"
			application_main_window_set_conversations (_data_->self, _data_->_tmp55_);
#line 838 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (_data_->_tmp55_);
#line 848 "../src/client/application/application-main-window.vala"
			_data_->_tmp56_ = _data_->self->priv->progress_monitor;
#line 848 "../src/client/application/application-main-window.vala"
			_data_->_tmp57_ = _data_->self->priv->_conversations;
#line 848 "../src/client/application/application-main-window.vala"
			_data_->_tmp58_ = geary_app_conversation_monitor_get_progress_monitor (_data_->_tmp57_);
#line 848 "../src/client/application/application-main-window.vala"
			_data_->_tmp59_ = _data_->_tmp58_;
#line 848 "../src/client/application/application-main-window.vala"
			geary_aggregate_progress_monitor_add (_data_->_tmp56_, _data_->_tmp59_);
#line 850 "../src/client/application/application-main-window.vala"
			_data_->_tmp60_ = _data_->self->priv->_conversations;
#line 850 "../src/client/application/application-main-window.vala"
			_data_->_tmp61_ = application_main_window_get_application (_data_->self);
#line 850 "../src/client/application/application-main-window.vala"
			_data_->_tmp62_ = _data_->_tmp61_;
#line 850 "../src/client/application/application-main-window.vala"
			_data_->_tmp63_ = application_client_get_config (_data_->_tmp62_);
#line 850 "../src/client/application/application-main-window.vala"
			_data_->_tmp64_ = _data_->_tmp63_;
#line 850 "../src/client/application/application-main-window.vala"
			_data_->_tmp65_ = conversation_list_store_new (_data_->_tmp60_, _data_->_tmp64_);
#line 850 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (_data_->conversations_model);
#line 850 "../src/client/application/application-main-window.vala"
			_data_->conversations_model = _data_->_tmp65_;
#line 854 "../src/client/application/application-main-window.vala"
			_data_->_tmp66_ = _data_->self->priv->progress_monitor;
#line 854 "../src/client/application/application-main-window.vala"
			_data_->_tmp67_ = _data_->conversations_model;
#line 854 "../src/client/application/application-main-window.vala"
			_data_->_tmp68_ = conversation_list_store_get_preview_monitor (_data_->_tmp67_);
#line 854 "../src/client/application/application-main-window.vala"
			_data_->_tmp69_ = _data_->_tmp68_;
#line 854 "../src/client/application/application-main-window.vala"
			geary_aggregate_progress_monitor_add (_data_->_tmp66_, _data_->_tmp69_);
#line 855 "../src/client/application/application-main-window.vala"
			if (_data_->inhibit_autoselect) {
#line 856 "../src/client/application/application-main-window.vala"
				_data_->_tmp70_ = _data_->self->priv->_conversation_list_view;
#line 856 "../src/client/application/application-main-window.vala"
				conversation_list_view_inhibit_next_autoselect (_data_->_tmp70_);
#line 4872 "application-main-window.c"
			}
#line 858 "../src/client/application/application-main-window.vala"
			_data_->_tmp71_ = _data_->self->priv->_conversation_list_view;
#line 858 "../src/client/application/application-main-window.vala"
			_data_->_tmp72_ = _data_->conversations_model;
#line 858 "../src/client/application/application-main-window.vala"
			conversation_list_view_set_model (_data_->_tmp71_, _data_->_tmp72_);
#line 861 "../src/client/application/application-main-window.vala"
			_data_->_tmp73_ = _data_->self->priv->folder_popovers;
#line 861 "../src/client/application/application-main-window.vala"
			_data_->_tmp73__length1 = _data_->self->priv->folder_popovers_length1;
#line 4884 "application-main-window.c"
			{
#line 861 "../src/client/application/application-main-window.vala"
				_data_->_vala1_menu_collection_length1 = 0;
#line 861 "../src/client/application/application-main-window.vala"
				_data_->__vala1_menu_collection_size_ = 0;
#line 861 "../src/client/application/application-main-window.vala"
				_data_->_vala1_menu_collection = _data_->_tmp73_;
#line 861 "../src/client/application/application-main-window.vala"
				_data_->_vala1_menu_collection_length1 = _data_->_tmp73__length1;
#line 861 "../src/client/application/application-main-window.vala"
				for (_data_->_vala1_menu_it = 0; _data_->_vala1_menu_it < _data_->_vala1_menu_collection_length1; _data_->_vala1_menu_it = _data_->_vala1_menu_it + 1) {
#line 861 "../src/client/application/application-main-window.vala"
					_data_->_tmp74_ = _g_object_ref0 (_data_->_vala1_menu_collection[_data_->_vala1_menu_it]);
#line 861 "../src/client/application/application-main-window.vala"
					_data_->_vala1_menu = _data_->_tmp74_;
#line 4900 "application-main-window.c"
					{
#line 862 "../src/client/application/application-main-window.vala"
						_data_->_tmp75_ = _data_->_vala1_menu;
#line 862 "../src/client/application/application-main-window.vala"
						folder_popover_enable_disable_folder (_data_->_tmp75_, _data_->to_select, FALSE);
#line 861 "../src/client/application/application-main-window.vala"
						_g_object_unref0 (_data_->_vala1_menu);
#line 4908 "application-main-window.c"
					}
				}
			}
#line 865 "../src/client/application/application-main-window.vala"
			_data_->_tmp76_ = _data_->self->priv->_conversations;
#line 865 "../src/client/application/application-main-window.vala"
			_data_->_tmp77_ = _data_->cancellable;
#line 865 "../src/client/application/application-main-window.vala"
			_data_->_state_ = 1;
#line 865 "../src/client/application/application-main-window.vala"
			application_main_window_open_conversation_monitor (_data_->self, _data_->_tmp76_, _data_->_tmp77_, application_main_window_select_folder_ready, _data_);
#line 865 "../src/client/application/application-main-window.vala"
			return FALSE;
#line 4922 "application-main-window.c"
			_state_1:
#line 865 "../src/client/application/application-main-window.vala"
			application_main_window_open_conversation_monitor_finish (_data_->self, _data_->_res_);
#line 866 "../src/client/application/application-main-window.vala"
			_data_->_tmp78_ = _data_->self->priv->controller;
#line 866 "../src/client/application/application-main-window.vala"
			_data_->_state_ = 2;
#line 866 "../src/client/application/application-main-window.vala"
			application_controller_process_pending_composers (_data_->_tmp78_, application_main_window_select_folder_ready, _data_);
#line 866 "../src/client/application/application-main-window.vala"
			return FALSE;
#line 4934 "application-main-window.c"
			_state_2:
#line 866 "../src/client/application/application-main-window.vala"
			application_controller_process_pending_composers_finish (_data_->_tmp78_, _data_->_res_);
#line 4938 "application-main-window.c"
		}
#line 769 "../src/client/application/application-main-window.vala"
		_g_free0 (_data_->_tmp46_);
#line 769 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data_->conversations_model);
#line 769 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data_->cancellable);
#line 4946 "application-main-window.c"
	}
#line 870 "../src/client/application/application-main-window.vala"
	application_main_window_update_headerbar (_data_->self);
#line 766 "../src/client/application/application-main-window.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 766 "../src/client/application/application-main-window.vala"
	if (_data_->_state_ != 0) {
#line 766 "../src/client/application/application-main-window.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 766 "../src/client/application/application-main-window.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4958 "application-main-window.c"
		}
	}
#line 766 "../src/client/application/application-main-window.vala"
	g_object_unref (_data_->_async_result);
#line 766 "../src/client/application/application-main-window.vala"
	return FALSE;
#line 4965 "application-main-window.c"
}

static void
application_main_window_show_conversations_data_free (gpointer _data)
{
	ApplicationMainWindowShowConversationsData* _data_;
	_data_ = _data;
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->location);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->to_show);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/client/application/application-main-window.vala"
	g_slice_free (ApplicationMainWindowShowConversationsData, _data_);
#line 4981 "application-main-window.c"
}

void
application_main_window_show_conversations (ApplicationMainWindow* self,
                                            GearyFolder* location,
                                            GeeCollection* to_show,
                                            gboolean is_interactive,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	ApplicationMainWindowShowConversationsData* _data_;
	ApplicationMainWindow* _tmp0_;
	GearyFolder* _tmp1_;
	GeeCollection* _tmp2_;
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (location, GEARY_TYPE_FOLDER));
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (to_show, GEE_TYPE_COLLECTION));
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_slice_new0 (ApplicationMainWindowShowConversationsData);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 10 "../src/client/application/application-main-window.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_main_window_show_conversations_data_free);
#line 10 "../src/client/application/application-main-window.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->self = _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (location);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->location);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->location = _tmp1_;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp2_ = _g_object_ref0 (to_show);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->to_show);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->to_show = _tmp2_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_->is_interactive = is_interactive;
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_show_conversations_co (_data_);
#line 5028 "application-main-window.c"
}

void
application_main_window_show_conversations_finish (ApplicationMainWindow* self,
                                                   GAsyncResult* _res_)
{
	ApplicationMainWindowShowConversationsData* _data_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 5038 "application-main-window.c"
}

/** Selects the given account, folder and conversations. */
static void
application_main_window_show_conversations_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_)
{
	ApplicationMainWindowShowConversationsData* _data_;
#line 878 "../src/client/application/application-main-window.vala"
	_data_ = _user_data_;
#line 878 "../src/client/application/application-main-window.vala"
	_data_->_source_object_ = source_object;
#line 878 "../src/client/application/application-main-window.vala"
	_data_->_res_ = _res_;
#line 878 "../src/client/application/application-main-window.vala"
	application_main_window_show_conversations_co (_data_);
#line 5056 "application-main-window.c"
}

static gboolean
application_main_window_show_conversations_co (ApplicationMainWindowShowConversationsData* _data_)
{
#line 874 "../src/client/application/application-main-window.vala"
	switch (_data_->_state_) {
#line 874 "../src/client/application/application-main-window.vala"
		case 0:
#line 5066 "application-main-window.c"
		goto _state_0;
#line 874 "../src/client/application/application-main-window.vala"
		case 1:
#line 5070 "application-main-window.c"
		goto _state_1;
#line 874 "../src/client/application/application-main-window.vala"
		case 2:
#line 5074 "application-main-window.c"
		goto _state_2;
#line 874 "../src/client/application/application-main-window.vala"
		case 3:
#line 5078 "application-main-window.c"
		goto _state_3;
		default:
#line 874 "../src/client/application/application-main-window.vala"
		g_assert_not_reached ();
#line 5083 "application-main-window.c"
	}
	_state_0:
#line 877 "../src/client/application/application-main-window.vala"
	_data_->_tmp0_ = _data_->self->priv->_selected_folder;
#line 877 "../src/client/application/application-main-window.vala"
	_data_->inhibit_autoselect = _data_->location != _data_->_tmp0_;
#line 878 "../src/client/application/application-main-window.vala"
	_data_->_state_ = 1;
#line 878 "../src/client/application/application-main-window.vala"
	application_main_window_select_folder (_data_->self, _data_->location, _data_->is_interactive, _data_->inhibit_autoselect, application_main_window_show_conversations_ready, _data_);
#line 878 "../src/client/application/application-main-window.vala"
	return FALSE;
#line 5096 "application-main-window.c"
	_state_1:
#line 878 "../src/client/application/application-main-window.vala"
	application_main_window_select_folder_finish (_data_->self, _data_->_res_);
#line 881 "../src/client/application/application-main-window.vala"
	_data_->_tmp1_ = _data_->self->priv->_selected_folder;
#line 881 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp1_ == _data_->location) {
#line 885 "../src/client/application/application-main-window.vala"
		_data_->_tmp2_ = gee_hash_set_new (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 885 "../src/client/application/application-main-window.vala"
		_data_->latest_email = _data_->_tmp2_;
#line 5108 "application-main-window.c"
		{
#line 886 "../src/client/application/application-main-window.vala"
			_data_->_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_data_->to_show, GEE_TYPE_ITERABLE, GeeIterable));
#line 886 "../src/client/application/application-main-window.vala"
			_data_->_stale_it = _data_->_tmp3_;
#line 886 "../src/client/application/application-main-window.vala"
			while (TRUE) {
#line 886 "../src/client/application/application-main-window.vala"
				_data_->_tmp4_ = _data_->_stale_it;
#line 886 "../src/client/application/application-main-window.vala"
				if (!gee_iterator_next (_data_->_tmp4_)) {
#line 886 "../src/client/application/application-main-window.vala"
					break;
#line 5122 "application-main-window.c"
				}
#line 886 "../src/client/application/application-main-window.vala"
				_data_->_tmp5_ = _data_->_stale_it;
#line 886 "../src/client/application/application-main-window.vala"
				_data_->_tmp6_ = gee_iterator_get (_data_->_tmp5_);
#line 886 "../src/client/application/application-main-window.vala"
				_data_->stale = (GearyAppConversation*) _data_->_tmp6_;
#line 887 "../src/client/application/application-main-window.vala"
				_data_->_tmp7_ = _data_->stale;
#line 887 "../src/client/application/application-main-window.vala"
				_data_->_tmp8_ = geary_app_conversation_get_latest_recv_email (_data_->_tmp7_, GEARY_APP_CONVERSATION_LOCATION_IN_FOLDER, NULL);
#line 887 "../src/client/application/application-main-window.vala"
				_data_->first = _data_->_tmp8_;
#line 888 "../src/client/application/application-main-window.vala"
				_data_->_tmp9_ = _data_->first;
#line 888 "../src/client/application/application-main-window.vala"
				if (_data_->_tmp9_ != NULL) {
#line 889 "../src/client/application/application-main-window.vala"
					_data_->_tmp10_ = _data_->latest_email;
#line 889 "../src/client/application/application-main-window.vala"
					_data_->_tmp11_ = _data_->first;
#line 889 "../src/client/application/application-main-window.vala"
					_data_->_tmp12_ = geary_email_get_id (_data_->_tmp11_);
#line 889 "../src/client/application/application-main-window.vala"
					_data_->_tmp13_ = _data_->_tmp12_;
#line 889 "../src/client/application/application-main-window.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp10_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _data_->_tmp13_);
#line 5150 "application-main-window.c"
				}
#line 886 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_data_->first);
#line 886 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_data_->stale);
#line 5156 "application-main-window.c"
			}
#line 886 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (_data_->_stale_it);
#line 5160 "application-main-window.c"
		}
#line 892 "../src/client/application/application-main-window.vala"
		_data_->_tmp14_ = _data_->latest_email;
#line 892 "../src/client/application/application-main-window.vala"
		_data_->_state_ = 2;
#line 892 "../src/client/application/application-main-window.vala"
		application_main_window_load_conversations_for_email (_data_->self, _data_->location, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp14_, GEE_TYPE_COLLECTION, GeeCollection), application_main_window_show_conversations_ready, _data_);
#line 892 "../src/client/application/application-main-window.vala"
		return FALSE;
#line 5170 "application-main-window.c"
		_state_2:
#line 892 "../src/client/application/application-main-window.vala"
		_data_->_tmp15_ = application_main_window_load_conversations_for_email_finish (_data_->self, _data_->_res_);
#line 892 "../src/client/application/application-main-window.vala"
		_data_->loaded = _data_->_tmp15_;
#line 895 "../src/client/application/application-main-window.vala"
		_data_->_tmp16_ = _data_->loaded;
#line 895 "../src/client/application/application-main-window.vala"
		_data_->_tmp17_ = gee_collection_get_is_empty (_data_->_tmp16_);
#line 895 "../src/client/application/application-main-window.vala"
		_data_->_tmp18_ = _data_->_tmp17_;
#line 895 "../src/client/application/application-main-window.vala"
		if (!_data_->_tmp18_) {
#line 896 "../src/client/application/application-main-window.vala"
			_data_->_tmp19_ = _data_->loaded;
#line 896 "../src/client/application/application-main-window.vala"
			_data_->_tmp20_ = gee_collection_empty (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref);
#line 896 "../src/client/application/application-main-window.vala"
			_data_->_tmp21_ = _data_->_tmp20_;
#line 896 "../src/client/application/application-main-window.vala"
			_data_->_state_ = 3;
#line 896 "../src/client/application/application-main-window.vala"
			application_main_window_select_conversations (_data_->self, _data_->_tmp19_, _data_->_tmp21_, _data_->is_interactive, application_main_window_show_conversations_ready, _data_);
#line 896 "../src/client/application/application-main-window.vala"
			return FALSE;
#line 5196 "application-main-window.c"
			_state_3:
#line 896 "../src/client/application/application-main-window.vala"
			application_main_window_select_conversations_finish (_data_->self, _data_->_res_);
#line 896 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (_data_->_tmp21_);
#line 5202 "application-main-window.c"
		}
#line 881 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data_->loaded);
#line 881 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data_->latest_email);
#line 5208 "application-main-window.c"
	}
#line 874 "../src/client/application/application-main-window.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 874 "../src/client/application/application-main-window.vala"
	if (_data_->_state_ != 0) {
#line 874 "../src/client/application/application-main-window.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 874 "../src/client/application/application-main-window.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 5218 "application-main-window.c"
		}
	}
#line 874 "../src/client/application/application-main-window.vala"
	g_object_unref (_data_->_async_result);
#line 874 "../src/client/application/application-main-window.vala"
	return FALSE;
#line 5225 "application-main-window.c"
}

static void
application_main_window_show_email_data_free (gpointer _data)
{
	ApplicationMainWindowShowEmailData* _data_;
	_data_ = _data;
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->location);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->to_show);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/client/application/application-main-window.vala"
	g_slice_free (ApplicationMainWindowShowEmailData, _data_);
#line 5241 "application-main-window.c"
}

void
application_main_window_show_email (ApplicationMainWindow* self,
                                    GearyFolder* location,
                                    GeeCollection* to_show,
                                    gboolean is_interactive,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	ApplicationMainWindowShowEmailData* _data_;
	ApplicationMainWindow* _tmp0_;
	GearyFolder* _tmp1_;
	GeeCollection* _tmp2_;
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (location, GEARY_TYPE_FOLDER));
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (to_show, GEE_TYPE_COLLECTION));
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_slice_new0 (ApplicationMainWindowShowEmailData);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 10 "../src/client/application/application-main-window.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_main_window_show_email_data_free);
#line 10 "../src/client/application/application-main-window.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->self = _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (location);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->location);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->location = _tmp1_;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp2_ = _g_object_ref0 (to_show);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->to_show);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->to_show = _tmp2_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_->is_interactive = is_interactive;
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_show_email_co (_data_);
#line 5288 "application-main-window.c"
}

void
application_main_window_show_email_finish (ApplicationMainWindow* self,
                                           GAsyncResult* _res_)
{
	ApplicationMainWindowShowEmailData* _data_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 5298 "application-main-window.c"
}

/** Selects the given account, folder and email. */
static void
application_main_window_show_email_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	ApplicationMainWindowShowEmailData* _data_;
#line 910 "../src/client/application/application-main-window.vala"
	_data_ = _user_data_;
#line 910 "../src/client/application/application-main-window.vala"
	_data_->_source_object_ = source_object;
#line 910 "../src/client/application/application-main-window.vala"
	_data_->_res_ = _res_;
#line 910 "../src/client/application/application-main-window.vala"
	application_main_window_show_email_co (_data_);
#line 5316 "application-main-window.c"
}

static gboolean
application_main_window_show_email_co (ApplicationMainWindowShowEmailData* _data_)
{
#line 906 "../src/client/application/application-main-window.vala"
	switch (_data_->_state_) {
#line 906 "../src/client/application/application-main-window.vala"
		case 0:
#line 5326 "application-main-window.c"
		goto _state_0;
#line 906 "../src/client/application/application-main-window.vala"
		case 1:
#line 5330 "application-main-window.c"
		goto _state_1;
#line 906 "../src/client/application/application-main-window.vala"
		case 2:
#line 5334 "application-main-window.c"
		goto _state_2;
#line 906 "../src/client/application/application-main-window.vala"
		case 3:
#line 5338 "application-main-window.c"
		goto _state_3;
#line 906 "../src/client/application/application-main-window.vala"
		case 4:
#line 5342 "application-main-window.c"
		goto _state_4;
		default:
#line 906 "../src/client/application/application-main-window.vala"
		g_assert_not_reached ();
#line 5347 "application-main-window.c"
	}
	_state_0:
#line 909 "../src/client/application/application-main-window.vala"
	_data_->_tmp0_ = _data_->self->priv->_selected_folder;
#line 909 "../src/client/application/application-main-window.vala"
	_data_->inhibit_autoselect = _data_->location != _data_->_tmp0_;
#line 910 "../src/client/application/application-main-window.vala"
	_data_->_state_ = 1;
#line 910 "../src/client/application/application-main-window.vala"
	application_main_window_select_folder (_data_->self, _data_->location, _data_->is_interactive, _data_->inhibit_autoselect, application_main_window_show_email_ready, _data_);
#line 910 "../src/client/application/application-main-window.vala"
	return FALSE;
#line 5360 "application-main-window.c"
	_state_1:
#line 910 "../src/client/application/application-main-window.vala"
	application_main_window_select_folder_finish (_data_->self, _data_->_res_);
#line 913 "../src/client/application/application-main-window.vala"
	_data_->_tmp1_ = _data_->self->priv->_selected_folder;
#line 913 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp1_ == _data_->location) {
#line 914 "../src/client/application/application-main-window.vala"
		_data_->_state_ = 2;
#line 914 "../src/client/application/application-main-window.vala"
		application_main_window_load_conversations_for_email (_data_->self, _data_->location, _data_->to_show, application_main_window_show_email_ready, _data_);
#line 914 "../src/client/application/application-main-window.vala"
		return FALSE;
#line 5374 "application-main-window.c"
		_state_2:
#line 914 "../src/client/application/application-main-window.vala"
		_data_->_tmp2_ = application_main_window_load_conversations_for_email_finish (_data_->self, _data_->_res_);
#line 914 "../src/client/application/application-main-window.vala"
		_data_->loaded = _data_->_tmp2_;
#line 916 "../src/client/application/application-main-window.vala"
		_data_->_tmp3_ = _data_->loaded;
#line 916 "../src/client/application/application-main-window.vala"
		_data_->_tmp4_ = gee_collection_get_size (_data_->_tmp3_);
#line 916 "../src/client/application/application-main-window.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 916 "../src/client/application/application-main-window.vala"
		if (_data_->_tmp5_ == 1) {
#line 919 "../src/client/application/application-main-window.vala"
			_data_->_tmp6_ = _data_->loaded;
#line 919 "../src/client/application/application-main-window.vala"
			_data_->_tmp7_ = geary_collection_first (GEARY_APP_TYPE_CONVERSATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _data_->_tmp6_);
#line 919 "../src/client/application/application-main-window.vala"
			_data_->target = (GearyAppConversation*) _data_->_tmp7_;
#line 920 "../src/client/application/application-main-window.vala"
			_data_->_tmp8_ = _data_->self->priv->_conversation_viewer;
#line 920 "../src/client/application/application-main-window.vala"
			_data_->_tmp9_ = conversation_viewer_get_current_list (_data_->_tmp8_);
#line 920 "../src/client/application/application-main-window.vala"
			_data_->_tmp10_ = _data_->_tmp9_;
#line 920 "../src/client/application/application-main-window.vala"
			_data_->_tmp11_ = _g_object_ref0 (_data_->_tmp10_);
#line 920 "../src/client/application/application-main-window.vala"
			_data_->current_list = _data_->_tmp11_;
#line 922 "../src/client/application/application-main-window.vala"
			_data_->_tmp13_ = _data_->current_list;
#line 922 "../src/client/application/application-main-window.vala"
			if (_data_->_tmp13_ != NULL) {
#line 923 "../src/client/application/application-main-window.vala"
				_data_->_tmp14_ = _data_->current_list;
#line 923 "../src/client/application/application-main-window.vala"
				_data_->_tmp15_ = conversation_list_box_get_conversation (_data_->_tmp14_);
#line 923 "../src/client/application/application-main-window.vala"
				_data_->_tmp16_ = _data_->_tmp15_;
#line 923 "../src/client/application/application-main-window.vala"
				_data_->_tmp17_ = _data_->target;
#line 923 "../src/client/application/application-main-window.vala"
				_data_->_tmp12_ = _data_->_tmp16_ == _data_->_tmp17_;
#line 5418 "application-main-window.c"
			} else {
#line 922 "../src/client/application/application-main-window.vala"
				_data_->_tmp12_ = FALSE;
#line 5422 "application-main-window.c"
			}
#line 922 "../src/client/application/application-main-window.vala"
			if (_data_->_tmp12_) {
#line 931 "../src/client/application/application-main-window.vala"
				_data_->_tmp18_ = _data_->current_list;
#line 931 "../src/client/application/application-main-window.vala"
				conversation_list_box_scroll_to_messages (_data_->_tmp18_, _data_->to_show);
#line 5430 "application-main-window.c"
			} else {
#line 935 "../src/client/application/application-main-window.vala"
				_data_->_tmp19_ = _data_->loaded;
#line 935 "../src/client/application/application-main-window.vala"
				_data_->_state_ = 3;
#line 935 "../src/client/application/application-main-window.vala"
				application_main_window_select_conversations (_data_->self, _data_->_tmp19_, _data_->to_show, _data_->is_interactive, application_main_window_show_email_ready, _data_);
#line 935 "../src/client/application/application-main-window.vala"
				return FALSE;
#line 5440 "application-main-window.c"
				_state_3:
#line 935 "../src/client/application/application-main-window.vala"
				application_main_window_select_conversations_finish (_data_->self, _data_->_res_);
#line 5444 "application-main-window.c"
			}
#line 916 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (_data_->current_list);
#line 916 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (_data_->target);
#line 5450 "application-main-window.c"
		} else {
#line 937 "../src/client/application/application-main-window.vala"
			_data_->_tmp20_ = _data_->loaded;
#line 937 "../src/client/application/application-main-window.vala"
			_data_->_tmp21_ = gee_collection_get_is_empty (_data_->_tmp20_);
#line 937 "../src/client/application/application-main-window.vala"
			_data_->_tmp22_ = _data_->_tmp21_;
#line 937 "../src/client/application/application-main-window.vala"
			if (!_data_->_tmp22_) {
#line 939 "../src/client/application/application-main-window.vala"
				_data_->_tmp23_ = _data_->loaded;
#line 939 "../src/client/application/application-main-window.vala"
				_data_->_tmp24_ = gee_collection_empty (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref);
#line 939 "../src/client/application/application-main-window.vala"
				_data_->_tmp25_ = _data_->_tmp24_;
#line 939 "../src/client/application/application-main-window.vala"
				_data_->_state_ = 4;
#line 939 "../src/client/application/application-main-window.vala"
				application_main_window_select_conversations (_data_->self, _data_->_tmp23_, _data_->_tmp25_, _data_->is_interactive, application_main_window_show_email_ready, _data_);
#line 939 "../src/client/application/application-main-window.vala"
				return FALSE;
#line 5472 "application-main-window.c"
				_state_4:
#line 939 "../src/client/application/application-main-window.vala"
				application_main_window_select_conversations_finish (_data_->self, _data_->_res_);
#line 939 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_data_->_tmp25_);
#line 5478 "application-main-window.c"
			} else {
			}
		}
#line 913 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data_->loaded);
#line 5484 "application-main-window.c"
	}
#line 906 "../src/client/application/application-main-window.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 906 "../src/client/application/application-main-window.vala"
	if (_data_->_state_ != 0) {
#line 906 "../src/client/application/application-main-window.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 906 "../src/client/application/application-main-window.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 5494 "application-main-window.c"
		}
	}
#line 906 "../src/client/application/application-main-window.vala"
	g_object_unref (_data_->_async_result);
#line 906 "../src/client/application/application-main-window.vala"
	return FALSE;
#line 5501 "application-main-window.c"
}

/** Shows the appopriate window menu, if any. */
void
application_main_window_show_window_menu (ApplicationMainWindow* self)
{
	HdyLeaflet* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	HdyLeaflet* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	ComponentsMainToolbar* _tmp8_;
#line 950 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 951 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->outer_leaflet;
#line 951 "../src/client/application/application-main-window.vala"
	_tmp1_ = hdy_leaflet_get_folded (_tmp0_);
#line 951 "../src/client/application/application-main-window.vala"
	_tmp2_ = _tmp1_;
#line 951 "../src/client/application/application-main-window.vala"
	if (_tmp2_) {
#line 5525 "application-main-window.c"
		HdyLeaflet* _tmp3_;
#line 952 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->outer_leaflet;
#line 952 "../src/client/application/application-main-window.vala"
		hdy_leaflet_navigate (_tmp3_, HDY_NAVIGATION_DIRECTION_BACK);
#line 5531 "application-main-window.c"
	}
#line 954 "../src/client/application/application-main-window.vala"
	_tmp4_ = self->priv->inner_leaflet;
#line 954 "../src/client/application/application-main-window.vala"
	_tmp5_ = hdy_leaflet_get_folded (_tmp4_);
#line 954 "../src/client/application/application-main-window.vala"
	_tmp6_ = _tmp5_;
#line 954 "../src/client/application/application-main-window.vala"
	if (_tmp6_) {
#line 5541 "application-main-window.c"
		HdyLeaflet* _tmp7_;
#line 955 "../src/client/application/application-main-window.vala"
		_tmp7_ = self->priv->inner_leaflet;
#line 955 "../src/client/application/application-main-window.vala"
		hdy_leaflet_navigate (_tmp7_, HDY_NAVIGATION_DIRECTION_BACK);
#line 5547 "application-main-window.c"
	}
#line 957 "../src/client/application/application-main-window.vala"
	_tmp8_ = self->priv->_main_toolbar;
#line 957 "../src/client/application/application-main-window.vala"
	components_main_toolbar_show_main_menu (_tmp8_);
#line 5553 "application-main-window.c"
}

/** Displays and focuses the search bar for the window. */
void
application_main_window_show_search_bar (ApplicationMainWindow* self,
                                         const gchar* text)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	SearchBar* _tmp7_;
#line 961 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 962 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_is_conversation_list_shown (self);
#line 962 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 962 "../src/client/application/application-main-window.vala"
	if (!_tmp1_) {
#line 5572 "application-main-window.c"
		HdyLeaflet* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
		HdyLeaflet* _tmp6_;
#line 963 "../src/client/application/application-main-window.vala"
		_tmp2_ = self->priv->outer_leaflet;
#line 963 "../src/client/application/application-main-window.vala"
		_tmp3_ = hdy_leaflet_get_folded (_tmp2_);
#line 963 "../src/client/application/application-main-window.vala"
		_tmp4_ = _tmp3_;
#line 963 "../src/client/application/application-main-window.vala"
		if (_tmp4_) {
#line 5585 "application-main-window.c"
			HdyLeaflet* _tmp5_;
#line 964 "../src/client/application/application-main-window.vala"
			_tmp5_ = self->priv->outer_leaflet;
#line 964 "../src/client/application/application-main-window.vala"
			hdy_leaflet_set_visible_child_name (_tmp5_, APPLICATION_MAIN_WINDOW_INNER_LEAFLET);
#line 5591 "application-main-window.c"
		}
#line 966 "../src/client/application/application-main-window.vala"
		_tmp6_ = self->priv->inner_leaflet;
#line 966 "../src/client/application/application-main-window.vala"
		hdy_leaflet_set_visible_child_name (_tmp6_, APPLICATION_MAIN_WINDOW_CONVERSATION_LIST);
#line 5597 "application-main-window.c"
	}
#line 969 "../src/client/application/application-main-window.vala"
	_tmp7_ = self->priv->_search_bar;
#line 969 "../src/client/application/application-main-window.vala"
	gtk_widget_grab_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_widget_get_type (), GtkWidget));
#line 970 "../src/client/application/application-main-window.vala"
	if (text != NULL) {
#line 5605 "application-main-window.c"
		SearchBar* _tmp8_;
		GtkSearchEntry* _tmp9_;
		GtkSearchEntry* _tmp10_;
#line 971 "../src/client/application/application-main-window.vala"
		_tmp8_ = self->priv->_search_bar;
#line 971 "../src/client/application/application-main-window.vala"
		_tmp9_ = search_bar_get_entry (_tmp8_);
#line 971 "../src/client/application/application-main-window.vala"
		_tmp10_ = _tmp9_;
#line 971 "../src/client/application/application-main-window.vala"
		gtk_entry_set_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_entry_get_type (), GtkEntry), text);
#line 5617 "application-main-window.c"
	}
}

/** Displays an infobar in the window. */
void
application_main_window_show_info_bar (ApplicationMainWindow* self,
                                       ComponentsInfoBar* info_bar)
{
	ComponentsInfoBarStack* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 976 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 976 "../src/client/application/application-main-window.vala"
	g_return_if_fail (COMPONENTS_IS_INFO_BAR (info_bar));
#line 977 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->info_bars;
#line 977 "../src/client/application/application-main-window.vala"
	_tmp1_ = components_info_bar_stack_get_has_current (_tmp0_);
#line 977 "../src/client/application/application-main-window.vala"
	_tmp2_ = _tmp1_;
#line 977 "../src/client/application/application-main-window.vala"
	if (!_tmp2_) {
#line 5641 "application-main-window.c"
		ComponentsInfoBarStack* _tmp3_;
#line 978 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->info_bars;
#line 978 "../src/client/application/application-main-window.vala"
		components_info_bar_stack_add (_tmp3_, info_bar);
#line 5647 "application-main-window.c"
	}
}

/**
     * Displays a composer in the window if possible, else in a new window.
     */
static Block15Data*
block15_data_ref (Block15Data* _data15_)
{
#line 994 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data15_->_ref_count_);
#line 994 "../src/client/application/application-main-window.vala"
	return _data15_;
#line 5661 "application-main-window.c"
}

static void
block15_data_unref (void * _userdata_)
{
	Block15Data* _data15_;
	_data15_ = (Block15Data*) _userdata_;
#line 994 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data15_->_ref_count_)) {
#line 5671 "application-main-window.c"
		ApplicationMainWindow* self;
#line 994 "../src/client/application/application-main-window.vala"
		self = _data15_->self;
#line 994 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data15_->referrants);
#line 994 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 994 "../src/client/application/application-main-window.vala"
		g_slice_free (Block15Data, _data15_);
#line 5681 "application-main-window.c"
	}
}

static gboolean
____lambda161_ (Block15Data* _data15_,
                GearyEmail* email)
{
	ApplicationMainWindow* self;
	GeeCollection* _tmp0_;
	GearyEmailIdentifier* _tmp1_;
	GearyEmailIdentifier* _tmp2_;
	gboolean result;
#line 1002 "../src/client/application/application-main-window.vala"
	self = _data15_->self;
#line 1002 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (email, GEARY_TYPE_EMAIL), FALSE);
#line 1002 "../src/client/application/application-main-window.vala"
	_tmp0_ = _data15_->referrants;
#line 1002 "../src/client/application/application-main-window.vala"
	_tmp1_ = geary_email_get_id (email);
#line 1002 "../src/client/application/application-main-window.vala"
	_tmp2_ = _tmp1_;
#line 1002 "../src/client/application/application-main-window.vala"
	result = gee_collection_contains (_tmp0_, _tmp2_);
#line 1002 "../src/client/application/application-main-window.vala"
	return result;
#line 5708 "application-main-window.c"
}

static gboolean
_____lambda161__gee_predicate (gconstpointer g,
                               gpointer self)
{
	gboolean result;
	result = ____lambda161_ (self, (GearyEmail*) g);
#line 999 "../src/client/application/application-main-window.vala"
	return result;
#line 5719 "application-main-window.c"
}

void
application_main_window_show_composer (ApplicationMainWindow* self,
                                       ComposerWidget* composer)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 985 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 985 "../src/client/application/application-main-window.vala"
	g_return_if_fail (COMPOSER_IS_WIDGET (composer));
#line 986 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_has_composer (self);
#line 986 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 986 "../src/client/application/application-main-window.vala"
	if (_tmp1_) {
#line 5738 "application-main-window.c"
		ApplicationClient* _tmp2_;
		ApplicationClient* _tmp3_;
#line 987 "../src/client/application/application-main-window.vala"
		_tmp2_ = application_main_window_get_application (self);
#line 987 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 987 "../src/client/application/application-main-window.vala"
		composer_widget_detach (composer, _tmp3_);
#line 5747 "application-main-window.c"
	} else {
		GearyEmail* latest_referred = NULL;
		ConversationViewer* _tmp4_;
		ConversationListBox* _tmp5_;
		ConversationListBox* _tmp6_;
		GearyEmail* _tmp18_;
		HdyLeaflet* _tmp22_;
#line 993 "../src/client/application/application-main-window.vala"
		latest_referred = NULL;
#line 994 "../src/client/application/application-main-window.vala"
		_tmp4_ = self->priv->_conversation_viewer;
#line 994 "../src/client/application/application-main-window.vala"
		_tmp5_ = conversation_viewer_get_current_list (_tmp4_);
#line 994 "../src/client/application/application-main-window.vala"
		_tmp6_ = _tmp5_;
#line 994 "../src/client/application/application-main-window.vala"
		if (_tmp6_ != NULL) {
#line 5765 "application-main-window.c"
			Block15Data* _data15_;
			GeeSet* _tmp7_;
			GearyAppConversation* selected = NULL;
			ConversationViewer* _tmp8_;
			ConversationListBox* _tmp9_;
			ConversationListBox* _tmp10_;
			GearyAppConversation* _tmp11_;
			GearyAppConversation* _tmp12_;
			GearyAppConversation* _tmp13_;
			GearyAppConversation* _tmp14_;
			GeeList* _tmp15_;
			GeeList* _tmp16_;
			gpointer _tmp17_;
#line 994 "../src/client/application/application-main-window.vala"
			_data15_ = g_slice_new0 (Block15Data);
#line 994 "../src/client/application/application-main-window.vala"
			_data15_->_ref_count_ = 1;
#line 994 "../src/client/application/application-main-window.vala"
			_data15_->self = g_object_ref (self);
#line 995 "../src/client/application/application-main-window.vala"
			_tmp7_ = composer_widget_get_referred_ids (composer);
#line 995 "../src/client/application/application-main-window.vala"
			_data15_->referrants = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection);
#line 997 "../src/client/application/application-main-window.vala"
			_tmp8_ = self->priv->_conversation_viewer;
#line 997 "../src/client/application/application-main-window.vala"
			_tmp9_ = conversation_viewer_get_current_list (_tmp8_);
#line 997 "../src/client/application/application-main-window.vala"
			_tmp10_ = _tmp9_;
#line 997 "../src/client/application/application-main-window.vala"
			_tmp11_ = conversation_list_box_get_conversation (_tmp10_);
#line 997 "../src/client/application/application-main-window.vala"
			_tmp12_ = _tmp11_;
#line 997 "../src/client/application/application-main-window.vala"
			_tmp13_ = _g_object_ref0 (_tmp12_);
#line 997 "../src/client/application/application-main-window.vala"
			selected = _tmp13_;
#line 999 "../src/client/application/application-main-window.vala"
			_tmp14_ = selected;
#line 999 "../src/client/application/application-main-window.vala"
			_tmp15_ = geary_app_conversation_get_emails (_tmp14_, GEARY_APP_CONVERSATION_ORDERING_RECV_DATE_DESCENDING, GEARY_APP_CONVERSATION_LOCATION_ANYWHERE, NULL, TRUE);
#line 999 "../src/client/application/application-main-window.vala"
			_tmp16_ = _tmp15_;
#line 999 "../src/client/application/application-main-window.vala"
			_tmp17_ = gee_traversable_first_match (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEE_TYPE_TRAVERSABLE, GeeTraversable), _____lambda161__gee_predicate, block15_data_ref (_data15_), block15_data_unref);
#line 999 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (latest_referred);
#line 999 "../src/client/application/application-main-window.vala"
			latest_referred = (GearyEmail*) _tmp17_;
#line 999 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (_tmp16_);
#line 994 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (selected);
#line 994 "../src/client/application/application-main-window.vala"
			block15_data_unref (_data15_);
#line 994 "../src/client/application/application-main-window.vala"
			_data15_ = NULL;
#line 5823 "application-main-window.c"
		}
#line 1006 "../src/client/application/application-main-window.vala"
		_tmp18_ = latest_referred;
#line 1006 "../src/client/application/application-main-window.vala"
		if (_tmp18_ != NULL) {
#line 5829 "application-main-window.c"
			ConversationViewer* _tmp19_;
			GearyEmail* _tmp20_;
#line 1007 "../src/client/application/application-main-window.vala"
			_tmp19_ = self->priv->_conversation_viewer;
#line 1007 "../src/client/application/application-main-window.vala"
			_tmp20_ = latest_referred;
#line 1007 "../src/client/application/application-main-window.vala"
			conversation_viewer_do_compose_embedded (_tmp19_, composer, _tmp20_);
#line 5838 "application-main-window.c"
		} else {
			ConversationViewer* _tmp21_;
#line 1011 "../src/client/application/application-main-window.vala"
			_tmp21_ = self->priv->_conversation_viewer;
#line 1011 "../src/client/application/application-main-window.vala"
			conversation_viewer_do_compose (_tmp21_, composer);
#line 5845 "application-main-window.c"
		}
#line 1014 "../src/client/application/application-main-window.vala"
		_tmp22_ = self->priv->outer_leaflet;
#line 1014 "../src/client/application/application-main-window.vala"
		hdy_leaflet_set_visible_child_name (_tmp22_, APPLICATION_MAIN_WINDOW_CONVERSATION_VIEWER);
#line 986 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (latest_referred);
#line 5853 "application-main-window.c"
	}
}

/**
     * Closes any open composers, after prompting the user if requested.
     *
     * Returns true if none were open or the user approved closing
     * them.
     */
gboolean
application_main_window_close_composer (ApplicationMainWindow* self,
                                        gboolean should_prompt,
                                        gboolean is_shutdown)
{
	gboolean closed = FALSE;
	ComposerWidget* composer = NULL;
	ConversationViewer* _tmp0_;
	ComposerWidget* _tmp1_;
	ComposerWidget* _tmp2_;
	ComposerWidget* _tmp3_;
	gboolean _tmp4_ = FALSE;
	ComposerWidget* _tmp5_;
	gboolean result;
#line 1024 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), FALSE);
#line 1025 "../src/client/application/application-main-window.vala"
	closed = TRUE;
#line 1026 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_conversation_viewer;
#line 1026 "../src/client/application/application-main-window.vala"
	_tmp1_ = conversation_viewer_get_current_composer (_tmp0_);
#line 1026 "../src/client/application/application-main-window.vala"
	_tmp2_ = _tmp1_;
#line 1026 "../src/client/application/application-main-window.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 1026 "../src/client/application/application-main-window.vala"
	composer = _tmp3_;
#line 1027 "../src/client/application/application-main-window.vala"
	_tmp5_ = composer;
#line 1027 "../src/client/application/application-main-window.vala"
	if (_tmp5_ != NULL) {
#line 5895 "application-main-window.c"
		ComposerWidget* _tmp6_;
#line 1028 "../src/client/application/application-main-window.vala"
		_tmp6_ = composer;
#line 1028 "../src/client/application/application-main-window.vala"
		_tmp4_ = composer_widget_conditional_close (_tmp6_, should_prompt, is_shutdown) == COMPOSER_WIDGET_CLOSE_STATUS_CANCELLED;
#line 5901 "application-main-window.c"
	} else {
#line 1027 "../src/client/application/application-main-window.vala"
		_tmp4_ = FALSE;
#line 5905 "application-main-window.c"
	}
#line 1027 "../src/client/application/application-main-window.vala"
	if (_tmp4_) {
#line 1029 "../src/client/application/application-main-window.vala"
		closed = FALSE;
#line 5911 "application-main-window.c"
	}
#line 1031 "../src/client/application/application-main-window.vala"
	result = closed;
#line 1031 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (composer);
#line 1031 "../src/client/application/application-main-window.vala"
	return result;
#line 5919 "application-main-window.c"
}

void
application_main_window_start_search (ApplicationMainWindow* self,
                                      const gchar* query_text,
                                      gboolean is_interactive)
{
	ApplicationAccountContext* context = NULL;
	ApplicationAccountContext* _tmp0_;
	ApplicationAccountContext* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 1034 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1034 "../src/client/application/application-main-window.vala"
	g_return_if_fail (query_text != NULL);
#line 1035 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_selected_account_context (self);
#line 1035 "../src/client/application/application-main-window.vala"
	context = _tmp0_;
#line 1036 "../src/client/application/application-main-window.vala"
	_tmp1_ = context;
#line 1036 "../src/client/application/application-main-window.vala"
	if (_tmp1_ != NULL) {
#line 5943 "application-main-window.c"
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
		GearyFolder* _tmp4_;
#line 1039 "../src/client/application/application-main-window.vala"
		_tmp4_ = self->priv->previous_non_search_folder;
#line 1039 "../src/client/application/application-main-window.vala"
		if (_tmp4_ == NULL) {
#line 5951 "application-main-window.c"
			GearyFolder* _tmp5_;
#line 1040 "../src/client/application/application-main-window.vala"
			_tmp5_ = self->priv->_selected_folder;
#line 1040 "../src/client/application/application-main-window.vala"
			_tmp3_ = _tmp5_ != NULL;
#line 5957 "application-main-window.c"
		} else {
#line 1039 "../src/client/application/application-main-window.vala"
			_tmp3_ = FALSE;
#line 5961 "application-main-window.c"
		}
#line 1039 "../src/client/application/application-main-window.vala"
		if (_tmp3_) {
#line 5965 "application-main-window.c"
			GearyFolder* _tmp6_;
			GearyFolderSpecialUse _tmp7_;
			GearyFolderSpecialUse _tmp8_;
#line 1041 "../src/client/application/application-main-window.vala"
			_tmp6_ = self->priv->_selected_folder;
#line 1041 "../src/client/application/application-main-window.vala"
			_tmp7_ = geary_folder_get_used_as (_tmp6_);
#line 1041 "../src/client/application/application-main-window.vala"
			_tmp8_ = _tmp7_;
#line 1041 "../src/client/application/application-main-window.vala"
			_tmp2_ = _tmp8_ != GEARY_FOLDER_SPECIAL_USE_SEARCH;
#line 5977 "application-main-window.c"
		} else {
#line 1039 "../src/client/application/application-main-window.vala"
			_tmp2_ = FALSE;
#line 5981 "application-main-window.c"
		}
#line 1039 "../src/client/application/application-main-window.vala"
		if (_tmp2_) {
#line 5985 "application-main-window.c"
			GearyFolder* _tmp9_;
			GearyFolder* _tmp10_;
#line 1042 "../src/client/application/application-main-window.vala"
			_tmp9_ = self->priv->_selected_folder;
#line 1042 "../src/client/application/application-main-window.vala"
			_tmp10_ = _g_object_ref0 (_tmp9_);
#line 1042 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (self->priv->previous_non_search_folder);
#line 1042 "../src/client/application/application-main-window.vala"
			self->priv->previous_non_search_folder = _tmp10_;
#line 5996 "application-main-window.c"
		}
		{
			UtilEmailSearchExpressionFactory* expr_factory = NULL;
			ApplicationClient* _tmp11_;
			ApplicationClient* _tmp12_;
			ApplicationConfiguration* _tmp13_;
			ApplicationConfiguration* _tmp14_;
			ApplicationAccountContext* _tmp15_;
			GearyAccount* _tmp16_;
			GearyAccount* _tmp17_;
			GearyAccountInformation* _tmp18_;
			GearyAccountInformation* _tmp19_;
			UtilEmailSearchExpressionFactory* _tmp20_;
			GearySearchQuery* query = NULL;
			ApplicationAccountContext* _tmp21_;
			GearyAccount* _tmp22_;
			GearyAccount* _tmp23_;
			UtilEmailSearchExpressionFactory* _tmp24_;
			GeeList* _tmp25_;
			GeeList* _tmp26_;
			GearySearchQuery* _tmp27_;
			GearySearchQuery* _tmp28_;
			FolderListTree* _tmp29_;
			ApplicationClient* _tmp30_;
			ApplicationClient* _tmp31_;
			GearyEngine* _tmp32_;
			GearyEngine* _tmp33_;
			ApplicationAccountContext* _tmp34_;
			GearyAppSearchFolder* _tmp35_;
			ApplicationAccountContext* _tmp36_;
			GearyAppSearchFolder* _tmp37_;
			GearySearchQuery* _tmp38_;
#line 1046 "../src/client/application/application-main-window.vala"
			_tmp11_ = application_main_window_get_application (self);
#line 1046 "../src/client/application/application-main-window.vala"
			_tmp12_ = _tmp11_;
#line 1046 "../src/client/application/application-main-window.vala"
			_tmp13_ = application_client_get_config (_tmp12_);
#line 1046 "../src/client/application/application-main-window.vala"
			_tmp14_ = _tmp13_;
#line 1046 "../src/client/application/application-main-window.vala"
			_tmp15_ = context;
#line 1046 "../src/client/application/application-main-window.vala"
			_tmp16_ = application_account_context_get_account (_tmp15_);
#line 1046 "../src/client/application/application-main-window.vala"
			_tmp17_ = _tmp16_;
#line 1046 "../src/client/application/application-main-window.vala"
			_tmp18_ = geary_account_get_information (_tmp17_);
#line 1046 "../src/client/application/application-main-window.vala"
			_tmp19_ = _tmp18_;
#line 1046 "../src/client/application/application-main-window.vala"
			_tmp20_ = util_email_search_expression_factory_new (application_configuration_get_search_strategy (_tmp14_), _tmp19_);
#line 1046 "../src/client/application/application-main-window.vala"
			expr_factory = _tmp20_;
#line 1050 "../src/client/application/application-main-window.vala"
			_tmp21_ = context;
#line 1050 "../src/client/application/application-main-window.vala"
			_tmp22_ = application_account_context_get_account (_tmp21_);
#line 1050 "../src/client/application/application-main-window.vala"
			_tmp23_ = _tmp22_;
#line 1050 "../src/client/application/application-main-window.vala"
			_tmp24_ = expr_factory;
#line 1050 "../src/client/application/application-main-window.vala"
			_tmp25_ = util_email_search_expression_factory_parse_query (_tmp24_, query_text);
#line 1050 "../src/client/application/application-main-window.vala"
			_tmp26_ = _tmp25_;
#line 1050 "../src/client/application/application-main-window.vala"
			_tmp27_ = geary_account_new_search_query (_tmp23_, _tmp26_, query_text, &_inner_error0_);
#line 1050 "../src/client/application/application-main-window.vala"
			_tmp28_ = _tmp27_;
#line 1050 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (_tmp26_);
#line 1050 "../src/client/application/application-main-window.vala"
			query = _tmp28_;
#line 1050 "../src/client/application/application-main-window.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1050 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (expr_factory);
#line 6075 "application-main-window.c"
				goto __catch0_g_error;
			}
#line 1054 "../src/client/application/application-main-window.vala"
			_tmp29_ = self->priv->_folder_list;
#line 1054 "../src/client/application/application-main-window.vala"
			_tmp30_ = application_main_window_get_application (self);
#line 1054 "../src/client/application/application-main-window.vala"
			_tmp31_ = _tmp30_;
#line 1054 "../src/client/application/application-main-window.vala"
			_tmp32_ = application_client_get_engine (_tmp31_);
#line 1054 "../src/client/application/application-main-window.vala"
			_tmp33_ = _tmp32_;
#line 1054 "../src/client/application/application-main-window.vala"
			_tmp34_ = context;
#line 1054 "../src/client/application/application-main-window.vala"
			_tmp35_ = _tmp34_->search;
#line 1054 "../src/client/application/application-main-window.vala"
			folder_list_tree_set_search (_tmp29_, _tmp33_, _tmp35_);
#line 1057 "../src/client/application/application-main-window.vala"
			_tmp36_ = context;
#line 1057 "../src/client/application/application-main-window.vala"
			_tmp37_ = _tmp36_->search;
#line 1057 "../src/client/application/application-main-window.vala"
			_tmp38_ = query;
#line 1057 "../src/client/application/application-main-window.vala"
			geary_app_search_folder_update_query (_tmp37_, _tmp38_);
#line 1045 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (query);
#line 1045 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (expr_factory);
#line 6106 "application-main-window.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* _error_ = NULL;
			ApplicationAccountContext* _tmp39_;
			GearyAccount* _tmp40_;
			GearyAccount* _tmp41_;
			GearyAccountInformation* _tmp42_;
			GearyAccountInformation* _tmp43_;
			GError* _tmp44_;
#line 1045 "../src/client/application/application-main-window.vala"
			_error_ = _inner_error0_;
#line 1045 "../src/client/application/application-main-window.vala"
			_inner_error0_ = NULL;
#line 1059 "../src/client/application/application-main-window.vala"
			_tmp39_ = context;
#line 1059 "../src/client/application/application-main-window.vala"
			_tmp40_ = application_account_context_get_account (_tmp39_);
#line 1059 "../src/client/application/application-main-window.vala"
			_tmp41_ = _tmp40_;
#line 1059 "../src/client/application/application-main-window.vala"
			_tmp42_ = geary_account_get_information (_tmp41_);
#line 1059 "../src/client/application/application-main-window.vala"
			_tmp43_ = _tmp42_;
#line 1059 "../src/client/application/application-main-window.vala"
			_tmp44_ = _error_;
#line 1059 "../src/client/application/application-main-window.vala"
			application_main_window_handle_error (self, _tmp43_, _tmp44_);
#line 1045 "../src/client/application/application-main-window.vala"
			_g_error_free0 (_error_);
#line 6138 "application-main-window.c"
		}
		__finally0:
#line 1045 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1045 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (context);
#line 1045 "../src/client/application/application-main-window.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1045 "../src/client/application/application-main-window.vala"
			g_clear_error (&_inner_error0_);
#line 1045 "../src/client/application/application-main-window.vala"
			return;
#line 6151 "application-main-window.c"
		}
	}
#line 1034 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (context);
#line 6156 "application-main-window.c"
}

void
application_main_window_stop_search (ApplicationMainWindow* self,
                                     gboolean is_interactive)
{
	gboolean _tmp0_ = FALSE;
	GearyFolder* _tmp1_;
	FolderListTree* _tmp15_;
#line 1064 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1067 "../src/client/application/application-main-window.vala"
	_tmp1_ = self->priv->_selected_folder;
#line 1067 "../src/client/application/application-main-window.vala"
	if (_tmp1_ == NULL) {
#line 1067 "../src/client/application/application-main-window.vala"
		_tmp0_ = TRUE;
#line 6174 "application-main-window.c"
	} else {
		GearyFolder* _tmp2_;
		GearyFolderSpecialUse _tmp3_;
		GearyFolderSpecialUse _tmp4_;
#line 1068 "../src/client/application/application-main-window.vala"
		_tmp2_ = self->priv->_selected_folder;
#line 1068 "../src/client/application/application-main-window.vala"
		_tmp3_ = geary_folder_get_used_as (_tmp2_);
#line 1068 "../src/client/application/application-main-window.vala"
		_tmp4_ = _tmp3_;
#line 1068 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp4_ == GEARY_FOLDER_SPECIAL_USE_SEARCH;
#line 6187 "application-main-window.c"
	}
#line 1067 "../src/client/application/application-main-window.vala"
	if (_tmp0_) {
#line 6191 "application-main-window.c"
		GearyFolder* to_select = NULL;
		GearyFolder* _tmp5_;
		GearyFolder* _tmp6_;
		GearyFolder* _tmp7_;
		GearyFolder* _tmp13_;
#line 1069 "../src/client/application/application-main-window.vala"
		_tmp5_ = self->priv->previous_non_search_folder;
#line 1069 "../src/client/application/application-main-window.vala"
		_tmp6_ = _g_object_ref0 (_tmp5_);
#line 1069 "../src/client/application/application-main-window.vala"
		to_select = _tmp6_;
#line 1070 "../src/client/application/application-main-window.vala"
		_tmp7_ = to_select;
#line 1070 "../src/client/application/application-main-window.vala"
		if (_tmp7_ == NULL) {
#line 6207 "application-main-window.c"
			ApplicationAccountContext* account = NULL;
			ApplicationAccountContext* _tmp8_;
			ApplicationAccountContext* _tmp9_;
#line 1071 "../src/client/application/application-main-window.vala"
			_tmp8_ = application_main_window_get_selected_account_context (self);
#line 1071 "../src/client/application/application-main-window.vala"
			account = _tmp8_;
#line 1072 "../src/client/application/application-main-window.vala"
			_tmp9_ = account;
#line 1072 "../src/client/application/application-main-window.vala"
			if (_tmp9_ != NULL) {
#line 6219 "application-main-window.c"
				ApplicationAccountContext* _tmp10_;
				GearyFolder* _tmp11_;
				GearyFolder* _tmp12_;
#line 1073 "../src/client/application/application-main-window.vala"
				_tmp10_ = account;
#line 1073 "../src/client/application/application-main-window.vala"
				_tmp11_ = _tmp10_->inbox;
#line 1073 "../src/client/application/application-main-window.vala"
				_tmp12_ = _g_object_ref0 (_tmp11_);
#line 1073 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (to_select);
#line 1073 "../src/client/application/application-main-window.vala"
				to_select = _tmp12_;
#line 6233 "application-main-window.c"
			}
#line 1070 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (account);
#line 6237 "application-main-window.c"
		}
#line 1077 "../src/client/application/application-main-window.vala"
		_tmp13_ = to_select;
#line 1077 "../src/client/application/application-main-window.vala"
		if (_tmp13_ != NULL) {
#line 6243 "application-main-window.c"
			GearyFolder* _tmp14_;
#line 1078 "../src/client/application/application-main-window.vala"
			_tmp14_ = self->priv->previous_non_search_folder;
#line 1078 "../src/client/application/application-main-window.vala"
			application_main_window_select_folder (self, _tmp14_, is_interactive, FALSE, NULL, NULL);
#line 6249 "application-main-window.c"
		} else {
#line 1082 "../src/client/application/application-main-window.vala"
			application_main_window_select_first_inbox (self, is_interactive);
#line 6253 "application-main-window.c"
		}
#line 1067 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (to_select);
#line 6257 "application-main-window.c"
	}
#line 1085 "../src/client/application/application-main-window.vala"
	_tmp15_ = self->priv->_folder_list;
#line 1085 "../src/client/application/application-main-window.vala"
	folder_list_tree_remove_search (_tmp15_);
#line 6263 "application-main-window.c"
	{
		GeeIterator* _context_it = NULL;
		ApplicationController* _tmp16_;
		GeeCollection* _tmp17_;
		GeeCollection* _tmp18_;
		GeeIterator* _tmp19_;
		GeeIterator* _tmp20_;
#line 1087 "../src/client/application/application-main-window.vala"
		_tmp16_ = self->priv->controller;
#line 1087 "../src/client/application/application-main-window.vala"
		_tmp17_ = application_account_interface_get_account_contexts (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, APPLICATION_TYPE_ACCOUNT_INTERFACE, ApplicationAccountInterface));
#line 1087 "../src/client/application/application-main-window.vala"
		_tmp18_ = _tmp17_;
#line 1087 "../src/client/application/application-main-window.vala"
		_tmp19_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1087 "../src/client/application/application-main-window.vala"
		_tmp20_ = _tmp19_;
#line 1087 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp18_);
#line 1087 "../src/client/application/application-main-window.vala"
		_context_it = _tmp20_;
#line 1087 "../src/client/application/application-main-window.vala"
		while (TRUE) {
#line 6287 "application-main-window.c"
			GeeIterator* _tmp21_;
			ApplicationAccountContext* context = NULL;
			GeeIterator* _tmp22_;
			gpointer _tmp23_;
			ApplicationAccountContext* _tmp24_;
			GearyAppSearchFolder* _tmp25_;
#line 1087 "../src/client/application/application-main-window.vala"
			_tmp21_ = _context_it;
#line 1087 "../src/client/application/application-main-window.vala"
			if (!gee_iterator_next (_tmp21_)) {
#line 1087 "../src/client/application/application-main-window.vala"
				break;
#line 6300 "application-main-window.c"
			}
#line 1087 "../src/client/application/application-main-window.vala"
			_tmp22_ = _context_it;
#line 1087 "../src/client/application/application-main-window.vala"
			_tmp23_ = gee_iterator_get (_tmp22_);
#line 1087 "../src/client/application/application-main-window.vala"
			context = (ApplicationAccountContext*) _tmp23_;
#line 1088 "../src/client/application/application-main-window.vala"
			_tmp24_ = context;
#line 1088 "../src/client/application/application-main-window.vala"
			_tmp25_ = _tmp24_->search;
#line 1088 "../src/client/application/application-main-window.vala"
			geary_app_search_folder_clear_query (_tmp25_);
#line 1087 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (context);
#line 6316 "application-main-window.c"
		}
#line 1087 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_context_it);
#line 6320 "application-main-window.c"
	}
}

gboolean
application_main_window_select_first_inbox (ApplicationMainWindow* self,
                                            gboolean is_interactive)
{
	gboolean success = FALSE;
	GearyFolder* inbox = NULL;
	GearyFolder* _tmp0_;
	GearyFolder* _tmp1_;
	gboolean result;
#line 1092 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), FALSE);
#line 1093 "../src/client/application/application-main-window.vala"
	success = FALSE;
#line 1094 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_first_inbox (self);
#line 1094 "../src/client/application/application-main-window.vala"
	inbox = _tmp0_;
#line 1095 "../src/client/application/application-main-window.vala"
	_tmp1_ = inbox;
#line 1095 "../src/client/application/application-main-window.vala"
	if (_tmp1_ != NULL) {
#line 6345 "application-main-window.c"
		GearyFolder* _tmp2_;
#line 1096 "../src/client/application/application-main-window.vala"
		_tmp2_ = inbox;
#line 1096 "../src/client/application/application-main-window.vala"
		application_main_window_select_folder (self, _tmp2_, is_interactive, FALSE, NULL, NULL);
#line 1097 "../src/client/application/application-main-window.vala"
		success = TRUE;
#line 6353 "application-main-window.c"
	}
#line 1099 "../src/client/application/application-main-window.vala"
	result = success;
#line 1099 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (inbox);
#line 1099 "../src/client/application/application-main-window.vala"
	return result;
#line 6361 "application-main-window.c"
}

static void
_application_main_window_on_folders_available_application_account_context_folders_available (ApplicationAccountContext* _sender,
                                                                                             GeeCollection* available,
                                                                                             gpointer self)
{
#line 1116 "../src/client/application/application-main-window.vala"
	application_main_window_on_folders_available ((ApplicationMainWindow*) self, available);
#line 6371 "application-main-window.c"
}

static void
_application_main_window_on_folders_unavailable_application_account_context_folders_unavailable (ApplicationAccountContext* _sender,
                                                                                                 GeeCollection* unavailable,
                                                                                                 gpointer self)
{
#line 1117 "../src/client/application/application-main-window.vala"
	application_main_window_on_folders_unavailable ((ApplicationMainWindow*) self, unavailable);
#line 6381 "application-main-window.c"
}

static void
_application_main_window_on_command_execute_application_command_stack_executed (ApplicationCommandStack* _sender,
                                                                                ApplicationCommand* command,
                                                                                gpointer self)
{
#line 1118 "../src/client/application/application-main-window.vala"
	application_main_window_on_command_execute ((ApplicationMainWindow*) self, command);
#line 6391 "application-main-window.c"
}

static void
_application_main_window_on_command_undo_application_command_stack_undone (ApplicationCommandStack* _sender,
                                                                           ApplicationCommand* command,
                                                                           gpointer self)
{
#line 1119 "../src/client/application/application-main-window.vala"
	application_main_window_on_command_undo ((ApplicationMainWindow*) self, command);
#line 6401 "application-main-window.c"
}

static void
_application_main_window_on_command_redo_application_command_stack_redone (ApplicationCommandStack* _sender,
                                                                           ApplicationCommand* command,
                                                                           gpointer self)
{
#line 1120 "../src/client/application/application-main-window.vala"
	application_main_window_on_command_redo ((ApplicationMainWindow*) self, command);
#line 6411 "application-main-window.c"
}

static void
application_main_window_add_account (ApplicationMainWindow* self,
                                     ApplicationAccountContext* to_add)
{
	GeeSet* _tmp0_;
#line 1102 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1102 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_ACCOUNT_CONTEXT (to_add));
#line 1103 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->accounts;
#line 1103 "../src/client/application/application-main-window.vala"
	if (!gee_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), to_add)) {
#line 6427 "application-main-window.c"
		FolderListTree* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAggregateProgressMonitor* _tmp4_;
		GearyAccount* _tmp5_;
		GearyAccount* _tmp6_;
		GearyProgressMonitor* _tmp7_;
		GearyProgressMonitor* _tmp8_;
		GearySmtpClientService* smtp = NULL;
		GearyAccount* _tmp9_;
		GearyAccount* _tmp10_;
		GearyClientService* _tmp11_;
		GearyClientService* _tmp12_;
		GearySmtpClientService* _tmp13_;
		GearySmtpClientService* _tmp14_;
		ApplicationCommandStack* _tmp19_;
		ApplicationCommandStack* _tmp20_;
		ApplicationCommandStack* _tmp21_;
		ApplicationCommandStack* _tmp22_;
		ApplicationCommandStack* _tmp23_;
		ApplicationCommandStack* _tmp24_;
		GeeTreeSet* added = NULL;
		GeeTreeSet* _tmp25_;
		GeeTreeSet* _tmp26_;
		GeeCollection* _tmp27_;
		GeeCollection* _tmp28_;
		GeeTreeSet* _tmp29_;
		GeeSet* _tmp30_;
#line 1104 "../src/client/application/application-main-window.vala"
		_tmp1_ = self->priv->_folder_list;
#line 1104 "../src/client/application/application-main-window.vala"
		_tmp2_ = application_account_context_get_account (to_add);
#line 1104 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 1104 "../src/client/application/application-main-window.vala"
		folder_list_tree_set_user_folders_root_name (_tmp1_, _tmp3_, _ ("Labels"));
#line 1108 "../src/client/application/application-main-window.vala"
		_tmp4_ = self->priv->progress_monitor;
#line 1108 "../src/client/application/application-main-window.vala"
		_tmp5_ = application_account_context_get_account (to_add);
#line 1108 "../src/client/application/application-main-window.vala"
		_tmp6_ = _tmp5_;
#line 1108 "../src/client/application/application-main-window.vala"
		_tmp7_ = geary_account_get_background_progress (_tmp6_);
#line 1108 "../src/client/application/application-main-window.vala"
		_tmp8_ = _tmp7_;
#line 1108 "../src/client/application/application-main-window.vala"
		geary_aggregate_progress_monitor_add (_tmp4_, _tmp8_);
#line 1109 "../src/client/application/application-main-window.vala"
		_tmp9_ = application_account_context_get_account (to_add);
#line 1109 "../src/client/application/application-main-window.vala"
		_tmp10_ = _tmp9_;
#line 1109 "../src/client/application/application-main-window.vala"
		_tmp11_ = geary_account_get_outgoing (_tmp10_);
#line 1109 "../src/client/application/application-main-window.vala"
		_tmp12_ = _tmp11_;
#line 1109 "../src/client/application/application-main-window.vala"
		_tmp13_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, GEARY_SMTP_TYPE_CLIENT_SERVICE) ? ((GearySmtpClientService*) _tmp12_) : NULL);
#line 1109 "../src/client/application/application-main-window.vala"
		smtp = _tmp13_;
#line 1112 "../src/client/application/application-main-window.vala"
		_tmp14_ = smtp;
#line 1112 "../src/client/application/application-main-window.vala"
		if (_tmp14_ != NULL) {
#line 6492 "application-main-window.c"
			GearyAggregateProgressMonitor* _tmp15_;
			GearySmtpClientService* _tmp16_;
			GearyProgressMonitor* _tmp17_;
			GearyProgressMonitor* _tmp18_;
#line 1113 "../src/client/application/application-main-window.vala"
			_tmp15_ = self->priv->progress_monitor;
#line 1113 "../src/client/application/application-main-window.vala"
			_tmp16_ = smtp;
#line 1113 "../src/client/application/application-main-window.vala"
			_tmp17_ = geary_smtp_client_service_get_sending_monitor (_tmp16_);
#line 1113 "../src/client/application/application-main-window.vala"
			_tmp18_ = _tmp17_;
#line 1113 "../src/client/application/application-main-window.vala"
			geary_aggregate_progress_monitor_add (_tmp15_, _tmp18_);
#line 6507 "application-main-window.c"
		}
#line 1116 "../src/client/application/application-main-window.vala"
		g_signal_connect_object (to_add, "folders-available", (GCallback) _application_main_window_on_folders_available_application_account_context_folders_available, self, 0);
#line 1117 "../src/client/application/application-main-window.vala"
		g_signal_connect_object (to_add, "folders-unavailable", (GCallback) _application_main_window_on_folders_unavailable_application_account_context_folders_unavailable, self, 0);
#line 1118 "../src/client/application/application-main-window.vala"
		_tmp19_ = application_account_context_get_commands (to_add);
#line 1118 "../src/client/application/application-main-window.vala"
		_tmp20_ = _tmp19_;
#line 1118 "../src/client/application/application-main-window.vala"
		g_signal_connect_object (_tmp20_, "executed", (GCallback) _application_main_window_on_command_execute_application_command_stack_executed, self, 0);
#line 1119 "../src/client/application/application-main-window.vala"
		_tmp21_ = application_account_context_get_commands (to_add);
#line 1119 "../src/client/application/application-main-window.vala"
		_tmp22_ = _tmp21_;
#line 1119 "../src/client/application/application-main-window.vala"
		g_signal_connect_object (_tmp22_, "undone", (GCallback) _application_main_window_on_command_undo_application_command_stack_undone, self, 0);
#line 1120 "../src/client/application/application-main-window.vala"
		_tmp23_ = application_account_context_get_commands (to_add);
#line 1120 "../src/client/application/application-main-window.vala"
		_tmp24_ = _tmp23_;
#line 1120 "../src/client/application/application-main-window.vala"
		g_signal_connect_object (_tmp24_, "redone", (GCallback) _application_main_window_on_command_redo_application_command_stack_redone, self, 0);
#line 1124 "../src/client/application/application-main-window.vala"
		_tmp25_ = gee_tree_set_new (APPLICATION_TYPE_FOLDER_CONTEXT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1124 "../src/client/application/application-main-window.vala"
		added = _tmp25_;
#line 1125 "../src/client/application/application-main-window.vala"
		_tmp26_ = added;
#line 1125 "../src/client/application/application-main-window.vala"
		_tmp27_ = application_account_context_get_folders (to_add);
#line 1125 "../src/client/application/application-main-window.vala"
		_tmp28_ = _tmp27_;
#line 1125 "../src/client/application/application-main-window.vala"
		gee_collection_add_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, GEE_TYPE_COLLECTION, GeeCollection), _tmp28_);
#line 1125 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp28_);
#line 1127 "../src/client/application/application-main-window.vala"
		_tmp29_ = added;
#line 1127 "../src/client/application/application-main-window.vala"
		application_main_window_add_folders (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1128 "../src/client/application/application-main-window.vala"
		_tmp30_ = self->priv->accounts;
#line 1128 "../src/client/application/application-main-window.vala"
		gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, GEE_TYPE_COLLECTION, GeeCollection), to_add);
#line 1103 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (added);
#line 1103 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (smtp);
#line 6557 "application-main-window.c"
	}
}

static void
application_main_window_remove_account_data_free (gpointer _data)
{
	ApplicationMainWindowRemoveAccountData* _data_;
	_data_ = _data;
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->to_remove);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->to_select);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/client/application/application-main-window.vala"
	g_slice_free (ApplicationMainWindowRemoveAccountData, _data_);
#line 6574 "application-main-window.c"
}

static void
application_main_window_remove_account (ApplicationMainWindow* self,
                                        ApplicationAccountContext* to_remove,
                                        GearyFolder* to_select,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_)
{
	ApplicationMainWindowRemoveAccountData* _data_;
	ApplicationMainWindow* _tmp0_;
	ApplicationAccountContext* _tmp1_;
	GearyFolder* _tmp2_;
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_ACCOUNT_CONTEXT (to_remove));
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((to_select == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (to_select, GEARY_TYPE_FOLDER));
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_slice_new0 (ApplicationMainWindowRemoveAccountData);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 10 "../src/client/application/application-main-window.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_main_window_remove_account_data_free);
#line 10 "../src/client/application/application-main-window.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->self = _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (to_remove);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->to_remove);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->to_remove = _tmp1_;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp2_ = _g_object_ref0 (to_select);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->to_select);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->to_select = _tmp2_;
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_remove_account_co (_data_);
#line 6618 "application-main-window.c"
}

static void
application_main_window_remove_account_finish (ApplicationMainWindow* self,
                                               GAsyncResult* _res_)
{
	ApplicationMainWindowRemoveAccountData* _data_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 6628 "application-main-window.c"
}

/**
     * Removes the given account from the main window.
     *
     * If `to_select` is not null, the given folder will be selected,
     * otherwise no folder will be.
     */
static void
application_main_window_remove_account_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_)
{
	ApplicationMainWindowRemoveAccountData* _data_;
#line 1151 "../src/client/application/application-main-window.vala"
	_data_ = _user_data_;
#line 1151 "../src/client/application/application-main-window.vala"
	_data_->_source_object_ = source_object;
#line 1151 "../src/client/application/application-main-window.vala"
	_data_->_res_ = _res_;
#line 1151 "../src/client/application/application-main-window.vala"
	application_main_window_remove_account_co (_data_);
#line 6651 "application-main-window.c"
}

static void
_application_main_window_on_folders_unavailable_application_account_context_folders_available (ApplicationAccountContext* _sender,
                                                                                               GeeCollection* available,
                                                                                               gpointer self)
{
#line 1163 "../src/client/application/application-main-window.vala"
	application_main_window_on_folders_unavailable ((ApplicationMainWindow*) self, available);
#line 6661 "application-main-window.c"
}

static gboolean
application_main_window_remove_account_co (ApplicationMainWindowRemoveAccountData* _data_)
{
#line 1138 "../src/client/application/application-main-window.vala"
	switch (_data_->_state_) {
#line 1138 "../src/client/application/application-main-window.vala"
		case 0:
#line 6671 "application-main-window.c"
		goto _state_0;
#line 1138 "../src/client/application/application-main-window.vala"
		case 1:
#line 6675 "application-main-window.c"
		goto _state_1;
		default:
#line 1138 "../src/client/application/application-main-window.vala"
		g_assert_not_reached ();
#line 6680 "application-main-window.c"
	}
	_state_0:
#line 1140 "../src/client/application/application-main-window.vala"
	_data_->_tmp0_ = _data_->self->priv->accounts;
#line 1140 "../src/client/application/application-main-window.vala"
	if (gee_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), _data_->to_remove)) {
#line 1145 "../src/client/application/application-main-window.vala"
		_data_->_tmp2_ = _data_->self->priv->_selected_folder;
#line 1145 "../src/client/application/application-main-window.vala"
		if (_data_->_tmp2_ != NULL) {
#line 1146 "../src/client/application/application-main-window.vala"
			_data_->_tmp3_ = _data_->self->priv->_selected_folder;
#line 1146 "../src/client/application/application-main-window.vala"
			_data_->_tmp4_ = geary_folder_get_account (_data_->_tmp3_);
#line 1146 "../src/client/application/application-main-window.vala"
			_data_->_tmp5_ = _data_->_tmp4_;
#line 1146 "../src/client/application/application-main-window.vala"
			_data_->_tmp6_ = application_account_context_get_account (_data_->to_remove);
#line 1146 "../src/client/application/application-main-window.vala"
			_data_->_tmp7_ = _data_->_tmp6_;
#line 1146 "../src/client/application/application-main-window.vala"
			_data_->_tmp1_ = _data_->_tmp5_ == _data_->_tmp7_;
#line 6703 "application-main-window.c"
		} else {
#line 1145 "../src/client/application/application-main-window.vala"
			_data_->_tmp1_ = FALSE;
#line 6707 "application-main-window.c"
		}
#line 1145 "../src/client/application/application-main-window.vala"
		if (_data_->_tmp1_) {
#line 1147 "../src/client/application/application-main-window.vala"
			_data_->_tmp8_ = _data_->self->priv->_selected_folder;
#line 1147 "../src/client/application/application-main-window.vala"
			_data_->_tmp9_ = geary_folder_get_used_as (_data_->_tmp8_);
#line 1147 "../src/client/application/application-main-window.vala"
			_data_->_tmp10_ = _data_->_tmp9_;
#line 1147 "../src/client/application/application-main-window.vala"
			_data_->is_account_search_active = _data_->_tmp10_ == GEARY_FOLDER_SPECIAL_USE_SEARCH;
#line 1151 "../src/client/application/application-main-window.vala"
			_data_->_state_ = 1;
#line 1151 "../src/client/application/application-main-window.vala"
			application_main_window_select_folder (_data_->self, _data_->to_select, FALSE, FALSE, application_main_window_remove_account_ready, _data_);
#line 1151 "../src/client/application/application-main-window.vala"
			return FALSE;
#line 6725 "application-main-window.c"
			_state_1:
#line 1151 "../src/client/application/application-main-window.vala"
			application_main_window_select_folder_finish (_data_->self, _data_->_res_);
#line 1153 "../src/client/application/application-main-window.vala"
			if (_data_->is_account_search_active) {
#line 1154 "../src/client/application/application-main-window.vala"
				_data_->_tmp11_ = _data_->self->priv->_search_bar;
#line 1154 "../src/client/application/application-main-window.vala"
				_data_->_tmp12_ = search_bar_get_entry (_data_->_tmp11_);
#line 1154 "../src/client/application/application-main-window.vala"
				_data_->_tmp13_ = _data_->_tmp12_;
#line 1154 "../src/client/application/application-main-window.vala"
				gtk_entry_set_text (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp13_, gtk_entry_get_type (), GtkEntry), "");
#line 1155 "../src/client/application/application-main-window.vala"
				_data_->_tmp14_ = _data_->self->priv->_search_bar;
#line 1155 "../src/client/application/application-main-window.vala"
				g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp14_, hdy_search_bar_get_type (), HdySearchBar), "search-mode-enabled", FALSE, NULL);
#line 6743 "application-main-window.c"
			}
		}
#line 1159 "../src/client/application/application-main-window.vala"
		_data_->_tmp15_ = application_account_context_get_commands (_data_->to_remove);
#line 1159 "../src/client/application/application-main-window.vala"
		_data_->_tmp16_ = _data_->_tmp15_;
#line 1159 "../src/client/application/application-main-window.vala"
		g_signal_parse_name ("executed", APPLICATION_TYPE_COMMAND_STACK, &_data_->_tmp17_, NULL, FALSE);
#line 1159 "../src/client/application/application-main-window.vala"
		g_signal_handlers_disconnect_matched (_data_->_tmp16_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _data_->_tmp17_, 0, NULL, (GCallback) _application_main_window_on_command_execute_application_command_stack_executed, _data_->self);
#line 1160 "../src/client/application/application-main-window.vala"
		_data_->_tmp18_ = application_account_context_get_commands (_data_->to_remove);
#line 1160 "../src/client/application/application-main-window.vala"
		_data_->_tmp19_ = _data_->_tmp18_;
#line 1160 "../src/client/application/application-main-window.vala"
		g_signal_parse_name ("undone", APPLICATION_TYPE_COMMAND_STACK, &_data_->_tmp20_, NULL, FALSE);
#line 1160 "../src/client/application/application-main-window.vala"
		g_signal_handlers_disconnect_matched (_data_->_tmp19_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _data_->_tmp20_, 0, NULL, (GCallback) _application_main_window_on_command_undo_application_command_stack_undone, _data_->self);
#line 1161 "../src/client/application/application-main-window.vala"
		_data_->_tmp21_ = application_account_context_get_commands (_data_->to_remove);
#line 1161 "../src/client/application/application-main-window.vala"
		_data_->_tmp22_ = _data_->_tmp21_;
#line 1161 "../src/client/application/application-main-window.vala"
		g_signal_parse_name ("redone", APPLICATION_TYPE_COMMAND_STACK, &_data_->_tmp23_, NULL, FALSE);
#line 1161 "../src/client/application/application-main-window.vala"
		g_signal_handlers_disconnect_matched (_data_->_tmp22_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _data_->_tmp23_, 0, NULL, (GCallback) _application_main_window_on_command_redo_application_command_stack_redone, _data_->self);
#line 1162 "../src/client/application/application-main-window.vala"
		g_signal_parse_name ("folders-available", APPLICATION_TYPE_ACCOUNT_CONTEXT, &_data_->_tmp24_, NULL, FALSE);
#line 1162 "../src/client/application/application-main-window.vala"
		g_signal_handlers_disconnect_matched (_data_->to_remove, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _data_->_tmp24_, 0, NULL, (GCallback) _application_main_window_on_folders_available_application_account_context_folders_available, _data_->self);
#line 1163 "../src/client/application/application-main-window.vala"
		g_signal_parse_name ("folders-available", APPLICATION_TYPE_ACCOUNT_CONTEXT, &_data_->_tmp25_, NULL, FALSE);
#line 1163 "../src/client/application/application-main-window.vala"
		g_signal_handlers_disconnect_matched (_data_->to_remove, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _data_->_tmp25_, 0, NULL, (GCallback) _application_main_window_on_folders_unavailable_application_account_context_folders_available, _data_->self);
#line 1165 "../src/client/application/application-main-window.vala"
		_data_->_tmp26_ = _data_->self->priv->progress_monitor;
#line 1165 "../src/client/application/application-main-window.vala"
		_data_->_tmp27_ = application_account_context_get_account (_data_->to_remove);
#line 1165 "../src/client/application/application-main-window.vala"
		_data_->_tmp28_ = _data_->_tmp27_;
#line 1165 "../src/client/application/application-main-window.vala"
		_data_->_tmp29_ = geary_account_get_background_progress (_data_->_tmp28_);
#line 1165 "../src/client/application/application-main-window.vala"
		_data_->_tmp30_ = _data_->_tmp29_;
#line 1165 "../src/client/application/application-main-window.vala"
		geary_aggregate_progress_monitor_remove (_data_->_tmp26_, _data_->_tmp30_);
#line 1166 "../src/client/application/application-main-window.vala"
		_data_->_tmp31_ = application_account_context_get_account (_data_->to_remove);
#line 1166 "../src/client/application/application-main-window.vala"
		_data_->_tmp32_ = _data_->_tmp31_;
#line 1166 "../src/client/application/application-main-window.vala"
		_data_->_tmp33_ = geary_account_get_outgoing (_data_->_tmp32_);
#line 1166 "../src/client/application/application-main-window.vala"
		_data_->_tmp34_ = _data_->_tmp33_;
#line 1166 "../src/client/application/application-main-window.vala"
		_data_->_tmp35_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_data_->_tmp34_, GEARY_SMTP_TYPE_CLIENT_SERVICE) ? ((GearySmtpClientService*) _data_->_tmp34_) : NULL);
#line 1166 "../src/client/application/application-main-window.vala"
		_data_->smtp = _data_->_tmp35_;
#line 1169 "../src/client/application/application-main-window.vala"
		_data_->_tmp36_ = _data_->smtp;
#line 1169 "../src/client/application/application-main-window.vala"
		if (_data_->_tmp36_ != NULL) {
#line 1170 "../src/client/application/application-main-window.vala"
			_data_->_tmp37_ = _data_->self->priv->progress_monitor;
#line 1170 "../src/client/application/application-main-window.vala"
			_data_->_tmp38_ = _data_->smtp;
#line 1170 "../src/client/application/application-main-window.vala"
			_data_->_tmp39_ = geary_smtp_client_service_get_sending_monitor (_data_->_tmp38_);
#line 1170 "../src/client/application/application-main-window.vala"
			_data_->_tmp40_ = _data_->_tmp39_;
#line 1170 "../src/client/application/application-main-window.vala"
			geary_aggregate_progress_monitor_remove (_data_->_tmp37_, _data_->_tmp40_);
#line 6816 "application-main-window.c"
		}
#line 1174 "../src/client/application/application-main-window.vala"
		_data_->_tmp41_ = application_account_context_get_folders (_data_->to_remove);
#line 1174 "../src/client/application/application-main-window.vala"
		_data_->_tmp42_ = _data_->_tmp41_;
#line 1174 "../src/client/application/application-main-window.vala"
		application_main_window_remove_folders (_data_->self, _data_->_tmp42_, FALSE);
#line 1174 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data_->_tmp42_);
#line 1175 "../src/client/application/application-main-window.vala"
		_data_->_tmp43_ = _data_->self->priv->_folder_list;
#line 1175 "../src/client/application/application-main-window.vala"
		_data_->_tmp44_ = application_account_context_get_account (_data_->to_remove);
#line 1175 "../src/client/application/application-main-window.vala"
		_data_->_tmp45_ = _data_->_tmp44_;
#line 1175 "../src/client/application/application-main-window.vala"
		folder_list_tree_remove_account (_data_->_tmp43_, _data_->_tmp45_);
#line 1176 "../src/client/application/application-main-window.vala"
		_data_->_tmp46_ = _data_->self->priv->accounts;
#line 1176 "../src/client/application/application-main-window.vala"
		gee_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp46_, GEE_TYPE_COLLECTION, GeeCollection), _data_->to_remove);
#line 1140 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data_->smtp);
#line 6840 "application-main-window.c"
	}
#line 1138 "../src/client/application/application-main-window.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1138 "../src/client/application/application-main-window.vala"
	if (_data_->_state_ != 0) {
#line 1138 "../src/client/application/application-main-window.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1138 "../src/client/application/application-main-window.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 6850 "application-main-window.c"
		}
	}
#line 1138 "../src/client/application/application-main-window.vala"
	g_object_unref (_data_->_async_result);
#line 1138 "../src/client/application/application-main-window.vala"
	return FALSE;
#line 6857 "application-main-window.c"
}

/** Adds a folder to the window. */
static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1455 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1455 "glib-2.0.vapi"
	end = _tmp0_;
#line 1456 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1456 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1457 "glib-2.0.vapi"
		result = maxlen;
#line 1457 "glib-2.0.vapi"
		return result;
#line 6881 "application-main-window.c"
	} else {
		gchar* _tmp2_;
#line 1459 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1459 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1459 "glib-2.0.vapi"
		return result;
#line 6890 "application-main-window.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1466 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1468 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 6909 "application-main-window.c"
	} else {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 6913 "application-main-window.c"
	}
#line 1468 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1470 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 6919 "application-main-window.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1472 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1472 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1472 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 6929 "application-main-window.c"
	}
#line 1475 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1476 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1477 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 6937 "application-main-window.c"
	} else {
#line 1479 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 6941 "application-main-window.c"
	}
#line 1481 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1482 "glib-2.0.vapi"
		len = string_length - offset;
#line 6947 "application-main-window.c"
	}
#line 1484 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1485 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1485 "glib-2.0.vapi"
	result = _tmp3_;
#line 1485 "glib-2.0.vapi"
	return result;
#line 6957 "application-main-window.c"
}

static void
_application_main_window_on_use_changed_geary_folder_use_changed (GearyFolder* _sender,
                                                                  GearyFolderSpecialUse old_use,
                                                                  GearyFolderSpecialUse new_use,
                                                                  gpointer self)
{
#line 1201 "../src/client/application/application-main-window.vala"
	application_main_window_on_use_changed ((ApplicationMainWindow*) self, _sender, old_use, new_use);
#line 6968 "application-main-window.c"
}

static void
application_main_window_add_folders (ApplicationMainWindow* self,
                                     GeeCollection* to_add)
{
	GeeHashMap* map = NULL;
	GeeHashMap* _tmp0_;
#line 1181 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1181 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (to_add, GEE_TYPE_COLLECTION));
#line 1184 "../src/client/application/application-main-window.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1184 "../src/client/application/application-main-window.vala"
	map = _tmp0_;
#line 6985 "application-main-window.c"
	{
		GeeIterator* _context_it = NULL;
		GeeIterator* _tmp1_;
#line 1185 "../src/client/application/application-main-window.vala"
		_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (to_add, GEE_TYPE_ITERABLE, GeeIterable));
#line 1185 "../src/client/application/application-main-window.vala"
		_context_it = _tmp1_;
#line 1185 "../src/client/application/application-main-window.vala"
		while (TRUE) {
#line 6995 "application-main-window.c"
			GeeIterator* _tmp2_;
			ApplicationFolderContext* context = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GearyFolder* folder = NULL;
			ApplicationFolderContext* _tmp5_;
			GearyFolder* _tmp6_;
			GearyFolder* _tmp7_;
			GearyFolder* _tmp8_;
			GearyFolder* _tmp9_;
			GearyFolderSpecialUse _tmp10_;
			GearyFolderSpecialUse _tmp11_;
			GeeHashMap* _tmp12_;
			GearyFolder* _tmp13_;
			GearyFolderPath* _tmp14_;
			GearyFolderPath* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			ApplicationFolderContext* _tmp20_;
			const gchar* _tmp21_;
			const gchar* _tmp22_;
#line 1185 "../src/client/application/application-main-window.vala"
			_tmp2_ = _context_it;
#line 1185 "../src/client/application/application-main-window.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 1185 "../src/client/application/application-main-window.vala"
				break;
#line 7025 "application-main-window.c"
			}
#line 1185 "../src/client/application/application-main-window.vala"
			_tmp3_ = _context_it;
#line 1185 "../src/client/application/application-main-window.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 1185 "../src/client/application/application-main-window.vala"
			context = (ApplicationFolderContext*) _tmp4_;
#line 1186 "../src/client/application/application-main-window.vala"
			_tmp5_ = context;
#line 1186 "../src/client/application/application-main-window.vala"
			_tmp6_ = application_folder_context_get_folder (_tmp5_);
#line 1186 "../src/client/application/application-main-window.vala"
			_tmp7_ = _tmp6_;
#line 1186 "../src/client/application/application-main-window.vala"
			_tmp8_ = _g_object_ref0 (_tmp7_);
#line 1186 "../src/client/application/application-main-window.vala"
			folder = _tmp8_;
#line 1187 "../src/client/application/application-main-window.vala"
			_tmp9_ = folder;
#line 1187 "../src/client/application/application-main-window.vala"
			_tmp10_ = geary_folder_get_used_as (_tmp9_);
#line 1187 "../src/client/application/application-main-window.vala"
			_tmp11_ = _tmp10_;
#line 1187 "../src/client/application/application-main-window.vala"
			if (_tmp11_ == GEARY_FOLDER_SPECIAL_USE_NONE) {
#line 1188 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (folder);
#line 1188 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (context);
#line 1188 "../src/client/application/application-main-window.vala"
				continue;
#line 7057 "application-main-window.c"
			}
#line 1189 "../src/client/application/application-main-window.vala"
			_tmp12_ = map;
#line 1189 "../src/client/application/application-main-window.vala"
			_tmp13_ = folder;
#line 1189 "../src/client/application/application-main-window.vala"
			_tmp14_ = geary_folder_get_path (_tmp13_);
#line 1189 "../src/client/application/application-main-window.vala"
			_tmp15_ = _tmp14_;
#line 1189 "../src/client/application/application-main-window.vala"
			_tmp16_ = geary_folder_path_to_string (_tmp15_);
#line 1189 "../src/client/application/application-main-window.vala"
			_tmp17_ = _tmp16_;
#line 1189 "../src/client/application/application-main-window.vala"
			_tmp18_ = string_substring (_tmp17_, (glong) 1, (glong) -1);
#line 1189 "../src/client/application/application-main-window.vala"
			_tmp19_ = _tmp18_;
#line 1189 "../src/client/application/application-main-window.vala"
			_tmp20_ = context;
#line 1189 "../src/client/application/application-main-window.vala"
			_tmp21_ = application_folder_context_get_display_name (_tmp20_);
#line 1189 "../src/client/application/application-main-window.vala"
			_tmp22_ = _tmp21_;
#line 1189 "../src/client/application/application-main-window.vala"
			gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp19_, _tmp22_);
#line 1189 "../src/client/application/application-main-window.vala"
			_g_free0 (_tmp19_);
#line 1189 "../src/client/application/application-main-window.vala"
			_g_free0 (_tmp17_);
#line 1185 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (folder);
#line 1185 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (context);
#line 7091 "application-main-window.c"
		}
#line 1185 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_context_it);
#line 7095 "application-main-window.c"
	}
	{
		GeeIterator* _context_it = NULL;
		GeeIterator* _tmp23_;
#line 1194 "../src/client/application/application-main-window.vala"
		_tmp23_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (to_add, GEE_TYPE_ITERABLE, GeeIterable));
#line 1194 "../src/client/application/application-main-window.vala"
		_context_it = _tmp23_;
#line 1194 "../src/client/application/application-main-window.vala"
		while (TRUE) {
#line 7106 "application-main-window.c"
			GeeIterator* _tmp24_;
			ApplicationFolderContext* context = NULL;
			GeeIterator* _tmp25_;
			gpointer _tmp26_;
			FolderListTree* _tmp27_;
			ApplicationFolderContext* _tmp28_;
			ApplicationFolderContext* _tmp29_;
			GearyFolder* _tmp30_;
			GearyFolder* _tmp31_;
			GearyAccount* _tmp32_;
			GearyAccount* _tmp33_;
			GearyAccount* _tmp34_;
			ApplicationFolderContext* _tmp40_;
			GearyFolder* _tmp41_;
			GearyFolder* _tmp42_;
#line 1194 "../src/client/application/application-main-window.vala"
			_tmp24_ = _context_it;
#line 1194 "../src/client/application/application-main-window.vala"
			if (!gee_iterator_next (_tmp24_)) {
#line 1194 "../src/client/application/application-main-window.vala"
				break;
#line 7128 "application-main-window.c"
			}
#line 1194 "../src/client/application/application-main-window.vala"
			_tmp25_ = _context_it;
#line 1194 "../src/client/application/application-main-window.vala"
			_tmp26_ = gee_iterator_get (_tmp25_);
#line 1194 "../src/client/application/application-main-window.vala"
			context = (ApplicationFolderContext*) _tmp26_;
#line 1195 "../src/client/application/application-main-window.vala"
			_tmp27_ = self->priv->_folder_list;
#line 1195 "../src/client/application/application-main-window.vala"
			_tmp28_ = context;
#line 1195 "../src/client/application/application-main-window.vala"
			folder_list_tree_add_folder (_tmp27_, _tmp28_);
#line 1196 "../src/client/application/application-main-window.vala"
			_tmp29_ = context;
#line 1196 "../src/client/application/application-main-window.vala"
			_tmp30_ = application_folder_context_get_folder (_tmp29_);
#line 1196 "../src/client/application/application-main-window.vala"
			_tmp31_ = _tmp30_;
#line 1196 "../src/client/application/application-main-window.vala"
			_tmp32_ = geary_folder_get_account (_tmp31_);
#line 1196 "../src/client/application/application-main-window.vala"
			_tmp33_ = _tmp32_;
#line 1196 "../src/client/application/application-main-window.vala"
			_tmp34_ = self->priv->_selected_account;
#line 1196 "../src/client/application/application-main-window.vala"
			if (_tmp33_ == _tmp34_) {
#line 7156 "application-main-window.c"
				FolderPopover** _tmp35_;
				gint _tmp35__length1;
#line 1197 "../src/client/application/application-main-window.vala"
				_tmp35_ = self->priv->folder_popovers;
#line 1197 "../src/client/application/application-main-window.vala"
				_tmp35__length1 = self->priv->folder_popovers_length1;
#line 7163 "application-main-window.c"
				{
					FolderPopover** menu_collection = NULL;
					gint menu_collection_length1 = 0;
					gint _menu_collection_size_ = 0;
					gint menu_it = 0;
#line 1197 "../src/client/application/application-main-window.vala"
					menu_collection = _tmp35_;
#line 1197 "../src/client/application/application-main-window.vala"
					menu_collection_length1 = _tmp35__length1;
#line 1197 "../src/client/application/application-main-window.vala"
					for (menu_it = 0; menu_it < menu_collection_length1; menu_it = menu_it + 1) {
#line 7175 "application-main-window.c"
						FolderPopover* _tmp36_;
						FolderPopover* menu = NULL;
#line 1197 "../src/client/application/application-main-window.vala"
						_tmp36_ = _g_object_ref0 (menu_collection[menu_it]);
#line 1197 "../src/client/application/application-main-window.vala"
						menu = _tmp36_;
#line 7182 "application-main-window.c"
						{
							FolderPopover* _tmp37_;
							ApplicationFolderContext* _tmp38_;
							GeeHashMap* _tmp39_;
#line 1198 "../src/client/application/application-main-window.vala"
							_tmp37_ = menu;
#line 1198 "../src/client/application/application-main-window.vala"
							_tmp38_ = context;
#line 1198 "../src/client/application/application-main-window.vala"
							_tmp39_ = map;
#line 1198 "../src/client/application/application-main-window.vala"
							folder_popover_add_folder (_tmp37_, _tmp38_, _tmp39_);
#line 1197 "../src/client/application/application-main-window.vala"
							_g_object_unref0 (menu);
#line 7197 "application-main-window.c"
						}
					}
				}
			}
#line 1201 "../src/client/application/application-main-window.vala"
			_tmp40_ = context;
#line 1201 "../src/client/application/application-main-window.vala"
			_tmp41_ = application_folder_context_get_folder (_tmp40_);
#line 1201 "../src/client/application/application-main-window.vala"
			_tmp42_ = _tmp41_;
#line 1201 "../src/client/application/application-main-window.vala"
			g_signal_connect_object (_tmp42_, "use-changed", (GCallback) _application_main_window_on_use_changed_geary_folder_use_changed, self, 0);
#line 1194 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (context);
#line 7212 "application-main-window.c"
		}
#line 1194 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_context_it);
#line 7216 "application-main-window.c"
	}
#line 1181 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (map);
#line 7220 "application-main-window.c"
}

/** Removes a folder from the window. */
static void
application_main_window_remove_folders (ApplicationMainWindow* self,
                                        GeeCollection* to_remove,
                                        gboolean update_selecton)
{
#line 1206 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1206 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (to_remove, GEE_TYPE_COLLECTION));
#line 7233 "application-main-window.c"
	{
		GeeIterator* _context_it = NULL;
		GeeIterator* _tmp0_;
#line 1208 "../src/client/application/application-main-window.vala"
		_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (to_remove, GEE_TYPE_ITERABLE, GeeIterable));
#line 1208 "../src/client/application/application-main-window.vala"
		_context_it = _tmp0_;
#line 1208 "../src/client/application/application-main-window.vala"
		while (TRUE) {
#line 7243 "application-main-window.c"
			GeeIterator* _tmp1_;
			ApplicationFolderContext* context = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			GearyFolder* folder = NULL;
			ApplicationFolderContext* _tmp4_;
			GearyFolder* _tmp5_;
			GearyFolder* _tmp6_;
			GearyFolder* _tmp7_;
			GearyFolder* _tmp8_;
			GearyFolder* _tmp9_;
			GearyFolder* _tmp14_;
			guint _tmp15_;
			GearyFolder* _tmp16_;
			GearyAccount* _tmp17_;
			GearyAccount* _tmp18_;
			GearyAccount* _tmp19_;
			FolderListTree* _tmp24_;
			ApplicationFolderContext* _tmp25_;
#line 1208 "../src/client/application/application-main-window.vala"
			_tmp1_ = _context_it;
#line 1208 "../src/client/application/application-main-window.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 1208 "../src/client/application/application-main-window.vala"
				break;
#line 7269 "application-main-window.c"
			}
#line 1208 "../src/client/application/application-main-window.vala"
			_tmp2_ = _context_it;
#line 1208 "../src/client/application/application-main-window.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 1208 "../src/client/application/application-main-window.vala"
			context = (ApplicationFolderContext*) _tmp3_;
#line 1209 "../src/client/application/application-main-window.vala"
			_tmp4_ = context;
#line 1209 "../src/client/application/application-main-window.vala"
			_tmp5_ = application_folder_context_get_folder (_tmp4_);
#line 1209 "../src/client/application/application-main-window.vala"
			_tmp6_ = _tmp5_;
#line 1209 "../src/client/application/application-main-window.vala"
			_tmp7_ = _g_object_ref0 (_tmp6_);
#line 1209 "../src/client/application/application-main-window.vala"
			folder = _tmp7_;
#line 1210 "../src/client/application/application-main-window.vala"
			_tmp8_ = self->priv->_selected_folder;
#line 1210 "../src/client/application/application-main-window.vala"
			_tmp9_ = folder;
#line 1210 "../src/client/application/application-main-window.vala"
			if (_tmp8_ == _tmp9_) {
#line 7293 "application-main-window.c"
				ApplicationAccountContext* account = NULL;
				ApplicationAccountContext* _tmp10_;
				ApplicationAccountContext* _tmp11_;
#line 1211 "../src/client/application/application-main-window.vala"
				_tmp10_ = application_main_window_get_selected_account_context (self);
#line 1211 "../src/client/application/application-main-window.vala"
				account = _tmp10_;
#line 1212 "../src/client/application/application-main-window.vala"
				_tmp11_ = account;
#line 1212 "../src/client/application/application-main-window.vala"
				if (_tmp11_ != NULL) {
#line 7305 "application-main-window.c"
					ApplicationAccountContext* _tmp12_;
					GearyFolder* _tmp13_;
#line 1213 "../src/client/application/application-main-window.vala"
					_tmp12_ = account;
#line 1213 "../src/client/application/application-main-window.vala"
					_tmp13_ = _tmp12_->inbox;
#line 1213 "../src/client/application/application-main-window.vala"
					application_main_window_select_folder (self, _tmp13_, TRUE, FALSE, NULL, NULL);
#line 7314 "application-main-window.c"
				}
#line 1210 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (account);
#line 7318 "application-main-window.c"
			}
#line 1217 "../src/client/application/application-main-window.vala"
			_tmp14_ = folder;
#line 1217 "../src/client/application/application-main-window.vala"
			g_signal_parse_name ("use-changed", GEARY_TYPE_FOLDER, &_tmp15_, NULL, FALSE);
#line 1217 "../src/client/application/application-main-window.vala"
			g_signal_handlers_disconnect_matched (_tmp14_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp15_, 0, NULL, (GCallback) _application_main_window_on_use_changed_geary_folder_use_changed, self);
#line 1218 "../src/client/application/application-main-window.vala"
			_tmp16_ = folder;
#line 1218 "../src/client/application/application-main-window.vala"
			_tmp17_ = geary_folder_get_account (_tmp16_);
#line 1218 "../src/client/application/application-main-window.vala"
			_tmp18_ = _tmp17_;
#line 1218 "../src/client/application/application-main-window.vala"
			_tmp19_ = self->priv->_selected_account;
#line 1218 "../src/client/application/application-main-window.vala"
			if (_tmp18_ == _tmp19_) {
#line 7336 "application-main-window.c"
				FolderPopover** _tmp20_;
				gint _tmp20__length1;
#line 1219 "../src/client/application/application-main-window.vala"
				_tmp20_ = self->priv->folder_popovers;
#line 1219 "../src/client/application/application-main-window.vala"
				_tmp20__length1 = self->priv->folder_popovers_length1;
#line 7343 "application-main-window.c"
				{
					FolderPopover** menu_collection = NULL;
					gint menu_collection_length1 = 0;
					gint _menu_collection_size_ = 0;
					gint menu_it = 0;
#line 1219 "../src/client/application/application-main-window.vala"
					menu_collection = _tmp20_;
#line 1219 "../src/client/application/application-main-window.vala"
					menu_collection_length1 = _tmp20__length1;
#line 1219 "../src/client/application/application-main-window.vala"
					for (menu_it = 0; menu_it < menu_collection_length1; menu_it = menu_it + 1) {
#line 7355 "application-main-window.c"
						FolderPopover* _tmp21_;
						FolderPopover* menu = NULL;
#line 1219 "../src/client/application/application-main-window.vala"
						_tmp21_ = _g_object_ref0 (menu_collection[menu_it]);
#line 1219 "../src/client/application/application-main-window.vala"
						menu = _tmp21_;
#line 7362 "application-main-window.c"
						{
							FolderPopover* _tmp22_;
							GearyFolder* _tmp23_;
#line 1220 "../src/client/application/application-main-window.vala"
							_tmp22_ = menu;
#line 1220 "../src/client/application/application-main-window.vala"
							_tmp23_ = folder;
#line 1220 "../src/client/application/application-main-window.vala"
							folder_popover_remove_folder (_tmp22_, _tmp23_);
#line 1219 "../src/client/application/application-main-window.vala"
							_g_object_unref0 (menu);
#line 7374 "application-main-window.c"
						}
					}
				}
			}
#line 1223 "../src/client/application/application-main-window.vala"
			_tmp24_ = self->priv->_folder_list;
#line 1223 "../src/client/application/application-main-window.vala"
			_tmp25_ = context;
#line 1223 "../src/client/application/application-main-window.vala"
			folder_list_tree_remove_folder (_tmp24_, _tmp25_);
#line 1208 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (folder);
#line 1208 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (context);
#line 7389 "application-main-window.c"
		}
#line 1208 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_context_it);
#line 7393 "application-main-window.c"
	}
}

static ApplicationAccountContext*
application_main_window_get_selected_account_context (ApplicationMainWindow* self)
{
	ApplicationAccountContext* context = NULL;
	GearyAccount* _tmp0_;
	ApplicationAccountContext* result;
#line 1227 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), NULL);
#line 1228 "../src/client/application/application-main-window.vala"
	context = NULL;
#line 1229 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_account;
#line 1229 "../src/client/application/application-main-window.vala"
	if (_tmp0_ != NULL) {
#line 7411 "application-main-window.c"
		ApplicationController* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccountInformation* _tmp3_;
		GearyAccountInformation* _tmp4_;
		ApplicationAccountContext* _tmp5_;
#line 1230 "../src/client/application/application-main-window.vala"
		_tmp1_ = self->priv->controller;
#line 1230 "../src/client/application/application-main-window.vala"
		_tmp2_ = self->priv->_selected_account;
#line 1230 "../src/client/application/application-main-window.vala"
		_tmp3_ = geary_account_get_information (_tmp2_);
#line 1230 "../src/client/application/application-main-window.vala"
		_tmp4_ = _tmp3_;
#line 1230 "../src/client/application/application-main-window.vala"
		_tmp5_ = application_account_interface_get_context_for_account (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, APPLICATION_TYPE_ACCOUNT_INTERFACE, ApplicationAccountInterface), _tmp4_);
#line 1230 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (context);
#line 1230 "../src/client/application/application-main-window.vala"
		context = _tmp5_;
#line 7431 "application-main-window.c"
	}
#line 1234 "../src/client/application/application-main-window.vala"
	result = context;
#line 1234 "../src/client/application/application-main-window.vala"
	return result;
#line 7437 "application-main-window.c"
}

static GearyFolder*
application_main_window_get_first_inbox (ApplicationMainWindow* self)
{
	GearyFolder* inbox = NULL;
	GError* _inner_error0_ = NULL;
	GearyFolder* result;
#line 1237 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), NULL);
#line 1238 "../src/client/application/application-main-window.vala"
	inbox = NULL;
#line 7450 "application-main-window.c"
	{
		GeeCollection* _tmp0_ = NULL;
		ApplicationClient* _tmp1_;
		ApplicationClient* _tmp2_;
		GearyEngine* _tmp3_;
		GearyEngine* _tmp4_;
		GeeCollection* _tmp5_;
		GearyAccount* first = NULL;
		gpointer _tmp6_;
		GearyAccount* _tmp7_;
#line 1241 "../src/client/application/application-main-window.vala"
		_tmp1_ = application_main_window_get_application (self);
#line 1241 "../src/client/application/application-main-window.vala"
		_tmp2_ = _tmp1_;
#line 1241 "../src/client/application/application-main-window.vala"
		_tmp3_ = application_client_get_engine (_tmp2_);
#line 1241 "../src/client/application/application-main-window.vala"
		_tmp4_ = _tmp3_;
#line 1241 "../src/client/application/application-main-window.vala"
		_tmp5_ = geary_engine_get_accounts (_tmp4_, &_inner_error0_);
#line 1241 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp5_;
#line 1241 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7475 "application-main-window.c"
			goto __catch0_g_error;
		}
#line 1240 "../src/client/application/application-main-window.vala"
		_tmp6_ = geary_collection_first (GEARY_TYPE_ACCOUNT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp0_);
#line 1240 "../src/client/application/application-main-window.vala"
		first = (GearyAccount*) _tmp6_;
#line 1243 "../src/client/application/application-main-window.vala"
		_tmp7_ = first;
#line 1243 "../src/client/application/application-main-window.vala"
		if (_tmp7_ != NULL) {
#line 7486 "application-main-window.c"
			GearyAccount* _tmp8_;
			GearyFolder* _tmp9_;
#line 1244 "../src/client/application/application-main-window.vala"
			_tmp8_ = first;
#line 1244 "../src/client/application/application-main-window.vala"
			_tmp9_ = geary_account_get_special_folder (_tmp8_, GEARY_FOLDER_SPECIAL_USE_INBOX);
#line 1244 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (inbox);
#line 1244 "../src/client/application/application-main-window.vala"
			inbox = _tmp9_;
#line 7497 "application-main-window.c"
		}
#line 1239 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (first);
#line 1239 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp0_);
#line 7503 "application-main-window.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 1239 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 1247 "../src/client/application/application-main-window.vala"
		g_debug ("application-main-window.vala:1247: Error getting inbox for first accou" \
"nt");
#line 7512 "application-main-window.c"
	}
	__finally0:
#line 1239 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1239 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (inbox);
#line 1239 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1239 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 1239 "../src/client/application/application-main-window.vala"
		return NULL;
#line 7525 "application-main-window.c"
	}
#line 1249 "../src/client/application/application-main-window.vala"
	result = inbox;
#line 1249 "../src/client/application/application-main-window.vala"
	return result;
#line 7531 "application-main-window.c"
}

static void
application_main_window_load_config (ApplicationMainWindow* self,
                                     ApplicationConfiguration* config)
{
#line 1252 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1252 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_CONFIGURATION (config));
#line 1256 "../src/client/application/application-main-window.vala"
	application_configuration_bind (config, APPLICATION_CONFIGURATION_WINDOW_WIDTH_KEY, G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "window-width", G_SETTINGS_BIND_DEFAULT);
#line 1257 "../src/client/application/application-main-window.vala"
	application_configuration_bind (config, APPLICATION_CONFIGURATION_WINDOW_HEIGHT_KEY, G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "window-height", G_SETTINGS_BIND_DEFAULT);
#line 1258 "../src/client/application/application-main-window.vala"
	application_configuration_bind (config, APPLICATION_CONFIGURATION_WINDOW_MAXIMIZE_KEY, G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "window-maximized", G_SETTINGS_BIND_DEFAULT);
#line 7548 "application-main-window.c"
}

static void
application_main_window_restore_saved_window_state (ApplicationMainWindow* self)
{
	GdkDisplay* display = NULL;
	GdkDisplay* _tmp0_;
	GdkDisplay* _tmp1_;
	GdkDisplay* _tmp2_;
	gboolean _tmp23_;
#line 1261 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1262 "../src/client/application/application-main-window.vala"
	_tmp0_ = gdk_display_get_default ();
#line 1262 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1262 "../src/client/application/application-main-window.vala"
	display = _tmp1_;
#line 1263 "../src/client/application/application-main-window.vala"
	_tmp2_ = display;
#line 1263 "../src/client/application/application-main-window.vala"
	if (_tmp2_ != NULL) {
#line 7571 "application-main-window.c"
		GdkMonitor* monitor = NULL;
		GdkDisplay* _tmp3_;
		GdkMonitor* _tmp4_;
		GdkMonitor* _tmp5_;
		GdkMonitor* _tmp6_;
		gboolean _tmp10_ = FALSE;
		gboolean _tmp11_ = FALSE;
		GdkMonitor* _tmp12_;
#line 1264 "../src/client/application/application-main-window.vala"
		_tmp3_ = display;
#line 1264 "../src/client/application/application-main-window.vala"
		_tmp4_ = gdk_display_get_primary_monitor (_tmp3_);
#line 1264 "../src/client/application/application-main-window.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 1264 "../src/client/application/application-main-window.vala"
		monitor = _tmp5_;
#line 1265 "../src/client/application/application-main-window.vala"
		_tmp6_ = monitor;
#line 1265 "../src/client/application/application-main-window.vala"
		if (_tmp6_ == NULL) {
#line 7592 "application-main-window.c"
			GdkDisplay* _tmp7_;
			GdkMonitor* _tmp8_;
			GdkMonitor* _tmp9_;
#line 1266 "../src/client/application/application-main-window.vala"
			_tmp7_ = display;
#line 1266 "../src/client/application/application-main-window.vala"
			_tmp8_ = gdk_display_get_monitor_at_point (_tmp7_, 1, 1);
#line 1266 "../src/client/application/application-main-window.vala"
			_tmp9_ = _g_object_ref0 (_tmp8_);
#line 1266 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (monitor);
#line 1266 "../src/client/application/application-main-window.vala"
			monitor = _tmp9_;
#line 7606 "application-main-window.c"
		}
#line 1268 "../src/client/application/application-main-window.vala"
		_tmp12_ = monitor;
#line 1268 "../src/client/application/application-main-window.vala"
		if (_tmp12_ != NULL) {
#line 7612 "application-main-window.c"
			gint _tmp13_;
			GdkMonitor* _tmp14_;
			GdkRectangle _tmp15_ = {0};
			GdkRectangle _tmp16_;
#line 1269 "../src/client/application/application-main-window.vala"
			_tmp13_ = self->priv->_window_width;
#line 1269 "../src/client/application/application-main-window.vala"
			_tmp14_ = monitor;
#line 1269 "../src/client/application/application-main-window.vala"
			gdk_monitor_get_geometry (_tmp14_, &_tmp15_);
#line 1269 "../src/client/application/application-main-window.vala"
			_tmp16_ = _tmp15_;
#line 1269 "../src/client/application/application-main-window.vala"
			_tmp11_ = _tmp13_ <= _tmp16_.width;
#line 7627 "application-main-window.c"
		} else {
#line 1268 "../src/client/application/application-main-window.vala"
			_tmp11_ = FALSE;
#line 7631 "application-main-window.c"
		}
#line 1268 "../src/client/application/application-main-window.vala"
		if (_tmp11_) {
#line 7635 "application-main-window.c"
			gint _tmp17_;
			GdkMonitor* _tmp18_;
			GdkRectangle _tmp19_ = {0};
			GdkRectangle _tmp20_;
#line 1270 "../src/client/application/application-main-window.vala"
			_tmp17_ = self->priv->_window_height;
#line 1270 "../src/client/application/application-main-window.vala"
			_tmp18_ = monitor;
#line 1270 "../src/client/application/application-main-window.vala"
			gdk_monitor_get_geometry (_tmp18_, &_tmp19_);
#line 1270 "../src/client/application/application-main-window.vala"
			_tmp20_ = _tmp19_;
#line 1270 "../src/client/application/application-main-window.vala"
			_tmp10_ = _tmp17_ <= _tmp20_.height;
#line 7650 "application-main-window.c"
		} else {
#line 1268 "../src/client/application/application-main-window.vala"
			_tmp10_ = FALSE;
#line 7654 "application-main-window.c"
		}
#line 1268 "../src/client/application/application-main-window.vala"
		if (_tmp10_) {
#line 7658 "application-main-window.c"
			gint _tmp21_;
			gint _tmp22_;
#line 1271 "../src/client/application/application-main-window.vala"
			_tmp21_ = self->priv->_window_width;
#line 1271 "../src/client/application/application-main-window.vala"
			_tmp22_ = self->priv->_window_height;
#line 1271 "../src/client/application/application-main-window.vala"
			gtk_window_set_default_size (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), _tmp21_, _tmp22_);
#line 7667 "application-main-window.c"
		}
#line 1263 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (monitor);
#line 7671 "application-main-window.c"
	}
#line 1274 "../src/client/application/application-main-window.vala"
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), "window-position", GTK_WIN_POS_CENTER, NULL);
#line 1275 "../src/client/application/application-main-window.vala"
	_tmp23_ = self->priv->_window_maximized;
#line 1275 "../src/client/application/application-main-window.vala"
	if (_tmp23_) {
#line 1276 "../src/client/application/application-main-window.vala"
		gtk_window_maximize (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow));
#line 7681 "application-main-window.c"
	}
#line 1261 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (display);
#line 7685 "application-main-window.c"
}

static gboolean
application_main_window_real_window_state_event (GtkWidget* base,
                                                 GdkEventWindowState* event)
{
	ApplicationMainWindow * self;
	gboolean result;
#line 1282 "../src/client/application/application-main-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, APPLICATION_TYPE_MAIN_WINDOW, ApplicationMainWindow);
#line 1282 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 1283 "../src/client/application/application-main-window.vala"
	if ((event->new_window_state & GDK_WINDOW_STATE_WITHDRAWN) == 0) {
#line 7700 "application-main-window.c"
		gboolean maximized = FALSE;
		gboolean _tmp0_;
#line 1284 "../src/client/application/application-main-window.vala"
		maximized = (event->new_window_state & GDK_WINDOW_STATE_MAXIMIZED) != 0;
#line 1287 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->_window_maximized;
#line 1287 "../src/client/application/application-main-window.vala"
		if (_tmp0_ != maximized) {
#line 1288 "../src/client/application/application-main-window.vala"
			application_main_window_set_window_maximized (self, maximized);
#line 7711 "application-main-window.c"
		}
	}
#line 1291 "../src/client/application/application-main-window.vala"
	result = GTK_WIDGET_CLASS (application_main_window_parent_class)->window_state_event (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, hdy_application_window_get_type (), HdyApplicationWindow), gtk_widget_get_type (), GtkWidget), event);
#line 1291 "../src/client/application/application-main-window.vala"
	return result;
#line 7718 "application-main-window.c"
}

static void
application_main_window_real_size_allocate (GtkWidget* base,
                                            GtkAllocation* allocation)
{
	ApplicationMainWindow * self;
	GtkAllocation _tmp0_;
	gboolean _tmp1_;
#line 1295 "../src/client/application/application-main-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, APPLICATION_TYPE_MAIN_WINDOW, ApplicationMainWindow);
#line 1295 "../src/client/application/application-main-window.vala"
	g_return_if_fail (allocation != NULL);
#line 1296 "../src/client/application/application-main-window.vala"
	_tmp0_ = *allocation;
#line 1296 "../src/client/application/application-main-window.vala"
	GTK_WIDGET_CLASS (application_main_window_parent_class)->size_allocate (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, hdy_application_window_get_type (), HdyApplicationWindow), gtk_widget_get_type (), GtkWidget), &_tmp0_);
#line 1298 "../src/client/application/application-main-window.vala"
	_tmp1_ = self->priv->_window_maximized;
#line 1298 "../src/client/application/application-main-window.vala"
	if (!_tmp1_) {
#line 7740 "application-main-window.c"
		GdkDisplay* display = NULL;
		GdkDisplay* _tmp2_;
		GdkDisplay* _tmp3_;
		GdkWindow* window = NULL;
		GdkWindow* _tmp4_;
		GdkWindow* _tmp5_;
		gboolean _tmp6_ = FALSE;
		GdkDisplay* _tmp7_;
#line 1299 "../src/client/application/application-main-window.vala"
		_tmp2_ = gtk_widget_get_display (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 1299 "../src/client/application/application-main-window.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 1299 "../src/client/application/application-main-window.vala"
		display = _tmp3_;
#line 1300 "../src/client/application/application-main-window.vala"
		_tmp4_ = gtk_widget_get_window (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 1300 "../src/client/application/application-main-window.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 1300 "../src/client/application/application-main-window.vala"
		window = _tmp5_;
#line 1301 "../src/client/application/application-main-window.vala"
		_tmp7_ = display;
#line 1301 "../src/client/application/application-main-window.vala"
		if (_tmp7_ != NULL) {
#line 7765 "application-main-window.c"
			GdkWindow* _tmp8_;
#line 1301 "../src/client/application/application-main-window.vala"
			_tmp8_ = window;
#line 1301 "../src/client/application/application-main-window.vala"
			_tmp6_ = _tmp8_ != NULL;
#line 7771 "application-main-window.c"
		} else {
#line 1301 "../src/client/application/application-main-window.vala"
			_tmp6_ = FALSE;
#line 7775 "application-main-window.c"
		}
#line 1301 "../src/client/application/application-main-window.vala"
		if (_tmp6_) {
#line 7779 "application-main-window.c"
			GdkMonitor* monitor = NULL;
			GdkDisplay* _tmp9_;
			GdkWindow* _tmp10_;
			GdkMonitor* _tmp11_;
			GdkMonitor* _tmp12_;
			gint width = 0;
			gint height = 0;
			gint _tmp13_ = 0;
			gint _tmp14_ = 0;
			gboolean _tmp15_ = FALSE;
			gboolean _tmp16_ = FALSE;
			gint _tmp17_;
			gboolean _tmp21_ = FALSE;
			gboolean _tmp22_ = FALSE;
			gint _tmp23_;
#line 1302 "../src/client/application/application-main-window.vala"
			_tmp9_ = display;
#line 1302 "../src/client/application/application-main-window.vala"
			_tmp10_ = window;
#line 1302 "../src/client/application/application-main-window.vala"
			_tmp11_ = gdk_display_get_monitor_at_window (_tmp9_, _tmp10_);
#line 1302 "../src/client/application/application-main-window.vala"
			_tmp12_ = _g_object_ref0 (_tmp11_);
#line 1302 "../src/client/application/application-main-window.vala"
			monitor = _tmp12_;
#line 1306 "../src/client/application/application-main-window.vala"
			width = 0;
#line 1307 "../src/client/application/application-main-window.vala"
			height = 0;
#line 1308 "../src/client/application/application-main-window.vala"
			gtk_window_get_size (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), &_tmp13_, &_tmp14_);
#line 1308 "../src/client/application/application-main-window.vala"
			width = _tmp13_;
#line 1308 "../src/client/application/application-main-window.vala"
			height = _tmp14_;
#line 1312 "../src/client/application/application-main-window.vala"
			_tmp17_ = self->priv->_window_width;
#line 1312 "../src/client/application/application-main-window.vala"
			if (_tmp17_ != width) {
#line 1313 "../src/client/application/application-main-window.vala"
				_tmp16_ = width > 0;
#line 7821 "application-main-window.c"
			} else {
#line 1312 "../src/client/application/application-main-window.vala"
				_tmp16_ = FALSE;
#line 7825 "application-main-window.c"
			}
#line 1312 "../src/client/application/application-main-window.vala"
			if (_tmp16_) {
#line 7829 "application-main-window.c"
				GdkMonitor* _tmp18_;
				GdkRectangle _tmp19_ = {0};
				GdkRectangle _tmp20_;
#line 1313 "../src/client/application/application-main-window.vala"
				_tmp18_ = monitor;
#line 1313 "../src/client/application/application-main-window.vala"
				gdk_monitor_get_geometry (_tmp18_, &_tmp19_);
#line 1313 "../src/client/application/application-main-window.vala"
				_tmp20_ = _tmp19_;
#line 1313 "../src/client/application/application-main-window.vala"
				_tmp15_ = width <= _tmp20_.width;
#line 7841 "application-main-window.c"
			} else {
#line 1312 "../src/client/application/application-main-window.vala"
				_tmp15_ = FALSE;
#line 7845 "application-main-window.c"
			}
#line 1312 "../src/client/application/application-main-window.vala"
			if (_tmp15_) {
#line 1314 "../src/client/application/application-main-window.vala"
				application_main_window_set_window_width (self, width);
#line 7851 "application-main-window.c"
			}
#line 1316 "../src/client/application/application-main-window.vala"
			_tmp23_ = self->priv->_window_height;
#line 1316 "../src/client/application/application-main-window.vala"
			if (_tmp23_ != height) {
#line 1317 "../src/client/application/application-main-window.vala"
				_tmp22_ = height > 0;
#line 7859 "application-main-window.c"
			} else {
#line 1316 "../src/client/application/application-main-window.vala"
				_tmp22_ = FALSE;
#line 7863 "application-main-window.c"
			}
#line 1316 "../src/client/application/application-main-window.vala"
			if (_tmp22_) {
#line 7867 "application-main-window.c"
				GdkMonitor* _tmp24_;
				GdkRectangle _tmp25_ = {0};
				GdkRectangle _tmp26_;
#line 1317 "../src/client/application/application-main-window.vala"
				_tmp24_ = monitor;
#line 1317 "../src/client/application/application-main-window.vala"
				gdk_monitor_get_geometry (_tmp24_, &_tmp25_);
#line 1317 "../src/client/application/application-main-window.vala"
				_tmp26_ = _tmp25_;
#line 1317 "../src/client/application/application-main-window.vala"
				_tmp21_ = height <= _tmp26_.height;
#line 7879 "application-main-window.c"
			} else {
#line 1316 "../src/client/application/application-main-window.vala"
				_tmp21_ = FALSE;
#line 7883 "application-main-window.c"
			}
#line 1316 "../src/client/application/application-main-window.vala"
			if (_tmp21_) {
#line 1318 "../src/client/application/application-main-window.vala"
				application_main_window_set_window_height (self, height);
#line 7889 "application-main-window.c"
			}
#line 1301 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (monitor);
#line 7893 "application-main-window.c"
		}
#line 1298 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (window);
#line 1298 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (display);
#line 7899 "application-main-window.c"
	}
}

void
application_main_window_add_notification (ApplicationMainWindow* self,
                                          ComponentsInAppNotification* notification)
{
	GtkOverlay* _tmp0_;
#line 1324 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1324 "../src/client/application/application-main-window.vala"
	g_return_if_fail (COMPONENTS_IS_IN_APP_NOTIFICATION (notification));
#line 1325 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->overlay;
#line 1325 "../src/client/application/application-main-window.vala"
	gtk_overlay_add_overlay (_tmp0_, G_TYPE_CHECK_INSTANCE_CAST (notification, gtk_widget_get_type (), GtkWidget));
#line 1326 "../src/client/application/application-main-window.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (notification, gtk_widget_get_type (), GtkWidget));
#line 7918 "application-main-window.c"
}

static void
_application_main_window_on_has_toplevel_focus_g_object_notify (GObject* _sender,
                                                                GParamSpec* pspec,
                                                                gpointer self)
{
#line 1330 "../src/client/application/application-main-window.vala"
	application_main_window_on_has_toplevel_focus ((ApplicationMainWindow*) self);
#line 7928 "application-main-window.c"
}

static void
_application_main_window_on_search_search_bar_search_text_changed (SearchBar* _sender,
                                                                   const gchar* search_text,
                                                                   gpointer self)
{
#line 1334 "../src/client/application/application-main-window.vala"
	application_main_window_on_search ((ApplicationMainWindow*) self, search_text);
#line 7938 "application-main-window.c"
}

static void
_application_main_window_on_folder_selected_folder_list_tree_folder_selected (FolderListTree* _sender,
                                                                              GearyFolder* folder,
                                                                              gpointer self)
{
#line 1339 "../src/client/application/application-main-window.vala"
	application_main_window_on_folder_selected ((ApplicationMainWindow*) self, folder);
#line 7948 "application-main-window.c"
}

static void
_application_main_window_on_move_conversation_folder_list_tree_move_conversation (FolderListTree* _sender,
                                                                                  GearyFolder* folder,
                                                                                  gpointer self)
{
#line 1340 "../src/client/application/application-main-window.vala"
	application_main_window_on_move_conversation ((ApplicationMainWindow*) self, folder);
#line 7958 "application-main-window.c"
}

static void
_application_main_window_on_copy_conversation_folder_list_tree_copy_conversation (FolderListTree* _sender,
                                                                                  GearyFolder* folder,
                                                                                  gpointer self)
{
#line 1341 "../src/client/application/application-main-window.vala"
	application_main_window_on_copy_conversation ((ApplicationMainWindow*) self, folder);
#line 7968 "application-main-window.c"
}

static void
_application_main_window_on_folder_activated_folder_list_tree_folder_activated (FolderListTree* _sender,
                                                                                GearyFolder* folder,
                                                                                gpointer self)
{
#line 1342 "../src/client/application/application-main-window.vala"
	application_main_window_on_folder_activated ((ApplicationMainWindow*) self, folder);
#line 7978 "application-main-window.c"
}

static void
_application_main_window_on_load_more_conversation_list_view_load_more (ConversationListView* _sender,
                                                                        gpointer self)
{
#line 1352 "../src/client/application/application-main-window.vala"
	application_main_window_on_load_more ((ApplicationMainWindow*) self);
#line 7987 "application-main-window.c"
}

static void
_application_main_window_on_mark_conversations_conversation_list_view_mark_conversations (ConversationListView* _sender,
                                                                                          GeeCollection* conversations,
                                                                                          GearyNamedFlag* flag,
                                                                                          gpointer self)
{
#line 1353 "../src/client/application/application-main-window.vala"
	application_main_window_on_mark_conversations ((ApplicationMainWindow*) self, conversations, flag);
#line 7998 "application-main-window.c"
}

static void
_application_main_window_on_conversations_selected_conversation_list_view_conversations_selected (ConversationListView* _sender,
                                                                                                  GeeSet* selected,
                                                                                                  gpointer self)
{
#line 1354 "../src/client/application/application-main-window.vala"
	application_main_window_on_conversations_selected ((ApplicationMainWindow*) self, selected);
#line 8008 "application-main-window.c"
}

static void
_application_main_window_on_conversation_activated_conversation_list_view_conversation_activated (ConversationListView* _sender,
                                                                                                  GearyAppConversation* activated,
                                                                                                  gboolean single,
                                                                                                  gpointer self)
{
#line 1355 "../src/client/application/application-main-window.vala"
	application_main_window_on_conversation_activated ((ApplicationMainWindow*) self, activated, single);
#line 8019 "application-main-window.c"
}

static void
_application_main_window_on_visible_conversations_changed_conversation_list_view_visible_conversations_changed (ConversationListView* _sender,
                                                                                                                GeeSet* visible,
                                                                                                                gpointer self)
{
#line 1356 "../src/client/application/application-main-window.vala"
	application_main_window_on_visible_conversations_changed ((ApplicationMainWindow*) self, visible);
#line 8029 "application-main-window.c"
}

static void
_application_main_window_on_conversation_view_added_conversation_viewer_conversation_added (ConversationViewer* _sender,
                                                                                            ConversationListBox* list,
                                                                                            gpointer self)
{
#line 1363 "../src/client/application/application-main-window.vala"
	application_main_window_on_conversation_view_added ((ApplicationMainWindow*) self, list);
#line 8039 "application-main-window.c"
}

static void
__lambda201_ (ApplicationMainWindow* self)
{
	GtkRevealer* _tmp0_;
	ComponentsMainToolbar* _tmp1_;
	ComponentsConversationActions* _tmp2_;
	ComponentsConversationActions* _tmp3_;
	ComponentsMainToolbar* _tmp4_;
	ComponentsConversationActions* _tmp5_;
#line 1391 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->conversation_viewer_actions_revealer;
#line 1391 "../src/client/application/application-main-window.vala"
	_tmp1_ = self->priv->_main_toolbar;
#line 1391 "../src/client/application/application-main-window.vala"
	_tmp2_ = components_main_toolbar_get_shown_actions (_tmp1_);
#line 1391 "../src/client/application/application-main-window.vala"
	_tmp3_ = _tmp2_;
#line 1391 "../src/client/application/application-main-window.vala"
	_tmp4_ = self->priv->_main_toolbar;
#line 1391 "../src/client/application/application-main-window.vala"
	_tmp5_ = _tmp4_->compact_actions;
#line 1391 "../src/client/application/application-main-window.vala"
	gtk_revealer_set_reveal_child (_tmp0_, _tmp3_ == _tmp5_);
#line 8065 "application-main-window.c"
}

static void
___lambda201__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
#line 1389 "../src/client/application/application-main-window.vala"
	__lambda201_ ((ApplicationMainWindow*) self);
#line 8075 "application-main-window.c"
}

static void
_vala_array_add8 (FolderPopover** * array,
                  gint* length,
                  gint* size,
                  FolderPopover* value)
{
#line 1420 "../src/client/application/application-main-window.vala"
	if ((*length) == (*size)) {
#line 1420 "../src/client/application/application-main-window.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1420 "../src/client/application/application-main-window.vala"
		*array = g_renew (FolderPopover*, *array, (*size) + 1);
#line 8090 "application-main-window.c"
	}
#line 1420 "../src/client/application/application-main-window.vala"
	(*array)[(*length)++] = value;
#line 1420 "../src/client/application/application-main-window.vala"
	(*array)[*length] = NULL;
#line 8096 "application-main-window.c"
}

static void
_application_main_window_on_move_conversation_folder_popover_folder_selected (FolderPopover* _sender,
                                                                              GearyFolder* folder,
                                                                              gpointer self)
{
#line 1421 "../src/client/application/application-main-window.vala"
	application_main_window_on_move_conversation ((ApplicationMainWindow*) self, folder);
#line 8106 "application-main-window.c"
}

static void
_vala_array_add9 (FolderPopover** * array,
                  gint* length,
                  gint* size,
                  FolderPopover* value)
{
#line 1424 "../src/client/application/application-main-window.vala"
	if ((*length) == (*size)) {
#line 1424 "../src/client/application/application-main-window.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1424 "../src/client/application/application-main-window.vala"
		*array = g_renew (FolderPopover*, *array, (*size) + 1);
#line 8121 "application-main-window.c"
	}
#line 1424 "../src/client/application/application-main-window.vala"
	(*array)[(*length)++] = value;
#line 1424 "../src/client/application/application-main-window.vala"
	(*array)[*length] = NULL;
#line 8127 "application-main-window.c"
}

static void
_application_main_window_on_copy_conversation_folder_popover_folder_selected (FolderPopover* _sender,
                                                                              GearyFolder* folder,
                                                                              gpointer self)
{
#line 1425 "../src/client/application/application-main-window.vala"
	application_main_window_on_copy_conversation ((ApplicationMainWindow*) self, folder);
#line 8137 "application-main-window.c"
}

static void
application_main_window_setup_layout (ApplicationMainWindow* self,
                                      ApplicationConfiguration* config)
{
	ApplicationClient* _tmp0_;
	ApplicationClient* _tmp1_;
	GearyEngine* _tmp2_;
	GearyEngine* _tmp3_;
	SearchBar* _tmp4_;
	SearchBar* _tmp5_;
	SearchBar* _tmp6_;
	GtkBox* _tmp7_;
	SearchBar* _tmp8_;
	FolderListTree* _tmp9_;
	FolderListTree* _tmp10_;
	FolderListTree* _tmp11_;
	FolderListTree* _tmp12_;
	GtkScrolledWindow* _tmp13_;
	FolderListTree* _tmp14_;
	GtkBox* _tmp15_;
	ComponentsInfoBarStack* _tmp16_;
	ApplicationClient* _tmp17_;
	ApplicationClient* _tmp18_;
	ApplicationConfiguration* _tmp19_;
	ApplicationConfiguration* _tmp20_;
	ConversationListView* _tmp21_;
	ConversationListView* _tmp22_;
	ConversationListView* _tmp23_;
	ConversationListView* _tmp24_;
	ConversationListView* _tmp25_;
	ConversationListView* _tmp26_;
	ConversationListView* _tmp27_;
	GtkScrolledWindow* _tmp28_;
	ConversationListView* _tmp29_;
	ApplicationClient* _tmp30_;
	ApplicationClient* _tmp31_;
	ApplicationConfiguration* _tmp32_;
	ApplicationConfiguration* _tmp33_;
	ConversationViewer* _tmp34_;
	ConversationViewer* _tmp35_;
	ConversationViewer* _tmp36_;
	ConversationViewer* _tmp37_;
	GtkBox* _tmp38_;
	ConversationViewer* _tmp39_;
	ComponentsMainToolbar* _tmp40_;
	ComponentsMainToolbar* _tmp41_;
	ComponentsMainToolbar* _tmp42_;
	GtkSizeGroup* _tmp43_;
	GtkSizeGroup* _tmp44_;
	GtkSizeGroup* _tmp45_;
	GtkSizeGroup* _tmp46_;
	GtkSizeGroup* _tmp47_;
	ComponentsMainToolbar* _tmp48_;
	HdySwipeGroup* _tmp49_;
	HdySwipeGroup* _tmp50_;
	ComponentsMainToolbar* _tmp51_;
	SearchBar* _tmp52_;
	ComponentsMainToolbar* _tmp53_;
	ConversationViewer* _tmp54_;
	GtkSearchBar* _tmp55_;
	ComponentsMainToolbar* _tmp56_;
	ApplicationConfigurationDesktopEnvironment _tmp57_;
	ApplicationConfigurationDesktopEnvironment _tmp58_;
	GtkBox* _tmp64_;
	ComponentsInfoBarStack* _tmp65_;
	StatusBar* _tmp66_;
	StatusBar* _tmp67_;
	MonitoredSpinner* _tmp68_;
	MonitoredSpinner* _tmp69_;
	GearyAggregateProgressMonitor* _tmp70_;
	StatusBar* _tmp71_;
	MonitoredSpinner* _tmp72_;
	StatusBar* _tmp73_;
	ComponentsMainToolbar* _tmp74_;
	ComponentsConversationActions* _tmp75_;
	ComponentsConversationActions* _tmp76_;
	ComponentsConversationActions* _tmp77_;
	ComponentsConversationActions* _tmp78_;
	ComponentsConversationActions** _tmp79_;
	ComponentsConversationActions** _tmp80_;
	gint _tmp80__length1;
#line 1329 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1329 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_CONFIGURATION (config));
#line 1330 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "notify::has-toplevel-focus", (GCallback) _application_main_window_on_has_toplevel_focus_g_object_notify, self, 0);
#line 1333 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_application (self);
#line 1333 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 1333 "../src/client/application/application-main-window.vala"
	_tmp2_ = application_client_get_engine (_tmp1_);
#line 1333 "../src/client/application/application-main-window.vala"
	_tmp3_ = _tmp2_;
#line 1333 "../src/client/application/application-main-window.vala"
	_tmp4_ = search_bar_new (_tmp3_);
#line 1333 "../src/client/application/application-main-window.vala"
	g_object_ref_sink (_tmp4_);
#line 1333 "../src/client/application/application-main-window.vala"
	_tmp5_ = _tmp4_;
#line 1333 "../src/client/application/application-main-window.vala"
	application_main_window_set_search_bar (self, _tmp5_);
#line 1333 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp5_);
#line 1334 "../src/client/application/application-main-window.vala"
	_tmp6_ = self->priv->_search_bar;
#line 1334 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_tmp6_, "search-text-changed", (GCallback) _application_main_window_on_search_search_bar_search_text_changed, self, 0);
#line 1335 "../src/client/application/application-main-window.vala"
	_tmp7_ = self->priv->conversation_list_box;
#line 1335 "../src/client/application/application-main-window.vala"
	_tmp8_ = self->priv->_search_bar;
#line 1335 "../src/client/application/application-main-window.vala"
	gtk_box_pack_start (_tmp7_, G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_widget_get_type (), GtkWidget), FALSE, FALSE, (guint) 0);
#line 1339 "../src/client/application/application-main-window.vala"
	_tmp9_ = self->priv->_folder_list;
#line 1339 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_tmp9_, "folder-selected", (GCallback) _application_main_window_on_folder_selected_folder_list_tree_folder_selected, self, 0);
#line 1340 "../src/client/application/application-main-window.vala"
	_tmp10_ = self->priv->_folder_list;
#line 1340 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_tmp10_, "move-conversation", (GCallback) _application_main_window_on_move_conversation_folder_list_tree_move_conversation, self, 0);
#line 1341 "../src/client/application/application-main-window.vala"
	_tmp11_ = self->priv->_folder_list;
#line 1341 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_tmp11_, "copy-conversation", (GCallback) _application_main_window_on_copy_conversation_folder_list_tree_copy_conversation, self, 0);
#line 1342 "../src/client/application/application-main-window.vala"
	_tmp12_ = self->priv->_folder_list;
#line 1342 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_tmp12_, "folder-activated", (GCallback) _application_main_window_on_folder_activated_folder_list_tree_folder_activated, self, 0);
#line 1343 "../src/client/application/application-main-window.vala"
	_tmp13_ = self->priv->folder_list_scrolled;
#line 1343 "../src/client/application/application-main-window.vala"
	_tmp14_ = self->priv->_folder_list;
#line 1343 "../src/client/application/application-main-window.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gtk_widget_get_type (), GtkWidget));
#line 1346 "../src/client/application/application-main-window.vala"
	_tmp15_ = self->priv->conversation_list_box;
#line 1346 "../src/client/application/application-main-window.vala"
	_tmp16_ = self->priv->_conversation_list_info_bars;
#line 1346 "../src/client/application/application-main-window.vala"
	gtk_box_pack_start (_tmp15_, G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_widget_get_type (), GtkWidget), FALSE, FALSE, (guint) 0);
#line 1349 "../src/client/application/application-main-window.vala"
	_tmp17_ = application_main_window_get_application (self);
#line 1349 "../src/client/application/application-main-window.vala"
	_tmp18_ = _tmp17_;
#line 1349 "../src/client/application/application-main-window.vala"
	_tmp19_ = application_client_get_config (_tmp18_);
#line 1349 "../src/client/application/application-main-window.vala"
	_tmp20_ = _tmp19_;
#line 1349 "../src/client/application/application-main-window.vala"
	_tmp21_ = conversation_list_view_new (_tmp20_);
#line 1349 "../src/client/application/application-main-window.vala"
	g_object_ref_sink (_tmp21_);
#line 1349 "../src/client/application/application-main-window.vala"
	_tmp22_ = _tmp21_;
#line 1349 "../src/client/application/application-main-window.vala"
	application_main_window_set_conversation_list_view (self, _tmp22_);
#line 1349 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp22_);
#line 1352 "../src/client/application/application-main-window.vala"
	_tmp23_ = self->priv->_conversation_list_view;
#line 1352 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_tmp23_, "load-more", (GCallback) _application_main_window_on_load_more_conversation_list_view_load_more, self, 0);
#line 1353 "../src/client/application/application-main-window.vala"
	_tmp24_ = self->priv->_conversation_list_view;
#line 1353 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_tmp24_, "mark-conversations", (GCallback) _application_main_window_on_mark_conversations_conversation_list_view_mark_conversations, self, 0);
#line 1354 "../src/client/application/application-main-window.vala"
	_tmp25_ = self->priv->_conversation_list_view;
#line 1354 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_tmp25_, "conversations-selected", (GCallback) _application_main_window_on_conversations_selected_conversation_list_view_conversations_selected, self, 0);
#line 1355 "../src/client/application/application-main-window.vala"
	_tmp26_ = self->priv->_conversation_list_view;
#line 1355 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_tmp26_, "conversation-activated", (GCallback) _application_main_window_on_conversation_activated_conversation_list_view_conversation_activated, self, 0);
#line 1356 "../src/client/application/application-main-window.vala"
	_tmp27_ = self->priv->_conversation_list_view;
#line 1356 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_tmp27_, "visible-conversations-changed", (GCallback) _application_main_window_on_visible_conversations_changed_conversation_list_view_visible_conversations_changed, self, 0);
#line 1357 "../src/client/application/application-main-window.vala"
	_tmp28_ = self->priv->conversation_list_scrolled;
#line 1357 "../src/client/application/application-main-window.vala"
	_tmp29_ = self->priv->_conversation_list_view;
#line 1357 "../src/client/application/application-main-window.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, gtk_widget_get_type (), GtkWidget));
#line 1360 "../src/client/application/application-main-window.vala"
	_tmp30_ = application_main_window_get_application (self);
#line 1360 "../src/client/application/application-main-window.vala"
	_tmp31_ = _tmp30_;
#line 1360 "../src/client/application/application-main-window.vala"
	_tmp32_ = application_client_get_config (_tmp31_);
#line 1360 "../src/client/application/application-main-window.vala"
	_tmp33_ = _tmp32_;
#line 1360 "../src/client/application/application-main-window.vala"
	_tmp34_ = conversation_viewer_new (_tmp33_);
#line 1360 "../src/client/application/application-main-window.vala"
	g_object_ref_sink (_tmp34_);
#line 1360 "../src/client/application/application-main-window.vala"
	_tmp35_ = _tmp34_;
#line 1360 "../src/client/application/application-main-window.vala"
	application_main_window_set_conversation_viewer (self, _tmp35_);
#line 1360 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp35_);
#line 1363 "../src/client/application/application-main-window.vala"
	_tmp36_ = self->priv->_conversation_viewer;
#line 1363 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_tmp36_, "conversation-added", (GCallback) _application_main_window_on_conversation_view_added_conversation_viewer_conversation_added, self, 0);
#line 1367 "../src/client/application/application-main-window.vala"
	_tmp37_ = self->priv->_conversation_viewer;
#line 1367 "../src/client/application/application-main-window.vala"
	gtk_widget_set_hexpand (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, gtk_widget_get_type (), GtkWidget), TRUE);
#line 1368 "../src/client/application/application-main-window.vala"
	_tmp38_ = self->priv->conversation_viewer_box;
#line 1368 "../src/client/application/application-main-window.vala"
	_tmp39_ = self->priv->_conversation_viewer;
#line 1368 "../src/client/application/application-main-window.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, gtk_widget_get_type (), GtkWidget));
#line 1371 "../src/client/application/application-main-window.vala"
	_tmp40_ = components_main_toolbar_new (config);
#line 1371 "../src/client/application/application-main-window.vala"
	g_object_ref_sink (_tmp40_);
#line 1371 "../src/client/application/application-main-window.vala"
	_tmp41_ = _tmp40_;
#line 1371 "../src/client/application/application-main-window.vala"
	application_main_window_set_main_toolbar (self, _tmp41_);
#line 1371 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp41_);
#line 1372 "../src/client/application/application-main-window.vala"
	_tmp42_ = self->priv->_main_toolbar;
#line 1372 "../src/client/application/application-main-window.vala"
	_tmp43_ = self->priv->folder_size_group;
#line 1372 "../src/client/application/application-main-window.vala"
	_tmp44_ = self->priv->folder_separator_size_group;
#line 1372 "../src/client/application/application-main-window.vala"
	_tmp45_ = self->priv->conversations_size_group;
#line 1372 "../src/client/application/application-main-window.vala"
	_tmp46_ = self->priv->conversations_separator_size_group;
#line 1372 "../src/client/application/application-main-window.vala"
	_tmp47_ = self->priv->conversation_size_group;
#line 1372 "../src/client/application/application-main-window.vala"
	components_main_toolbar_add_to_size_groups (_tmp42_, _tmp43_, _tmp44_, _tmp45_, _tmp46_, _tmp47_);
#line 1377 "../src/client/application/application-main-window.vala"
	_tmp48_ = self->priv->_main_toolbar;
#line 1377 "../src/client/application/application-main-window.vala"
	_tmp49_ = self->priv->conversations_swipe_group;
#line 1377 "../src/client/application/application-main-window.vala"
	_tmp50_ = self->priv->conversation_swipe_group;
#line 1377 "../src/client/application/application-main-window.vala"
	components_main_toolbar_add_to_swipe_groups (_tmp48_, _tmp49_, _tmp50_);
#line 1379 "../src/client/application/application-main-window.vala"
	_tmp51_ = self->priv->_main_toolbar;
#line 1379 "../src/client/application/application-main-window.vala"
	_tmp52_ = self->priv->_search_bar;
#line 1379 "../src/client/application/application-main-window.vala"
	g_object_bind_property_with_closures (G_TYPE_CHECK_INSTANCE_CAST (_tmp51_, G_TYPE_OBJECT, GObject), "search-open", G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, G_TYPE_OBJECT, GObject), "search-mode-enabled", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 1384 "../src/client/application/application-main-window.vala"
	_tmp53_ = self->priv->_main_toolbar;
#line 1384 "../src/client/application/application-main-window.vala"
	_tmp54_ = self->priv->_conversation_viewer;
#line 1384 "../src/client/application/application-main-window.vala"
	_tmp55_ = _tmp54_->conversation_find_bar;
#line 1384 "../src/client/application/application-main-window.vala"
	g_object_bind_property_with_closures (G_TYPE_CHECK_INSTANCE_CAST (_tmp53_, G_TYPE_OBJECT, GObject), "find-open", G_TYPE_CHECK_INSTANCE_CAST (_tmp55_, G_TYPE_OBJECT, GObject), "search-mode-enabled", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 1389 "../src/client/application/application-main-window.vala"
	_tmp56_ = self->priv->_main_toolbar;
#line 1389 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp56_, G_TYPE_OBJECT, GObject), "notify::shown-actions", (GCallback) ___lambda201__g_object_notify, self, 0);
#line 1397 "../src/client/application/application-main-window.vala"
	_tmp57_ = application_configuration_get_desktop_environment (config);
#line 1397 "../src/client/application/application-main-window.vala"
	_tmp58_ = _tmp57_;
#line 1397 "../src/client/application/application-main-window.vala"
	if (_tmp58_ == APPLICATION_CONFIGURATION_DESKTOP_ENVIRONMENT_UNITY) {
#line 8415 "application-main-window.c"
		ComponentsMainToolbar* _tmp59_;
		GtkBox* _tmp60_;
		ComponentsMainToolbar* _tmp61_;
#line 1398 "../src/client/application/application-main-window.vala"
		_tmp59_ = self->priv->_main_toolbar;
#line 1398 "../src/client/application/application-main-window.vala"
		components_main_toolbar_set_show_close_button (_tmp59_, FALSE);
#line 1399 "../src/client/application/application-main-window.vala"
		_tmp60_ = self->priv->main_layout;
#line 1399 "../src/client/application/application-main-window.vala"
		_tmp61_ = self->priv->_main_toolbar;
#line 1399 "../src/client/application/application-main-window.vala"
		gtk_box_pack_start (_tmp60_, G_TYPE_CHECK_INSTANCE_CAST (_tmp61_, gtk_widget_get_type (), GtkWidget), FALSE, TRUE, (guint) 0);
#line 8429 "application-main-window.c"
	} else {
		GtkBox* _tmp62_;
		ComponentsMainToolbar* _tmp63_;
#line 1401 "../src/client/application/application-main-window.vala"
		_tmp62_ = self->priv->main_layout;
#line 1401 "../src/client/application/application-main-window.vala"
		_tmp63_ = self->priv->_main_toolbar;
#line 1401 "../src/client/application/application-main-window.vala"
		gtk_box_pack_start (_tmp62_, G_TYPE_CHECK_INSTANCE_CAST (_tmp63_, gtk_widget_get_type (), GtkWidget), FALSE, TRUE, (guint) 0);
#line 8439 "application-main-window.c"
	}
#line 1404 "../src/client/application/application-main-window.vala"
	_tmp64_ = self->priv->main_layout;
#line 1404 "../src/client/application/application-main-window.vala"
	_tmp65_ = self->priv->info_bars;
#line 1404 "../src/client/application/application-main-window.vala"
	gtk_box_pack_start (_tmp64_, G_TYPE_CHECK_INSTANCE_CAST (_tmp65_, gtk_widget_get_type (), GtkWidget), FALSE, TRUE, (guint) 0);
#line 1407 "../src/client/application/application-main-window.vala"
	_tmp66_ = self->priv->_status_bar;
#line 1407 "../src/client/application/application-main-window.vala"
	gtk_widget_set_size_request (G_TYPE_CHECK_INSTANCE_CAST (_tmp66_, gtk_widget_get_type (), GtkWidget), -1, APPLICATION_MAIN_WINDOW_STATUS_BAR_HEIGHT);
#line 1408 "../src/client/application/application-main-window.vala"
	_tmp67_ = self->priv->_status_bar;
#line 1408 "../src/client/application/application-main-window.vala"
	gtk_container_set_border_width (G_TYPE_CHECK_INSTANCE_CAST (_tmp67_, gtk_container_get_type (), GtkContainer), (guint) 2);
#line 1409 "../src/client/application/application-main-window.vala"
	_tmp68_ = self->priv->spinner;
#line 1409 "../src/client/application/application-main-window.vala"
	gtk_widget_set_size_request (G_TYPE_CHECK_INSTANCE_CAST (_tmp68_, gtk_widget_get_type (), GtkWidget), APPLICATION_MAIN_WINDOW_STATUS_BAR_HEIGHT - 2, -1);
#line 1410 "../src/client/application/application-main-window.vala"
	_tmp69_ = self->priv->spinner;
#line 1410 "../src/client/application/application-main-window.vala"
	_tmp70_ = self->priv->progress_monitor;
#line 1410 "../src/client/application/application-main-window.vala"
	monitored_spinner_set_progress_monitor (_tmp69_, G_TYPE_CHECK_INSTANCE_CAST (_tmp70_, GEARY_TYPE_PROGRESS_MONITOR, GearyProgressMonitor));
#line 1411 "../src/client/application/application-main-window.vala"
	_tmp71_ = self->priv->_status_bar;
#line 1411 "../src/client/application/application-main-window.vala"
	_tmp72_ = self->priv->spinner;
#line 1411 "../src/client/application/application-main-window.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp71_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp72_, gtk_widget_get_type (), GtkWidget));
#line 1412 "../src/client/application/application-main-window.vala"
	_tmp73_ = self->priv->_status_bar;
#line 1412 "../src/client/application/application-main-window.vala"
	gtk_widget_show_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp73_, gtk_widget_get_type (), GtkWidget));
#line 1414 "../src/client/application/application-main-window.vala"
	_tmp74_ = self->priv->_main_toolbar;
#line 1414 "../src/client/application/application-main-window.vala"
	_tmp75_ = _tmp74_->full_actions;
#line 1414 "../src/client/application/application-main-window.vala"
	_tmp76_ = _g_object_ref0 (_tmp75_);
#line 1414 "../src/client/application/application-main-window.vala"
	_tmp77_ = self->priv->conversation_list_actions;
#line 1414 "../src/client/application/application-main-window.vala"
	_tmp78_ = _g_object_ref0 (_tmp77_);
#line 1414 "../src/client/application/application-main-window.vala"
	_tmp79_ = g_new0 (ComponentsConversationActions*, 2 + 1);
#line 1414 "../src/client/application/application-main-window.vala"
	_tmp79_[0] = _tmp76_;
#line 1414 "../src/client/application/application-main-window.vala"
	_tmp79_[1] = _tmp78_;
#line 1414 "../src/client/application/application-main-window.vala"
	self->priv->folder_conversation_actions = (_vala_array_free (self->priv->folder_conversation_actions, self->priv->folder_conversation_actions_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1414 "../src/client/application/application-main-window.vala"
	self->priv->folder_conversation_actions = _tmp79_;
#line 1414 "../src/client/application/application-main-window.vala"
	self->priv->folder_conversation_actions_length1 = 2;
#line 1414 "../src/client/application/application-main-window.vala"
	self->priv->_folder_conversation_actions_size_ = self->priv->folder_conversation_actions_length1;
#line 1418 "../src/client/application/application-main-window.vala"
	_tmp80_ = self->priv->folder_conversation_actions;
#line 1418 "../src/client/application/application-main-window.vala"
	_tmp80__length1 = self->priv->folder_conversation_actions_length1;
#line 8503 "application-main-window.c"
	{
		ComponentsConversationActions** actions_collection = NULL;
		gint actions_collection_length1 = 0;
		gint _actions_collection_size_ = 0;
		gint actions_it = 0;
#line 1418 "../src/client/application/application-main-window.vala"
		actions_collection = _tmp80_;
#line 1418 "../src/client/application/application-main-window.vala"
		actions_collection_length1 = _tmp80__length1;
#line 1418 "../src/client/application/application-main-window.vala"
		for (actions_it = 0; actions_it < actions_collection_length1; actions_it = actions_it + 1) {
#line 8515 "application-main-window.c"
			ComponentsConversationActions* _tmp81_;
			ComponentsConversationActions* actions = NULL;
#line 1418 "../src/client/application/application-main-window.vala"
			_tmp81_ = _g_object_ref0 (actions_collection[actions_it]);
#line 1418 "../src/client/application/application-main-window.vala"
			actions = _tmp81_;
#line 8522 "application-main-window.c"
			{
				FolderPopover* move = NULL;
				ComponentsConversationActions* _tmp82_;
				FolderPopover* _tmp83_;
				FolderPopover* _tmp84_;
				FolderPopover* _tmp85_;
				FolderPopover* _tmp86_;
				FolderPopover* _tmp87_;
				FolderPopover* _tmp88_;
				FolderPopover* copy = NULL;
				ComponentsConversationActions* _tmp89_;
				FolderPopover* _tmp90_;
				FolderPopover* _tmp91_;
				FolderPopover* _tmp92_;
				FolderPopover* _tmp93_;
				FolderPopover* _tmp94_;
				FolderPopover* _tmp95_;
#line 1419 "../src/client/application/application-main-window.vala"
				_tmp82_ = actions;
#line 1419 "../src/client/application/application-main-window.vala"
				_tmp83_ = components_conversation_actions_get_move_folder_menu (_tmp82_);
#line 1419 "../src/client/application/application-main-window.vala"
				_tmp84_ = _tmp83_;
#line 1419 "../src/client/application/application-main-window.vala"
				_tmp85_ = _g_object_ref0 (_tmp84_);
#line 1419 "../src/client/application/application-main-window.vala"
				move = _tmp85_;
#line 1420 "../src/client/application/application-main-window.vala"
				_tmp86_ = move;
#line 1420 "../src/client/application/application-main-window.vala"
				_tmp87_ = _g_object_ref0 (_tmp86_);
#line 1420 "../src/client/application/application-main-window.vala"
				_vala_array_add8 (&self->priv->folder_popovers, &self->priv->folder_popovers_length1, &self->priv->_folder_popovers_size_, _tmp87_);
#line 1421 "../src/client/application/application-main-window.vala"
				_tmp88_ = move;
#line 1421 "../src/client/application/application-main-window.vala"
				g_signal_connect_object (_tmp88_, "folder-selected", (GCallback) _application_main_window_on_move_conversation_folder_popover_folder_selected, self, 0);
#line 1423 "../src/client/application/application-main-window.vala"
				_tmp89_ = actions;
#line 1423 "../src/client/application/application-main-window.vala"
				_tmp90_ = components_conversation_actions_get_copy_folder_menu (_tmp89_);
#line 1423 "../src/client/application/application-main-window.vala"
				_tmp91_ = _tmp90_;
#line 1423 "../src/client/application/application-main-window.vala"
				_tmp92_ = _g_object_ref0 (_tmp91_);
#line 1423 "../src/client/application/application-main-window.vala"
				copy = _tmp92_;
#line 1424 "../src/client/application/application-main-window.vala"
				_tmp93_ = copy;
#line 1424 "../src/client/application/application-main-window.vala"
				_tmp94_ = _g_object_ref0 (_tmp93_);
#line 1424 "../src/client/application/application-main-window.vala"
				_vala_array_add9 (&self->priv->folder_popovers, &self->priv->folder_popovers_length1, &self->priv->_folder_popovers_size_, _tmp94_);
#line 1425 "../src/client/application/application-main-window.vala"
				_tmp95_ = copy;
#line 1425 "../src/client/application/application-main-window.vala"
				g_signal_connect_object (_tmp95_, "folder-selected", (GCallback) _application_main_window_on_copy_conversation_folder_popover_folder_selected, self, 0);
#line 1418 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (copy);
#line 1418 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (move);
#line 1418 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (actions);
#line 8586 "application-main-window.c"
			}
		}
	}
}

/** {@inheritDoc} */
static gboolean
application_main_window_real_key_press_event (GtkWidget* base,
                                              GdkEventKey* event)
{
	ApplicationMainWindow * self;
	gboolean result;
#line 1430 "../src/client/application/application-main-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, APPLICATION_TYPE_MAIN_WINDOW, ApplicationMainWindow);
#line 1430 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 1431 "../src/client/application/application-main-window.vala"
	application_main_window_check_shift_event (self, event);
#line 1432 "../src/client/application/application-main-window.vala"
	result = GTK_WIDGET_CLASS (application_main_window_parent_class)->key_press_event (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, hdy_application_window_get_type (), HdyApplicationWindow), gtk_widget_get_type (), GtkWidget), event);
#line 1432 "../src/client/application/application-main-window.vala"
	return result;
#line 8609 "application-main-window.c"
}

/** {@inheritDoc} */
static gboolean
application_main_window_real_key_release_event (GtkWidget* base,
                                                GdkEventKey* event)
{
	ApplicationMainWindow * self;
	gboolean result;
#line 1436 "../src/client/application/application-main-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, APPLICATION_TYPE_MAIN_WINDOW, ApplicationMainWindow);
#line 1436 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 1437 "../src/client/application/application-main-window.vala"
	application_main_window_check_shift_event (self, event);
#line 1438 "../src/client/application/application-main-window.vala"
	result = GTK_WIDGET_CLASS (application_main_window_parent_class)->key_release_event (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, hdy_application_window_get_type (), HdyApplicationWindow), gtk_widget_get_type (), GtkWidget), event);
#line 1438 "../src/client/application/application-main-window.vala"
	return result;
#line 8629 "application-main-window.c"
}

gboolean
application_main_window_prompt_empty_folder (ApplicationMainWindow* self,
                                             GearyFolderSpecialUse type)
{
	gchar* folder_name = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	ConfirmationDialog* dialog = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	ConfirmationDialog* _tmp12_;
	ConfirmationDialog* _tmp13_;
	gboolean result;
#line 1441 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), FALSE);
#line 1442 "../src/client/application/application-main-window.vala"
	_tmp0_ = util_i18n_to_folder_type_display_name (type);
#line 1442 "../src/client/application/application-main-window.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 1442 "../src/client/application/application-main-window.vala"
	folder_name = _tmp1_;
#line 1443 "../src/client/application/application-main-window.vala"
	_tmp2_ = g_strdup_printf (_ ("Empty all email from your %s folder?"), folder_name);
#line 1443 "../src/client/application/application-main-window.vala"
	_tmp3_ = _tmp2_;
#line 1443 "../src/client/application/application-main-window.vala"
	_tmp4_ = g_strconcat (_ ("This removes the email from Geary and your email server."), "  <b>", NULL);
#line 1443 "../src/client/application/application-main-window.vala"
	_tmp5_ = _tmp4_;
#line 1443 "../src/client/application/application-main-window.vala"
	_tmp6_ = g_strconcat (_tmp5_, _ ("This cannot be undone."), NULL);
#line 1443 "../src/client/application/application-main-window.vala"
	_tmp7_ = _tmp6_;
#line 1443 "../src/client/application/application-main-window.vala"
	_tmp8_ = g_strconcat (_tmp7_, "</b>", NULL);
#line 1443 "../src/client/application/application-main-window.vala"
	_tmp9_ = _tmp8_;
#line 1443 "../src/client/application/application-main-window.vala"
	_tmp10_ = g_strdup_printf (_ ("Empty %s"), folder_name);
#line 1443 "../src/client/application/application-main-window.vala"
	_tmp11_ = _tmp10_;
#line 1443 "../src/client/application/application-main-window.vala"
	_tmp12_ = confirmation_dialog_new (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), _tmp3_, _tmp9_, _tmp11_, "destructive-action");
#line 1443 "../src/client/application/application-main-window.vala"
	_tmp13_ = _tmp12_;
#line 1443 "../src/client/application/application-main-window.vala"
	_g_free0 (_tmp11_);
#line 1443 "../src/client/application/application-main-window.vala"
	_g_free0 (_tmp9_);
#line 1443 "../src/client/application/application-main-window.vala"
	_g_free0 (_tmp7_);
#line 1443 "../src/client/application/application-main-window.vala"
	_g_free0 (_tmp5_);
#line 1443 "../src/client/application/application-main-window.vala"
	_g_free0 (_tmp3_);
#line 1443 "../src/client/application/application-main-window.vala"
	dialog = _tmp13_;
#line 1451 "../src/client/application/application-main-window.vala"
	alert_dialog_use_secondary_markup (G_TYPE_CHECK_INSTANCE_CAST (dialog, TYPE_ALERT_DIALOG, AlertDialog), TRUE);
#line 1452 "../src/client/application/application-main-window.vala"
	alert_dialog_set_focus_response (G_TYPE_CHECK_INSTANCE_CAST (dialog, TYPE_ALERT_DIALOG, AlertDialog), GTK_RESPONSE_CANCEL);
#line 1453 "../src/client/application/application-main-window.vala"
	result = alert_dialog_run (G_TYPE_CHECK_INSTANCE_CAST (dialog, TYPE_ALERT_DIALOG, AlertDialog)) == GTK_RESPONSE_OK;
#line 1453 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (dialog);
#line 1453 "../src/client/application/application-main-window.vala"
	_g_free0 (folder_name);
#line 1453 "../src/client/application/application-main-window.vala"
	return result;
#line 8709 "application-main-window.c"
}

static void
application_main_window_undo_data_free (gpointer _data)
{
	ApplicationMainWindowUndoData* _data_;
	_data_ = _data;
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/client/application/application-main-window.vala"
	g_slice_free (ApplicationMainWindowUndoData, _data_);
#line 8721 "application-main-window.c"
}

static void
application_main_window_undo (ApplicationMainWindow* self,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
	ApplicationMainWindowUndoData* _data_;
	ApplicationMainWindow* _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_slice_new0 (ApplicationMainWindowUndoData);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 10 "../src/client/application/application-main-window.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_main_window_undo_data_free);
#line 10 "../src/client/application/application-main-window.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->self = _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_undo_co (_data_);
#line 8745 "application-main-window.c"
}

static void
application_main_window_undo_finish (ApplicationMainWindow* self,
                                     GAsyncResult* _res_)
{
	ApplicationMainWindowUndoData* _data_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 8755 "application-main-window.c"
}

/** Un-does the last executed application command, if any. */
static Block16Data*
block16_data_ref (Block16Data* _data16_)
{
#line 1457 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data16_->_ref_count_);
#line 1457 "../src/client/application/application-main-window.vala"
	return _data16_;
#line 8766 "application-main-window.c"
}

static void
block16_data_unref (void * _userdata_)
{
	Block16Data* _data16_;
	_data16_ = (Block16Data*) _userdata_;
#line 1457 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data16_->_ref_count_)) {
#line 8776 "application-main-window.c"
		ApplicationMainWindow* self;
#line 1457 "../src/client/application/application-main-window.vala"
		self = _data16_->self;
#line 1457 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data16_->selected);
#line 1457 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 1457 "../src/client/application/application-main-window.vala"
		g_slice_free (Block16Data, _data16_);
#line 8786 "application-main-window.c"
	}
}

static void
___lambda183_ (Block16Data* _data16_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 1462 "../src/client/application/application-main-window.vala"
	self = _data16_->self;
#line 1462 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 1462 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 8803 "application-main-window.c"
	{
		ApplicationAccountContext* _tmp0_;
		ApplicationCommandStack* _tmp1_;
		ApplicationCommandStack* _tmp2_;
#line 1464 "../src/client/application/application-main-window.vala"
		_tmp0_ = _data16_->selected;
#line 1464 "../src/client/application/application-main-window.vala"
		_tmp1_ = application_account_context_get_commands (_tmp0_);
#line 1464 "../src/client/application/application-main-window.vala"
		_tmp2_ = _tmp1_;
#line 1464 "../src/client/application/application-main-window.vala"
		application_command_stack_undo_finish (_tmp2_, res, &_inner_error0_);
#line 1464 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8818 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		ApplicationAccountContext* _tmp3_;
		GearyAccount* _tmp4_;
		GearyAccount* _tmp5_;
		GearyAccountInformation* _tmp6_;
		GearyAccountInformation* _tmp7_;
		GError* _tmp8_;
#line 1463 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 1463 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 1466 "../src/client/application/application-main-window.vala"
		_tmp3_ = _data16_->selected;
#line 1466 "../src/client/application/application-main-window.vala"
		_tmp4_ = application_account_context_get_account (_tmp3_);
#line 1466 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 1466 "../src/client/application/application-main-window.vala"
		_tmp6_ = geary_account_get_information (_tmp5_);
#line 1466 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 1466 "../src/client/application/application-main-window.vala"
		_tmp8_ = err;
#line 1466 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp7_, _tmp8_);
#line 1463 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 8852 "application-main-window.c"
	}
	__finally0:
#line 1463 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1463 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1463 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 1463 "../src/client/application/application-main-window.vala"
		return;
#line 8863 "application-main-window.c"
	}
}

static void
____lambda183__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 1460 "../src/client/application/application-main-window.vala"
	___lambda183_ (self, source_object, res);
#line 1460 "../src/client/application/application-main-window.vala"
	block16_data_unref (self);
#line 8876 "application-main-window.c"
}

static gboolean
application_main_window_undo_co (ApplicationMainWindowUndoData* _data_)
{
#line 1457 "../src/client/application/application-main-window.vala"
	switch (_data_->_state_) {
#line 1457 "../src/client/application/application-main-window.vala"
		case 0:
#line 8886 "application-main-window.c"
		goto _state_0;
		default:
#line 1457 "../src/client/application/application-main-window.vala"
		g_assert_not_reached ();
#line 8891 "application-main-window.c"
	}
	_state_0:
#line 1457 "../src/client/application/application-main-window.vala"
	_data_->_data16_ = g_slice_new0 (Block16Data);
#line 1457 "../src/client/application/application-main-window.vala"
	_data_->_data16_->_ref_count_ = 1;
#line 1457 "../src/client/application/application-main-window.vala"
	_data_->_data16_->self = g_object_ref (_data_->self);
#line 1457 "../src/client/application/application-main-window.vala"
	_data_->_data16_->_async_data_ = _data_;
#line 1458 "../src/client/application/application-main-window.vala"
	_data_->_tmp0_ = application_main_window_get_selected_account_context (_data_->self);
#line 1458 "../src/client/application/application-main-window.vala"
	_data_->_data16_->selected = _data_->_tmp0_;
#line 1459 "../src/client/application/application-main-window.vala"
	_data_->_tmp1_ = _data_->_data16_->selected;
#line 1459 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp1_ != NULL) {
#line 1460 "../src/client/application/application-main-window.vala"
		_data_->_tmp2_ = _data_->_data16_->selected;
#line 1460 "../src/client/application/application-main-window.vala"
		_data_->_tmp3_ = application_account_context_get_commands (_data_->_tmp2_);
#line 1460 "../src/client/application/application-main-window.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 1460 "../src/client/application/application-main-window.vala"
		_data_->_tmp5_ = _data_->_data16_->selected;
#line 1460 "../src/client/application/application-main-window.vala"
		_data_->_tmp6_ = application_account_context_get_cancellable (_data_->_tmp5_);
#line 1460 "../src/client/application/application-main-window.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 1460 "../src/client/application/application-main-window.vala"
		application_command_stack_undo (_data_->_tmp4_, _data_->_tmp7_, ____lambda183__gasync_ready_callback, block16_data_ref (_data_->_data16_));
#line 8924 "application-main-window.c"
	}
#line 1457 "../src/client/application/application-main-window.vala"
	block16_data_unref (_data_->_data16_);
#line 1457 "../src/client/application/application-main-window.vala"
	_data_->_data16_ = NULL;
#line 1457 "../src/client/application/application-main-window.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1457 "../src/client/application/application-main-window.vala"
	if (_data_->_state_ != 0) {
#line 1457 "../src/client/application/application-main-window.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1457 "../src/client/application/application-main-window.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8938 "application-main-window.c"
		}
	}
#line 1457 "../src/client/application/application-main-window.vala"
	g_object_unref (_data_->_async_result);
#line 1457 "../src/client/application/application-main-window.vala"
	return FALSE;
#line 8945 "application-main-window.c"
}

static void
application_main_window_redo_data_free (gpointer _data)
{
	ApplicationMainWindowRedoData* _data_;
	_data_ = _data;
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/client/application/application-main-window.vala"
	g_slice_free (ApplicationMainWindowRedoData, _data_);
#line 8957 "application-main-window.c"
}

static void
application_main_window_redo (ApplicationMainWindow* self,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
	ApplicationMainWindowRedoData* _data_;
	ApplicationMainWindow* _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_slice_new0 (ApplicationMainWindowRedoData);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 10 "../src/client/application/application-main-window.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_main_window_redo_data_free);
#line 10 "../src/client/application/application-main-window.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->self = _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_redo_co (_data_);
#line 8981 "application-main-window.c"
}

static void
application_main_window_redo_finish (ApplicationMainWindow* self,
                                     GAsyncResult* _res_)
{
	ApplicationMainWindowRedoData* _data_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 8991 "application-main-window.c"
}

/** Re-does the last undone application command, if any. */
static Block17Data*
block17_data_ref (Block17Data* _data17_)
{
#line 1474 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data17_->_ref_count_);
#line 1474 "../src/client/application/application-main-window.vala"
	return _data17_;
#line 9002 "application-main-window.c"
}

static void
block17_data_unref (void * _userdata_)
{
	Block17Data* _data17_;
	_data17_ = (Block17Data*) _userdata_;
#line 1474 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data17_->_ref_count_)) {
#line 9012 "application-main-window.c"
		ApplicationMainWindow* self;
#line 1474 "../src/client/application/application-main-window.vala"
		self = _data17_->self;
#line 1474 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data17_->selected);
#line 1474 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 1474 "../src/client/application/application-main-window.vala"
		g_slice_free (Block17Data, _data17_);
#line 9022 "application-main-window.c"
	}
}

static void
___lambda184_ (Block17Data* _data17_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 1479 "../src/client/application/application-main-window.vala"
	self = _data17_->self;
#line 1479 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 1479 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 9039 "application-main-window.c"
	{
		ApplicationAccountContext* _tmp0_;
		ApplicationCommandStack* _tmp1_;
		ApplicationCommandStack* _tmp2_;
#line 1481 "../src/client/application/application-main-window.vala"
		_tmp0_ = _data17_->selected;
#line 1481 "../src/client/application/application-main-window.vala"
		_tmp1_ = application_account_context_get_commands (_tmp0_);
#line 1481 "../src/client/application/application-main-window.vala"
		_tmp2_ = _tmp1_;
#line 1481 "../src/client/application/application-main-window.vala"
		application_command_stack_redo_finish (_tmp2_, res, &_inner_error0_);
#line 1481 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9054 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		ApplicationAccountContext* _tmp3_;
		GearyAccount* _tmp4_;
		GearyAccount* _tmp5_;
		GearyAccountInformation* _tmp6_;
		GearyAccountInformation* _tmp7_;
		GError* _tmp8_;
#line 1480 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 1480 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 1483 "../src/client/application/application-main-window.vala"
		_tmp3_ = _data17_->selected;
#line 1483 "../src/client/application/application-main-window.vala"
		_tmp4_ = application_account_context_get_account (_tmp3_);
#line 1483 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 1483 "../src/client/application/application-main-window.vala"
		_tmp6_ = geary_account_get_information (_tmp5_);
#line 1483 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 1483 "../src/client/application/application-main-window.vala"
		_tmp8_ = err;
#line 1483 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp7_, _tmp8_);
#line 1480 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 9088 "application-main-window.c"
	}
	__finally0:
#line 1480 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1480 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1480 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 1480 "../src/client/application/application-main-window.vala"
		return;
#line 9099 "application-main-window.c"
	}
}

static void
____lambda184__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 1477 "../src/client/application/application-main-window.vala"
	___lambda184_ (self, source_object, res);
#line 1477 "../src/client/application/application-main-window.vala"
	block17_data_unref (self);
#line 9112 "application-main-window.c"
}

static gboolean
application_main_window_redo_co (ApplicationMainWindowRedoData* _data_)
{
#line 1474 "../src/client/application/application-main-window.vala"
	switch (_data_->_state_) {
#line 1474 "../src/client/application/application-main-window.vala"
		case 0:
#line 9122 "application-main-window.c"
		goto _state_0;
		default:
#line 1474 "../src/client/application/application-main-window.vala"
		g_assert_not_reached ();
#line 9127 "application-main-window.c"
	}
	_state_0:
#line 1474 "../src/client/application/application-main-window.vala"
	_data_->_data17_ = g_slice_new0 (Block17Data);
#line 1474 "../src/client/application/application-main-window.vala"
	_data_->_data17_->_ref_count_ = 1;
#line 1474 "../src/client/application/application-main-window.vala"
	_data_->_data17_->self = g_object_ref (_data_->self);
#line 1474 "../src/client/application/application-main-window.vala"
	_data_->_data17_->_async_data_ = _data_;
#line 1475 "../src/client/application/application-main-window.vala"
	_data_->_tmp0_ = application_main_window_get_selected_account_context (_data_->self);
#line 1475 "../src/client/application/application-main-window.vala"
	_data_->_data17_->selected = _data_->_tmp0_;
#line 1476 "../src/client/application/application-main-window.vala"
	_data_->_tmp1_ = _data_->_data17_->selected;
#line 1476 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp1_ != NULL) {
#line 1477 "../src/client/application/application-main-window.vala"
		_data_->_tmp2_ = _data_->_data17_->selected;
#line 1477 "../src/client/application/application-main-window.vala"
		_data_->_tmp3_ = application_account_context_get_commands (_data_->_tmp2_);
#line 1477 "../src/client/application/application-main-window.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 1477 "../src/client/application/application-main-window.vala"
		_data_->_tmp5_ = _data_->_data17_->selected;
#line 1477 "../src/client/application/application-main-window.vala"
		_data_->_tmp6_ = application_account_context_get_cancellable (_data_->_tmp5_);
#line 1477 "../src/client/application/application-main-window.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 1477 "../src/client/application/application-main-window.vala"
		application_command_stack_redo (_data_->_tmp4_, _data_->_tmp7_, ____lambda184__gasync_ready_callback, block17_data_ref (_data_->_data17_));
#line 9160 "application-main-window.c"
	}
#line 1474 "../src/client/application/application-main-window.vala"
	block17_data_unref (_data_->_data17_);
#line 1474 "../src/client/application/application-main-window.vala"
	_data_->_data17_ = NULL;
#line 1474 "../src/client/application/application-main-window.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1474 "../src/client/application/application-main-window.vala"
	if (_data_->_state_ != 0) {
#line 1474 "../src/client/application/application-main-window.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1474 "../src/client/application/application-main-window.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 9174 "application-main-window.c"
		}
	}
#line 1474 "../src/client/application/application-main-window.vala"
	g_object_unref (_data_->_async_result);
#line 1474 "../src/client/application/application-main-window.vala"
	return FALSE;
#line 9181 "application-main-window.c"
}

static void
application_main_window_update_command_actions (ApplicationMainWindow* self)
{
	ApplicationAccountContext* selected = NULL;
	ApplicationAccountContext* _tmp0_;
	gboolean _tmp1_ = FALSE;
	ApplicationAccountContext* _tmp2_;
	GSimpleAction* _tmp8_;
	GSimpleAction* _tmp9_;
	gboolean _tmp10_ = FALSE;
	ApplicationAccountContext* _tmp11_;
	GSimpleAction* _tmp17_;
	GSimpleAction* _tmp18_;
#line 1490 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1491 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_selected_account_context (self);
#line 1491 "../src/client/application/application-main-window.vala"
	selected = _tmp0_;
#line 1493 "../src/client/application/application-main-window.vala"
	_tmp2_ = selected;
#line 1493 "../src/client/application/application-main-window.vala"
	if (_tmp2_ != NULL) {
#line 9207 "application-main-window.c"
		ApplicationAccountContext* _tmp3_;
		ApplicationCommandStack* _tmp4_;
		ApplicationCommandStack* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 1493 "../src/client/application/application-main-window.vala"
		_tmp3_ = selected;
#line 1493 "../src/client/application/application-main-window.vala"
		_tmp4_ = application_account_context_get_commands (_tmp3_);
#line 1493 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 1493 "../src/client/application/application-main-window.vala"
		_tmp6_ = application_command_stack_get_can_undo (_tmp5_);
#line 1493 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 1493 "../src/client/application/application-main-window.vala"
		_tmp1_ = _tmp7_;
#line 9225 "application-main-window.c"
	} else {
#line 1493 "../src/client/application/application-main-window.vala"
		_tmp1_ = FALSE;
#line 9229 "application-main-window.c"
	}
#line 1492 "../src/client/application/application-main-window.vala"
	_tmp8_ = application_main_window_get_edit_action (self, ACTION_EDIT_UNDO);
#line 1492 "../src/client/application/application-main-window.vala"
	_tmp9_ = _tmp8_;
#line 1492 "../src/client/application/application-main-window.vala"
	g_simple_action_set_enabled (_tmp9_, _tmp1_);
#line 1492 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp9_);
#line 1496 "../src/client/application/application-main-window.vala"
	_tmp11_ = selected;
#line 1496 "../src/client/application/application-main-window.vala"
	if (_tmp11_ != NULL) {
#line 9243 "application-main-window.c"
		ApplicationAccountContext* _tmp12_;
		ApplicationCommandStack* _tmp13_;
		ApplicationCommandStack* _tmp14_;
		gboolean _tmp15_;
		gboolean _tmp16_;
#line 1496 "../src/client/application/application-main-window.vala"
		_tmp12_ = selected;
#line 1496 "../src/client/application/application-main-window.vala"
		_tmp13_ = application_account_context_get_commands (_tmp12_);
#line 1496 "../src/client/application/application-main-window.vala"
		_tmp14_ = _tmp13_;
#line 1496 "../src/client/application/application-main-window.vala"
		_tmp15_ = application_command_stack_get_can_redo (_tmp14_);
#line 1496 "../src/client/application/application-main-window.vala"
		_tmp16_ = _tmp15_;
#line 1496 "../src/client/application/application-main-window.vala"
		_tmp10_ = _tmp16_;
#line 9261 "application-main-window.c"
	} else {
#line 1496 "../src/client/application/application-main-window.vala"
		_tmp10_ = FALSE;
#line 9265 "application-main-window.c"
	}
#line 1495 "../src/client/application/application-main-window.vala"
	_tmp17_ = application_main_window_get_edit_action (self, ACTION_EDIT_REDO);
#line 1495 "../src/client/application/application-main-window.vala"
	_tmp18_ = _tmp17_;
#line 1495 "../src/client/application/application-main-window.vala"
	g_simple_action_set_enabled (_tmp18_, _tmp10_);
#line 1495 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp18_);
#line 1490 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (selected);
#line 9277 "application-main-window.c"
}

static gboolean
application_main_window_prompt_delete_conversations (ApplicationMainWindow* self,
                                                     gint count)
{
	ConfirmationDialog* dialog = NULL;
	ConfirmationDialog* _tmp0_;
	gboolean result;
#line 1500 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), FALSE);
#line 1501 "../src/client/application/application-main-window.vala"
	_tmp0_ = confirmation_dialog_new (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), ngettext ("Do you want to permanently delete this conversation?", "Do you want to permanently delete these conversations?", (gulong) count), NULL, _ ("Delete"), "destructive-action");
#line 1501 "../src/client/application/application-main-window.vala"
	dialog = _tmp0_;
#line 1512 "../src/client/application/application-main-window.vala"
	result = alert_dialog_run (G_TYPE_CHECK_INSTANCE_CAST (dialog, TYPE_ALERT_DIALOG, AlertDialog)) == GTK_RESPONSE_OK;
#line 1512 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (dialog);
#line 1512 "../src/client/application/application-main-window.vala"
	return result;
#line 9299 "application-main-window.c"
}

static gboolean
application_main_window_prompt_delete_messages (ApplicationMainWindow* self,
                                                gint count)
{
	ConfirmationDialog* dialog = NULL;
	ConfirmationDialog* _tmp0_;
	gboolean result;
#line 1515 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), FALSE);
#line 1516 "../src/client/application/application-main-window.vala"
	_tmp0_ = confirmation_dialog_new (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), ngettext ("Do you want to permanently delete this message?", "Do you want to permanently delete these messages?", (gulong) count), NULL, _ ("Delete"), "destructive-action");
#line 1516 "../src/client/application/application-main-window.vala"
	dialog = _tmp0_;
#line 1527 "../src/client/application/application-main-window.vala"
	result = alert_dialog_run (G_TYPE_CHECK_INSTANCE_CAST (dialog, TYPE_ALERT_DIALOG, AlertDialog)) == GTK_RESPONSE_OK;
#line 1527 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (dialog);
#line 1527 "../src/client/application/application-main-window.vala"
	return result;
#line 9321 "application-main-window.c"
}

static void
application_main_window_load_conversations_for_email_data_free (gpointer _data)
{
	ApplicationMainWindowLoadConversationsForEmailData* _data_;
	_data_ = _data;
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->location);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->to_load);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->result);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/client/application/application-main-window.vala"
	g_slice_free (ApplicationMainWindowLoadConversationsForEmailData, _data_);
#line 9339 "application-main-window.c"
}

static void
application_main_window_load_conversations_for_email (ApplicationMainWindow* self,
                                                      GearyFolder* location,
                                                      GeeCollection* to_load,
                                                      GAsyncReadyCallback _callback_,
                                                      gpointer _user_data_)
{
	ApplicationMainWindowLoadConversationsForEmailData* _data_;
	ApplicationMainWindow* _tmp0_;
	GearyFolder* _tmp1_;
	GeeCollection* _tmp2_;
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (location, GEARY_TYPE_FOLDER));
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (to_load, GEE_TYPE_COLLECTION));
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_slice_new0 (ApplicationMainWindowLoadConversationsForEmailData);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 10 "../src/client/application/application-main-window.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_main_window_load_conversations_for_email_data_free);
#line 10 "../src/client/application/application-main-window.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->self = _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (location);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->location);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->location = _tmp1_;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp2_ = _g_object_ref0 (to_load);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->to_load);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->to_load = _tmp2_;
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_load_conversations_for_email_co (_data_);
#line 9383 "application-main-window.c"
}

static GeeCollection*
application_main_window_load_conversations_for_email_finish (ApplicationMainWindow* self,
                                                             GAsyncResult* _res_)
{
	GeeCollection* result;
	ApplicationMainWindowLoadConversationsForEmailData* _data_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 10 "../src/client/application/application-main-window.vala"
	result = _data_->result;
#line 10 "../src/client/application/application-main-window.vala"
	_data_->result = NULL;
#line 10 "../src/client/application/application-main-window.vala"
	return result;
#line 9400 "application-main-window.c"
}

static void
application_main_window_load_conversations_for_email_ready (GObject* source_object,
                                                            GAsyncResult* _res_,
                                                            gpointer _user_data_)
{
	ApplicationMainWindowLoadConversationsForEmailData* _data_;
#line 1540 "../src/client/application/application-main-window.vala"
	_data_ = _user_data_;
#line 1540 "../src/client/application/application-main-window.vala"
	_data_->_source_object_ = source_object;
#line 1540 "../src/client/application/application-main-window.vala"
	_data_->_res_ = _res_;
#line 1540 "../src/client/application/application-main-window.vala"
	application_main_window_load_conversations_for_email_co (_data_);
#line 9417 "application-main-window.c"
}

static gboolean
application_main_window_load_conversations_for_email_co (ApplicationMainWindowLoadConversationsForEmailData* _data_)
{
#line 1530 "../src/client/application/application-main-window.vala"
	switch (_data_->_state_) {
#line 1530 "../src/client/application/application-main-window.vala"
		case 0:
#line 9427 "application-main-window.c"
		goto _state_0;
#line 1530 "../src/client/application/application-main-window.vala"
		case 1:
#line 9431 "application-main-window.c"
		goto _state_1;
		default:
#line 1530 "../src/client/application/application-main-window.vala"
		g_assert_not_reached ();
#line 9436 "application-main-window.c"
	}
	_state_0:
#line 1534 "../src/client/application/application-main-window.vala"
	_data_->was_loaded = FALSE;
#line 1537 "../src/client/application/application-main-window.vala"
	_data_->_tmp1_ = _data_->self->priv->_conversations;
#line 1537 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp1_ != NULL) {
#line 1538 "../src/client/application/application-main-window.vala"
		_data_->_tmp2_ = _data_->self->priv->_conversations;
#line 1538 "../src/client/application/application-main-window.vala"
		_data_->_tmp3_ = geary_app_conversation_monitor_get_base_folder (_data_->_tmp2_);
#line 1538 "../src/client/application/application-main-window.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 1538 "../src/client/application/application-main-window.vala"
		_data_->_tmp0_ = _data_->_tmp4_ == _data_->location;
#line 9453 "application-main-window.c"
	} else {
#line 1537 "../src/client/application/application-main-window.vala"
		_data_->_tmp0_ = FALSE;
#line 9457 "application-main-window.c"
	}
#line 1537 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp0_) {
#line 9461 "application-main-window.c"
		{
#line 1540 "../src/client/application/application-main-window.vala"
			_data_->_tmp5_ = _data_->self->priv->_conversations;
#line 1540 "../src/client/application/application-main-window.vala"
			_data_->_tmp6_ = _data_->self->priv->folder_open;
#line 1540 "../src/client/application/application-main-window.vala"
			_data_->_state_ = 1;
#line 1540 "../src/client/application/application-main-window.vala"
			geary_app_conversation_monitor_load_email (_data_->_tmp5_, _data_->to_load, _data_->_tmp6_, application_main_window_load_conversations_for_email_ready, _data_);
#line 1540 "../src/client/application/application-main-window.vala"
			return FALSE;
#line 9473 "application-main-window.c"
			_state_1:
#line 1540 "../src/client/application/application-main-window.vala"
			geary_app_conversation_monitor_load_email_finish (_data_->_tmp5_, _data_->_res_, &_data_->_inner_error0_);
#line 1540 "../src/client/application/application-main-window.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 9479 "application-main-window.c"
				goto __catch0_g_error;
			}
#line 1541 "../src/client/application/application-main-window.vala"
			_data_->was_loaded = TRUE;
#line 9484 "application-main-window.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 1539 "../src/client/application/application-main-window.vala"
			_data_->err = _data_->_inner_error0_;
#line 1539 "../src/client/application/application-main-window.vala"
			_data_->_inner_error0_ = NULL;
#line 1543 "../src/client/application/application-main-window.vala"
			_data_->_tmp7_ = _data_->err;
#line 1543 "../src/client/application/application-main-window.vala"
			_data_->_tmp8_ = _data_->_tmp7_->message;
#line 1543 "../src/client/application/application-main-window.vala"
			g_debug ("application-main-window.vala:1543: Error loading conversations to show" \
" them: %s", _data_->_tmp8_);
#line 1539 "../src/client/application/application-main-window.vala"
			_g_error_free0 (_data_->err);
#line 9501 "application-main-window.c"
		}
		__finally0:
#line 1539 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1539 "../src/client/application/application-main-window.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 1539 "../src/client/application/application-main-window.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 1539 "../src/client/application/application-main-window.vala"
			g_object_unref (_data_->_async_result);
#line 1539 "../src/client/application/application-main-window.vala"
			return FALSE;
#line 9514 "application-main-window.c"
		}
	}
#line 1550 "../src/client/application/application-main-window.vala"
	_data_->_tmp9_ = gee_hash_set_new (GEARY_APP_TYPE_CONVERSATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1550 "../src/client/application/application-main-window.vala"
	_data_->loaded = _data_->_tmp9_;
#line 1551 "../src/client/application/application-main-window.vala"
	if (_data_->was_loaded) {
#line 1552 "../src/client/application/application-main-window.vala"
		_data_->_tmp12_ = _data_->self->priv->_conversations;
#line 1552 "../src/client/application/application-main-window.vala"
		_data_->_tmp11_ = _data_->_tmp12_ != NULL;
#line 9527 "application-main-window.c"
	} else {
#line 1551 "../src/client/application/application-main-window.vala"
		_data_->_tmp11_ = FALSE;
#line 9531 "application-main-window.c"
	}
#line 1551 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp11_) {
#line 1553 "../src/client/application/application-main-window.vala"
		_data_->_tmp13_ = _data_->self->priv->_conversations;
#line 1553 "../src/client/application/application-main-window.vala"
		_data_->_tmp14_ = geary_app_conversation_monitor_get_base_folder (_data_->_tmp13_);
#line 1553 "../src/client/application/application-main-window.vala"
		_data_->_tmp15_ = _data_->_tmp14_;
#line 1553 "../src/client/application/application-main-window.vala"
		_data_->_tmp10_ = _data_->_tmp15_ == _data_->location;
#line 9543 "application-main-window.c"
	} else {
#line 1551 "../src/client/application/application-main-window.vala"
		_data_->_tmp10_ = FALSE;
#line 9547 "application-main-window.c"
	}
#line 1551 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp10_) {
#line 9551 "application-main-window.c"
		{
#line 1554 "../src/client/application/application-main-window.vala"
			_data_->_tmp16_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_data_->to_load, GEE_TYPE_ITERABLE, GeeIterable));
#line 1554 "../src/client/application/application-main-window.vala"
			_data_->_id_it = _data_->_tmp16_;
#line 1554 "../src/client/application/application-main-window.vala"
			while (TRUE) {
#line 1554 "../src/client/application/application-main-window.vala"
				_data_->_tmp17_ = _data_->_id_it;
#line 1554 "../src/client/application/application-main-window.vala"
				if (!gee_iterator_next (_data_->_tmp17_)) {
#line 1554 "../src/client/application/application-main-window.vala"
					break;
#line 9565 "application-main-window.c"
				}
#line 1554 "../src/client/application/application-main-window.vala"
				_data_->_tmp18_ = _data_->_id_it;
#line 1554 "../src/client/application/application-main-window.vala"
				_data_->_tmp19_ = gee_iterator_get (_data_->_tmp18_);
#line 1554 "../src/client/application/application-main-window.vala"
				_data_->id = (GearyEmailIdentifier*) _data_->_tmp19_;
#line 1555 "../src/client/application/application-main-window.vala"
				_data_->_tmp20_ = _data_->self->priv->_conversations;
#line 1555 "../src/client/application/application-main-window.vala"
				_data_->_tmp21_ = _data_->id;
#line 1555 "../src/client/application/application-main-window.vala"
				_data_->_tmp22_ = geary_app_conversation_monitor_get_by_email_identifier (_data_->_tmp20_, _data_->_tmp21_);
#line 1555 "../src/client/application/application-main-window.vala"
				_data_->conversation = _data_->_tmp22_;
#line 1557 "../src/client/application/application-main-window.vala"
				_data_->_tmp23_ = _data_->conversation;
#line 1557 "../src/client/application/application-main-window.vala"
				if (_data_->_tmp23_ != NULL) {
#line 1558 "../src/client/application/application-main-window.vala"
					_data_->_tmp24_ = _data_->loaded;
#line 1558 "../src/client/application/application-main-window.vala"
					_data_->_tmp25_ = _data_->conversation;
#line 1558 "../src/client/application/application-main-window.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp24_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _data_->_tmp25_);
#line 9591 "application-main-window.c"
				}
#line 1554 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_data_->conversation);
#line 1554 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_data_->id);
#line 9597 "application-main-window.c"
			}
#line 1554 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (_data_->_id_it);
#line 9601 "application-main-window.c"
		}
	}
#line 1562 "../src/client/application/application-main-window.vala"
	_data_->result = G_TYPE_CHECK_INSTANCE_CAST (_data_->loaded, GEE_TYPE_COLLECTION, GeeCollection);
#line 1562 "../src/client/application/application-main-window.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1562 "../src/client/application/application-main-window.vala"
	if (_data_->_state_ != 0) {
#line 1562 "../src/client/application/application-main-window.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1562 "../src/client/application/application-main-window.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 9614 "application-main-window.c"
		}
	}
#line 1562 "../src/client/application/application-main-window.vala"
	g_object_unref (_data_->_async_result);
#line 1562 "../src/client/application/application-main-window.vala"
	return FALSE;
#line 9621 "application-main-window.c"
}

static inline void
application_main_window_handle_error (ApplicationMainWindow* self,
                                      GearyAccountInformation* account,
                                      GError* _error_)
{
	GearyProblemReport* _tmp0_ = NULL;
	GearyProblemReport* report = NULL;
	GearyProblemReport* _tmp3_;
	ApplicationController* _tmp4_;
#line 1565 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1565 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((account == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT_INFORMATION));
#line 1565 "../src/client/application/application-main-window.vala"
	g_return_if_fail (_error_ != NULL);
#line 1567 "../src/client/application/application-main-window.vala"
	if (account != NULL) {
#line 9641 "application-main-window.c"
		GearyAccountProblemReport* _tmp1_;
#line 1568 "../src/client/application/application-main-window.vala"
		_tmp1_ = geary_account_problem_report_new (account, _error_);
#line 1568 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp0_);
#line 1568 "../src/client/application/application-main-window.vala"
		_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEARY_TYPE_PROBLEM_REPORT, GearyProblemReport);
#line 9649 "application-main-window.c"
	} else {
		GearyProblemReport* _tmp2_;
#line 1569 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_problem_report_new (_error_);
#line 1569 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp0_);
#line 1569 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp2_;
#line 9658 "application-main-window.c"
	}
#line 1567 "../src/client/application/application-main-window.vala"
	_tmp3_ = _g_object_ref0 (_tmp0_);
#line 1567 "../src/client/application/application-main-window.vala"
	report = _tmp3_;
#line 1570 "../src/client/application/application-main-window.vala"
	_tmp4_ = self->priv->controller;
#line 1570 "../src/client/application/application-main-window.vala"
	composer_application_interface_report_problem (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, COMPOSER_TYPE_APPLICATION_INTERFACE, ComposerApplicationInterface), report);
#line 1565 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (report);
#line 1565 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp0_);
#line 9672 "application-main-window.c"
}

static void
application_main_window_update_ui (ApplicationMainWindow* self)
{
	gint64 now = 0LL;
#line 1573 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1575 "../src/client/application/application-main-window.vala"
	now = g_get_monotonic_time () / (1000 * 1000);
#line 1576 "../src/client/application/application-main-window.vala"
	if ((self->priv->update_ui_last + APPLICATION_MAIN_WINDOW_UPDATE_UI_INTERVAL) < now) {
#line 9685 "application-main-window.c"
		ConversationViewer* _tmp0_;
		ConversationListBox* _tmp1_;
		ConversationListBox* _tmp2_;
		ConversationListStore* list_store = NULL;
		ConversationListView* _tmp6_;
		ConversationListStore* _tmp7_;
		ConversationListStore* _tmp8_;
		ConversationListStore* _tmp9_;
#line 1577 "../src/client/application/application-main-window.vala"
		self->priv->update_ui_last = now;
#line 1579 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->_conversation_viewer;
#line 1579 "../src/client/application/application-main-window.vala"
		_tmp1_ = conversation_viewer_get_current_list (_tmp0_);
#line 1579 "../src/client/application/application-main-window.vala"
		_tmp2_ = _tmp1_;
#line 1579 "../src/client/application/application-main-window.vala"
		if (_tmp2_ != NULL) {
#line 9704 "application-main-window.c"
			ConversationViewer* _tmp3_;
			ConversationListBox* _tmp4_;
			ConversationListBox* _tmp5_;
#line 1580 "../src/client/application/application-main-window.vala"
			_tmp3_ = self->priv->_conversation_viewer;
#line 1580 "../src/client/application/application-main-window.vala"
			_tmp4_ = conversation_viewer_get_current_list (_tmp3_);
#line 1580 "../src/client/application/application-main-window.vala"
			_tmp5_ = _tmp4_;
#line 1580 "../src/client/application/application-main-window.vala"
			conversation_list_box_update_display (_tmp5_);
#line 9716 "application-main-window.c"
		}
#line 1583 "../src/client/application/application-main-window.vala"
		_tmp6_ = self->priv->_conversation_list_view;
#line 1583 "../src/client/application/application-main-window.vala"
		_tmp7_ = conversation_list_view_get_model (_tmp6_);
#line 1583 "../src/client/application/application-main-window.vala"
		_tmp8_ = IS_CONVERSATION_LIST_STORE (_tmp7_) ? ((ConversationListStore*) _tmp7_) : NULL;
#line 1583 "../src/client/application/application-main-window.vala"
		if (_tmp8_ == NULL) {
#line 1583 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (_tmp7_);
#line 9728 "application-main-window.c"
		}
#line 1583 "../src/client/application/application-main-window.vala"
		list_store = _tmp8_;
#line 1585 "../src/client/application/application-main-window.vala"
		_tmp9_ = list_store;
#line 1585 "../src/client/application/application-main-window.vala"
		if (_tmp9_ != NULL) {
#line 9736 "application-main-window.c"
			ConversationListStore* _tmp10_;
#line 1586 "../src/client/application/application-main-window.vala"
			_tmp10_ = list_store;
#line 1586 "../src/client/application/application-main-window.vala"
			conversation_list_store_update_display (_tmp10_);
#line 9742 "application-main-window.c"
		}
#line 1576 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (list_store);
#line 9746 "application-main-window.c"
	}
}

static void
application_main_window_select_account (ApplicationMainWindow* self,
                                        GearyAccount* account)
{
	GearyAccount* _tmp0_;
#line 1591 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1591 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((account == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT));
#line 1592 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_account;
#line 1592 "../src/client/application/application-main-window.vala"
	if (_tmp0_ != account) {
#line 9763 "application-main-window.c"
		GearyAccount* _tmp1_;
		SearchBar* _tmp5_;
#line 1593 "../src/client/application/application-main-window.vala"
		_tmp1_ = self->priv->_selected_account;
#line 1593 "../src/client/application/application-main-window.vala"
		if (_tmp1_ != NULL) {
#line 9770 "application-main-window.c"
			FolderPopover** _tmp2_;
			gint _tmp2__length1;
#line 1594 "../src/client/application/application-main-window.vala"
			_tmp2_ = self->priv->folder_popovers;
#line 1594 "../src/client/application/application-main-window.vala"
			_tmp2__length1 = self->priv->folder_popovers_length1;
#line 9777 "application-main-window.c"
			{
				FolderPopover** menu_collection = NULL;
				gint menu_collection_length1 = 0;
				gint _menu_collection_size_ = 0;
				gint menu_it = 0;
#line 1594 "../src/client/application/application-main-window.vala"
				menu_collection = _tmp2_;
#line 1594 "../src/client/application/application-main-window.vala"
				menu_collection_length1 = _tmp2__length1;
#line 1594 "../src/client/application/application-main-window.vala"
				for (menu_it = 0; menu_it < menu_collection_length1; menu_it = menu_it + 1) {
#line 9789 "application-main-window.c"
					FolderPopover* _tmp3_;
					FolderPopover* menu = NULL;
#line 1594 "../src/client/application/application-main-window.vala"
					_tmp3_ = _g_object_ref0 (menu_collection[menu_it]);
#line 1594 "../src/client/application/application-main-window.vala"
					menu = _tmp3_;
#line 9796 "application-main-window.c"
					{
						FolderPopover* _tmp4_;
#line 1595 "../src/client/application/application-main-window.vala"
						_tmp4_ = menu;
#line 1595 "../src/client/application/application-main-window.vala"
						folder_popover_clear (_tmp4_);
#line 1594 "../src/client/application/application-main-window.vala"
						_g_object_unref0 (menu);
#line 9805 "application-main-window.c"
					}
				}
			}
		}
#line 1599 "../src/client/application/application-main-window.vala"
		application_main_window_set_selected_account (self, account);
#line 1600 "../src/client/application/application-main-window.vala"
		_tmp5_ = self->priv->_search_bar;
#line 1600 "../src/client/application/application-main-window.vala"
		search_bar_set_account (_tmp5_, account);
#line 1602 "../src/client/application/application-main-window.vala"
		if (account != NULL) {
#line 9818 "application-main-window.c"
			GearyServiceProvider service_provider = 0;
			GearyAccountInformation* _tmp6_;
			GearyAccountInformation* _tmp7_;
			GearyServiceProvider _tmp8_;
			GearyServiceProvider _tmp9_;
			ComponentsConversationActions* _tmp10_;
			ComponentsMainToolbar* _tmp11_;
			ComponentsConversationActions* _tmp12_;
			ComponentsMainToolbar* _tmp13_;
			ComponentsConversationActions* _tmp14_;
			FolderPopover** _tmp15_;
			gint _tmp15__length1;
#line 1603 "../src/client/application/application-main-window.vala"
			_tmp6_ = geary_account_get_information (account);
#line 1603 "../src/client/application/application-main-window.vala"
			_tmp7_ = _tmp6_;
#line 1603 "../src/client/application/application-main-window.vala"
			_tmp8_ = geary_account_information_get_service_provider (_tmp7_);
#line 1603 "../src/client/application/application-main-window.vala"
			_tmp9_ = _tmp8_;
#line 1603 "../src/client/application/application-main-window.vala"
			service_provider = _tmp9_;
#line 1604 "../src/client/application/application-main-window.vala"
			_tmp10_ = self->priv->conversation_list_actions;
#line 1604 "../src/client/application/application-main-window.vala"
			components_conversation_actions_set_service_provider (_tmp10_, service_provider);
#line 1605 "../src/client/application/application-main-window.vala"
			_tmp11_ = self->priv->_main_toolbar;
#line 1605 "../src/client/application/application-main-window.vala"
			_tmp12_ = _tmp11_->full_actions;
#line 1605 "../src/client/application/application-main-window.vala"
			components_conversation_actions_set_service_provider (_tmp12_, service_provider);
#line 1606 "../src/client/application/application-main-window.vala"
			_tmp13_ = self->priv->_main_toolbar;
#line 1606 "../src/client/application/application-main-window.vala"
			_tmp14_ = _tmp13_->compact_actions;
#line 1606 "../src/client/application/application-main-window.vala"
			components_conversation_actions_set_service_provider (_tmp14_, service_provider);
#line 1608 "../src/client/application/application-main-window.vala"
			_tmp15_ = self->priv->folder_popovers;
#line 1608 "../src/client/application/application-main-window.vala"
			_tmp15__length1 = self->priv->folder_popovers_length1;
#line 9861 "application-main-window.c"
			{
				FolderPopover** menu_collection = NULL;
				gint menu_collection_length1 = 0;
				gint _menu_collection_size_ = 0;
				gint menu_it = 0;
#line 1608 "../src/client/application/application-main-window.vala"
				menu_collection = _tmp15_;
#line 1608 "../src/client/application/application-main-window.vala"
				menu_collection_length1 = _tmp15__length1;
#line 1608 "../src/client/application/application-main-window.vala"
				for (menu_it = 0; menu_it < menu_collection_length1; menu_it = menu_it + 1) {
#line 9873 "application-main-window.c"
					FolderPopover* _tmp16_;
					FolderPopover* menu = NULL;
#line 1608 "../src/client/application/application-main-window.vala"
					_tmp16_ = _g_object_ref0 (menu_collection[menu_it]);
#line 1608 "../src/client/application/application-main-window.vala"
					menu = _tmp16_;
#line 9880 "application-main-window.c"
					{
						GeeCollection* folders = NULL;
						GeeCollection* _tmp17_;
						GeeHashMap* map = NULL;
						GeeHashMap* _tmp18_;
#line 1609 "../src/client/application/application-main-window.vala"
						_tmp17_ = geary_account_list_folders (account);
#line 1609 "../src/client/application/application-main-window.vala"
						folders = _tmp17_;
#line 1612 "../src/client/application/application-main-window.vala"
						_tmp18_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1612 "../src/client/application/application-main-window.vala"
						map = _tmp18_;
#line 9894 "application-main-window.c"
						{
							GeeIterator* _folder_it = NULL;
							GeeCollection* _tmp19_;
							GeeIterator* _tmp20_;
#line 1613 "../src/client/application/application-main-window.vala"
							_tmp19_ = folders;
#line 1613 "../src/client/application/application-main-window.vala"
							_tmp20_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1613 "../src/client/application/application-main-window.vala"
							_folder_it = _tmp20_;
#line 1613 "../src/client/application/application-main-window.vala"
							while (TRUE) {
#line 9907 "application-main-window.c"
								GeeIterator* _tmp21_;
								GearyFolder* folder = NULL;
								GeeIterator* _tmp22_;
								gpointer _tmp23_;
								ApplicationFolderContext* context = NULL;
								GearyFolder* _tmp24_;
								ApplicationFolderContext* _tmp25_;
								GearyFolder* _tmp26_;
								GearyFolderSpecialUse _tmp27_;
								GearyFolderSpecialUse _tmp28_;
								GeeHashMap* _tmp29_;
								GearyFolder* _tmp30_;
								GearyFolderPath* _tmp31_;
								GearyFolderPath* _tmp32_;
								gchar* _tmp33_;
								gchar* _tmp34_;
								gchar* _tmp35_;
								gchar* _tmp36_;
								ApplicationFolderContext* _tmp37_;
								const gchar* _tmp38_;
								const gchar* _tmp39_;
#line 1613 "../src/client/application/application-main-window.vala"
								_tmp21_ = _folder_it;
#line 1613 "../src/client/application/application-main-window.vala"
								if (!gee_iterator_next (_tmp21_)) {
#line 1613 "../src/client/application/application-main-window.vala"
									break;
#line 9935 "application-main-window.c"
								}
#line 1613 "../src/client/application/application-main-window.vala"
								_tmp22_ = _folder_it;
#line 1613 "../src/client/application/application-main-window.vala"
								_tmp23_ = gee_iterator_get (_tmp22_);
#line 1613 "../src/client/application/application-main-window.vala"
								folder = (GearyFolder*) _tmp23_;
#line 1614 "../src/client/application/application-main-window.vala"
								_tmp24_ = folder;
#line 1614 "../src/client/application/application-main-window.vala"
								_tmp25_ = application_folder_context_new (_tmp24_);
#line 1614 "../src/client/application/application-main-window.vala"
								context = _tmp25_;
#line 1615 "../src/client/application/application-main-window.vala"
								_tmp26_ = folder;
#line 1615 "../src/client/application/application-main-window.vala"
								_tmp27_ = geary_folder_get_used_as (_tmp26_);
#line 1615 "../src/client/application/application-main-window.vala"
								_tmp28_ = _tmp27_;
#line 1615 "../src/client/application/application-main-window.vala"
								if (_tmp28_ == GEARY_FOLDER_SPECIAL_USE_NONE) {
#line 1616 "../src/client/application/application-main-window.vala"
									_g_object_unref0 (context);
#line 1616 "../src/client/application/application-main-window.vala"
									_g_object_unref0 (folder);
#line 1616 "../src/client/application/application-main-window.vala"
									continue;
#line 9963 "application-main-window.c"
								}
#line 1617 "../src/client/application/application-main-window.vala"
								_tmp29_ = map;
#line 1617 "../src/client/application/application-main-window.vala"
								_tmp30_ = folder;
#line 1617 "../src/client/application/application-main-window.vala"
								_tmp31_ = geary_folder_get_path (_tmp30_);
#line 1617 "../src/client/application/application-main-window.vala"
								_tmp32_ = _tmp31_;
#line 1617 "../src/client/application/application-main-window.vala"
								_tmp33_ = geary_folder_path_to_string (_tmp32_);
#line 1617 "../src/client/application/application-main-window.vala"
								_tmp34_ = _tmp33_;
#line 1617 "../src/client/application/application-main-window.vala"
								_tmp35_ = string_substring (_tmp34_, (glong) 1, (glong) -1);
#line 1617 "../src/client/application/application-main-window.vala"
								_tmp36_ = _tmp35_;
#line 1617 "../src/client/application/application-main-window.vala"
								_tmp37_ = context;
#line 1617 "../src/client/application/application-main-window.vala"
								_tmp38_ = application_folder_context_get_display_name (_tmp37_);
#line 1617 "../src/client/application/application-main-window.vala"
								_tmp39_ = _tmp38_;
#line 1617 "../src/client/application/application-main-window.vala"
								gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp36_, _tmp39_);
#line 1617 "../src/client/application/application-main-window.vala"
								_g_free0 (_tmp36_);
#line 1617 "../src/client/application/application-main-window.vala"
								_g_free0 (_tmp34_);
#line 1613 "../src/client/application/application-main-window.vala"
								_g_object_unref0 (context);
#line 1613 "../src/client/application/application-main-window.vala"
								_g_object_unref0 (folder);
#line 9997 "application-main-window.c"
							}
#line 1613 "../src/client/application/application-main-window.vala"
							_g_object_unref0 (_folder_it);
#line 10001 "application-main-window.c"
						}
						{
							GeeIterator* _folder_it = NULL;
							GeeCollection* _tmp40_;
							GeeIterator* _tmp41_;
#line 1622 "../src/client/application/application-main-window.vala"
							_tmp40_ = folders;
#line 1622 "../src/client/application/application-main-window.vala"
							_tmp41_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1622 "../src/client/application/application-main-window.vala"
							_folder_it = _tmp41_;
#line 1622 "../src/client/application/application-main-window.vala"
							while (TRUE) {
#line 10015 "application-main-window.c"
								GeeIterator* _tmp42_;
								GearyFolder* folder = NULL;
								GeeIterator* _tmp43_;
								gpointer _tmp44_;
								ApplicationFolderContext* context = NULL;
								GearyFolder* _tmp45_;
								ApplicationFolderContext* _tmp46_;
								FolderPopover* _tmp47_;
								ApplicationFolderContext* _tmp48_;
								GeeHashMap* _tmp49_;
#line 1622 "../src/client/application/application-main-window.vala"
								_tmp42_ = _folder_it;
#line 1622 "../src/client/application/application-main-window.vala"
								if (!gee_iterator_next (_tmp42_)) {
#line 1622 "../src/client/application/application-main-window.vala"
									break;
#line 10032 "application-main-window.c"
								}
#line 1622 "../src/client/application/application-main-window.vala"
								_tmp43_ = _folder_it;
#line 1622 "../src/client/application/application-main-window.vala"
								_tmp44_ = gee_iterator_get (_tmp43_);
#line 1622 "../src/client/application/application-main-window.vala"
								folder = (GearyFolder*) _tmp44_;
#line 1623 "../src/client/application/application-main-window.vala"
								_tmp45_ = folder;
#line 1623 "../src/client/application/application-main-window.vala"
								_tmp46_ = application_folder_context_new (_tmp45_);
#line 1623 "../src/client/application/application-main-window.vala"
								context = _tmp46_;
#line 1624 "../src/client/application/application-main-window.vala"
								_tmp47_ = menu;
#line 1624 "../src/client/application/application-main-window.vala"
								_tmp48_ = context;
#line 1624 "../src/client/application/application-main-window.vala"
								_tmp49_ = map;
#line 1624 "../src/client/application/application-main-window.vala"
								folder_popover_add_folder (_tmp47_, _tmp48_, _tmp49_);
#line 1622 "../src/client/application/application-main-window.vala"
								_g_object_unref0 (context);
#line 1622 "../src/client/application/application-main-window.vala"
								_g_object_unref0 (folder);
#line 10058 "application-main-window.c"
							}
#line 1622 "../src/client/application/application-main-window.vala"
							_g_object_unref0 (_folder_it);
#line 10062 "application-main-window.c"
						}
#line 1608 "../src/client/application/application-main-window.vala"
						_g_object_unref0 (map);
#line 1608 "../src/client/application/application-main-window.vala"
						_g_object_unref0 (folders);
#line 1608 "../src/client/application/application-main-window.vala"
						_g_object_unref0 (menu);
#line 10070 "application-main-window.c"
					}
				}
			}
		}
#line 1629 "../src/client/application/application-main-window.vala"
		application_main_window_update_command_actions (self);
#line 10077 "application-main-window.c"
	}
}

static void
application_main_window_select_conversations_data_free (gpointer _data)
{
	ApplicationMainWindowSelectConversationsData* _data_;
	_data_ = _data;
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->to_select);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->scroll_to);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/client/application/application-main-window.vala"
	g_slice_free (ApplicationMainWindowSelectConversationsData, _data_);
#line 10094 "application-main-window.c"
}

static void
application_main_window_select_conversations (ApplicationMainWindow* self,
                                              GeeCollection* to_select,
                                              GeeCollection* scroll_to,
                                              gboolean is_interactive,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	ApplicationMainWindowSelectConversationsData* _data_;
	ApplicationMainWindow* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (to_select, GEE_TYPE_COLLECTION));
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (scroll_to, GEE_TYPE_COLLECTION));
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_slice_new0 (ApplicationMainWindowSelectConversationsData);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 10 "../src/client/application/application-main-window.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_main_window_select_conversations_data_free);
#line 10 "../src/client/application/application-main-window.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->self = _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (to_select);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->to_select);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->to_select = _tmp1_;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp2_ = _g_object_ref0 (scroll_to);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->scroll_to);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->scroll_to = _tmp2_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_->is_interactive = is_interactive;
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_select_conversations_co (_data_);
#line 10141 "application-main-window.c"
}

static void
application_main_window_select_conversations_finish (ApplicationMainWindow* self,
                                                     GAsyncResult* _res_)
{
	ApplicationMainWindowSelectConversationsData* _data_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 10151 "application-main-window.c"
}

static void
application_main_window_select_conversations_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_)
{
	ApplicationMainWindowSelectConversationsData* _data_;
#line 1670 "../src/client/application/application-main-window.vala"
	_data_ = _user_data_;
#line 1670 "../src/client/application/application-main-window.vala"
	_data_->_source_object_ = source_object;
#line 1670 "../src/client/application/application-main-window.vala"
	_data_->_res_ = _res_;
#line 1670 "../src/client/application/application-main-window.vala"
	application_main_window_select_conversations_co (_data_);
#line 10168 "application-main-window.c"
}

static gboolean
application_main_window_select_conversations_co (ApplicationMainWindowSelectConversationsData* _data_)
{
#line 1633 "../src/client/application/application-main-window.vala"
	switch (_data_->_state_) {
#line 1633 "../src/client/application/application-main-window.vala"
		case 0:
#line 10178 "application-main-window.c"
		goto _state_0;
#line 1633 "../src/client/application/application-main-window.vala"
		case 1:
#line 10182 "application-main-window.c"
		goto _state_1;
		default:
#line 1633 "../src/client/application/application-main-window.vala"
		g_assert_not_reached ();
#line 10187 "application-main-window.c"
	}
	_state_0:
#line 1636 "../src/client/application/application-main-window.vala"
	if (_data_->self->priv->previous_selection_was_interactive) {
#line 1637 "../src/client/application/application-main-window.vala"
		_data_->_tmp0_ = _data_->is_interactive;
#line 10194 "application-main-window.c"
	} else {
#line 1637 "../src/client/application/application-main-window.vala"
		_data_->_tmp0_ = FALSE;
#line 10198 "application-main-window.c"
	}
#line 1636 "../src/client/application/application-main-window.vala"
	_data_->start_mark_timer = _data_->_tmp0_;
#line 1639 "../src/client/application/application-main-window.vala"
	_data_->self->priv->previous_selection_was_interactive = _data_->is_interactive;
#line 1645 "../src/client/application/application-main-window.vala"
	_data_->_tmp1_ = _data_->self->priv->_conversation_list_view;
#line 1645 "../src/client/application/application-main-window.vala"
	conversation_list_view_select_conversations (_data_->_tmp1_, _data_->to_select);
#line 1647 "../src/client/application/application-main-window.vala"
	_data_->_tmp2_ = _data_->self->priv->conversation_list_actions;
#line 1647 "../src/client/application/application-main-window.vala"
	_data_->_tmp3_ = gee_collection_get_size (_data_->to_select);
#line 1647 "../src/client/application/application-main-window.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 1647 "../src/client/application/application-main-window.vala"
	components_conversation_actions_set_selected_conversations (_data_->_tmp2_, _data_->_tmp4_);
#line 1648 "../src/client/application/application-main-window.vala"
	_data_->_tmp5_ = _data_->self->priv->_main_toolbar;
#line 1648 "../src/client/application/application-main-window.vala"
	_data_->_tmp6_ = _data_->_tmp5_->full_actions;
#line 1648 "../src/client/application/application-main-window.vala"
	_data_->_tmp7_ = gee_collection_get_size (_data_->to_select);
#line 1648 "../src/client/application/application-main-window.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 1648 "../src/client/application/application-main-window.vala"
	components_conversation_actions_set_selected_conversations (_data_->_tmp6_, _data_->_tmp8_);
#line 1649 "../src/client/application/application-main-window.vala"
	_data_->_tmp9_ = _data_->self->priv->_main_toolbar;
#line 1649 "../src/client/application/application-main-window.vala"
	_data_->_tmp10_ = _data_->_tmp9_->compact_actions;
#line 1649 "../src/client/application/application-main-window.vala"
	_data_->_tmp11_ = gee_collection_get_size (_data_->to_select);
#line 1649 "../src/client/application/application-main-window.vala"
	_data_->_tmp12_ = _data_->_tmp11_;
#line 1649 "../src/client/application/application-main-window.vala"
	components_conversation_actions_set_selected_conversations (_data_->_tmp10_, _data_->_tmp12_);
#line 1651 "../src/client/application/application-main-window.vala"
	_data_->_tmp14_ = _data_->self->priv->_selected_folder;
#line 1651 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp14_ != NULL) {
#line 1651 "../src/client/application/application-main-window.vala"
		_data_->_tmp15_ = application_main_window_get_has_composer (_data_->self);
#line 1651 "../src/client/application/application-main-window.vala"
		_data_->_tmp16_ = _data_->_tmp15_;
#line 1651 "../src/client/application/application-main-window.vala"
		_data_->_tmp13_ = !_data_->_tmp16_;
#line 10246 "application-main-window.c"
	} else {
#line 1651 "../src/client/application/application-main-window.vala"
		_data_->_tmp13_ = FALSE;
#line 10250 "application-main-window.c"
	}
#line 1651 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp13_) {
#line 1652 "../src/client/application/application-main-window.vala"
		_data_->_tmp17_ = gee_collection_get_size (_data_->to_select);
#line 1652 "../src/client/application/application-main-window.vala"
		_data_->_tmp18_ = _data_->_tmp17_;
#line 1652 "../src/client/application/application-main-window.vala"
		switch (_data_->_tmp18_) {
#line 1652 "../src/client/application/application-main-window.vala"
			case 0:
#line 10262 "application-main-window.c"
			{
#line 1654 "../src/client/application/application-main-window.vala"
				application_main_window_update_conversation_actions (_data_->self, APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_NONE);
#line 1655 "../src/client/application/application-main-window.vala"
				_data_->_tmp19_ = _data_->self->priv->_conversation_viewer;
#line 1655 "../src/client/application/application-main-window.vala"
				conversation_viewer_show_none_selected (_data_->_tmp19_);
#line 1656 "../src/client/application/application-main-window.vala"
				break;
#line 10272 "application-main-window.c"
			}
#line 1652 "../src/client/application/application-main-window.vala"
			case 1:
#line 10276 "application-main-window.c"
			{
#line 1659 "../src/client/application/application-main-window.vala"
				application_main_window_update_conversation_actions (_data_->self, APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_SINGLE);
#line 1660 "../src/client/application/application-main-window.vala"
				_data_->_tmp20_ = geary_collection_first (GEARY_APP_TYPE_CONVERSATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _data_->to_select);
#line 1660 "../src/client/application/application-main-window.vala"
				_data_->convo = (GearyAppConversation*) _data_->_tmp20_;
#line 1667 "../src/client/application/application-main-window.vala"
				_data_->_tmp21_ = application_main_window_get_selected_account_context (_data_->self);
#line 1667 "../src/client/application/application-main-window.vala"
				_data_->context = _data_->_tmp21_;
#line 1668 "../src/client/application/application-main-window.vala"
				_data_->_tmp23_ = _data_->context;
#line 1668 "../src/client/application/application-main-window.vala"
				if (_data_->_tmp23_ != NULL) {
#line 1668 "../src/client/application/application-main-window.vala"
					_data_->_tmp24_ = _data_->convo;
#line 1668 "../src/client/application/application-main-window.vala"
					_data_->_tmp22_ = geary_app_conversation_get_count (_data_->_tmp24_) > 0;
#line 10296 "application-main-window.c"
				} else {
#line 1668 "../src/client/application/application-main-window.vala"
					_data_->_tmp22_ = FALSE;
#line 10300 "application-main-window.c"
				}
#line 1668 "../src/client/application/application-main-window.vala"
				if (_data_->_tmp22_) {
#line 10304 "application-main-window.c"
					{
#line 1670 "../src/client/application/application-main-window.vala"
						_data_->_tmp25_ = _data_->self->priv->_conversation_viewer;
#line 1670 "../src/client/application/application-main-window.vala"
						_data_->_tmp26_ = _data_->convo;
#line 1670 "../src/client/application/application-main-window.vala"
						_data_->_tmp27_ = _data_->context;
#line 1670 "../src/client/application/application-main-window.vala"
						_data_->_tmp28_ = application_account_context_get_emails (_data_->_tmp27_);
#line 1670 "../src/client/application/application-main-window.vala"
						_data_->_tmp29_ = _data_->_tmp28_;
#line 1670 "../src/client/application/application-main-window.vala"
						_data_->_tmp30_ = _data_->context;
#line 1670 "../src/client/application/application-main-window.vala"
						_data_->_tmp31_ = application_account_context_get_contacts (_data_->_tmp30_);
#line 1670 "../src/client/application/application-main-window.vala"
						_data_->_tmp32_ = _data_->_tmp31_;
#line 1670 "../src/client/application/application-main-window.vala"
						_data_->_state_ = 1;
#line 1670 "../src/client/application/application-main-window.vala"
						conversation_viewer_load_conversation (_data_->_tmp25_, _data_->_tmp26_, _data_->scroll_to, _data_->_tmp29_, _data_->_tmp32_, _data_->start_mark_timer, application_main_window_select_conversations_ready, _data_);
#line 1670 "../src/client/application/application-main-window.vala"
						return FALSE;
#line 10328 "application-main-window.c"
						_state_1:
#line 1670 "../src/client/application/application-main-window.vala"
						conversation_viewer_load_conversation_finish (_data_->_tmp25_, _data_->_res_, &_data_->_inner_error0_);
#line 1670 "../src/client/application/application-main-window.vala"
						if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1670 "../src/client/application/application-main-window.vala"
							if (g_error_matches (_data_->_inner_error0_, GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_NOT_FOUND)) {
#line 10336 "application-main-window.c"
								goto __catch0_geary_engine_error_not_found;
							}
#line 1670 "../src/client/application/application-main-window.vala"
							if (g_error_matches (_data_->_inner_error0_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 10341 "application-main-window.c"
								goto __catch0_g_io_error_cancelled;
							}
							goto __catch0_g_error;
						}
					}
					goto __finally0;
					__catch0_geary_engine_error_not_found:
					{
#line 1669 "../src/client/application/application-main-window.vala"
						_data_->err = _data_->_inner_error0_;
#line 1669 "../src/client/application/application-main-window.vala"
						_data_->_inner_error0_ = NULL;
#line 1686 "../src/client/application/application-main-window.vala"
						_data_->_tmp33_ = _data_->convo;
#line 1686 "../src/client/application/application-main-window.vala"
						if (geary_app_conversation_get_count (_data_->_tmp33_) == 0) {
#line 1687 "../src/client/application/application-main-window.vala"
							_data_->_tmp34_ = _data_->err;
#line 1687 "../src/client/application/application-main-window.vala"
							_data_->_tmp35_ = _data_->_tmp34_->message;
#line 1687 "../src/client/application/application-main-window.vala"
							g_debug ("application-main-window.vala:1687: Ignoring not found error: %s", _data_->_tmp35_);
#line 10364 "application-main-window.c"
						} else {
#line 1689 "../src/client/application/application-main-window.vala"
							_data_->_tmp36_ = _data_->convo;
#line 1689 "../src/client/application/application-main-window.vala"
							_data_->_tmp37_ = geary_app_conversation_get_base_folder (_data_->_tmp36_);
#line 1689 "../src/client/application/application-main-window.vala"
							_data_->_tmp38_ = _data_->_tmp37_;
#line 1689 "../src/client/application/application-main-window.vala"
							_data_->_tmp39_ = geary_folder_get_account (_data_->_tmp38_);
#line 1689 "../src/client/application/application-main-window.vala"
							_data_->_tmp40_ = _data_->_tmp39_;
#line 1689 "../src/client/application/application-main-window.vala"
							_data_->_tmp41_ = geary_account_get_information (_data_->_tmp40_);
#line 1689 "../src/client/application/application-main-window.vala"
							_data_->_tmp42_ = _data_->_tmp41_;
#line 1689 "../src/client/application/application-main-window.vala"
							_data_->_tmp43_ = _data_->err;
#line 1689 "../src/client/application/application-main-window.vala"
							application_main_window_handle_error (_data_->self, _data_->_tmp42_, _data_->_tmp43_);
#line 10384 "application-main-window.c"
						}
#line 1669 "../src/client/application/application-main-window.vala"
						_g_error_free0 (_data_->err);
#line 10388 "application-main-window.c"
					}
					goto __finally0;
					__catch0_g_io_error_cancelled:
					{
#line 1669 "../src/client/application/application-main-window.vala"
						g_clear_error (&_data_->_inner_error0_);
#line 10395 "application-main-window.c"
					}
					goto __finally0;
					__catch0_g_error:
					{
#line 1669 "../src/client/application/application-main-window.vala"
						_data_->_vala1_err = _data_->_inner_error0_;
#line 1669 "../src/client/application/application-main-window.vala"
						_data_->_inner_error0_ = NULL;
#line 1696 "../src/client/application/application-main-window.vala"
						_data_->_tmp44_ = _data_->convo;
#line 1696 "../src/client/application/application-main-window.vala"
						_data_->_tmp45_ = geary_app_conversation_get_base_folder (_data_->_tmp44_);
#line 1696 "../src/client/application/application-main-window.vala"
						_data_->_tmp46_ = _data_->_tmp45_;
#line 1696 "../src/client/application/application-main-window.vala"
						_data_->_tmp47_ = geary_folder_get_account (_data_->_tmp46_);
#line 1696 "../src/client/application/application-main-window.vala"
						_data_->_tmp48_ = _data_->_tmp47_;
#line 1696 "../src/client/application/application-main-window.vala"
						_data_->_tmp49_ = geary_account_get_information (_data_->_tmp48_);
#line 1696 "../src/client/application/application-main-window.vala"
						_data_->_tmp50_ = _data_->_tmp49_;
#line 1696 "../src/client/application/application-main-window.vala"
						_data_->_tmp51_ = _data_->_vala1_err;
#line 1696 "../src/client/application/application-main-window.vala"
						application_main_window_handle_error (_data_->self, _data_->_tmp50_, _data_->_tmp51_);
#line 1669 "../src/client/application/application-main-window.vala"
						_g_error_free0 (_data_->_vala1_err);
#line 10424 "application-main-window.c"
					}
					__finally0:
#line 1669 "../src/client/application/application-main-window.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1669 "../src/client/application/application-main-window.vala"
						_g_object_unref0 (_data_->context);
#line 1669 "../src/client/application/application-main-window.vala"
						_g_object_unref0 (_data_->convo);
#line 1669 "../src/client/application/application-main-window.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 1669 "../src/client/application/application-main-window.vala"
						g_clear_error (&_data_->_inner_error0_);
#line 1669 "../src/client/application/application-main-window.vala"
						g_object_unref (_data_->_async_result);
#line 1669 "../src/client/application/application-main-window.vala"
						return FALSE;
#line 10441 "application-main-window.c"
					}
				}
#line 1699 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_data_->context);
#line 1699 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_data_->convo);
#line 1699 "../src/client/application/application-main-window.vala"
				break;
#line 10450 "application-main-window.c"
			}
			default:
			{
#line 1702 "../src/client/application/application-main-window.vala"
				application_main_window_update_conversation_actions (_data_->self, APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_MULTIPLE);
#line 1703 "../src/client/application/application-main-window.vala"
				_data_->_tmp52_ = _data_->self->priv->_conversation_viewer;
#line 1703 "../src/client/application/application-main-window.vala"
				conversation_viewer_show_multiple_selected (_data_->_tmp52_);
#line 1704 "../src/client/application/application-main-window.vala"
				break;
#line 10462 "application-main-window.c"
			}
		}
	}
#line 1633 "../src/client/application/application-main-window.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1633 "../src/client/application/application-main-window.vala"
	if (_data_->_state_ != 0) {
#line 1633 "../src/client/application/application-main-window.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1633 "../src/client/application/application-main-window.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 10474 "application-main-window.c"
		}
	}
#line 1633 "../src/client/application/application-main-window.vala"
	g_object_unref (_data_->_async_result);
#line 1633 "../src/client/application/application-main-window.vala"
	return FALSE;
#line 10481 "application-main-window.c"
}

static void
application_main_window_open_conversation_monitor_data_free (gpointer _data)
{
	ApplicationMainWindowOpenConversationMonitorData* _data_;
	_data_ = _data;
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/client/application/application-main-window.vala"
	g_slice_free (ApplicationMainWindowOpenConversationMonitorData, _data_);
#line 10495 "application-main-window.c"
}

static void
application_main_window_open_conversation_monitor (ApplicationMainWindow* self,
                                                   GearyAppConversationMonitor* to_open,
                                                   GCancellable* cancellable,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_)
{
	ApplicationMainWindowOpenConversationMonitorData* _data_;
	ApplicationMainWindow* _tmp0_;
	GearyAppConversationMonitor* _tmp1_;
	GCancellable* _tmp2_;
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (to_open, GEARY_APP_TYPE_CONVERSATION_MONITOR));
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_slice_new0 (ApplicationMainWindowOpenConversationMonitorData);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 10 "../src/client/application/application-main-window.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_main_window_open_conversation_monitor_data_free);
#line 10 "../src/client/application/application-main-window.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->self = _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (to_open);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->to_open);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->to_open = _tmp1_;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->cancellable);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->cancellable = _tmp2_;
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_open_conversation_monitor_co (_data_);
#line 10539 "application-main-window.c"
}

static void
application_main_window_open_conversation_monitor_finish (ApplicationMainWindow* self,
                                                          GAsyncResult* _res_)
{
	ApplicationMainWindowOpenConversationMonitorData* _data_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 10 "../src/client/application/application-main-window.vala"
	if (NULL == _data_) {
#line 10 "../src/client/application/application-main-window.vala"
		return;
#line 10553 "application-main-window.c"
	}
}

static Block18Data*
block18_data_ref (Block18Data* _data18_)
{
#line 1709 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data18_->_ref_count_);
#line 1709 "../src/client/application/application-main-window.vala"
	return _data18_;
#line 10564 "application-main-window.c"
}

static void
block18_data_unref (void * _userdata_)
{
	Block18Data* _data18_;
	_data18_ = (Block18Data*) _userdata_;
#line 1709 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data18_->_ref_count_)) {
#line 10574 "application-main-window.c"
		ApplicationMainWindow* self;
#line 1709 "../src/client/application/application-main-window.vala"
		self = _data18_->self;
#line 1709 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data18_->to_open);
#line 1709 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 1709 "../src/client/application/application-main-window.vala"
		g_slice_free (Block18Data, _data18_);
#line 10584 "application-main-window.c"
	}
}

static void
_application_main_window_on_scan_completed_geary_app_conversation_monitor_scan_completed (GearyAppConversationMonitor* _sender,
                                                                                          gpointer self)
{
#line 1711 "../src/client/application/application-main-window.vala"
	application_main_window_on_scan_completed ((ApplicationMainWindow*) self, _sender);
#line 10594 "application-main-window.c"
}

static void
_application_main_window_on_scan_error_geary_app_conversation_monitor_scan_error (GearyAppConversationMonitor* _sender,
                                                                                  GError* err,
                                                                                  gpointer self)
{
#line 1712 "../src/client/application/application-main-window.vala"
	application_main_window_on_scan_error ((ApplicationMainWindow*) self, _sender, err);
#line 10604 "application-main-window.c"
}

static void
_application_main_window_on_conversation_count_changed_geary_app_conversation_monitor_scan_completed (GearyAppConversationMonitor* _sender,
                                                                                                      gpointer self)
{
#line 1714 "../src/client/application/application-main-window.vala"
	application_main_window_on_conversation_count_changed ((ApplicationMainWindow*) self);
#line 10613 "application-main-window.c"
}

static void
_application_main_window_on_conversation_count_changed_geary_app_conversation_monitor_conversations_added (GearyAppConversationMonitor* _sender,
                                                                                                           GeeCollection* conversations,
                                                                                                           gpointer self)
{
#line 1715 "../src/client/application/application-main-window.vala"
	application_main_window_on_conversation_count_changed ((ApplicationMainWindow*) self);
#line 10623 "application-main-window.c"
}

static void
_application_main_window_on_conversation_count_changed_geary_app_conversation_monitor_conversations_removed (GearyAppConversationMonitor* _sender,
                                                                                                             GeeCollection* conversations,
                                                                                                             gpointer self)
{
#line 1716 "../src/client/application/application-main-window.vala"
	application_main_window_on_conversation_count_changed ((ApplicationMainWindow*) self);
#line 10633 "application-main-window.c"
}

static void
__lambda160_ (Block18Data* _data18_,
              GObject* obj,
              GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 1721 "../src/client/application/application-main-window.vala"
	self = _data18_->self;
#line 1721 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 1721 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 10649 "application-main-window.c"
	{
#line 1723 "../src/client/application/application-main-window.vala"
		geary_app_conversation_monitor_start_monitoring_finish (_data18_->to_open, res, &_inner_error0_);
#line 1723 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10655 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolder* _tmp0_;
		GearyFolder* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAccountInformation* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GError* _tmp6_;
#line 1722 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 1722 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 1725 "../src/client/application/application-main-window.vala"
		_tmp0_ = geary_app_conversation_monitor_get_base_folder (_data18_->to_open);
#line 1725 "../src/client/application/application-main-window.vala"
		_tmp1_ = _tmp0_;
#line 1725 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_account (_tmp1_);
#line 1725 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 1725 "../src/client/application/application-main-window.vala"
		_tmp4_ = geary_account_get_information (_tmp3_);
#line 1725 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 1725 "../src/client/application/application-main-window.vala"
		_tmp6_ = err;
#line 1725 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp5_, _tmp6_);
#line 1722 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 10692 "application-main-window.c"
	}
	__finally0:
#line 1722 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1722 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1722 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 1722 "../src/client/application/application-main-window.vala"
		return;
#line 10703 "application-main-window.c"
	}
}

static void
___lambda160__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 1718 "../src/client/application/application-main-window.vala"
	__lambda160_ (self, source_object, res);
#line 1718 "../src/client/application/application-main-window.vala"
	block18_data_unref (self);
#line 10716 "application-main-window.c"
}

static gboolean
application_main_window_open_conversation_monitor_co (ApplicationMainWindowOpenConversationMonitorData* _data_)
{
#line 1709 "../src/client/application/application-main-window.vala"
	switch (_data_->_state_) {
#line 1709 "../src/client/application/application-main-window.vala"
		case 0:
#line 10726 "application-main-window.c"
		goto _state_0;
		default:
#line 1709 "../src/client/application/application-main-window.vala"
		g_assert_not_reached ();
#line 10731 "application-main-window.c"
	}
	_state_0:
#line 1709 "../src/client/application/application-main-window.vala"
	_data_->_data18_ = g_slice_new0 (Block18Data);
#line 1709 "../src/client/application/application-main-window.vala"
	_data_->_data18_->_ref_count_ = 1;
#line 1709 "../src/client/application/application-main-window.vala"
	_data_->_data18_->self = g_object_ref (_data_->self);
#line 1709 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->_data18_->to_open);
#line 1709 "../src/client/application/application-main-window.vala"
	_data_->_data18_->to_open = _data_->to_open;
#line 1709 "../src/client/application/application-main-window.vala"
	_data_->_data18_->_async_data_ = _data_;
#line 1711 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_data_->_data18_->to_open, "scan-completed", (GCallback) _application_main_window_on_scan_completed_geary_app_conversation_monitor_scan_completed, _data_->self, 0);
#line 1712 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_data_->_data18_->to_open, "scan-error", (GCallback) _application_main_window_on_scan_error_geary_app_conversation_monitor_scan_error, _data_->self, 0);
#line 1714 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_data_->_data18_->to_open, "scan-completed", (GCallback) _application_main_window_on_conversation_count_changed_geary_app_conversation_monitor_scan_completed, _data_->self, 0);
#line 1715 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_data_->_data18_->to_open, "conversations-added", (GCallback) _application_main_window_on_conversation_count_changed_geary_app_conversation_monitor_conversations_added, _data_->self, 0);
#line 1716 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (_data_->_data18_->to_open, "conversations-removed", (GCallback) _application_main_window_on_conversation_count_changed_geary_app_conversation_monitor_conversations_removed, _data_->self, 0);
#line 1718 "../src/client/application/application-main-window.vala"
	geary_app_conversation_monitor_start_monitoring (_data_->_data18_->to_open, GEARY_FOLDER_OPEN_FLAGS_NO_DELAY, _data_->cancellable, ___lambda160__gasync_ready_callback, block18_data_ref (_data_->_data18_));
#line 1709 "../src/client/application/application-main-window.vala"
	block18_data_unref (_data_->_data18_);
#line 1709 "../src/client/application/application-main-window.vala"
	_data_->_data18_ = NULL;
#line 1709 "../src/client/application/application-main-window.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1709 "../src/client/application/application-main-window.vala"
	if (_data_->_state_ != 0) {
#line 1709 "../src/client/application/application-main-window.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1709 "../src/client/application/application-main-window.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 10770 "application-main-window.c"
		}
	}
#line 1709 "../src/client/application/application-main-window.vala"
	g_object_unref (_data_->_async_result);
#line 1709 "../src/client/application/application-main-window.vala"
	return FALSE;
#line 10777 "application-main-window.c"
}

static Block19Data*
block19_data_ref (Block19Data* _data19_)
{
#line 1731 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data19_->_ref_count_);
#line 1731 "../src/client/application/application-main-window.vala"
	return _data19_;
#line 10787 "application-main-window.c"
}

static void
block19_data_unref (void * _userdata_)
{
	Block19Data* _data19_;
	_data19_ = (Block19Data*) _userdata_;
#line 1731 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data19_->_ref_count_)) {
#line 10797 "application-main-window.c"
		ApplicationMainWindow* self;
#line 1731 "../src/client/application/application-main-window.vala"
		self = _data19_->self;
#line 1731 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data19_->to_close);
#line 1731 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 1731 "../src/client/application/application-main-window.vala"
		g_slice_free (Block19Data, _data19_);
#line 10807 "application-main-window.c"
	}
}

static void
__lambda158_ (Block19Data* _data19_,
              GObject* obj,
              GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 1741 "../src/client/application/application-main-window.vala"
	self = _data19_->self;
#line 1741 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 1741 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 10824 "application-main-window.c"
	{
#line 1743 "../src/client/application/application-main-window.vala"
		geary_app_conversation_monitor_stop_monitoring_finish (_data19_->to_close, res, &_inner_error0_);
#line 1743 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10830 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolder* _tmp0_;
		GearyFolder* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 1742 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 1742 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 1745 "../src/client/application/application-main-window.vala"
		_tmp0_ = geary_app_conversation_monitor_get_base_folder (_data19_->to_close);
#line 1745 "../src/client/application/application-main-window.vala"
		_tmp1_ = _tmp0_;
#line 1745 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_logging_source_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 1745 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 1745 "../src/client/application/application-main-window.vala"
		_tmp4_ = err;
#line 1745 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_->message;
#line 1745 "../src/client/application/application-main-window.vala"
		g_warning ("application-main-window.vala:1745: Error closing conversation monitor " \
"%s: %s", _tmp3_, _tmp5_);
#line 1745 "../src/client/application/application-main-window.vala"
		_g_free0 (_tmp3_);
#line 1742 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 10866 "application-main-window.c"
	}
	__finally0:
#line 1742 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1742 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1742 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 1742 "../src/client/application/application-main-window.vala"
		return;
#line 10877 "application-main-window.c"
	}
}

static void
___lambda158__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 1739 "../src/client/application/application-main-window.vala"
	__lambda158_ (self, source_object, res);
#line 1739 "../src/client/application/application-main-window.vala"
	block19_data_unref (self);
#line 10890 "application-main-window.c"
}

static void
application_main_window_close_conversation_monitor (ApplicationMainWindow* self,
                                                    GearyAppConversationMonitor* to_close)
{
	Block19Data* _data19_;
	GearyAppConversationMonitor* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	guint _tmp4_;
	guint _tmp5_;
#line 1731 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1731 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (to_close, GEARY_APP_TYPE_CONVERSATION_MONITOR));
#line 1731 "../src/client/application/application-main-window.vala"
	_data19_ = g_slice_new0 (Block19Data);
#line 1731 "../src/client/application/application-main-window.vala"
	_data19_->_ref_count_ = 1;
#line 1731 "../src/client/application/application-main-window.vala"
	_data19_->self = g_object_ref (self);
#line 1731 "../src/client/application/application-main-window.vala"
	_tmp0_ = _g_object_ref0 (to_close);
#line 1731 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data19_->to_close);
#line 1731 "../src/client/application/application-main-window.vala"
	_data19_->to_close = _tmp0_;
#line 1732 "../src/client/application/application-main-window.vala"
	g_signal_parse_name ("scan-completed", GEARY_APP_TYPE_CONVERSATION_MONITOR, &_tmp1_, NULL, FALSE);
#line 1732 "../src/client/application/application-main-window.vala"
	g_signal_handlers_disconnect_matched (_data19_->to_close, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _application_main_window_on_scan_completed_geary_app_conversation_monitor_scan_completed, self);
#line 1733 "../src/client/application/application-main-window.vala"
	g_signal_parse_name ("scan-error", GEARY_APP_TYPE_CONVERSATION_MONITOR, &_tmp2_, NULL, FALSE);
#line 1733 "../src/client/application/application-main-window.vala"
	g_signal_handlers_disconnect_matched (_data19_->to_close, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _application_main_window_on_scan_error_geary_app_conversation_monitor_scan_error, self);
#line 1735 "../src/client/application/application-main-window.vala"
	g_signal_parse_name ("scan-completed", GEARY_APP_TYPE_CONVERSATION_MONITOR, &_tmp3_, NULL, FALSE);
#line 1735 "../src/client/application/application-main-window.vala"
	g_signal_handlers_disconnect_matched (_data19_->to_close, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _application_main_window_on_conversation_count_changed_geary_app_conversation_monitor_scan_completed, self);
#line 1736 "../src/client/application/application-main-window.vala"
	g_signal_parse_name ("conversations-added", GEARY_APP_TYPE_CONVERSATION_MONITOR, &_tmp4_, NULL, FALSE);
#line 1736 "../src/client/application/application-main-window.vala"
	g_signal_handlers_disconnect_matched (_data19_->to_close, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _application_main_window_on_conversation_count_changed_geary_app_conversation_monitor_conversations_added, self);
#line 1737 "../src/client/application/application-main-window.vala"
	g_signal_parse_name ("conversations-removed", GEARY_APP_TYPE_CONVERSATION_MONITOR, &_tmp5_, NULL, FALSE);
#line 1737 "../src/client/application/application-main-window.vala"
	g_signal_handlers_disconnect_matched (_data19_->to_close, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _application_main_window_on_conversation_count_changed_geary_app_conversation_monitor_conversations_removed, self);
#line 1739 "../src/client/application/application-main-window.vala"
	geary_app_conversation_monitor_stop_monitoring (_data19_->to_close, NULL, ___lambda158__gasync_ready_callback, block19_data_ref (_data19_));
#line 1731 "../src/client/application/application-main-window.vala"
	block19_data_unref (_data19_);
#line 1731 "../src/client/application/application-main-window.vala"
	_data19_ = NULL;
#line 10946 "application-main-window.c"
}

static void
application_main_window_create_composer_data_free (gpointer _data)
{
	ApplicationMainWindowCreateComposerData* _data_;
	_data_ = _data;
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->send_context);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->context);
#line 10 "../src/client/application/application-main-window.vala"
	_g_free0 (_data_->quote);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/client/application/application-main-window.vala"
	g_slice_free (ApplicationMainWindowCreateComposerData, _data_);
#line 10964 "application-main-window.c"
}

static void
application_main_window_create_composer (ApplicationMainWindow* self,
                                         GearyAccount* send_context,
                                         ComposerWidgetContextType type,
                                         GearyEmail* context,
                                         const gchar* quote,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	ApplicationMainWindowCreateComposerData* _data_;
	ApplicationMainWindow* _tmp0_;
	GearyAccount* _tmp1_;
	GearyEmail* _tmp2_;
	gchar* _tmp3_;
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (send_context, GEARY_TYPE_ACCOUNT));
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (context, GEARY_TYPE_EMAIL));
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_slice_new0 (ApplicationMainWindowCreateComposerData);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 10 "../src/client/application/application-main-window.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_main_window_create_composer_data_free);
#line 10 "../src/client/application/application-main-window.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->self = _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (send_context);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->send_context);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->send_context = _tmp1_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_->type = type;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp2_ = _g_object_ref0 (context);
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->context);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->context = _tmp2_;
#line 10 "../src/client/application/application-main-window.vala"
	_tmp3_ = g_strdup (quote);
#line 10 "../src/client/application/application-main-window.vala"
	_g_free0 (_data_->quote);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->quote = _tmp3_;
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_create_composer_co (_data_);
#line 11019 "application-main-window.c"
}

static void
application_main_window_create_composer_finish (ApplicationMainWindow* self,
                                                GAsyncResult* _res_)
{
	ApplicationMainWindowCreateComposerData* _data_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 11029 "application-main-window.c"
}

static void
application_main_window_create_composer_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_)
{
	ApplicationMainWindowCreateComposerData* _data_;
#line 1759 "../src/client/application/application-main-window.vala"
	_data_ = _user_data_;
#line 1759 "../src/client/application/application-main-window.vala"
	_data_->_source_object_ = source_object;
#line 1759 "../src/client/application/application-main-window.vala"
	_data_->_res_ = _res_;
#line 1759 "../src/client/application/application-main-window.vala"
	application_main_window_create_composer_co (_data_);
#line 11046 "application-main-window.c"
}

static gboolean
application_main_window_create_composer_co (ApplicationMainWindowCreateComposerData* _data_)
{
#line 1755 "../src/client/application/application-main-window.vala"
	switch (_data_->_state_) {
#line 1755 "../src/client/application/application-main-window.vala"
		case 0:
#line 11056 "application-main-window.c"
		goto _state_0;
#line 1755 "../src/client/application/application-main-window.vala"
		case 1:
#line 11060 "application-main-window.c"
		goto _state_1;
		default:
#line 1755 "../src/client/application/application-main-window.vala"
		g_assert_not_reached ();
#line 11065 "application-main-window.c"
	}
	_state_0:
#line 1763 "../src/client/application/application-main-window.vala"
	_data_->_tmp0_ = _data_->quote;
#line 1763 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp0_ == NULL) {
#line 1763 "../src/client/application/application-main-window.vala"
		_data_->_tmp0_ = "";
#line 11074 "application-main-window.c"
	}
#line 1759 "../src/client/application/application-main-window.vala"
	_data_->_tmp1_ = _data_->self->priv->controller;
#line 1759 "../src/client/application/application-main-window.vala"
	_data_->_tmp2_ = _data_->self->priv->controller;
#line 1759 "../src/client/application/application-main-window.vala"
	_data_->_tmp3_ = geary_account_get_information (_data_->send_context);
#line 1759 "../src/client/application/application-main-window.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 1759 "../src/client/application/application-main-window.vala"
	_data_->_tmp5_ = application_account_interface_get_context_for_account (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp2_, APPLICATION_TYPE_ACCOUNT_INTERFACE, ApplicationAccountInterface), _data_->_tmp4_);
#line 1759 "../src/client/application/application-main-window.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 1759 "../src/client/application/application-main-window.vala"
	_data_->_state_ = 1;
#line 1759 "../src/client/application/application-main-window.vala"
	application_controller_compose_with_context (_data_->_tmp1_, _data_->_tmp6_, _data_->type, _data_->context, _data_->_tmp0_, application_main_window_create_composer_ready, _data_);
#line 1759 "../src/client/application/application-main-window.vala"
	return FALSE;
#line 11094 "application-main-window.c"
	_state_1:
#line 1759 "../src/client/application/application-main-window.vala"
	_data_->_tmp7_ = application_controller_compose_with_context_finish (_data_->_tmp1_, _data_->_res_);
#line 1759 "../src/client/application/application-main-window.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 1759 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->_tmp6_);
#line 1759 "../src/client/application/application-main-window.vala"
	_data_->composer = _data_->_tmp8_;
#line 1765 "../src/client/application/application-main-window.vala"
	_data_->_tmp9_ = _data_->self->priv->controller;
#line 1765 "../src/client/application/application-main-window.vala"
	application_controller_present_composer (_data_->_tmp9_, _data_->composer);
#line 1755 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->composer);
#line 1755 "../src/client/application/application-main-window.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1755 "../src/client/application/application-main-window.vala"
	if (_data_->_state_ != 0) {
#line 1755 "../src/client/application/application-main-window.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1755 "../src/client/application/application-main-window.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 11118 "application-main-window.c"
		}
	}
#line 1755 "../src/client/application/application-main-window.vala"
	g_object_unref (_data_->_async_result);
#line 1755 "../src/client/application/application-main-window.vala"
	return FALSE;
#line 11125 "application-main-window.c"
}

static void
application_main_window_create_composer_from_viewer_data_free (gpointer _data)
{
	ApplicationMainWindowCreateComposerFromViewerData* _data_;
	_data_ = _data;
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/client/application/application-main-window.vala"
	g_slice_free (ApplicationMainWindowCreateComposerFromViewerData, _data_);
#line 11137 "application-main-window.c"
}

static void
application_main_window_create_composer_from_viewer (ApplicationMainWindow* self,
                                                     ComposerWidgetContextType type,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_)
{
	ApplicationMainWindowCreateComposerFromViewerData* _data_;
	ApplicationMainWindow* _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_slice_new0 (ApplicationMainWindowCreateComposerFromViewerData);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 10 "../src/client/application/application-main-window.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_main_window_create_composer_from_viewer_data_free);
#line 10 "../src/client/application/application-main-window.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->self = _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_->type = type;
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_create_composer_from_viewer_co (_data_);
#line 11164 "application-main-window.c"
}

static void
application_main_window_create_composer_from_viewer_finish (ApplicationMainWindow* self,
                                                            GAsyncResult* _res_)
{
	ApplicationMainWindowCreateComposerFromViewerData* _data_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 11174 "application-main-window.c"
}

static void
application_main_window_create_composer_from_viewer_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_)
{
	ApplicationMainWindowCreateComposerFromViewerData* _data_;
#line 1776 "../src/client/application/application-main-window.vala"
	_data_ = _user_data_;
#line 1776 "../src/client/application/application-main-window.vala"
	_data_->_source_object_ = source_object;
#line 1776 "../src/client/application/application-main-window.vala"
	_data_->_res_ = _res_;
#line 1776 "../src/client/application/application-main-window.vala"
	application_main_window_create_composer_from_viewer_co (_data_);
#line 11191 "application-main-window.c"
}

static gboolean
application_main_window_create_composer_from_viewer_co (ApplicationMainWindowCreateComposerFromViewerData* _data_)
{
#line 1768 "../src/client/application/application-main-window.vala"
	switch (_data_->_state_) {
#line 1768 "../src/client/application/application-main-window.vala"
		case 0:
#line 11201 "application-main-window.c"
		goto _state_0;
#line 1768 "../src/client/application/application-main-window.vala"
		case 1:
#line 11205 "application-main-window.c"
		goto _state_1;
#line 1768 "../src/client/application/application-main-window.vala"
		case 2:
#line 11209 "application-main-window.c"
		goto _state_2;
		default:
#line 1768 "../src/client/application/application-main-window.vala"
		g_assert_not_reached ();
#line 11214 "application-main-window.c"
	}
	_state_0:
#line 1769 "../src/client/application/application-main-window.vala"
	_data_->_tmp0_ = _data_->self->priv->_selected_account;
#line 1769 "../src/client/application/application-main-window.vala"
	_data_->_tmp1_ = _g_object_ref0 (_data_->_tmp0_);
#line 1769 "../src/client/application/application-main-window.vala"
	_data_->account = _data_->_tmp1_;
#line 1770 "../src/client/application/application-main-window.vala"
	_data_->email_view = NULL;
#line 1771 "../src/client/application/application-main-window.vala"
	_data_->_tmp2_ = _data_->self->priv->_conversation_viewer;
#line 1771 "../src/client/application/application-main-window.vala"
	_data_->_tmp3_ = conversation_viewer_get_current_list (_data_->_tmp2_);
#line 1771 "../src/client/application/application-main-window.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 1771 "../src/client/application/application-main-window.vala"
	_data_->_tmp5_ = _g_object_ref0 (_data_->_tmp4_);
#line 1771 "../src/client/application/application-main-window.vala"
	_data_->list_view = _data_->_tmp5_;
#line 1772 "../src/client/application/application-main-window.vala"
	_data_->_tmp6_ = _data_->list_view;
#line 1772 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp6_ != NULL) {
#line 1773 "../src/client/application/application-main-window.vala"
		_data_->_tmp7_ = _data_->list_view;
#line 1773 "../src/client/application/application-main-window.vala"
		_data_->_tmp8_ = conversation_list_box_get_reply_target (_data_->_tmp7_);
#line 1773 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data_->email_view);
#line 1773 "../src/client/application/application-main-window.vala"
		_data_->email_view = _data_->_tmp8_;
#line 11247 "application-main-window.c"
	}
#line 1775 "../src/client/application/application-main-window.vala"
	_data_->_tmp10_ = _data_->account;
#line 1775 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp10_ != NULL) {
#line 1775 "../src/client/application/application-main-window.vala"
		_data_->_tmp11_ = _data_->email_view;
#line 1775 "../src/client/application/application-main-window.vala"
		_data_->_tmp9_ = _data_->_tmp11_ != NULL;
#line 11257 "application-main-window.c"
	} else {
#line 1775 "../src/client/application/application-main-window.vala"
		_data_->_tmp9_ = FALSE;
#line 11261 "application-main-window.c"
	}
#line 1775 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp9_) {
#line 1776 "../src/client/application/application-main-window.vala"
		_data_->_tmp12_ = _data_->email_view;
#line 1776 "../src/client/application/application-main-window.vala"
		_data_->_state_ = 1;
#line 1776 "../src/client/application/application-main-window.vala"
		conversation_email_get_selection_for_quoting (_data_->_tmp12_, application_main_window_create_composer_from_viewer_ready, _data_);
#line 1776 "../src/client/application/application-main-window.vala"
		return FALSE;
#line 11273 "application-main-window.c"
		_state_1:
#line 1776 "../src/client/application/application-main-window.vala"
		_data_->_tmp13_ = conversation_email_get_selection_for_quoting_finish (_data_->_tmp12_, _data_->_res_);
#line 1776 "../src/client/application/application-main-window.vala"
		_data_->quote = _data_->_tmp13_;
#line 1777 "../src/client/application/application-main-window.vala"
		_data_->_tmp14_ = _data_->account;
#line 1777 "../src/client/application/application-main-window.vala"
		_data_->_tmp15_ = _data_->email_view;
#line 1777 "../src/client/application/application-main-window.vala"
		_data_->_tmp16_ = conversation_email_get_email (_data_->_tmp15_);
#line 1777 "../src/client/application/application-main-window.vala"
		_data_->_tmp17_ = _data_->_tmp16_;
#line 1777 "../src/client/application/application-main-window.vala"
		_data_->_tmp18_ = _data_->quote;
#line 1777 "../src/client/application/application-main-window.vala"
		_data_->_state_ = 2;
#line 1777 "../src/client/application/application-main-window.vala"
		application_main_window_create_composer (_data_->self, _data_->_tmp14_, _data_->type, _data_->_tmp17_, _data_->_tmp18_, application_main_window_create_composer_from_viewer_ready, _data_);
#line 1777 "../src/client/application/application-main-window.vala"
		return FALSE;
#line 11295 "application-main-window.c"
		_state_2:
#line 1777 "../src/client/application/application-main-window.vala"
		application_main_window_create_composer_finish (_data_->self, _data_->_res_);
#line 1775 "../src/client/application/application-main-window.vala"
		_g_free0 (_data_->quote);
#line 11301 "application-main-window.c"
	}
#line 1768 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->list_view);
#line 1768 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->email_view);
#line 1768 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->account);
#line 1768 "../src/client/application/application-main-window.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1768 "../src/client/application/application-main-window.vala"
	if (_data_->_state_ != 0) {
#line 1768 "../src/client/application/application-main-window.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1768 "../src/client/application/application-main-window.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 11317 "application-main-window.c"
		}
	}
#line 1768 "../src/client/application/application-main-window.vala"
	g_object_unref (_data_->_async_result);
#line 1768 "../src/client/application/application-main-window.vala"
	return FALSE;
#line 11324 "application-main-window.c"
}

static void
application_main_window_load_more (ApplicationMainWindow* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 1781 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1782 "../src/client/application/application-main-window.vala"
	_tmp1_ = application_main_window_get_is_conversation_list_shown (self);
#line 1782 "../src/client/application/application-main-window.vala"
	_tmp2_ = _tmp1_;
#line 1782 "../src/client/application/application-main-window.vala"
	if (_tmp2_) {
#line 11341 "application-main-window.c"
		GearyAppConversationMonitor* _tmp3_;
#line 1783 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->_conversations;
#line 1783 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp3_ != NULL;
#line 11347 "application-main-window.c"
	} else {
#line 1782 "../src/client/application/application-main-window.vala"
		_tmp0_ = FALSE;
#line 11351 "application-main-window.c"
	}
#line 1782 "../src/client/application/application-main-window.vala"
	if (_tmp0_) {
#line 11355 "application-main-window.c"
		GearyAppConversationMonitor* _tmp4_;
		GearyAppConversationMonitor* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 1784 "../src/client/application/application-main-window.vala"
		_tmp4_ = self->priv->_conversations;
#line 1784 "../src/client/application/application-main-window.vala"
		_tmp5_ = self->priv->_conversations;
#line 1784 "../src/client/application/application-main-window.vala"
		_tmp6_ = geary_app_conversation_monitor_get_min_window_count (_tmp5_);
#line 1784 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 1784 "../src/client/application/application-main-window.vala"
		geary_app_conversation_monitor_set_min_window_count (_tmp5_, _tmp7_ + APPLICATION_MAIN_WINDOW_MIN_CONVERSATION_COUNT);
#line 11370 "application-main-window.c"
	}
}

static void
application_main_window_on_conversations_selected (ApplicationMainWindow* self,
                                                   GeeSet* selected)
{
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
#line 1788 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1788 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (selected, GEE_TYPE_SET));
#line 1789 "../src/client/application/application-main-window.vala"
	_tmp0_ = gee_collection_empty (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref);
#line 1789 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 1789 "../src/client/application/application-main-window.vala"
	application_main_window_select_conversations (self, G_TYPE_CHECK_INSTANCE_CAST (selected, GEE_TYPE_COLLECTION, GeeCollection), _tmp1_, TRUE, NULL, NULL);
#line 1789 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp1_);
#line 11392 "application-main-window.c"
}

static void
application_main_window_on_conversation_count_changed (ApplicationMainWindow* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 1792 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1795 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_main_window_get_has_composer (self);
#line 1795 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 1795 "../src/client/application/application-main-window.vala"
	if (!_tmp1_) {
#line 11408 "application-main-window.c"
		GearyAppConversationMonitor* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 1796 "../src/client/application/application-main-window.vala"
		_tmp2_ = self->priv->_conversations;
#line 1796 "../src/client/application/application-main-window.vala"
		_tmp3_ = geary_app_conversation_monitor_get_size (_tmp2_);
#line 1796 "../src/client/application/application-main-window.vala"
		_tmp4_ = _tmp3_;
#line 1796 "../src/client/application/application-main-window.vala"
		if (_tmp4_ == 0) {
#line 11420 "application-main-window.c"
			GearyFolder* _tmp5_;
			GearyFolderSpecialUse _tmp6_;
			GearyFolderSpecialUse _tmp7_;
#line 1798 "../src/client/application/application-main-window.vala"
			_tmp5_ = self->priv->_selected_folder;
#line 1798 "../src/client/application/application-main-window.vala"
			_tmp6_ = geary_folder_get_used_as (_tmp5_);
#line 1798 "../src/client/application/application-main-window.vala"
			_tmp7_ = _tmp6_;
#line 1798 "../src/client/application/application-main-window.vala"
			if (_tmp7_ == GEARY_FOLDER_SPECIAL_USE_SEARCH) {
#line 11432 "application-main-window.c"
				ConversationViewer* _tmp8_;
#line 1799 "../src/client/application/application-main-window.vala"
				_tmp8_ = self->priv->_conversation_viewer;
#line 1799 "../src/client/application/application-main-window.vala"
				conversation_viewer_show_empty_search (_tmp8_);
#line 11438 "application-main-window.c"
			} else {
				ConversationViewer* _tmp9_;
#line 1801 "../src/client/application/application-main-window.vala"
				_tmp9_ = self->priv->_conversation_viewer;
#line 1801 "../src/client/application/application-main-window.vala"
				conversation_viewer_show_empty_folder (_tmp9_);
#line 11445 "application-main-window.c"
			}
#line 1803 "../src/client/application/application-main-window.vala"
			application_main_window_update_conversation_actions (self, APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_NONE);
#line 11449 "application-main-window.c"
		} else {
			gboolean _tmp10_ = FALSE;
			ApplicationClient* _tmp11_;
			ApplicationClient* _tmp12_;
			ApplicationConfiguration* _tmp13_;
			ApplicationConfiguration* _tmp14_;
			gboolean _tmp15_;
			gboolean _tmp16_;
#line 1808 "../src/client/application/application-main-window.vala"
			_tmp11_ = application_main_window_get_application (self);
#line 1808 "../src/client/application/application-main-window.vala"
			_tmp12_ = _tmp11_;
#line 1808 "../src/client/application/application-main-window.vala"
			_tmp13_ = application_client_get_config (_tmp12_);
#line 1808 "../src/client/application/application-main-window.vala"
			_tmp14_ = _tmp13_;
#line 1808 "../src/client/application/application-main-window.vala"
			_tmp15_ = application_configuration_get_autoselect (_tmp14_);
#line 1808 "../src/client/application/application-main-window.vala"
			_tmp16_ = _tmp15_;
#line 1808 "../src/client/application/application-main-window.vala"
			if (!_tmp16_) {
#line 11472 "application-main-window.c"
				ConversationListView* _tmp17_;
				GtkTreeSelection* _tmp18_;
#line 1809 "../src/client/application/application-main-window.vala"
				_tmp17_ = self->priv->_conversation_list_view;
#line 1809 "../src/client/application/application-main-window.vala"
				_tmp18_ = gtk_tree_view_get_selection (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, gtk_tree_view_get_type (), GtkTreeView));
#line 1809 "../src/client/application/application-main-window.vala"
				_tmp10_ = gtk_tree_selection_count_selected_rows (_tmp18_) == 0;
#line 11481 "application-main-window.c"
			} else {
#line 1808 "../src/client/application/application-main-window.vala"
				_tmp10_ = FALSE;
#line 11485 "application-main-window.c"
			}
#line 1808 "../src/client/application/application-main-window.vala"
			if (_tmp10_) {
#line 11489 "application-main-window.c"
				ConversationViewer* _tmp19_;
#line 1810 "../src/client/application/application-main-window.vala"
				_tmp19_ = self->priv->_conversation_viewer;
#line 1810 "../src/client/application/application-main-window.vala"
				conversation_viewer_show_none_selected (_tmp19_);
#line 1811 "../src/client/application/application-main-window.vala"
				application_main_window_update_conversation_actions (self, APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_NONE);
#line 11497 "application-main-window.c"
			}
		}
	}
}

static void
application_main_window_update_headerbar (ApplicationMainWindow* self)
{
	GearyFolder* _tmp0_;
#line 1817 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1818 "../src/client/application/application-main-window.vala"
	application_main_window_update_title (self);
#line 1819 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 1819 "../src/client/application/application-main-window.vala"
	if (_tmp0_ != NULL) {
#line 11515 "application-main-window.c"
		gint count = 0;
		GearyFolder* _tmp1_;
		GearyFolderSpecialUse _tmp2_;
		GearyFolderSpecialUse _tmp3_;
#line 1824 "../src/client/application/application-main-window.vala"
		_tmp1_ = self->priv->_selected_folder;
#line 1824 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_used_as (_tmp1_);
#line 1824 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 1824 "../src/client/application/application-main-window.vala"
		switch (_tmp3_) {
#line 1824 "../src/client/application/application-main-window.vala"
			case GEARY_FOLDER_SPECIAL_USE_DRAFTS:
#line 1824 "../src/client/application/application-main-window.vala"
			case GEARY_FOLDER_SPECIAL_USE_OUTBOX:
#line 11532 "application-main-window.c"
			{
				GearyFolder* _tmp4_;
				GearyFolderProperties* _tmp5_;
				GearyFolderProperties* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
#line 1827 "../src/client/application/application-main-window.vala"
				_tmp4_ = self->priv->_selected_folder;
#line 1827 "../src/client/application/application-main-window.vala"
				_tmp5_ = geary_folder_get_properties (_tmp4_);
#line 1827 "../src/client/application/application-main-window.vala"
				_tmp6_ = _tmp5_;
#line 1827 "../src/client/application/application-main-window.vala"
				_tmp7_ = geary_folder_properties_get_email_total (_tmp6_);
#line 1827 "../src/client/application/application-main-window.vala"
				_tmp8_ = _tmp7_;
#line 1827 "../src/client/application/application-main-window.vala"
				count = _tmp8_;
#line 1828 "../src/client/application/application-main-window.vala"
				break;
#line 11553 "application-main-window.c"
			}
			default:
			{
				GearyFolder* _tmp9_;
				GearyFolderProperties* _tmp10_;
				GearyFolderProperties* _tmp11_;
				gint _tmp12_;
				gint _tmp13_;
#line 1831 "../src/client/application/application-main-window.vala"
				_tmp9_ = self->priv->_selected_folder;
#line 1831 "../src/client/application/application-main-window.vala"
				_tmp10_ = geary_folder_get_properties (_tmp9_);
#line 1831 "../src/client/application/application-main-window.vala"
				_tmp11_ = _tmp10_;
#line 1831 "../src/client/application/application-main-window.vala"
				_tmp12_ = geary_folder_properties_get_email_unread (_tmp11_);
#line 1831 "../src/client/application/application-main-window.vala"
				_tmp13_ = _tmp12_;
#line 1831 "../src/client/application/application-main-window.vala"
				count = _tmp13_;
#line 1832 "../src/client/application/application-main-window.vala"
				break;
#line 11576 "application-main-window.c"
			}
		}
#line 1835 "../src/client/application/application-main-window.vala"
		if (count > 0) {
#line 11581 "application-main-window.c"
			ComponentsMainToolbar* _tmp14_;
			ComponentsMainToolbar* _tmp15_;
			const gchar* _tmp16_;
			const gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
#line 1836 "../src/client/application/application-main-window.vala"
			_tmp14_ = self->priv->_main_toolbar;
#line 1836 "../src/client/application/application-main-window.vala"
			_tmp15_ = self->priv->_main_toolbar;
#line 1836 "../src/client/application/application-main-window.vala"
			_tmp16_ = components_main_toolbar_get_folder (_tmp15_);
#line 1836 "../src/client/application/application-main-window.vala"
			_tmp17_ = _tmp16_;
#line 1836 "../src/client/application/application-main-window.vala"
			_tmp18_ = g_strdup_printf (_ ("%s (%d)"), _tmp17_, count);
#line 1836 "../src/client/application/application-main-window.vala"
			_tmp19_ = _tmp18_;
#line 1836 "../src/client/application/application-main-window.vala"
			components_main_toolbar_set_folder (_tmp14_, _tmp19_);
#line 1836 "../src/client/application/application-main-window.vala"
			_g_free0 (_tmp19_);
#line 11604 "application-main-window.c"
		}
	}
}

static void
application_main_window_update_conversation_actions (ApplicationMainWindow* self,
                                                     ApplicationMainWindowConversationCount count)
{
	gboolean sensitive = FALSE;
	gboolean multiple = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GSimpleAction* _tmp4_;
	GSimpleAction* _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean reply_sensitive = FALSE;
	GSimpleAction* _tmp13_;
	GSimpleAction* _tmp14_;
	GSimpleAction* _tmp15_;
	GSimpleAction* _tmp16_;
	GSimpleAction* _tmp17_;
	GSimpleAction* _tmp18_;
	gboolean _tmp19_ = FALSE;
	gboolean move_enabled = FALSE;
	GSimpleAction* _tmp21_;
	GSimpleAction* _tmp22_;
	ComponentsConversationActions** _tmp23_;
	gint _tmp23__length1;
	gboolean _tmp26_ = FALSE;
	gboolean copy_enabled = FALSE;
	GSimpleAction* _tmp28_;
	GSimpleAction* _tmp29_;
	ComponentsConversationActions** _tmp30_;
	gint _tmp30__length1;
	gboolean _tmp33_ = FALSE;
	gboolean mark_enabled = FALSE;
	ComponentsConversationActions** _tmp35_;
	gint _tmp35__length1;
	gboolean _tmp38_ = FALSE;
	GSimpleAction* _tmp40_;
	GSimpleAction* _tmp41_;
	gboolean _tmp42_ = FALSE;
	GSimpleAction* _tmp45_;
	GSimpleAction* _tmp46_;
	gboolean _tmp47_ = FALSE;
	GSimpleAction* _tmp49_;
	GSimpleAction* _tmp50_;
#line 1843 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1844 "../src/client/application/application-main-window.vala"
	sensitive = count != APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_NONE;
#line 1845 "../src/client/application/application-main-window.vala"
	multiple = count == APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_MULTIPLE;
#line 1848 "../src/client/application/application-main-window.vala"
	if (sensitive) {
#line 1848 "../src/client/application/application-main-window.vala"
		_tmp1_ = !multiple;
#line 11664 "application-main-window.c"
	} else {
#line 1848 "../src/client/application/application-main-window.vala"
		_tmp1_ = FALSE;
#line 11668 "application-main-window.c"
	}
#line 1848 "../src/client/application/application-main-window.vala"
	if (_tmp1_) {
#line 11672 "application-main-window.c"
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 1848 "../src/client/application/application-main-window.vala"
		_tmp2_ = application_main_window_get_is_conversation_viewer_shown (self);
#line 1848 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 1848 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp3_;
#line 11681 "application-main-window.c"
	} else {
#line 1848 "../src/client/application/application-main-window.vala"
		_tmp0_ = FALSE;
#line 11685 "application-main-window.c"
	}
#line 1847 "../src/client/application/application-main-window.vala"
	_tmp4_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_FIND_IN_CONVERSATION);
#line 1847 "../src/client/application/application-main-window.vala"
	_tmp5_ = _tmp4_;
#line 1847 "../src/client/application/application-main-window.vala"
	g_simple_action_set_enabled (_tmp5_, _tmp0_);
#line 1847 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp5_);
#line 1852 "../src/client/application/application-main-window.vala"
	if (sensitive) {
#line 1853 "../src/client/application/application-main-window.vala"
		_tmp8_ = !multiple;
#line 11699 "application-main-window.c"
	} else {
#line 1852 "../src/client/application/application-main-window.vala"
		_tmp8_ = FALSE;
#line 11703 "application-main-window.c"
	}
#line 1852 "../src/client/application/application-main-window.vala"
	if (_tmp8_) {
#line 11707 "application-main-window.c"
		GearyFolder* _tmp9_;
#line 1854 "../src/client/application/application-main-window.vala"
		_tmp9_ = self->priv->_selected_folder;
#line 1854 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp9_ != NULL;
#line 11713 "application-main-window.c"
	} else {
#line 1852 "../src/client/application/application-main-window.vala"
		_tmp7_ = FALSE;
#line 11717 "application-main-window.c"
	}
#line 1851 "../src/client/application/application-main-window.vala"
	if (_tmp7_) {
#line 11721 "application-main-window.c"
		GearyFolder* _tmp10_;
		GearyFolderSpecialUse _tmp11_;
		GearyFolderSpecialUse _tmp12_;
#line 1855 "../src/client/application/application-main-window.vala"
		_tmp10_ = self->priv->_selected_folder;
#line 1855 "../src/client/application/application-main-window.vala"
		_tmp11_ = geary_folder_get_used_as (_tmp10_);
#line 1855 "../src/client/application/application-main-window.vala"
		_tmp12_ = _tmp11_;
#line 1855 "../src/client/application/application-main-window.vala"
		_tmp6_ = _tmp12_ != GEARY_FOLDER_SPECIAL_USE_DRAFTS;
#line 11733 "application-main-window.c"
	} else {
#line 1852 "../src/client/application/application-main-window.vala"
		_tmp6_ = FALSE;
#line 11737 "application-main-window.c"
	}
#line 1851 "../src/client/application/application-main-window.vala"
	reply_sensitive = _tmp6_;
#line 1857 "../src/client/application/application-main-window.vala"
	_tmp13_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_REPLY_CONVERSATION);
#line 1857 "../src/client/application/application-main-window.vala"
	_tmp14_ = _tmp13_;
#line 1857 "../src/client/application/application-main-window.vala"
	g_simple_action_set_enabled (_tmp14_, reply_sensitive);
#line 1857 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp14_);
#line 1858 "../src/client/application/application-main-window.vala"
	_tmp15_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_REPLY_ALL_CONVERSATION);
#line 1858 "../src/client/application/application-main-window.vala"
	_tmp16_ = _tmp15_;
#line 1858 "../src/client/application/application-main-window.vala"
	g_simple_action_set_enabled (_tmp16_, reply_sensitive);
#line 1858 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp16_);
#line 1859 "../src/client/application/application-main-window.vala"
	_tmp17_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_FORWARD_CONVERSATION);
#line 1859 "../src/client/application/application-main-window.vala"
	_tmp18_ = _tmp17_;
#line 1859 "../src/client/application/application-main-window.vala"
	g_simple_action_set_enabled (_tmp18_, reply_sensitive);
#line 1859 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp18_);
#line 1861 "../src/client/application/application-main-window.vala"
	if (sensitive) {
#line 11767 "application-main-window.c"
		GearyFolder* _tmp20_;
#line 1862 "../src/client/application/application-main-window.vala"
		_tmp20_ = self->priv->_selected_folder;
#line 1862 "../src/client/application/application-main-window.vala"
		_tmp19_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp20_, GEARY_FOLDER_SUPPORT_TYPE_MOVE);
#line 11773 "application-main-window.c"
	} else {
#line 1862 "../src/client/application/application-main-window.vala"
		_tmp19_ = FALSE;
#line 11777 "application-main-window.c"
	}
#line 1861 "../src/client/application/application-main-window.vala"
	move_enabled = _tmp19_;
#line 1864 "../src/client/application/application-main-window.vala"
	_tmp21_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_SHOW_MOVE_MENU);
#line 1864 "../src/client/application/application-main-window.vala"
	_tmp22_ = _tmp21_;
#line 1864 "../src/client/application/application-main-window.vala"
	g_simple_action_set_enabled (_tmp22_, move_enabled);
#line 1864 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp22_);
#line 1865 "../src/client/application/application-main-window.vala"
	_tmp23_ = self->priv->folder_conversation_actions;
#line 1865 "../src/client/application/application-main-window.vala"
	_tmp23__length1 = self->priv->folder_conversation_actions_length1;
#line 11793 "application-main-window.c"
	{
		ComponentsConversationActions** actions_collection = NULL;
		gint actions_collection_length1 = 0;
		gint _actions_collection_size_ = 0;
		gint actions_it = 0;
#line 1865 "../src/client/application/application-main-window.vala"
		actions_collection = _tmp23_;
#line 1865 "../src/client/application/application-main-window.vala"
		actions_collection_length1 = _tmp23__length1;
#line 1865 "../src/client/application/application-main-window.vala"
		for (actions_it = 0; actions_it < actions_collection_length1; actions_it = actions_it + 1) {
#line 11805 "application-main-window.c"
			ComponentsConversationActions* _tmp24_;
			ComponentsConversationActions* actions = NULL;
#line 1865 "../src/client/application/application-main-window.vala"
			_tmp24_ = _g_object_ref0 (actions_collection[actions_it]);
#line 1865 "../src/client/application/application-main-window.vala"
			actions = _tmp24_;
#line 11812 "application-main-window.c"
			{
				ComponentsConversationActions* _tmp25_;
#line 1866 "../src/client/application/application-main-window.vala"
				_tmp25_ = actions;
#line 1866 "../src/client/application/application-main-window.vala"
				components_conversation_actions_set_move_sensitive (_tmp25_, move_enabled);
#line 1865 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (actions);
#line 11821 "application-main-window.c"
			}
		}
	}
#line 1869 "../src/client/application/application-main-window.vala"
	if (sensitive) {
#line 11827 "application-main-window.c"
		GearyFolder* _tmp27_;
#line 1870 "../src/client/application/application-main-window.vala"
		_tmp27_ = self->priv->_selected_folder;
#line 1870 "../src/client/application/application-main-window.vala"
		_tmp26_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp27_, GEARY_FOLDER_SUPPORT_TYPE_COPY);
#line 11833 "application-main-window.c"
	} else {
#line 1870 "../src/client/application/application-main-window.vala"
		_tmp26_ = FALSE;
#line 11837 "application-main-window.c"
	}
#line 1869 "../src/client/application/application-main-window.vala"
	copy_enabled = _tmp26_;
#line 1872 "../src/client/application/application-main-window.vala"
	_tmp28_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_SHOW_COPY_MENU);
#line 1872 "../src/client/application/application-main-window.vala"
	_tmp29_ = _tmp28_;
#line 1872 "../src/client/application/application-main-window.vala"
	g_simple_action_set_enabled (_tmp29_, move_enabled);
#line 1872 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp29_);
#line 1873 "../src/client/application/application-main-window.vala"
	_tmp30_ = self->priv->folder_conversation_actions;
#line 1873 "../src/client/application/application-main-window.vala"
	_tmp30__length1 = self->priv->folder_conversation_actions_length1;
#line 11853 "application-main-window.c"
	{
		ComponentsConversationActions** actions_collection = NULL;
		gint actions_collection_length1 = 0;
		gint _actions_collection_size_ = 0;
		gint actions_it = 0;
#line 1873 "../src/client/application/application-main-window.vala"
		actions_collection = _tmp30_;
#line 1873 "../src/client/application/application-main-window.vala"
		actions_collection_length1 = _tmp30__length1;
#line 1873 "../src/client/application/application-main-window.vala"
		for (actions_it = 0; actions_it < actions_collection_length1; actions_it = actions_it + 1) {
#line 11865 "application-main-window.c"
			ComponentsConversationActions* _tmp31_;
			ComponentsConversationActions* actions = NULL;
#line 1873 "../src/client/application/application-main-window.vala"
			_tmp31_ = _g_object_ref0 (actions_collection[actions_it]);
#line 1873 "../src/client/application/application-main-window.vala"
			actions = _tmp31_;
#line 11872 "application-main-window.c"
			{
				ComponentsConversationActions* _tmp32_;
#line 1874 "../src/client/application/application-main-window.vala"
				_tmp32_ = actions;
#line 1874 "../src/client/application/application-main-window.vala"
				components_conversation_actions_set_copy_sensitive (_tmp32_, copy_enabled);
#line 1873 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (actions);
#line 11881 "application-main-window.c"
			}
		}
	}
#line 1877 "../src/client/application/application-main-window.vala"
	if (sensitive) {
#line 11887 "application-main-window.c"
		GearyFolder* _tmp34_;
#line 1878 "../src/client/application/application-main-window.vala"
		_tmp34_ = self->priv->_selected_folder;
#line 1878 "../src/client/application/application-main-window.vala"
		_tmp33_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp34_, GEARY_FOLDER_SUPPORT_TYPE_MARK);
#line 11893 "application-main-window.c"
	} else {
#line 1878 "../src/client/application/application-main-window.vala"
		_tmp33_ = FALSE;
#line 11897 "application-main-window.c"
	}
#line 1877 "../src/client/application/application-main-window.vala"
	mark_enabled = _tmp33_;
#line 1880 "../src/client/application/application-main-window.vala"
	_tmp35_ = self->priv->folder_conversation_actions;
#line 1880 "../src/client/application/application-main-window.vala"
	_tmp35__length1 = self->priv->folder_conversation_actions_length1;
#line 11905 "application-main-window.c"
	{
		ComponentsConversationActions** actions_collection = NULL;
		gint actions_collection_length1 = 0;
		gint _actions_collection_size_ = 0;
		gint actions_it = 0;
#line 1880 "../src/client/application/application-main-window.vala"
		actions_collection = _tmp35_;
#line 1880 "../src/client/application/application-main-window.vala"
		actions_collection_length1 = _tmp35__length1;
#line 1880 "../src/client/application/application-main-window.vala"
		for (actions_it = 0; actions_it < actions_collection_length1; actions_it = actions_it + 1) {
#line 11917 "application-main-window.c"
			ComponentsConversationActions* _tmp36_;
			ComponentsConversationActions* actions = NULL;
#line 1880 "../src/client/application/application-main-window.vala"
			_tmp36_ = _g_object_ref0 (actions_collection[actions_it]);
#line 1880 "../src/client/application/application-main-window.vala"
			actions = _tmp36_;
#line 11924 "application-main-window.c"
			{
				ComponentsConversationActions* _tmp37_;
#line 1881 "../src/client/application/application-main-window.vala"
				_tmp37_ = actions;
#line 1881 "../src/client/application/application-main-window.vala"
				components_conversation_actions_set_mark_sensitive (_tmp37_, mark_enabled);
#line 1880 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (actions);
#line 11933 "application-main-window.c"
			}
		}
	}
#line 1885 "../src/client/application/application-main-window.vala"
	if (sensitive) {
#line 11939 "application-main-window.c"
		GearyFolder* _tmp39_;
#line 1885 "../src/client/application/application-main-window.vala"
		_tmp39_ = self->priv->_selected_folder;
#line 1885 "../src/client/application/application-main-window.vala"
		_tmp38_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp39_, GEARY_FOLDER_SUPPORT_TYPE_ARCHIVE);
#line 11945 "application-main-window.c"
	} else {
#line 1885 "../src/client/application/application-main-window.vala"
		_tmp38_ = FALSE;
#line 11949 "application-main-window.c"
	}
#line 1884 "../src/client/application/application-main-window.vala"
	_tmp40_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_ARCHIVE_CONVERSATION);
#line 1884 "../src/client/application/application-main-window.vala"
	_tmp41_ = _tmp40_;
#line 1884 "../src/client/application/application-main-window.vala"
	g_simple_action_set_enabled (_tmp41_, _tmp38_);
#line 1884 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp41_);
#line 1888 "../src/client/application/application-main-window.vala"
	if (sensitive) {
#line 11961 "application-main-window.c"
		gboolean _tmp43_;
		gboolean _tmp44_;
#line 1888 "../src/client/application/application-main-window.vala"
		_tmp43_ = application_main_window_get_selected_folder_supports_trash (self);
#line 1888 "../src/client/application/application-main-window.vala"
		_tmp44_ = _tmp43_;
#line 1888 "../src/client/application/application-main-window.vala"
		_tmp42_ = _tmp44_;
#line 11970 "application-main-window.c"
	} else {
#line 1888 "../src/client/application/application-main-window.vala"
		_tmp42_ = FALSE;
#line 11974 "application-main-window.c"
	}
#line 1887 "../src/client/application/application-main-window.vala"
	_tmp45_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_TRASH_CONVERSATION);
#line 1887 "../src/client/application/application-main-window.vala"
	_tmp46_ = _tmp45_;
#line 1887 "../src/client/application/application-main-window.vala"
	g_simple_action_set_enabled (_tmp46_, _tmp42_);
#line 1887 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp46_);
#line 1891 "../src/client/application/application-main-window.vala"
	if (sensitive) {
#line 11986 "application-main-window.c"
		GearyFolder* _tmp48_;
#line 1891 "../src/client/application/application-main-window.vala"
		_tmp48_ = self->priv->_selected_folder;
#line 1891 "../src/client/application/application-main-window.vala"
		_tmp47_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp48_, GEARY_FOLDER_SUPPORT_TYPE_REMOVE);
#line 11992 "application-main-window.c"
	} else {
#line 1891 "../src/client/application/application-main-window.vala"
		_tmp47_ = FALSE;
#line 11996 "application-main-window.c"
	}
#line 1890 "../src/client/application/application-main-window.vala"
	_tmp49_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_DELETE_CONVERSATION);
#line 1890 "../src/client/application/application-main-window.vala"
	_tmp50_ = _tmp49_;
#line 1890 "../src/client/application/application-main-window.vala"
	g_simple_action_set_enabled (_tmp50_, _tmp47_);
#line 1890 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp50_);
#line 1894 "../src/client/application/application-main-window.vala"
	switch (count) {
#line 1894 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_NONE:
#line 12010 "application-main-window.c"
		{
			GtkRevealer* _tmp51_;
#line 1896 "../src/client/application/application-main-window.vala"
			_tmp51_ = self->priv->conversation_list_actions_revealer;
#line 1896 "../src/client/application/application-main-window.vala"
			gtk_revealer_set_reveal_child (_tmp51_, FALSE);
#line 1897 "../src/client/application/application-main-window.vala"
			break;
#line 12019 "application-main-window.c"
		}
#line 1894 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_SINGLE:
#line 12023 "application-main-window.c"
		{
			GtkRevealer* _tmp52_;
			HdyLeaflet* _tmp53_;
			gboolean _tmp54_;
			gboolean _tmp55_;
#line 1899 "../src/client/application/application-main-window.vala"
			_tmp52_ = self->priv->conversation_list_actions_revealer;
#line 1899 "../src/client/application/application-main-window.vala"
			_tmp53_ = self->priv->outer_leaflet;
#line 1899 "../src/client/application/application-main-window.vala"
			_tmp54_ = hdy_leaflet_get_folded (_tmp53_);
#line 1899 "../src/client/application/application-main-window.vala"
			_tmp55_ = _tmp54_;
#line 1899 "../src/client/application/application-main-window.vala"
			gtk_revealer_set_reveal_child (_tmp52_, _tmp55_);
#line 1902 "../src/client/application/application-main-window.vala"
			break;
#line 12041 "application-main-window.c"
		}
#line 1894 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_CONVERSATION_COUNT_MULTIPLE:
#line 12045 "application-main-window.c"
		{
			GtkRevealer* _tmp56_;
#line 1904 "../src/client/application/application-main-window.vala"
			_tmp56_ = self->priv->conversation_list_actions_revealer;
#line 1904 "../src/client/application/application-main-window.vala"
			gtk_revealer_set_reveal_child (_tmp56_, TRUE);
#line 1905 "../src/client/application/application-main-window.vala"
			break;
#line 12054 "application-main-window.c"
		}
		default:
#line 1894 "../src/client/application/application-main-window.vala"
		break;
#line 12059 "application-main-window.c"
	}
#line 1908 "../src/client/application/application-main-window.vala"
	application_main_window_update_context_dependent_actions (self, sensitive, NULL, NULL);
#line 12063 "application-main-window.c"
}

static void
application_main_window_update_trash_action (ApplicationMainWindow* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean show_trash = FALSE;
	ComponentsConversationActions* _tmp4_;
	ComponentsMainToolbar* _tmp5_;
	ComponentsConversationActions* _tmp6_;
#line 1911 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1912 "../src/client/application/application-main-window.vala"
	_tmp1_ = self->priv->_is_shift_down;
#line 1912 "../src/client/application/application-main-window.vala"
	if (!_tmp1_) {
#line 12081 "application-main-window.c"
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 1914 "../src/client/application/application-main-window.vala"
		_tmp2_ = application_main_window_get_selected_folder_supports_trash (self);
#line 1914 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 1914 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp3_;
#line 12090 "application-main-window.c"
	} else {
#line 1913 "../src/client/application/application-main-window.vala"
		_tmp0_ = FALSE;
#line 12094 "application-main-window.c"
	}
#line 1912 "../src/client/application/application-main-window.vala"
	show_trash = _tmp0_;
#line 1916 "../src/client/application/application-main-window.vala"
	_tmp4_ = self->priv->conversation_list_actions;
#line 1916 "../src/client/application/application-main-window.vala"
	components_conversation_actions_update_trash_button (_tmp4_, show_trash);
#line 1917 "../src/client/application/application-main-window.vala"
	_tmp5_ = self->priv->_main_toolbar;
#line 1917 "../src/client/application/application-main-window.vala"
	_tmp6_ = _tmp5_->full_actions;
#line 1917 "../src/client/application/application-main-window.vala"
	components_conversation_actions_update_trash_button (_tmp6_, show_trash);
#line 12108 "application-main-window.c"
}

static void
application_main_window_update_context_dependent_actions_data_free (gpointer _data)
{
	ApplicationMainWindowUpdateContextDependentActionsData* _data_;
	_data_ = _data;
#line 10 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->self);
#line 10 "../src/client/application/application-main-window.vala"
	g_slice_free (ApplicationMainWindowUpdateContextDependentActionsData, _data_);
#line 12120 "application-main-window.c"
}

static void
application_main_window_update_context_dependent_actions (ApplicationMainWindow* self,
                                                          gboolean sensitive,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_)
{
	ApplicationMainWindowUpdateContextDependentActionsData* _data_;
	ApplicationMainWindow* _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_slice_new0 (ApplicationMainWindowUpdateContextDependentActionsData);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 10 "../src/client/application/application-main-window.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_main_window_update_context_dependent_actions_data_free);
#line 10 "../src/client/application/application-main-window.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 10 "../src/client/application/application-main-window.vala"
	_data_->self = _tmp0_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_->sensitive = sensitive;
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_update_context_dependent_actions_co (_data_);
#line 12147 "application-main-window.c"
}

static void
application_main_window_update_context_dependent_actions_finish (ApplicationMainWindow* self,
                                                                 GAsyncResult* _res_)
{
	ApplicationMainWindowUpdateContextDependentActionsData* _data_;
#line 10 "../src/client/application/application-main-window.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 12157 "application-main-window.c"
}

static void
application_main_window_update_context_dependent_actions_ready (GObject* source_object,
                                                                GAsyncResult* _res_,
                                                                gpointer _user_data_)
{
	ApplicationMainWindowUpdateContextDependentActionsData* _data_;
#line 1940 "../src/client/application/application-main-window.vala"
	_data_ = _user_data_;
#line 1940 "../src/client/application/application-main-window.vala"
	_data_->_source_object_ = source_object;
#line 1940 "../src/client/application/application-main-window.vala"
	_data_->_res_ = _res_;
#line 1940 "../src/client/application/application-main-window.vala"
	application_main_window_update_context_dependent_actions_co (_data_);
#line 12174 "application-main-window.c"
}

static gboolean
application_main_window_update_context_dependent_actions_co (ApplicationMainWindowUpdateContextDependentActionsData* _data_)
{
#line 1920 "../src/client/application/application-main-window.vala"
	switch (_data_->_state_) {
#line 1920 "../src/client/application/application-main-window.vala"
		case 0:
#line 12184 "application-main-window.c"
		goto _state_0;
#line 1920 "../src/client/application/application-main-window.vala"
		case 1:
#line 12188 "application-main-window.c"
		goto _state_1;
		default:
#line 1920 "../src/client/application/application-main-window.vala"
		g_assert_not_reached ();
#line 12193 "application-main-window.c"
	}
	_state_0:
#line 1922 "../src/client/application/application-main-window.vala"
	_data_->_tmp0_ = _data_->self->priv->action_update_cancellable;
#line 1922 "../src/client/application/application-main-window.vala"
	g_cancellable_cancel (_data_->_tmp0_);
#line 1923 "../src/client/application/application-main-window.vala"
	_data_->_tmp1_ = g_cancellable_new ();
#line 1923 "../src/client/application/application-main-window.vala"
	_data_->cancellable = _data_->_tmp1_;
#line 1924 "../src/client/application/application-main-window.vala"
	_data_->_tmp2_ = _data_->cancellable;
#line 1924 "../src/client/application/application-main-window.vala"
	_data_->_tmp3_ = _g_object_ref0 (_data_->_tmp2_);
#line 1924 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->self->priv->action_update_cancellable);
#line 1924 "../src/client/application/application-main-window.vala"
	_data_->self->priv->action_update_cancellable = _data_->_tmp3_;
#line 1926 "../src/client/application/application-main-window.vala"
	_data_->selected_operations = NULL;
#line 1927 "../src/client/application/application-main-window.vala"
	_data_->_tmp4_ = _data_->self->priv->_selected_folder;
#line 1927 "../src/client/application/application-main-window.vala"
	if (_data_->_tmp4_ != NULL) {
#line 1928 "../src/client/application/application-main-window.vala"
		_data_->_tmp5_ = _data_->self->priv->controller;
#line 1928 "../src/client/application/application-main-window.vala"
		_data_->_tmp6_ = _data_->self->priv->_selected_folder;
#line 1928 "../src/client/application/application-main-window.vala"
		_data_->_tmp7_ = geary_folder_get_account (_data_->_tmp6_);
#line 1928 "../src/client/application/application-main-window.vala"
		_data_->_tmp8_ = _data_->_tmp7_;
#line 1928 "../src/client/application/application-main-window.vala"
		_data_->_tmp9_ = geary_account_get_information (_data_->_tmp8_);
#line 1928 "../src/client/application/application-main-window.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 1928 "../src/client/application/application-main-window.vala"
		_data_->_tmp11_ = application_account_interface_get_context_for_account (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp5_, APPLICATION_TYPE_ACCOUNT_INTERFACE, ApplicationAccountInterface), _data_->_tmp10_);
#line 1928 "../src/client/application/application-main-window.vala"
		_data_->context = _data_->_tmp11_;
#line 1932 "../src/client/application/application-main-window.vala"
		_data_->_tmp12_ = _data_->context;
#line 1932 "../src/client/application/application-main-window.vala"
		if (_data_->_tmp12_ != NULL) {
#line 1933 "../src/client/application/application-main-window.vala"
			_data_->_tmp13_ = gee_linked_list_new (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1933 "../src/client/application/application-main-window.vala"
			_data_->ids = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp13_, GEE_TYPE_COLLECTION, GeeCollection);
#line 12242 "application-main-window.c"
			{
#line 1935 "../src/client/application/application-main-window.vala"
				_data_->_tmp14_ = _data_->self->priv->_conversation_list_view;
#line 1935 "../src/client/application/application-main-window.vala"
				_data_->_tmp15_ = conversation_list_view_get_selected (_data_->_tmp14_);
#line 1935 "../src/client/application/application-main-window.vala"
				_data_->_tmp16_ = _data_->_tmp15_;
#line 1935 "../src/client/application/application-main-window.vala"
				_data_->_tmp17_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp16_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1935 "../src/client/application/application-main-window.vala"
				_data_->_tmp18_ = _data_->_tmp17_;
#line 1935 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_data_->_tmp16_);
#line 1935 "../src/client/application/application-main-window.vala"
				_data_->_convo_it = _data_->_tmp18_;
#line 1935 "../src/client/application/application-main-window.vala"
				while (TRUE) {
#line 1935 "../src/client/application/application-main-window.vala"
					_data_->_tmp19_ = _data_->_convo_it;
#line 1935 "../src/client/application/application-main-window.vala"
					if (!gee_iterator_next (_data_->_tmp19_)) {
#line 1935 "../src/client/application/application-main-window.vala"
						break;
#line 12266 "application-main-window.c"
					}
#line 1935 "../src/client/application/application-main-window.vala"
					_data_->_tmp20_ = _data_->_convo_it;
#line 1935 "../src/client/application/application-main-window.vala"
					_data_->_tmp21_ = gee_iterator_get (_data_->_tmp20_);
#line 1935 "../src/client/application/application-main-window.vala"
					_data_->convo = (GearyAppConversation*) _data_->_tmp21_;
#line 1937 "../src/client/application/application-main-window.vala"
					_data_->_tmp22_ = _data_->ids;
#line 1937 "../src/client/application/application-main-window.vala"
					_data_->_tmp23_ = _data_->convo;
#line 1937 "../src/client/application/application-main-window.vala"
					_data_->_tmp24_ = geary_app_conversation_get_email_ids (_data_->_tmp23_);
#line 1937 "../src/client/application/application-main-window.vala"
					_data_->_tmp25_ = _data_->_tmp24_;
#line 1937 "../src/client/application/application-main-window.vala"
					gee_collection_add_all (_data_->_tmp22_, _data_->_tmp25_);
#line 1937 "../src/client/application/application-main-window.vala"
					_g_object_unref0 (_data_->_tmp25_);
#line 1935 "../src/client/application/application-main-window.vala"
					_g_object_unref0 (_data_->convo);
#line 12288 "application-main-window.c"
				}
#line 1935 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_data_->_convo_it);
#line 12292 "application-main-window.c"
			}
			{
#line 1940 "../src/client/application/application-main-window.vala"
				_data_->_tmp27_ = _data_->context;
#line 1940 "../src/client/application/application-main-window.vala"
				_data_->_tmp28_ = application_account_context_get_emails (_data_->_tmp27_);
#line 1940 "../src/client/application/application-main-window.vala"
				_data_->_tmp29_ = _data_->_tmp28_;
#line 1940 "../src/client/application/application-main-window.vala"
				_data_->_tmp30_ = _data_->ids;
#line 1940 "../src/client/application/application-main-window.vala"
				_data_->_tmp31_ = _data_->cancellable;
#line 1940 "../src/client/application/application-main-window.vala"
				_data_->_state_ = 1;
#line 1940 "../src/client/application/application-main-window.vala"
				geary_app_email_store_get_supported_operations_async (_data_->_tmp29_, _data_->_tmp30_, _data_->_tmp31_, application_main_window_update_context_dependent_actions_ready, _data_);
#line 1940 "../src/client/application/application-main-window.vala"
				return FALSE;
#line 12311 "application-main-window.c"
				_state_1:
#line 1940 "../src/client/application/application-main-window.vala"
				_data_->_tmp32_ = geary_app_email_store_get_supported_operations_finish (_data_->_tmp29_, _data_->_res_, &_data_->_inner_error0_);
#line 1940 "../src/client/application/application-main-window.vala"
				_data_->_tmp26_ = _data_->_tmp32_;
#line 1940 "../src/client/application/application-main-window.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 12319 "application-main-window.c"
					goto __catch0_g_error;
				}
#line 1940 "../src/client/application/application-main-window.vala"
				_data_->_tmp33_ = _data_->_tmp26_;
#line 1940 "../src/client/application/application-main-window.vala"
				_data_->_tmp26_ = NULL;
#line 1940 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_data_->selected_operations);
#line 1940 "../src/client/application/application-main-window.vala"
				_data_->selected_operations = _data_->_tmp33_;
#line 1939 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_data_->_tmp26_);
#line 12332 "application-main-window.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
#line 1939 "../src/client/application/application-main-window.vala"
				_data_->e = _data_->_inner_error0_;
#line 1939 "../src/client/application/application-main-window.vala"
				_data_->_inner_error0_ = NULL;
#line 1944 "../src/client/application/application-main-window.vala"
				_data_->_tmp34_ = _data_->e;
#line 1944 "../src/client/application/application-main-window.vala"
				_data_->_tmp35_ = _data_->_tmp34_->message;
#line 1944 "../src/client/application/application-main-window.vala"
				g_debug ("application-main-window.vala:1944: Error checking for what operations " \
"are supported in the selected conversations: %s", _data_->_tmp35_);
#line 1939 "../src/client/application/application-main-window.vala"
				_g_error_free0 (_data_->e);
#line 12349 "application-main-window.c"
			}
			__finally0:
#line 1939 "../src/client/application/application-main-window.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1939 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_data_->ids);
#line 1939 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_data_->context);
#line 1939 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_data_->selected_operations);
#line 1939 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_data_->cancellable);
#line 1939 "../src/client/application/application-main-window.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 1939 "../src/client/application/application-main-window.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 1939 "../src/client/application/application-main-window.vala"
				g_object_unref (_data_->_async_result);
#line 1939 "../src/client/application/application-main-window.vala"
				return FALSE;
#line 12370 "application-main-window.c"
			}
#line 1932 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (_data_->ids);
#line 12374 "application-main-window.c"
		}
#line 1927 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data_->context);
#line 12378 "application-main-window.c"
	}
#line 1950 "../src/client/application/application-main-window.vala"
	_data_->_tmp36_ = _data_->cancellable;
#line 1950 "../src/client/application/application-main-window.vala"
	if (!g_cancellable_is_cancelled (_data_->_tmp36_)) {
#line 1951 "../src/client/application/application-main-window.vala"
		_data_->_tmp37_ = gee_hash_set_new (G_TYPE_GTYPE, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1951 "../src/client/application/application-main-window.vala"
		_data_->supported_operations = _data_->_tmp37_;
#line 1952 "../src/client/application/application-main-window.vala"
		_data_->_tmp38_ = _data_->selected_operations;
#line 1952 "../src/client/application/application-main-window.vala"
		if (_data_->_tmp38_ != NULL) {
#line 1953 "../src/client/application/application-main-window.vala"
			_data_->_tmp39_ = _data_->supported_operations;
#line 1953 "../src/client/application/application-main-window.vala"
			_data_->_tmp40_ = _data_->selected_operations;
#line 1953 "../src/client/application/application-main-window.vala"
			_data_->_tmp41_ = gee_multi_map_get_values (_data_->_tmp40_);
#line 1953 "../src/client/application/application-main-window.vala"
			_data_->_tmp42_ = _data_->_tmp41_;
#line 1953 "../src/client/application/application-main-window.vala"
			gee_collection_add_all (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp39_, GEE_TYPE_COLLECTION, GeeCollection), _data_->_tmp42_);
#line 1953 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (_data_->_tmp42_);
#line 12404 "application-main-window.c"
		}
#line 1957 "../src/client/application/application-main-window.vala"
		if (_data_->sensitive) {
#line 1958 "../src/client/application/application-main-window.vala"
			_data_->_tmp44_ = _data_->supported_operations;
#line 1958 "../src/client/application/application-main-window.vala"
			_data_->_tmp43_ = gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp44_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), (gpointer) ((gintptr) GEARY_FOLDER_SUPPORT_TYPE_COPY));
#line 12412 "application-main-window.c"
		} else {
#line 1957 "../src/client/application/application-main-window.vala"
			_data_->_tmp43_ = FALSE;
#line 12416 "application-main-window.c"
		}
#line 1956 "../src/client/application/application-main-window.vala"
		_data_->_tmp45_ = application_main_window_get_window_action (_data_->self, APPLICATION_MAIN_WINDOW_ACTION_SHOW_COPY_MENU);
#line 1956 "../src/client/application/application-main-window.vala"
		_data_->_tmp46_ = _data_->_tmp45_;
#line 1956 "../src/client/application/application-main-window.vala"
		g_simple_action_set_enabled (_data_->_tmp46_, _data_->_tmp43_);
#line 1956 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data_->_tmp46_);
#line 1961 "../src/client/application/application-main-window.vala"
		if (_data_->sensitive) {
#line 1962 "../src/client/application/application-main-window.vala"
			_data_->_tmp48_ = _data_->supported_operations;
#line 1962 "../src/client/application/application-main-window.vala"
			_data_->_tmp47_ = gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp48_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), (gpointer) ((gintptr) GEARY_FOLDER_SUPPORT_TYPE_MOVE));
#line 12432 "application-main-window.c"
		} else {
#line 1961 "../src/client/application/application-main-window.vala"
			_data_->_tmp47_ = FALSE;
#line 12436 "application-main-window.c"
		}
#line 1960 "../src/client/application/application-main-window.vala"
		_data_->_tmp49_ = application_main_window_get_window_action (_data_->self, APPLICATION_MAIN_WINDOW_ACTION_SHOW_MOVE_MENU);
#line 1960 "../src/client/application/application-main-window.vala"
		_data_->_tmp50_ = _data_->_tmp49_;
#line 1960 "../src/client/application/application-main-window.vala"
		g_simple_action_set_enabled (_data_->_tmp50_, _data_->_tmp47_);
#line 1960 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data_->_tmp50_);
#line 1950 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data_->supported_operations);
#line 12448 "application-main-window.c"
	}
#line 1920 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->selected_operations);
#line 1920 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_data_->cancellable);
#line 1920 "../src/client/application/application-main-window.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1920 "../src/client/application/application-main-window.vala"
	if (_data_->_state_ != 0) {
#line 1920 "../src/client/application/application-main-window.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1920 "../src/client/application/application-main-window.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 12462 "application-main-window.c"
		}
	}
#line 1920 "../src/client/application/application-main-window.vala"
	g_object_unref (_data_->_async_result);
#line 1920 "../src/client/application/application-main-window.vala"
	return FALSE;
#line 12469 "application-main-window.c"
}

static void
application_main_window_set_shift_key_down (ApplicationMainWindow* self,
                                            gboolean down)
{
#line 1967 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1968 "../src/client/application/application-main-window.vala"
	application_main_window_set_is_shift_down (self, down);
#line 1969 "../src/client/application/application-main-window.vala"
	application_main_window_update_trash_action (self);
#line 12482 "application-main-window.c"
}

static inline void
application_main_window_check_shift_event (ApplicationMainWindow* self,
                                           GdkEventKey* event)
{
	gboolean _tmp0_ = FALSE;
#line 1972 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1972 "../src/client/application/application-main-window.vala"
	g_return_if_fail (event != NULL);
#line 1976 "../src/client/application/application-main-window.vala"
	if (event->keyval == GDK_KEY_Shift_L) {
#line 1976 "../src/client/application/application-main-window.vala"
		_tmp0_ = TRUE;
#line 12498 "application-main-window.c"
	} else {
#line 1976 "../src/client/application/application-main-window.vala"
		_tmp0_ = event->keyval == GDK_KEY_Shift_R;
#line 12502 "application-main-window.c"
	}
#line 1976 "../src/client/application/application-main-window.vala"
	if (_tmp0_) {
#line 12506 "application-main-window.c"
		GtkWidget* focus = NULL;
		GtkWidget* _tmp1_;
		GtkWidget* _tmp2_;
		gboolean _tmp3_ = FALSE;
		GtkWidget* _tmp4_;
#line 1977 "../src/client/application/application-main-window.vala"
		_tmp1_ = gtk_window_get_focus (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow));
#line 1977 "../src/client/application/application-main-window.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1977 "../src/client/application/application-main-window.vala"
		focus = _tmp2_;
#line 1978 "../src/client/application/application-main-window.vala"
		_tmp4_ = focus;
#line 1978 "../src/client/application/application-main-window.vala"
		if (_tmp4_ == NULL) {
#line 1978 "../src/client/application/application-main-window.vala"
			_tmp3_ = TRUE;
#line 12524 "application-main-window.c"
		} else {
			gboolean _tmp5_ = FALSE;
			GtkWidget* _tmp6_;
#line 1979 "../src/client/application/application-main-window.vala"
			_tmp6_ = focus;
#line 1979 "../src/client/application/application-main-window.vala"
			if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, gtk_entry_get_type ())) {
#line 12532 "application-main-window.c"
				GtkWidget* _tmp7_;
#line 1979 "../src/client/application/application-main-window.vala"
				_tmp7_ = focus;
#line 1979 "../src/client/application/application-main-window.vala"
				_tmp5_ = !COMPOSER_IS_WEB_VIEW (_tmp7_);
#line 12538 "application-main-window.c"
			} else {
#line 1979 "../src/client/application/application-main-window.vala"
				_tmp5_ = FALSE;
#line 12542 "application-main-window.c"
			}
#line 1979 "../src/client/application/application-main-window.vala"
			_tmp3_ = _tmp5_;
#line 12546 "application-main-window.c"
		}
#line 1978 "../src/client/application/application-main-window.vala"
		if (_tmp3_) {
#line 1980 "../src/client/application/application-main-window.vala"
			application_main_window_set_shift_key_down (self, event->type == GDK_KEY_PRESS);
#line 12552 "application-main-window.c"
		}
#line 1976 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (focus);
#line 12556 "application-main-window.c"
	}
}

static void
application_main_window_focus_next_pane (ApplicationMainWindow* self)
{
	GtkWidget* focus = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	HdyLeaflet* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GtkWidget* _tmp62_;
#line 1985 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 1986 "../src/client/application/application-main-window.vala"
	_tmp0_ = gtk_window_get_focus (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow));
#line 1986 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1986 "../src/client/application/application-main-window.vala"
	focus = _tmp1_;
#line 1988 "../src/client/application/application-main-window.vala"
	_tmp2_ = self->priv->outer_leaflet;
#line 1988 "../src/client/application/application-main-window.vala"
	_tmp3_ = hdy_leaflet_get_folded (_tmp2_);
#line 1988 "../src/client/application/application-main-window.vala"
	_tmp4_ = _tmp3_;
#line 1988 "../src/client/application/application-main-window.vala"
	if (_tmp4_) {
#line 12586 "application-main-window.c"
		HdyLeaflet* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 1989 "../src/client/application/application-main-window.vala"
		_tmp5_ = self->priv->outer_leaflet;
#line 1989 "../src/client/application/application-main-window.vala"
		_tmp6_ = hdy_leaflet_get_visible_child_name (_tmp5_);
#line 1989 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 1989 "../src/client/application/application-main-window.vala"
		if (g_strcmp0 (_tmp7_, APPLICATION_MAIN_WINDOW_INNER_LEAFLET) == 0) {
#line 12598 "application-main-window.c"
			gboolean _tmp8_ = FALSE;
			gboolean _tmp9_ = FALSE;
			HdyLeaflet* _tmp10_;
			gboolean _tmp11_;
			gboolean _tmp12_;
#line 1990 "../src/client/application/application-main-window.vala"
			_tmp10_ = self->priv->inner_leaflet;
#line 1990 "../src/client/application/application-main-window.vala"
			_tmp11_ = hdy_leaflet_get_folded (_tmp10_);
#line 1990 "../src/client/application/application-main-window.vala"
			_tmp12_ = _tmp11_;
#line 1990 "../src/client/application/application-main-window.vala"
			if (_tmp12_) {
#line 12612 "application-main-window.c"
				HdyLeaflet* _tmp13_;
				const gchar* _tmp14_;
				const gchar* _tmp15_;
#line 1991 "../src/client/application/application-main-window.vala"
				_tmp13_ = self->priv->inner_leaflet;
#line 1991 "../src/client/application/application-main-window.vala"
				_tmp14_ = hdy_leaflet_get_visible_child_name (_tmp13_);
#line 1991 "../src/client/application/application-main-window.vala"
				_tmp15_ = _tmp14_;
#line 1991 "../src/client/application/application-main-window.vala"
				_tmp9_ = g_strcmp0 (_tmp15_, APPLICATION_MAIN_WINDOW_FOLDER_LIST) == 0;
#line 12624 "application-main-window.c"
			} else {
#line 1990 "../src/client/application/application-main-window.vala"
				_tmp9_ = FALSE;
#line 12628 "application-main-window.c"
			}
#line 1990 "../src/client/application/application-main-window.vala"
			if (_tmp9_) {
#line 1990 "../src/client/application/application-main-window.vala"
				_tmp8_ = TRUE;
#line 12634 "application-main-window.c"
			} else {
				GtkWidget* _tmp16_;
				FolderListTree* _tmp17_;
#line 1992 "../src/client/application/application-main-window.vala"
				_tmp16_ = focus;
#line 1992 "../src/client/application/application-main-window.vala"
				_tmp17_ = self->priv->_folder_list;
#line 1992 "../src/client/application/application-main-window.vala"
				_tmp8_ = _tmp16_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, gtk_widget_get_type (), GtkWidget);
#line 12644 "application-main-window.c"
			}
#line 1990 "../src/client/application/application-main-window.vala"
			if (_tmp8_) {
#line 12648 "application-main-window.c"
				HdyLeaflet* _tmp18_;
				ConversationListView* _tmp19_;
				GtkWidget* _tmp20_;
#line 1993 "../src/client/application/application-main-window.vala"
				_tmp18_ = self->priv->inner_leaflet;
#line 1993 "../src/client/application/application-main-window.vala"
				hdy_leaflet_navigate (_tmp18_, HDY_NAVIGATION_DIRECTION_FORWARD);
#line 1994 "../src/client/application/application-main-window.vala"
				_tmp19_ = self->priv->_conversation_list_view;
#line 1994 "../src/client/application/application-main-window.vala"
				_tmp20_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, gtk_widget_get_type (), GtkWidget));
#line 1994 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (focus);
#line 1994 "../src/client/application/application-main-window.vala"
				focus = _tmp20_;
#line 12664 "application-main-window.c"
			} else {
				gboolean _tmp21_ = FALSE;
				ConversationListView* _tmp22_;
				GeeSet* _tmp23_;
				GeeSet* _tmp24_;
				gint _tmp25_;
				gint _tmp26_;
				gboolean _tmp27_;
#line 1996 "../src/client/application/application-main-window.vala"
				_tmp22_ = self->priv->_conversation_list_view;
#line 1996 "../src/client/application/application-main-window.vala"
				_tmp23_ = conversation_list_view_get_selected (_tmp22_);
#line 1996 "../src/client/application/application-main-window.vala"
				_tmp24_ = _tmp23_;
#line 1996 "../src/client/application/application-main-window.vala"
				_tmp25_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1996 "../src/client/application/application-main-window.vala"
				_tmp26_ = _tmp25_;
#line 1996 "../src/client/application/application-main-window.vala"
				_tmp27_ = _tmp26_ == 1;
#line 1996 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_tmp24_);
#line 1996 "../src/client/application/application-main-window.vala"
				if (_tmp27_) {
#line 12689 "application-main-window.c"
					GearyFolder* _tmp28_;
					GearyFolderProperties* _tmp29_;
					GearyFolderProperties* _tmp30_;
					gint _tmp31_;
					gint _tmp32_;
#line 1997 "../src/client/application/application-main-window.vala"
					_tmp28_ = self->priv->_selected_folder;
#line 1997 "../src/client/application/application-main-window.vala"
					_tmp29_ = geary_folder_get_properties (_tmp28_);
#line 1997 "../src/client/application/application-main-window.vala"
					_tmp30_ = _tmp29_;
#line 1997 "../src/client/application/application-main-window.vala"
					_tmp31_ = geary_folder_properties_get_email_total (_tmp30_);
#line 1997 "../src/client/application/application-main-window.vala"
					_tmp32_ = _tmp31_;
#line 1997 "../src/client/application/application-main-window.vala"
					_tmp21_ = _tmp32_ > 0;
#line 12707 "application-main-window.c"
				} else {
#line 1996 "../src/client/application/application-main-window.vala"
					_tmp21_ = FALSE;
#line 12711 "application-main-window.c"
				}
#line 1996 "../src/client/application/application-main-window.vala"
				if (_tmp21_) {
#line 12715 "application-main-window.c"
					HdyLeaflet* _tmp33_;
					ConversationViewer* _tmp34_;
					GtkWidget* _tmp35_;
					GtkWidget* _tmp36_;
					GtkWidget* _tmp37_;
#line 1998 "../src/client/application/application-main-window.vala"
					_tmp33_ = self->priv->outer_leaflet;
#line 1998 "../src/client/application/application-main-window.vala"
					hdy_leaflet_navigate (_tmp33_, HDY_NAVIGATION_DIRECTION_FORWARD);
#line 1999 "../src/client/application/application-main-window.vala"
					_tmp34_ = self->priv->_conversation_viewer;
#line 1999 "../src/client/application/application-main-window.vala"
					_tmp35_ = gtk_stack_get_visible_child (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, gtk_stack_get_type (), GtkStack));
#line 1999 "../src/client/application/application-main-window.vala"
					_tmp36_ = _tmp35_;
#line 1999 "../src/client/application/application-main-window.vala"
					_tmp37_ = _g_object_ref0 (_tmp36_);
#line 1999 "../src/client/application/application-main-window.vala"
					_g_object_unref0 (focus);
#line 1999 "../src/client/application/application-main-window.vala"
					focus = _tmp37_;
#line 12737 "application-main-window.c"
				}
			}
		}
	} else {
		GtkWidget* _tmp38_;
#line 2003 "../src/client/application/application-main-window.vala"
		_tmp38_ = focus;
#line 2003 "../src/client/application/application-main-window.vala"
		if (_tmp38_ != NULL) {
#line 12747 "application-main-window.c"
			gboolean _tmp39_ = FALSE;
			GtkWidget* _tmp40_;
			FolderListTree* _tmp41_;
#line 2004 "../src/client/application/application-main-window.vala"
			_tmp40_ = focus;
#line 2004 "../src/client/application/application-main-window.vala"
			_tmp41_ = self->priv->_folder_list;
#line 2004 "../src/client/application/application-main-window.vala"
			if (_tmp40_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, gtk_widget_get_type (), GtkWidget)) {
#line 2004 "../src/client/application/application-main-window.vala"
				_tmp39_ = TRUE;
#line 12759 "application-main-window.c"
			} else {
				GtkWidget* _tmp42_;
				FolderListTree* _tmp43_;
#line 2005 "../src/client/application/application-main-window.vala"
				_tmp42_ = focus;
#line 2005 "../src/client/application/application-main-window.vala"
				_tmp43_ = self->priv->_folder_list;
#line 2005 "../src/client/application/application-main-window.vala"
				_tmp39_ = gtk_widget_is_ancestor (_tmp42_, G_TYPE_CHECK_INSTANCE_CAST (_tmp43_, gtk_widget_get_type (), GtkWidget));
#line 12769 "application-main-window.c"
			}
#line 2004 "../src/client/application/application-main-window.vala"
			if (_tmp39_) {
#line 12773 "application-main-window.c"
				ConversationListView* _tmp44_;
				GtkWidget* _tmp45_;
#line 2006 "../src/client/application/application-main-window.vala"
				_tmp44_ = self->priv->_conversation_list_view;
#line 2006 "../src/client/application/application-main-window.vala"
				_tmp45_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp44_, gtk_widget_get_type (), GtkWidget));
#line 2006 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (focus);
#line 2006 "../src/client/application/application-main-window.vala"
				focus = _tmp45_;
#line 12784 "application-main-window.c"
			} else {
				gboolean _tmp46_ = FALSE;
				GtkWidget* _tmp47_;
				ConversationListView* _tmp48_;
#line 2007 "../src/client/application/application-main-window.vala"
				_tmp47_ = focus;
#line 2007 "../src/client/application/application-main-window.vala"
				_tmp48_ = self->priv->_conversation_list_view;
#line 2007 "../src/client/application/application-main-window.vala"
				if (_tmp47_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, gtk_widget_get_type (), GtkWidget)) {
#line 2007 "../src/client/application/application-main-window.vala"
					_tmp46_ = TRUE;
#line 12797 "application-main-window.c"
				} else {
					GtkWidget* _tmp49_;
					ConversationListView* _tmp50_;
#line 2008 "../src/client/application/application-main-window.vala"
					_tmp49_ = focus;
#line 2008 "../src/client/application/application-main-window.vala"
					_tmp50_ = self->priv->_conversation_list_view;
#line 2008 "../src/client/application/application-main-window.vala"
					_tmp46_ = gtk_widget_is_ancestor (_tmp49_, G_TYPE_CHECK_INSTANCE_CAST (_tmp50_, gtk_widget_get_type (), GtkWidget));
#line 12807 "application-main-window.c"
				}
#line 2007 "../src/client/application/application-main-window.vala"
				if (_tmp46_) {
#line 12811 "application-main-window.c"
					ConversationViewer* _tmp51_;
					GtkWidget* _tmp52_;
					GtkWidget* _tmp53_;
					GtkWidget* _tmp54_;
#line 2009 "../src/client/application/application-main-window.vala"
					_tmp51_ = self->priv->_conversation_viewer;
#line 2009 "../src/client/application/application-main-window.vala"
					_tmp52_ = gtk_stack_get_visible_child (G_TYPE_CHECK_INSTANCE_CAST (_tmp51_, gtk_stack_get_type (), GtkStack));
#line 2009 "../src/client/application/application-main-window.vala"
					_tmp53_ = _tmp52_;
#line 2009 "../src/client/application/application-main-window.vala"
					_tmp54_ = _g_object_ref0 (_tmp53_);
#line 2009 "../src/client/application/application-main-window.vala"
					_g_object_unref0 (focus);
#line 2009 "../src/client/application/application-main-window.vala"
					focus = _tmp54_;
#line 12828 "application-main-window.c"
				} else {
					gboolean _tmp55_ = FALSE;
					GtkWidget* _tmp56_;
					ConversationViewer* _tmp57_;
#line 2010 "../src/client/application/application-main-window.vala"
					_tmp56_ = focus;
#line 2010 "../src/client/application/application-main-window.vala"
					_tmp57_ = self->priv->_conversation_viewer;
#line 2010 "../src/client/application/application-main-window.vala"
					if (_tmp56_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp57_, gtk_widget_get_type (), GtkWidget)) {
#line 2010 "../src/client/application/application-main-window.vala"
						_tmp55_ = TRUE;
#line 12841 "application-main-window.c"
					} else {
						GtkWidget* _tmp58_;
						ConversationViewer* _tmp59_;
#line 2011 "../src/client/application/application-main-window.vala"
						_tmp58_ = focus;
#line 2011 "../src/client/application/application-main-window.vala"
						_tmp59_ = self->priv->_conversation_viewer;
#line 2011 "../src/client/application/application-main-window.vala"
						_tmp55_ = gtk_widget_is_ancestor (_tmp58_, G_TYPE_CHECK_INSTANCE_CAST (_tmp59_, gtk_widget_get_type (), GtkWidget));
#line 12851 "application-main-window.c"
					}
#line 2010 "../src/client/application/application-main-window.vala"
					if (_tmp55_) {
#line 12855 "application-main-window.c"
						FolderListTree* _tmp60_;
						GtkWidget* _tmp61_;
#line 2012 "../src/client/application/application-main-window.vala"
						_tmp60_ = self->priv->_folder_list;
#line 2012 "../src/client/application/application-main-window.vala"
						_tmp61_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp60_, gtk_widget_get_type (), GtkWidget));
#line 2012 "../src/client/application/application-main-window.vala"
						_g_object_unref0 (focus);
#line 2012 "../src/client/application/application-main-window.vala"
						focus = _tmp61_;
#line 12866 "application-main-window.c"
					}
				}
			}
		}
	}
#line 2016 "../src/client/application/application-main-window.vala"
	_tmp62_ = focus;
#line 2016 "../src/client/application/application-main-window.vala"
	if (_tmp62_ != NULL) {
#line 12876 "application-main-window.c"
		GtkWidget* _tmp63_;
		gboolean _tmp64_ = FALSE;
#line 2017 "../src/client/application/application-main-window.vala"
		_tmp63_ = focus;
#line 2017 "../src/client/application/application-main-window.vala"
		g_signal_emit_by_name (_tmp63_, "focus", GTK_DIR_TAB_FORWARD, &_tmp64_);
#line 12883 "application-main-window.c"
	} else {
#line 2019 "../src/client/application/application-main-window.vala"
		gtk_widget_error_bell (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 12887 "application-main-window.c"
	}
#line 1985 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (focus);
#line 12891 "application-main-window.c"
}

static void
application_main_window_focus_previous_pane (ApplicationMainWindow* self)
{
	GtkWidget* focus = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	HdyLeaflet* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GtkWidget* _tmp50_;
#line 2023 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2024 "../src/client/application/application-main-window.vala"
	_tmp0_ = gtk_window_get_focus (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow));
#line 2024 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 2024 "../src/client/application/application-main-window.vala"
	focus = _tmp1_;
#line 2026 "../src/client/application/application-main-window.vala"
	_tmp2_ = self->priv->outer_leaflet;
#line 2026 "../src/client/application/application-main-window.vala"
	_tmp3_ = hdy_leaflet_get_folded (_tmp2_);
#line 2026 "../src/client/application/application-main-window.vala"
	_tmp4_ = _tmp3_;
#line 2026 "../src/client/application/application-main-window.vala"
	if (_tmp4_) {
#line 12920 "application-main-window.c"
		HdyLeaflet* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 2027 "../src/client/application/application-main-window.vala"
		_tmp5_ = self->priv->outer_leaflet;
#line 2027 "../src/client/application/application-main-window.vala"
		_tmp6_ = hdy_leaflet_get_visible_child_name (_tmp5_);
#line 2027 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 2027 "../src/client/application/application-main-window.vala"
		if (g_strcmp0 (_tmp7_, APPLICATION_MAIN_WINDOW_INNER_LEAFLET) == 0) {
#line 12932 "application-main-window.c"
			HdyLeaflet* _tmp8_;
			gboolean _tmp9_;
			gboolean _tmp10_;
#line 2028 "../src/client/application/application-main-window.vala"
			_tmp8_ = self->priv->inner_leaflet;
#line 2028 "../src/client/application/application-main-window.vala"
			_tmp9_ = hdy_leaflet_get_folded (_tmp8_);
#line 2028 "../src/client/application/application-main-window.vala"
			_tmp10_ = _tmp9_;
#line 2028 "../src/client/application/application-main-window.vala"
			if (_tmp10_) {
#line 12944 "application-main-window.c"
				HdyLeaflet* _tmp11_;
				const gchar* _tmp12_;
				const gchar* _tmp13_;
#line 2029 "../src/client/application/application-main-window.vala"
				_tmp11_ = self->priv->inner_leaflet;
#line 2029 "../src/client/application/application-main-window.vala"
				_tmp12_ = hdy_leaflet_get_visible_child_name (_tmp11_);
#line 2029 "../src/client/application/application-main-window.vala"
				_tmp13_ = _tmp12_;
#line 2029 "../src/client/application/application-main-window.vala"
				if (g_strcmp0 (_tmp13_, APPLICATION_MAIN_WINDOW_CONVERSATION_LIST) == 0) {
#line 12956 "application-main-window.c"
					HdyLeaflet* _tmp14_;
					FolderListTree* _tmp15_;
					GtkWidget* _tmp16_;
#line 2030 "../src/client/application/application-main-window.vala"
					_tmp14_ = self->priv->inner_leaflet;
#line 2030 "../src/client/application/application-main-window.vala"
					hdy_leaflet_navigate (_tmp14_, HDY_NAVIGATION_DIRECTION_BACK);
#line 2031 "../src/client/application/application-main-window.vala"
					_tmp15_ = self->priv->_folder_list;
#line 2031 "../src/client/application/application-main-window.vala"
					_tmp16_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_widget_get_type (), GtkWidget));
#line 2031 "../src/client/application/application-main-window.vala"
					_g_object_unref0 (focus);
#line 2031 "../src/client/application/application-main-window.vala"
					focus = _tmp16_;
#line 12972 "application-main-window.c"
				}
			} else {
				GtkWidget* _tmp17_;
				ConversationListView* _tmp18_;
#line 2034 "../src/client/application/application-main-window.vala"
				_tmp17_ = focus;
#line 2034 "../src/client/application/application-main-window.vala"
				_tmp18_ = self->priv->_conversation_list_view;
#line 2034 "../src/client/application/application-main-window.vala"
				if (_tmp17_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, gtk_widget_get_type (), GtkWidget)) {
#line 12983 "application-main-window.c"
					FolderListTree* _tmp19_;
					GtkWidget* _tmp20_;
#line 2035 "../src/client/application/application-main-window.vala"
					_tmp19_ = self->priv->_folder_list;
#line 2035 "../src/client/application/application-main-window.vala"
					_tmp20_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, gtk_widget_get_type (), GtkWidget));
#line 2035 "../src/client/application/application-main-window.vala"
					_g_object_unref0 (focus);
#line 2035 "../src/client/application/application-main-window.vala"
					focus = _tmp20_;
#line 12994 "application-main-window.c"
				} else {
					ConversationListView* _tmp21_;
					GtkWidget* _tmp22_;
#line 2037 "../src/client/application/application-main-window.vala"
					_tmp21_ = self->priv->_conversation_list_view;
#line 2037 "../src/client/application/application-main-window.vala"
					_tmp22_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, gtk_widget_get_type (), GtkWidget));
#line 2037 "../src/client/application/application-main-window.vala"
					_g_object_unref0 (focus);
#line 2037 "../src/client/application/application-main-window.vala"
					focus = _tmp22_;
#line 13006 "application-main-window.c"
				}
			}
		} else {
			HdyLeaflet* _tmp23_;
			ConversationListView* _tmp24_;
			GtkWidget* _tmp25_;
#line 2040 "../src/client/application/application-main-window.vala"
			_tmp23_ = self->priv->outer_leaflet;
#line 2040 "../src/client/application/application-main-window.vala"
			hdy_leaflet_navigate (_tmp23_, HDY_NAVIGATION_DIRECTION_BACK);
#line 2041 "../src/client/application/application-main-window.vala"
			_tmp24_ = self->priv->_conversation_list_view;
#line 2041 "../src/client/application/application-main-window.vala"
			_tmp25_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, gtk_widget_get_type (), GtkWidget));
#line 2041 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (focus);
#line 2041 "../src/client/application/application-main-window.vala"
			focus = _tmp25_;
#line 13025 "application-main-window.c"
		}
	} else {
		GtkWidget* _tmp26_;
#line 2043 "../src/client/application/application-main-window.vala"
		_tmp26_ = focus;
#line 2043 "../src/client/application/application-main-window.vala"
		if (_tmp26_ != NULL) {
#line 13033 "application-main-window.c"
			gboolean _tmp27_ = FALSE;
			GtkWidget* _tmp28_;
			FolderListTree* _tmp29_;
#line 2044 "../src/client/application/application-main-window.vala"
			_tmp28_ = focus;
#line 2044 "../src/client/application/application-main-window.vala"
			_tmp29_ = self->priv->_folder_list;
#line 2044 "../src/client/application/application-main-window.vala"
			if (_tmp28_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, gtk_widget_get_type (), GtkWidget)) {
#line 2044 "../src/client/application/application-main-window.vala"
				_tmp27_ = TRUE;
#line 13045 "application-main-window.c"
			} else {
				GtkWidget* _tmp30_;
				FolderListTree* _tmp31_;
#line 2045 "../src/client/application/application-main-window.vala"
				_tmp30_ = focus;
#line 2045 "../src/client/application/application-main-window.vala"
				_tmp31_ = self->priv->_folder_list;
#line 2045 "../src/client/application/application-main-window.vala"
				_tmp27_ = gtk_widget_is_ancestor (_tmp30_, G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, gtk_widget_get_type (), GtkWidget));
#line 13055 "application-main-window.c"
			}
#line 2044 "../src/client/application/application-main-window.vala"
			if (_tmp27_) {
#line 13059 "application-main-window.c"
				ConversationViewer* _tmp32_;
				GtkWidget* _tmp33_;
				GtkWidget* _tmp34_;
				GtkWidget* _tmp35_;
#line 2046 "../src/client/application/application-main-window.vala"
				_tmp32_ = self->priv->_conversation_viewer;
#line 2046 "../src/client/application/application-main-window.vala"
				_tmp33_ = gtk_stack_get_visible_child (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, gtk_stack_get_type (), GtkStack));
#line 2046 "../src/client/application/application-main-window.vala"
				_tmp34_ = _tmp33_;
#line 2046 "../src/client/application/application-main-window.vala"
				_tmp35_ = _g_object_ref0 (_tmp34_);
#line 2046 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (focus);
#line 2046 "../src/client/application/application-main-window.vala"
				focus = _tmp35_;
#line 13076 "application-main-window.c"
			} else {
				gboolean _tmp36_ = FALSE;
				GtkWidget* _tmp37_;
				ConversationListView* _tmp38_;
#line 2047 "../src/client/application/application-main-window.vala"
				_tmp37_ = focus;
#line 2047 "../src/client/application/application-main-window.vala"
				_tmp38_ = self->priv->_conversation_list_view;
#line 2047 "../src/client/application/application-main-window.vala"
				if (_tmp37_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, gtk_widget_get_type (), GtkWidget)) {
#line 2047 "../src/client/application/application-main-window.vala"
					_tmp36_ = TRUE;
#line 13089 "application-main-window.c"
				} else {
					GtkWidget* _tmp39_;
					ConversationListView* _tmp40_;
#line 2048 "../src/client/application/application-main-window.vala"
					_tmp39_ = focus;
#line 2048 "../src/client/application/application-main-window.vala"
					_tmp40_ = self->priv->_conversation_list_view;
#line 2048 "../src/client/application/application-main-window.vala"
					_tmp36_ = gtk_widget_is_ancestor (_tmp39_, G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, gtk_widget_get_type (), GtkWidget));
#line 13099 "application-main-window.c"
				}
#line 2047 "../src/client/application/application-main-window.vala"
				if (_tmp36_) {
#line 13103 "application-main-window.c"
					FolderListTree* _tmp41_;
					GtkWidget* _tmp42_;
#line 2049 "../src/client/application/application-main-window.vala"
					_tmp41_ = self->priv->_folder_list;
#line 2049 "../src/client/application/application-main-window.vala"
					_tmp42_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, gtk_widget_get_type (), GtkWidget));
#line 2049 "../src/client/application/application-main-window.vala"
					_g_object_unref0 (focus);
#line 2049 "../src/client/application/application-main-window.vala"
					focus = _tmp42_;
#line 13114 "application-main-window.c"
				} else {
					gboolean _tmp43_ = FALSE;
					GtkWidget* _tmp44_;
					ConversationViewer* _tmp45_;
#line 2050 "../src/client/application/application-main-window.vala"
					_tmp44_ = focus;
#line 2050 "../src/client/application/application-main-window.vala"
					_tmp45_ = self->priv->_conversation_viewer;
#line 2050 "../src/client/application/application-main-window.vala"
					if (_tmp44_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, gtk_widget_get_type (), GtkWidget)) {
#line 2050 "../src/client/application/application-main-window.vala"
						_tmp43_ = TRUE;
#line 13127 "application-main-window.c"
					} else {
						GtkWidget* _tmp46_;
						ConversationViewer* _tmp47_;
#line 2051 "../src/client/application/application-main-window.vala"
						_tmp46_ = focus;
#line 2051 "../src/client/application/application-main-window.vala"
						_tmp47_ = self->priv->_conversation_viewer;
#line 2051 "../src/client/application/application-main-window.vala"
						_tmp43_ = gtk_widget_is_ancestor (_tmp46_, G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, gtk_widget_get_type (), GtkWidget));
#line 13137 "application-main-window.c"
					}
#line 2050 "../src/client/application/application-main-window.vala"
					if (_tmp43_) {
#line 13141 "application-main-window.c"
						ConversationListView* _tmp48_;
						GtkWidget* _tmp49_;
#line 2052 "../src/client/application/application-main-window.vala"
						_tmp48_ = self->priv->_conversation_list_view;
#line 2052 "../src/client/application/application-main-window.vala"
						_tmp49_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, gtk_widget_get_type (), GtkWidget));
#line 2052 "../src/client/application/application-main-window.vala"
						_g_object_unref0 (focus);
#line 2052 "../src/client/application/application-main-window.vala"
						focus = _tmp49_;
#line 13152 "application-main-window.c"
					}
				}
			}
		}
	}
#line 2056 "../src/client/application/application-main-window.vala"
	_tmp50_ = focus;
#line 2056 "../src/client/application/application-main-window.vala"
	if (_tmp50_ != NULL) {
#line 13162 "application-main-window.c"
		GtkWidget* _tmp51_;
		gboolean _tmp52_ = FALSE;
#line 2057 "../src/client/application/application-main-window.vala"
		_tmp51_ = focus;
#line 2057 "../src/client/application/application-main-window.vala"
		g_signal_emit_by_name (_tmp51_, "focus", GTK_DIR_TAB_FORWARD, &_tmp52_);
#line 13169 "application-main-window.c"
	} else {
#line 2059 "../src/client/application/application-main-window.vala"
		gtk_widget_error_bell (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 13173 "application-main-window.c"
	}
#line 2023 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (focus);
#line 13177 "application-main-window.c"
}

static GSimpleAction*
application_main_window_get_window_action (ApplicationMainWindow* self,
                                           const gchar* name)
{
	GAction* _tmp0_;
	GSimpleAction* _tmp1_;
	GSimpleAction* result;
#line 2064 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), NULL);
#line 2064 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 2065 "../src/client/application/application-main-window.vala"
	_tmp0_ = g_action_map_lookup_action (G_TYPE_CHECK_INSTANCE_CAST (self, g_action_map_get_type (), GActionMap), name);
#line 2065 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_simple_action_get_type (), GSimpleAction));
#line 2065 "../src/client/application/application-main-window.vala"
	result = _tmp1_;
#line 2065 "../src/client/application/application-main-window.vala"
	return result;
#line 13199 "application-main-window.c"
}

static GSimpleAction*
application_main_window_get_edit_action (ApplicationMainWindow* self,
                                         const gchar* name)
{
	GSimpleActionGroup* _tmp0_;
	GAction* _tmp1_;
	GSimpleAction* _tmp2_;
	GSimpleAction* result;
#line 2068 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), NULL);
#line 2068 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 2069 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->edit_actions;
#line 2069 "../src/client/application/application-main-window.vala"
	_tmp1_ = g_action_map_lookup_action (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_action_map_get_type (), GActionMap), name);
#line 2069 "../src/client/application/application-main-window.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_simple_action_get_type (), GSimpleAction));
#line 2069 "../src/client/application/application-main-window.vala"
	result = _tmp2_;
#line 2069 "../src/client/application/application-main-window.vala"
	return result;
#line 13224 "application-main-window.c"
}

static void
application_main_window_activate_action (ApplicationMainWindow* self,
                                         GAction* action)
{
	gboolean _tmp0_ = FALSE;
#line 2072 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2072 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((action == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (action, g_action_get_type ()));
#line 2073 "../src/client/application/application-main-window.vala"
	if (action != NULL) {
#line 2073 "../src/client/application/application-main-window.vala"
		_tmp0_ = g_action_get_enabled (action);
#line 13240 "application-main-window.c"
	} else {
#line 2073 "../src/client/application/application-main-window.vala"
		_tmp0_ = FALSE;
#line 13244 "application-main-window.c"
	}
#line 2073 "../src/client/application/application-main-window.vala"
	if (_tmp0_) {
#line 2074 "../src/client/application/application-main-window.vala"
		g_action_activate (action, NULL);
#line 13250 "application-main-window.c"
	} else {
#line 2076 "../src/client/application/application-main-window.vala"
		gtk_widget_error_bell (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 13254 "application-main-window.c"
	}
}

static void
application_main_window_on_scan_completed (ApplicationMainWindow* self,
                                           GearyAppConversationMonitor* monitor)
{
	GtkScrollbar* scrollbar = NULL;
	GtkScrolledWindow* _tmp0_;
	GtkWidget* _tmp1_;
	GtkScrollbar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
#line 2080 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2080 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (monitor, GEARY_APP_TYPE_CONVERSATION_MONITOR));
#line 2083 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->conversation_list_scrolled;
#line 2083 "../src/client/application/application-main-window.vala"
	_tmp1_ = gtk_scrolled_window_get_vscrollbar (_tmp0_);
#line 2083 "../src/client/application/application-main-window.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gtk_scrollbar_get_type ()) ? ((GtkScrollbar*) _tmp1_) : NULL);
#line 2083 "../src/client/application/application-main-window.vala"
	scrollbar = _tmp2_;
#line 2086 "../src/client/application/application-main-window.vala"
	if (gtk_widget_is_visible (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget))) {
#line 13283 "application-main-window.c"
		gboolean _tmp6_ = FALSE;
		GtkScrollbar* _tmp7_;
#line 2087 "../src/client/application/application-main-window.vala"
		_tmp7_ = scrollbar;
#line 2087 "../src/client/application/application-main-window.vala"
		if (_tmp7_ == NULL) {
#line 2087 "../src/client/application/application-main-window.vala"
			_tmp6_ = TRUE;
#line 13292 "application-main-window.c"
		} else {
			GtkScrollbar* _tmp8_;
#line 2087 "../src/client/application/application-main-window.vala"
			_tmp8_ = scrollbar;
#line 2087 "../src/client/application/application-main-window.vala"
			_tmp6_ = !gtk_widget_get_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_widget_get_type (), GtkWidget));
#line 13299 "application-main-window.c"
		}
#line 2087 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp6_;
#line 13303 "application-main-window.c"
	} else {
#line 2086 "../src/client/application/application-main-window.vala"
		_tmp5_ = FALSE;
#line 13307 "application-main-window.c"
	}
#line 2086 "../src/client/application/application-main-window.vala"
	if (_tmp5_) {
#line 13311 "application-main-window.c"
		GearyAppConversationMonitor* _tmp9_;
#line 2088 "../src/client/application/application-main-window.vala"
		_tmp9_ = self->priv->_conversations;
#line 2088 "../src/client/application/application-main-window.vala"
		_tmp4_ = monitor == _tmp9_;
#line 13317 "application-main-window.c"
	} else {
#line 2086 "../src/client/application/application-main-window.vala"
		_tmp4_ = FALSE;
#line 13321 "application-main-window.c"
	}
#line 2086 "../src/client/application/application-main-window.vala"
	if (_tmp4_) {
#line 13325 "application-main-window.c"
		gboolean _tmp10_;
		gboolean _tmp11_;
#line 2089 "../src/client/application/application-main-window.vala"
		_tmp10_ = geary_app_conversation_monitor_get_can_load_more (monitor);
#line 2089 "../src/client/application/application-main-window.vala"
		_tmp11_ = _tmp10_;
#line 2089 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp11_;
#line 13334 "application-main-window.c"
	} else {
#line 2086 "../src/client/application/application-main-window.vala"
		_tmp3_ = FALSE;
#line 13338 "application-main-window.c"
	}
#line 2086 "../src/client/application/application-main-window.vala"
	if (_tmp3_) {
#line 13342 "application-main-window.c"
		GearyFolder* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 2090 "../src/client/application/application-main-window.vala"
		_tmp12_ = self->priv->_selected_folder;
#line 2090 "../src/client/application/application-main-window.vala"
		_tmp13_ = geary_logging_source_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEARY_LOGGING_TYPE_SOURCE, GearyLoggingSource));
#line 2090 "../src/client/application/application-main-window.vala"
		_tmp14_ = _tmp13_;
#line 2090 "../src/client/application/application-main-window.vala"
		g_debug ("application-main-window.vala:2090: Not enough messages, loading more f" \
"or folder %s", _tmp14_);
#line 2090 "../src/client/application/application-main-window.vala"
		_g_free0 (_tmp14_);
#line 2092 "../src/client/application/application-main-window.vala"
		application_main_window_load_more (self);
#line 13358 "application-main-window.c"
	}
#line 2080 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (scrollbar);
#line 13362 "application-main-window.c"
}

static void
application_main_window_on_scan_error (ApplicationMainWindow* self,
                                       GearyAppConversationMonitor* monitor,
                                       GError* err)
{
	GearyAccountInformation* account = NULL;
	GearyFolder* _tmp0_;
	GearyFolder* _tmp1_;
	GearyAccount* _tmp2_;
	GearyAccount* _tmp3_;
	GearyAccountInformation* _tmp4_;
	GearyAccountInformation* _tmp5_;
	GearyAccountInformation* _tmp6_;
	ApplicationController* _tmp7_;
	GearyServiceInformation* _tmp8_;
	GearyServiceInformation* _tmp9_;
	GearyServiceProblemReport* _tmp10_;
	GearyServiceProblemReport* _tmp11_;
#line 2096 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2096 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (monitor, GEARY_APP_TYPE_CONVERSATION_MONITOR));
#line 2096 "../src/client/application/application-main-window.vala"
	g_return_if_fail (err != NULL);
#line 2098 "../src/client/application/application-main-window.vala"
	_tmp0_ = geary_app_conversation_monitor_get_base_folder (monitor);
#line 2098 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 2098 "../src/client/application/application-main-window.vala"
	_tmp2_ = geary_folder_get_account (_tmp1_);
#line 2098 "../src/client/application/application-main-window.vala"
	_tmp3_ = _tmp2_;
#line 2098 "../src/client/application/application-main-window.vala"
	_tmp4_ = geary_account_get_information (_tmp3_);
#line 2098 "../src/client/application/application-main-window.vala"
	_tmp5_ = _tmp4_;
#line 2098 "../src/client/application/application-main-window.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 2098 "../src/client/application/application-main-window.vala"
	account = _tmp6_;
#line 2100 "../src/client/application/application-main-window.vala"
	_tmp7_ = self->priv->controller;
#line 2100 "../src/client/application/application-main-window.vala"
	_tmp8_ = geary_account_information_get_incoming (account);
#line 2100 "../src/client/application/application-main-window.vala"
	_tmp9_ = _tmp8_;
#line 2100 "../src/client/application/application-main-window.vala"
	_tmp10_ = geary_service_problem_report_new (account, _tmp9_, err);
#line 2100 "../src/client/application/application-main-window.vala"
	_tmp11_ = _tmp10_;
#line 2100 "../src/client/application/application-main-window.vala"
	composer_application_interface_report_problem (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, COMPOSER_TYPE_APPLICATION_INTERFACE, ComposerApplicationInterface), G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEARY_TYPE_PROBLEM_REPORT, GearyProblemReport));
#line 2100 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp11_);
#line 2096 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (account);
#line 13421 "application-main-window.c"
}

static void
application_main_window_on_load_more (ApplicationMainWindow* self)
{
#line 2105 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2106 "../src/client/application/application-main-window.vala"
	application_main_window_load_more (self);
#line 13431 "application-main-window.c"
}

static void
application_main_window_on_map (ApplicationMainWindow* self)
{
	GearyTimeoutManager* _tmp0_;
#line 2110 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2111 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->update_ui_timeout;
#line 2111 "../src/client/application/application-main-window.vala"
	geary_timeout_manager_start (_tmp0_);
#line 2112 "../src/client/application/application-main-window.vala"
	application_main_window_update_ui (self);
#line 13446 "application-main-window.c"
}

static void
_application_main_window_on_map_gtk_widget_map (GtkWidget* _sender,
                                                gpointer self)
{
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_on_map ((ApplicationMainWindow*) self);
#line 13455 "application-main-window.c"
}

static void
application_main_window_on_unmap (ApplicationMainWindow* self)
{
	GearyTimeoutManager* _tmp0_;
#line 2116 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2117 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->update_ui_timeout;
#line 2117 "../src/client/application/application-main-window.vala"
	geary_timeout_manager_reset (_tmp0_);
#line 13468 "application-main-window.c"
}

static void
_application_main_window_on_unmap_gtk_widget_unmap (GtkWidget* _sender,
                                                    gpointer self)
{
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_on_unmap ((ApplicationMainWindow*) self);
#line 13477 "application-main-window.c"
}

static gboolean
application_main_window_on_focus_event (ApplicationMainWindow* self)
{
	gboolean result;
#line 2121 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), FALSE);
#line 2122 "../src/client/application/application-main-window.vala"
	application_main_window_set_shift_key_down (self, FALSE);
#line 2123 "../src/client/application/application-main-window.vala"
	result = FALSE;
#line 2123 "../src/client/application/application-main-window.vala"
	return result;
#line 13492 "application-main-window.c"
}

static gboolean
_application_main_window_on_focus_event_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                    GdkEventFocus* event,
                                                                    gpointer self)
{
	gboolean result;
	result = application_main_window_on_focus_event ((ApplicationMainWindow*) self);
#line 10 "../src/client/application/application-main-window.vala"
	return result;
#line 13504 "application-main-window.c"
}

static void
___lambda202_ (ApplicationMainWindow* self,
               GObject* obj,
               GAsyncResult* res)
{
#line 2134 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 2134 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 2135 "../src/client/application/application-main-window.vala"
	application_main_window_select_folder_finish (self, res);
#line 2136 "../src/client/application/application-main-window.vala"
	gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 13520 "application-main-window.c"
}

static void
____lambda202__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 2130 "../src/client/application/application-main-window.vala"
	___lambda202_ ((ApplicationMainWindow*) self, source_object, res);
#line 2130 "../src/client/application/application-main-window.vala"
	g_object_unref (self);
#line 13532 "application-main-window.c"
}

static gboolean
application_main_window_on_delete_event (ApplicationMainWindow* self)
{
	gboolean result;
#line 2127 "../src/client/application/application-main-window.vala"
	g_return_val_if_fail (APPLICATION_IS_MAIN_WINDOW (self), FALSE);
#line 2128 "../src/client/application/application-main-window.vala"
	if (application_main_window_close_composer (self, TRUE, FALSE)) {
#line 2129 "../src/client/application/application-main-window.vala"
		gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), FALSE);
#line 2130 "../src/client/application/application-main-window.vala"
		application_main_window_select_folder (self, NULL, FALSE, TRUE, ____lambda202__gasync_ready_callback, g_object_ref (self));
#line 13547 "application-main-window.c"
	}
#line 2140 "../src/client/application/application-main-window.vala"
	result = GDK_EVENT_STOP;
#line 2140 "../src/client/application/application-main-window.vala"
	return result;
#line 13553 "application-main-window.c"
}

static gboolean
_application_main_window_on_delete_event_gtk_widget_delete_event (GtkWidget* _sender,
                                                                  GdkEventAny* event,
                                                                  gpointer self)
{
	gboolean result;
	result = application_main_window_on_delete_event ((ApplicationMainWindow*) self);
#line 10 "../src/client/application/application-main-window.vala"
	return result;
#line 13565 "application-main-window.c"
}

static void
application_main_window_on_outer_leaflet_changed (ApplicationMainWindow* self)
{
	gint selected = 0;
	ConversationListView* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	HdyLeaflet* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
#line 2144 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2145 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_conversation_list_view;
#line 2145 "../src/client/application/application-main-window.vala"
	_tmp1_ = conversation_list_view_get_selected (_tmp0_);
#line 2145 "../src/client/application/application-main-window.vala"
	_tmp2_ = _tmp1_;
#line 2145 "../src/client/application/application-main-window.vala"
	_tmp3_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection));
#line 2145 "../src/client/application/application-main-window.vala"
	_tmp4_ = _tmp3_;
#line 2145 "../src/client/application/application-main-window.vala"
	_tmp5_ = _tmp4_;
#line 2145 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp2_);
#line 2145 "../src/client/application/application-main-window.vala"
	selected = _tmp5_;
#line 2146 "../src/client/application/application-main-window.vala"
	application_main_window_update_conversation_actions (self, application_main_window_conversation_count_for_size (selected));
#line 2149 "../src/client/application/application-main-window.vala"
	_tmp6_ = self->priv->outer_leaflet;
#line 2149 "../src/client/application/application-main-window.vala"
	_tmp7_ = hdy_leaflet_get_folded (_tmp6_);
#line 2149 "../src/client/application/application-main-window.vala"
	_tmp8_ = _tmp7_;
#line 2149 "../src/client/application/application-main-window.vala"
	if (_tmp8_) {
#line 13609 "application-main-window.c"
		gboolean _tmp9_;
		gboolean _tmp10_;
		gboolean _tmp15_ = FALSE;
		gboolean _tmp16_;
		gboolean _tmp17_;
#line 2152 "../src/client/application/application-main-window.vala"
		_tmp9_ = application_main_window_get_is_conversation_list_shown (self);
#line 2152 "../src/client/application/application-main-window.vala"
		_tmp10_ = _tmp9_;
#line 2152 "../src/client/application/application-main-window.vala"
		if (_tmp10_) {
#line 13621 "application-main-window.c"
			ConversationListView* _tmp11_;
#line 2153 "../src/client/application/application-main-window.vala"
			_tmp11_ = self->priv->_conversation_list_view;
#line 2153 "../src/client/application/application-main-window.vala"
			gtk_widget_grab_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gtk_widget_get_type (), GtkWidget));
#line 13627 "application-main-window.c"
		} else {
			gboolean _tmp12_;
			gboolean _tmp13_;
#line 2154 "../src/client/application/application-main-window.vala"
			_tmp12_ = application_main_window_get_is_folder_list_shown (self);
#line 2154 "../src/client/application/application-main-window.vala"
			_tmp13_ = _tmp12_;
#line 2154 "../src/client/application/application-main-window.vala"
			if (_tmp13_) {
#line 13637 "application-main-window.c"
				FolderListTree* _tmp14_;
#line 2155 "../src/client/application/application-main-window.vala"
				_tmp14_ = self->priv->_folder_list;
#line 2155 "../src/client/application/application-main-window.vala"
				gtk_widget_grab_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gtk_widget_get_type (), GtkWidget));
#line 13643 "application-main-window.c"
			}
		}
#line 2159 "../src/client/application/application-main-window.vala"
		_tmp16_ = application_main_window_get_has_composer (self);
#line 2159 "../src/client/application/application-main-window.vala"
		_tmp17_ = _tmp16_;
#line 2159 "../src/client/application/application-main-window.vala"
		if (_tmp17_) {
#line 13652 "application-main-window.c"
			gboolean _tmp18_ = FALSE;
			gboolean _tmp19_;
			gboolean _tmp20_;
#line 2160 "../src/client/application/application-main-window.vala"
			_tmp19_ = application_main_window_get_is_folder_list_shown (self);
#line 2160 "../src/client/application/application-main-window.vala"
			_tmp20_ = _tmp19_;
#line 2160 "../src/client/application/application-main-window.vala"
			if (_tmp20_) {
#line 2160 "../src/client/application/application-main-window.vala"
				_tmp18_ = TRUE;
#line 13664 "application-main-window.c"
			} else {
				gboolean _tmp21_;
				gboolean _tmp22_;
#line 2160 "../src/client/application/application-main-window.vala"
				_tmp21_ = application_main_window_get_is_conversation_list_shown (self);
#line 2160 "../src/client/application/application-main-window.vala"
				_tmp22_ = _tmp21_;
#line 2160 "../src/client/application/application-main-window.vala"
				_tmp18_ = _tmp22_;
#line 13674 "application-main-window.c"
			}
#line 2160 "../src/client/application/application-main-window.vala"
			_tmp15_ = _tmp18_;
#line 13678 "application-main-window.c"
		} else {
#line 2159 "../src/client/application/application-main-window.vala"
			_tmp15_ = FALSE;
#line 13682 "application-main-window.c"
		}
#line 2159 "../src/client/application/application-main-window.vala"
		if (_tmp15_) {
#line 2161 "../src/client/application/application-main-window.vala"
			application_main_window_close_composer (self, FALSE, FALSE);
#line 13688 "application-main-window.c"
		}
	}
}

static void
_application_main_window_on_outer_leaflet_changed_g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self)
{
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_on_outer_leaflet_changed ((ApplicationMainWindow*) self);
#line 13700 "application-main-window.c"
}

static void
application_main_window_on_inner_leaflet_changed (ApplicationMainWindow* self)
{
	HdyLeaflet* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 2167 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2168 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->inner_leaflet;
#line 2168 "../src/client/application/application-main-window.vala"
	_tmp1_ = hdy_leaflet_get_folded (_tmp0_);
#line 2168 "../src/client/application/application-main-window.vala"
	_tmp2_ = _tmp1_;
#line 2168 "../src/client/application/application-main-window.vala"
	if (_tmp2_) {
#line 13719 "application-main-window.c"
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 2171 "../src/client/application/application-main-window.vala"
		_tmp3_ = application_main_window_get_is_conversation_list_shown (self);
#line 2171 "../src/client/application/application-main-window.vala"
		_tmp4_ = _tmp3_;
#line 2171 "../src/client/application/application-main-window.vala"
		if (_tmp4_) {
#line 13728 "application-main-window.c"
			ConversationListView* _tmp5_;
#line 2172 "../src/client/application/application-main-window.vala"
			_tmp5_ = self->priv->_conversation_list_view;
#line 2172 "../src/client/application/application-main-window.vala"
			gtk_widget_grab_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_widget_get_type (), GtkWidget));
#line 13734 "application-main-window.c"
		} else {
			gboolean _tmp6_;
			gboolean _tmp7_;
#line 2173 "../src/client/application/application-main-window.vala"
			_tmp6_ = application_main_window_get_is_folder_list_shown (self);
#line 2173 "../src/client/application/application-main-window.vala"
			_tmp7_ = _tmp6_;
#line 2173 "../src/client/application/application-main-window.vala"
			if (_tmp7_) {
#line 13744 "application-main-window.c"
				FolderListTree* _tmp8_;
#line 2174 "../src/client/application/application-main-window.vala"
				_tmp8_ = self->priv->_folder_list;
#line 2174 "../src/client/application/application-main-window.vala"
				gtk_widget_grab_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_widget_get_type (), GtkWidget));
#line 13750 "application-main-window.c"
			}
		}
	}
}

static void
_application_main_window_on_inner_leaflet_changed_g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self)
{
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_on_inner_leaflet_changed ((ApplicationMainWindow*) self);
#line 13763 "application-main-window.c"
}

static void
application_main_window_on_offline_infobar_response (ApplicationMainWindow* self)
{
	ComponentsInfoBarStack* _tmp0_;
	ComponentsInfoBar* _tmp1_;
#line 2179 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2180 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->info_bars;
#line 2180 "../src/client/application/application-main-window.vala"
	_tmp1_ = self->priv->offline_infobar;
#line 2180 "../src/client/application/application-main-window.vala"
	components_info_bar_stack_remove (_tmp0_, _tmp1_);
#line 13779 "application-main-window.c"
}

static void
application_main_window_on_service_problem_retry (ApplicationMainWindow* self)
{
	ComponentsInfoBarStack* _tmp0_;
	ComponentsProblemReportInfoBar* _tmp1_;
#line 2183 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2184 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->info_bars;
#line 2184 "../src/client/application/application-main-window.vala"
	_tmp1_ = self->priv->service_problem_infobar;
#line 2184 "../src/client/application/application-main-window.vala"
	components_info_bar_stack_remove (_tmp0_, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, COMPONENTS_TYPE_INFO_BAR, ComponentsInfoBar));
#line 2185 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->service_problem_infobar);
#line 2185 "../src/client/application/application-main-window.vala"
	self->priv->service_problem_infobar = NULL;
#line 2186 "../src/client/application/application-main-window.vala"
	g_signal_emit (self, application_main_window_signals[APPLICATION_MAIN_WINDOW_RETRY_SERVICE_PROBLEM_SIGNAL], 0, GEARY_CLIENT_SERVICE_STATUS_CONNECTION_FAILED);
#line 13801 "application-main-window.c"
}

static void
application_main_window_on_cert_problem_retry (ApplicationMainWindow* self)
{
	ComponentsInfoBarStack* _tmp0_;
	ComponentsInfoBar* _tmp1_;
#line 2189 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2190 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->info_bars;
#line 2190 "../src/client/application/application-main-window.vala"
	_tmp1_ = self->priv->cert_problem_infobar;
#line 2190 "../src/client/application/application-main-window.vala"
	components_info_bar_stack_remove (_tmp0_, _tmp1_);
#line 2191 "../src/client/application/application-main-window.vala"
	g_signal_emit (self, application_main_window_signals[APPLICATION_MAIN_WINDOW_RETRY_SERVICE_PROBLEM_SIGNAL], 0, GEARY_CLIENT_SERVICE_STATUS_TLS_VALIDATION_FAILED);
#line 13819 "application-main-window.c"
}

static void
application_main_window_on_auth_problem_retry (ApplicationMainWindow* self)
{
	ComponentsInfoBarStack* _tmp0_;
	ComponentsInfoBar* _tmp1_;
#line 2194 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2195 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->info_bars;
#line 2195 "../src/client/application/application-main-window.vala"
	_tmp1_ = self->priv->auth_problem_infobar;
#line 2195 "../src/client/application/application-main-window.vala"
	components_info_bar_stack_remove (_tmp0_, _tmp1_);
#line 2196 "../src/client/application/application-main-window.vala"
	g_signal_emit (self, application_main_window_signals[APPLICATION_MAIN_WINDOW_RETRY_SERVICE_PROBLEM_SIGNAL], 0, GEARY_CLIENT_SERVICE_STATUS_AUTHENTICATION_FAILED);
#line 13837 "application-main-window.c"
}

static void
application_main_window_on_update_ui_timeout (ApplicationMainWindow* self)
{
#line 2199 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2200 "../src/client/application/application-main-window.vala"
	application_main_window_update_ui (self);
#line 13847 "application-main-window.c"
}

static void
application_main_window_on_account_available (ApplicationMainWindow* self,
                                              ApplicationAccountContext* account)
{
#line 2203 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2203 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_ACCOUNT_CONTEXT (account));
#line 2204 "../src/client/application/application-main-window.vala"
	application_main_window_add_account (self, account);
#line 13860 "application-main-window.c"
}

static void
application_main_window_on_account_unavailable (ApplicationMainWindow* self,
                                                ApplicationAccountContext* account,
                                                gboolean is_shutdown)
{
	GearyFolder* to_select = NULL;
	GearyFolder* _tmp1_;
#line 2207 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2207 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_ACCOUNT_CONTEXT (account));
#line 2212 "../src/client/application/application-main-window.vala"
	to_select = NULL;
#line 2213 "../src/client/application/application-main-window.vala"
	if (!is_shutdown) {
#line 13878 "application-main-window.c"
		GearyFolder* _tmp0_;
#line 2214 "../src/client/application/application-main-window.vala"
		_tmp0_ = application_main_window_get_first_inbox (self);
#line 2214 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (to_select);
#line 2214 "../src/client/application/application-main-window.vala"
		to_select = _tmp0_;
#line 13886 "application-main-window.c"
	}
#line 2216 "../src/client/application/application-main-window.vala"
	_tmp1_ = to_select;
#line 2216 "../src/client/application/application-main-window.vala"
	application_main_window_remove_account (self, account, _tmp1_, NULL, NULL);
#line 2207 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (to_select);
#line 13894 "application-main-window.c"
}

static void
application_main_window_on_folders_available (ApplicationMainWindow* self,
                                              GeeCollection* available)
{
#line 2219 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2219 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (available, GEE_TYPE_COLLECTION));
#line 2220 "../src/client/application/application-main-window.vala"
	application_main_window_add_folders (self, available);
#line 13907 "application-main-window.c"
}

static void
application_main_window_on_folders_unavailable (ApplicationMainWindow* self,
                                                GeeCollection* unavailable)
{
#line 2223 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2223 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (unavailable, GEE_TYPE_COLLECTION));
#line 2224 "../src/client/application/application-main-window.vala"
	application_main_window_remove_folders (self, unavailable, TRUE);
#line 13920 "application-main-window.c"
}

static void
application_main_window_on_use_changed (ApplicationMainWindow* self,
                                        GearyFolder* folder,
                                        GearyFolderSpecialUse old_type,
                                        GearyFolderSpecialUse new_type)
{
	ApplicationAccountContext* context = NULL;
	ApplicationController* _tmp0_;
	GearyAccount* _tmp1_;
	GearyAccount* _tmp2_;
	GearyAccountInformation* _tmp3_;
	GearyAccountInformation* _tmp4_;
	ApplicationAccountContext* _tmp5_;
	ApplicationAccountContext* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 2227 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2227 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (folder, GEARY_TYPE_FOLDER));
#line 2231 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->controller;
#line 2231 "../src/client/application/application-main-window.vala"
	_tmp1_ = geary_folder_get_account (folder);
#line 2231 "../src/client/application/application-main-window.vala"
	_tmp2_ = _tmp1_;
#line 2231 "../src/client/application/application-main-window.vala"
	_tmp3_ = geary_account_get_information (_tmp2_);
#line 2231 "../src/client/application/application-main-window.vala"
	_tmp4_ = _tmp3_;
#line 2231 "../src/client/application/application-main-window.vala"
	_tmp5_ = application_account_interface_get_context_for_account (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, APPLICATION_TYPE_ACCOUNT_INTERFACE, ApplicationAccountInterface), _tmp4_);
#line 2231 "../src/client/application/application-main-window.vala"
	context = _tmp5_;
#line 2234 "../src/client/application/application-main-window.vala"
	_tmp6_ = context;
#line 2234 "../src/client/application/application-main-window.vala"
	if (_tmp6_ != NULL) {
#line 13960 "application-main-window.c"
		ApplicationFolderContext* folder_context = NULL;
		ApplicationAccountContext* _tmp7_;
		ApplicationFolderContext* _tmp8_;
		ApplicationFolderContext* _tmp9_;
#line 2235 "../src/client/application/application-main-window.vala"
		_tmp7_ = context;
#line 2235 "../src/client/application/application-main-window.vala"
		_tmp8_ = application_account_context_get_folder (_tmp7_, folder);
#line 2235 "../src/client/application/application-main-window.vala"
		folder_context = _tmp8_;
#line 2236 "../src/client/application/application-main-window.vala"
		_tmp9_ = folder_context;
#line 2236 "../src/client/application/application-main-window.vala"
		if (_tmp9_ != NULL) {
#line 13975 "application-main-window.c"
			FolderListTree* _tmp10_;
			ApplicationFolderContext* _tmp11_;
			FolderListTree* _tmp12_;
			ApplicationFolderContext* _tmp13_;
#line 2237 "../src/client/application/application-main-window.vala"
			_tmp10_ = self->priv->_folder_list;
#line 2237 "../src/client/application/application-main-window.vala"
			_tmp11_ = folder_context;
#line 2237 "../src/client/application/application-main-window.vala"
			folder_list_tree_remove_folder (_tmp10_, _tmp11_);
#line 2238 "../src/client/application/application-main-window.vala"
			_tmp12_ = self->priv->_folder_list;
#line 2238 "../src/client/application/application-main-window.vala"
			_tmp13_ = folder_context;
#line 2238 "../src/client/application/application-main-window.vala"
			folder_list_tree_add_folder (_tmp12_, _tmp13_);
#line 13992 "application-main-window.c"
			{
				GeeCollection* _tmp14_ = NULL;
				GearyAccount* _tmp15_;
				GearyAccount* _tmp16_;
				GearyFolderPath* _tmp17_;
				GearyFolderPath* _tmp18_;
				GeeCollection* _tmp19_;
#line 2245 "../src/client/application/application-main-window.vala"
				_tmp15_ = geary_folder_get_account (folder);
#line 2245 "../src/client/application/application-main-window.vala"
				_tmp16_ = _tmp15_;
#line 2245 "../src/client/application/application-main-window.vala"
				_tmp17_ = geary_folder_get_path (folder);
#line 2245 "../src/client/application/application-main-window.vala"
				_tmp18_ = _tmp17_;
#line 2245 "../src/client/application/application-main-window.vala"
				_tmp19_ = geary_account_list_matching_folders (_tmp16_, _tmp18_, &_inner_error0_);
#line 2245 "../src/client/application/application-main-window.vala"
				_tmp14_ = _tmp19_;
#line 2245 "../src/client/application/application-main-window.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 14014 "application-main-window.c"
					goto __catch0_g_error;
				}
				{
					GeeIterator* _child_it = NULL;
					GeeIterator* _tmp20_;
#line 2244 "../src/client/application/application-main-window.vala"
					_tmp20_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GEE_TYPE_ITERABLE, GeeIterable));
#line 2244 "../src/client/application/application-main-window.vala"
					_child_it = _tmp20_;
#line 2244 "../src/client/application/application-main-window.vala"
					while (TRUE) {
#line 14026 "application-main-window.c"
						GeeIterator* _tmp21_;
						GearyFolder* child = NULL;
						GeeIterator* _tmp22_;
						gpointer _tmp23_;
						ApplicationFolderContext* child_context = NULL;
						ApplicationAccountContext* _tmp24_;
						GearyFolder* _tmp25_;
						ApplicationFolderContext* _tmp26_;
						ApplicationFolderContext* _tmp27_;
#line 2244 "../src/client/application/application-main-window.vala"
						_tmp21_ = _child_it;
#line 2244 "../src/client/application/application-main-window.vala"
						if (!gee_iterator_next (_tmp21_)) {
#line 2244 "../src/client/application/application-main-window.vala"
							break;
#line 14042 "application-main-window.c"
						}
#line 2244 "../src/client/application/application-main-window.vala"
						_tmp22_ = _child_it;
#line 2244 "../src/client/application/application-main-window.vala"
						_tmp23_ = gee_iterator_get (_tmp22_);
#line 2244 "../src/client/application/application-main-window.vala"
						child = (GearyFolder*) _tmp23_;
#line 2246 "../src/client/application/application-main-window.vala"
						_tmp24_ = context;
#line 2246 "../src/client/application/application-main-window.vala"
						_tmp25_ = child;
#line 2246 "../src/client/application/application-main-window.vala"
						_tmp26_ = application_account_context_get_folder (_tmp24_, _tmp25_);
#line 2246 "../src/client/application/application-main-window.vala"
						child_context = _tmp26_;
#line 2247 "../src/client/application/application-main-window.vala"
						_tmp27_ = child_context;
#line 2247 "../src/client/application/application-main-window.vala"
						if (_tmp27_ != NULL) {
#line 14062 "application-main-window.c"
							FolderListTree* _tmp28_;
							ApplicationFolderContext* _tmp29_;
#line 2248 "../src/client/application/application-main-window.vala"
							_tmp28_ = self->priv->_folder_list;
#line 2248 "../src/client/application/application-main-window.vala"
							_tmp29_ = child_context;
#line 2248 "../src/client/application/application-main-window.vala"
							folder_list_tree_add_folder (_tmp28_, _tmp29_);
#line 14071 "application-main-window.c"
						}
#line 2244 "../src/client/application/application-main-window.vala"
						_g_object_unref0 (child_context);
#line 2244 "../src/client/application/application-main-window.vala"
						_g_object_unref0 (child);
#line 14077 "application-main-window.c"
					}
#line 2244 "../src/client/application/application-main-window.vala"
					_g_object_unref0 (_child_it);
#line 14081 "application-main-window.c"
				}
#line 2243 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_tmp14_);
#line 14085 "application-main-window.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
#line 2243 "../src/client/application/application-main-window.vala"
				g_clear_error (&_inner_error0_);
#line 14092 "application-main-window.c"
			}
			__finally0:
#line 2243 "../src/client/application/application-main-window.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2243 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (folder_context);
#line 2243 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (context);
#line 2243 "../src/client/application/application-main-window.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2243 "../src/client/application/application-main-window.vala"
				g_clear_error (&_inner_error0_);
#line 2243 "../src/client/application/application-main-window.vala"
				return;
#line 14107 "application-main-window.c"
			}
		}
#line 2234 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (folder_context);
#line 14112 "application-main-window.c"
	}
#line 2227 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (context);
#line 14116 "application-main-window.c"
}

static void
application_main_window_on_command_execute (ApplicationMainWindow* self,
                                            ApplicationCommand* command)
{
#line 2258 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2258 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_COMMAND (command));
#line 2259 "../src/client/application/application-main-window.vala"
	if (!APPLICATION_IS_TRIVIAL_COMMAND (command)) {
#line 2262 "../src/client/application/application-main-window.vala"
		application_main_window_on_command_redo (self, command);
#line 14131 "application-main-window.c"
	} else {
#line 2266 "../src/client/application/application-main-window.vala"
		application_main_window_update_command_actions (self);
#line 14135 "application-main-window.c"
	}
}

static void
application_main_window_on_command_undo (ApplicationMainWindow* self,
                                         ApplicationCommand* command)
{
	ApplicationEmailCommand* email = NULL;
	ApplicationEmailCommand* _tmp0_;
	ApplicationEmailCommand* _tmp1_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
#line 2270 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2270 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_COMMAND (command));
#line 2271 "../src/client/application/application-main-window.vala"
	application_main_window_update_command_actions (self);
#line 2272 "../src/client/application/application-main-window.vala"
	_tmp0_ = _g_object_ref0 (APPLICATION_IS_EMAIL_COMMAND (command) ? ((ApplicationEmailCommand*) command) : NULL);
#line 2272 "../src/client/application/application-main-window.vala"
	email = _tmp0_;
#line 2273 "../src/client/application/application-main-window.vala"
	_tmp1_ = email;
#line 2273 "../src/client/application/application-main-window.vala"
	if (_tmp1_ != NULL) {
#line 14162 "application-main-window.c"
		ApplicationEmailCommand* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
#line 2274 "../src/client/application/application-main-window.vala"
		_tmp2_ = email;
#line 2274 "../src/client/application/application-main-window.vala"
		_tmp3_ = application_email_command_get_conversations (_tmp2_);
#line 2274 "../src/client/application/application-main-window.vala"
		_tmp4_ = _tmp3_;
#line 2274 "../src/client/application/application-main-window.vala"
		_tmp5_ = gee_collection_get_size (_tmp4_);
#line 2274 "../src/client/application/application-main-window.vala"
		_tmp6_ = _tmp5_;
#line 2274 "../src/client/application/application-main-window.vala"
		if (_tmp6_ > 1) {
#line 14180 "application-main-window.c"
			ApplicationEmailCommand* _tmp7_;
			GearyFolder* _tmp8_;
			GearyFolder* _tmp9_;
			ApplicationEmailCommand* _tmp10_;
			GeeCollection* _tmp11_;
			GeeCollection* _tmp12_;
#line 2275 "../src/client/application/application-main-window.vala"
			_tmp7_ = email;
#line 2275 "../src/client/application/application-main-window.vala"
			_tmp8_ = application_email_command_get_location (_tmp7_);
#line 2275 "../src/client/application/application-main-window.vala"
			_tmp9_ = _tmp8_;
#line 2275 "../src/client/application/application-main-window.vala"
			_tmp10_ = email;
#line 2275 "../src/client/application/application-main-window.vala"
			_tmp11_ = application_email_command_get_conversations (_tmp10_);
#line 2275 "../src/client/application/application-main-window.vala"
			_tmp12_ = _tmp11_;
#line 2275 "../src/client/application/application-main-window.vala"
			application_main_window_show_conversations (self, _tmp9_, _tmp12_, FALSE, NULL, NULL);
#line 14201 "application-main-window.c"
		} else {
			ApplicationEmailCommand* _tmp13_;
			GearyFolder* _tmp14_;
			GearyFolder* _tmp15_;
			ApplicationEmailCommand* _tmp16_;
			GeeCollection* _tmp17_;
			GeeCollection* _tmp18_;
#line 2279 "../src/client/application/application-main-window.vala"
			_tmp13_ = email;
#line 2279 "../src/client/application/application-main-window.vala"
			_tmp14_ = application_email_command_get_location (_tmp13_);
#line 2279 "../src/client/application/application-main-window.vala"
			_tmp15_ = _tmp14_;
#line 2279 "../src/client/application/application-main-window.vala"
			_tmp16_ = email;
#line 2279 "../src/client/application/application-main-window.vala"
			_tmp17_ = application_email_command_get_email (_tmp16_);
#line 2279 "../src/client/application/application-main-window.vala"
			_tmp18_ = _tmp17_;
#line 2279 "../src/client/application/application-main-window.vala"
			application_main_window_show_email (self, _tmp15_, _tmp18_, FALSE, NULL, NULL);
#line 14223 "application-main-window.c"
		}
	}
#line 2284 "../src/client/application/application-main-window.vala"
	_tmp19_ = application_command_get_undone_label (command);
#line 2284 "../src/client/application/application-main-window.vala"
	_tmp20_ = _tmp19_;
#line 2284 "../src/client/application/application-main-window.vala"
	if (_tmp20_ != NULL) {
#line 14232 "application-main-window.c"
		ComponentsInAppNotification* ian = NULL;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
		ComponentsInAppNotification* _tmp23_;
		ComponentsInAppNotification* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		ComponentsInAppNotification* _tmp27_;
#line 2285 "../src/client/application/application-main-window.vala"
		_tmp21_ = application_command_get_undone_label (command);
#line 2285 "../src/client/application/application-main-window.vala"
		_tmp22_ = _tmp21_;
#line 2285 "../src/client/application/application-main-window.vala"
		_tmp23_ = components_in_app_notification_new (_tmp22_, COMPONENTS_IN_APP_NOTIFICATION_DEFAULT_DURATION);
#line 2285 "../src/client/application/application-main-window.vala"
		g_object_ref_sink (_tmp23_);
#line 2285 "../src/client/application/application-main-window.vala"
		ian = _tmp23_;
#line 2287 "../src/client/application/application-main-window.vala"
		_tmp24_ = ian;
#line 2287 "../src/client/application/application-main-window.vala"
		_tmp25_ = action_edit_prefix (ACTION_EDIT_REDO);
#line 2287 "../src/client/application/application-main-window.vala"
		_tmp26_ = _tmp25_;
#line 2287 "../src/client/application/application-main-window.vala"
		components_in_app_notification_set_button (_tmp24_, _ ("Redo"), _tmp26_);
#line 2287 "../src/client/application/application-main-window.vala"
		_g_free0 (_tmp26_);
#line 2288 "../src/client/application/application-main-window.vala"
		_tmp27_ = ian;
#line 2288 "../src/client/application/application-main-window.vala"
		application_main_window_add_notification (self, _tmp27_);
#line 2284 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (ian);
#line 14267 "application-main-window.c"
	}
#line 2270 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (email);
#line 14271 "application-main-window.c"
}

static void
application_main_window_on_command_redo (ApplicationMainWindow* self,
                                         ApplicationCommand* command)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 2292 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2292 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_COMMAND (command));
#line 2293 "../src/client/application/application-main-window.vala"
	application_main_window_update_command_actions (self);
#line 2294 "../src/client/application/application-main-window.vala"
	_tmp0_ = application_command_get_executed_label (command);
#line 2294 "../src/client/application/application-main-window.vala"
	_tmp1_ = _tmp0_;
#line 2294 "../src/client/application/application-main-window.vala"
	if (_tmp1_ != NULL) {
#line 14292 "application-main-window.c"
		guint notification_time = 0U;
		gboolean _tmp2_;
		gboolean _tmp3_;
		ComponentsInAppNotification* ian = NULL;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		ComponentsInAppNotification* _tmp12_;
		ComponentsInAppNotification* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		ComponentsInAppNotification* _tmp16_;
#line 2295 "../src/client/application/application-main-window.vala"
		notification_time = COMPONENTS_IN_APP_NOTIFICATION_DEFAULT_DURATION;
#line 2297 "../src/client/application/application-main-window.vala"
		_tmp2_ = application_command_get_executed_notification_brief (command);
#line 2297 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 2297 "../src/client/application/application-main-window.vala"
		if (_tmp3_) {
#line 14312 "application-main-window.c"
			ApplicationClient* _tmp4_;
			ApplicationClient* _tmp5_;
			ApplicationConfiguration* _tmp6_;
			ApplicationConfiguration* _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
#line 2298 "../src/client/application/application-main-window.vala"
			_tmp4_ = application_main_window_get_application (self);
#line 2298 "../src/client/application/application-main-window.vala"
			_tmp5_ = _tmp4_;
#line 2298 "../src/client/application/application-main-window.vala"
			_tmp6_ = application_client_get_config (_tmp5_);
#line 2298 "../src/client/application/application-main-window.vala"
			_tmp7_ = _tmp6_;
#line 2298 "../src/client/application/application-main-window.vala"
			_tmp8_ = application_configuration_get_brief_notification_duration (_tmp7_);
#line 2298 "../src/client/application/application-main-window.vala"
			_tmp9_ = _tmp8_;
#line 2298 "../src/client/application/application-main-window.vala"
			notification_time = (guint) _tmp9_;
#line 14333 "application-main-window.c"
		}
#line 2301 "../src/client/application/application-main-window.vala"
		_tmp10_ = application_command_get_executed_label (command);
#line 2301 "../src/client/application/application-main-window.vala"
		_tmp11_ = _tmp10_;
#line 2301 "../src/client/application/application-main-window.vala"
		_tmp12_ = components_in_app_notification_new (_tmp11_, notification_time);
#line 2301 "../src/client/application/application-main-window.vala"
		g_object_ref_sink (_tmp12_);
#line 2301 "../src/client/application/application-main-window.vala"
		ian = _tmp12_;
#line 2304 "../src/client/application/application-main-window.vala"
		_tmp13_ = ian;
#line 2304 "../src/client/application/application-main-window.vala"
		_tmp14_ = action_edit_prefix (ACTION_EDIT_UNDO);
#line 2304 "../src/client/application/application-main-window.vala"
		_tmp15_ = _tmp14_;
#line 2304 "../src/client/application/application-main-window.vala"
		components_in_app_notification_set_button (_tmp13_, _ ("Undo"), _tmp15_);
#line 2304 "../src/client/application/application-main-window.vala"
		_g_free0 (_tmp15_);
#line 2305 "../src/client/application/application-main-window.vala"
		_tmp16_ = ian;
#line 2305 "../src/client/application/application-main-window.vala"
		application_main_window_add_notification (self, _tmp16_);
#line 2294 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (ian);
#line 14361 "application-main-window.c"
	}
}

static void
_application_main_window_on_email_loaded_conversation_list_box_email_loaded (ConversationListBox* _sender,
                                                                             GearyEmail* email,
                                                                             gpointer self)
{
#line 2310 "../src/client/application/application-main-window.vala"
	application_main_window_on_email_loaded ((ApplicationMainWindow*) self, _sender, email);
#line 14372 "application-main-window.c"
}

static void
_application_main_window_on_email_mark_conversation_list_box_mark_email (ConversationListBox* _sender,
                                                                         GeeCollection* email,
                                                                         GearyNamedFlag* to_add,
                                                                         GearyNamedFlag* to_remove,
                                                                         gpointer self)
{
#line 2311 "../src/client/application/application-main-window.vala"
	application_main_window_on_email_mark ((ApplicationMainWindow*) self, _sender, email, to_add, to_remove);
#line 14384 "application-main-window.c"
}

static void
_application_main_window_on_email_reply_to_all_conversation_list_box_reply_to_all_email (ConversationListBox* _sender,
                                                                                         GearyEmail* email,
                                                                                         const gchar* quote,
                                                                                         gpointer self)
{
#line 2312 "../src/client/application/application-main-window.vala"
	application_main_window_on_email_reply_to_all ((ApplicationMainWindow*) self, email, quote);
#line 14395 "application-main-window.c"
}

static void
_application_main_window_on_email_reply_to_sender_conversation_list_box_reply_to_sender_email (ConversationListBox* _sender,
                                                                                               GearyEmail* email,
                                                                                               const gchar* quote,
                                                                                               gpointer self)
{
#line 2313 "../src/client/application/application-main-window.vala"
	application_main_window_on_email_reply_to_sender ((ApplicationMainWindow*) self, email, quote);
#line 14406 "application-main-window.c"
}

static void
_application_main_window_on_email_forward_conversation_list_box_forward_email (ConversationListBox* _sender,
                                                                               GearyEmail* email,
                                                                               const gchar* quote,
                                                                               gpointer self)
{
#line 2314 "../src/client/application/application-main-window.vala"
	application_main_window_on_email_forward ((ApplicationMainWindow*) self, email, quote);
#line 14417 "application-main-window.c"
}

static void
_application_main_window_on_email_trash_conversation_list_box_trash_email (ConversationListBox* _sender,
                                                                           GearyEmail* email,
                                                                           gpointer self)
{
#line 2315 "../src/client/application/application-main-window.vala"
	application_main_window_on_email_trash ((ApplicationMainWindow*) self, _sender, email);
#line 14427 "application-main-window.c"
}

static void
_application_main_window_on_email_delete_conversation_list_box_delete_email (ConversationListBox* _sender,
                                                                             GearyEmail* email,
                                                                             gpointer self)
{
#line 2316 "../src/client/application/application-main-window.vala"
	application_main_window_on_email_delete ((ApplicationMainWindow*) self, _sender, email);
#line 14437 "application-main-window.c"
}

static void
application_main_window_on_conversation_view_added (ApplicationMainWindow* self,
                                                    ConversationListBox* list)
{
#line 2309 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2309 "../src/client/application/application-main-window.vala"
	g_return_if_fail (IS_CONVERSATION_LIST_BOX (list));
#line 2310 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (list, "email-loaded", (GCallback) _application_main_window_on_email_loaded_conversation_list_box_email_loaded, self, 0);
#line 2311 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (list, "mark-email", (GCallback) _application_main_window_on_email_mark_conversation_list_box_mark_email, self, 0);
#line 2312 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (list, "reply-to-all-email", (GCallback) _application_main_window_on_email_reply_to_all_conversation_list_box_reply_to_all_email, self, 0);
#line 2313 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (list, "reply-to-sender-email", (GCallback) _application_main_window_on_email_reply_to_sender_conversation_list_box_reply_to_sender_email, self, 0);
#line 2314 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (list, "forward-email", (GCallback) _application_main_window_on_email_forward_conversation_list_box_forward_email, self, 0);
#line 2315 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (list, "trash-email", (GCallback) _application_main_window_on_email_trash_conversation_list_box_trash_email, self, 0);
#line 2316 "../src/client/application/application-main-window.vala"
	g_signal_connect_object (list, "delete-email", (GCallback) _application_main_window_on_email_delete_conversation_list_box_delete_email, self, 0);
#line 14462 "application-main-window.c"
}

static void
application_main_window_on_undo (ApplicationMainWindow* self)
{
#line 2321 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2322 "../src/client/application/application-main-window.vala"
	application_main_window_undo (self, NULL, NULL);
#line 14472 "application-main-window.c"
}

static void
application_main_window_on_redo (ApplicationMainWindow* self)
{
#line 2325 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2326 "../src/client/application/application-main-window.vala"
	application_main_window_redo (self, NULL, NULL);
#line 14482 "application-main-window.c"
}

static void
application_main_window_on_close (ApplicationMainWindow* self)
{
#line 2329 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2330 "../src/client/application/application-main-window.vala"
	gtk_window_close (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow));
#line 14492 "application-main-window.c"
}

static void
application_main_window_on_has_toplevel_focus (ApplicationMainWindow* self)
{
	GearyFolder* _tmp0_;
#line 2335 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2336 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2336 "../src/client/application/application-main-window.vala"
	if (_tmp0_ != NULL) {
#line 14505 "application-main-window.c"
		ApplicationController* _tmp1_;
		GearyFolder* _tmp2_;
		ConversationListView* _tmp3_;
		GeeSet* _tmp4_;
		GeeSet* _tmp5_;
#line 2337 "../src/client/application/application-main-window.vala"
		_tmp1_ = self->priv->controller;
#line 2337 "../src/client/application/application-main-window.vala"
		_tmp2_ = self->priv->_selected_folder;
#line 2337 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->_conversation_list_view;
#line 2337 "../src/client/application/application-main-window.vala"
		_tmp4_ = conversation_list_view_get_visible_conversations (_tmp3_);
#line 2337 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2337 "../src/client/application/application-main-window.vala"
		application_controller_clear_new_messages (_tmp1_, _tmp2_, _tmp5_);
#line 2337 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp5_);
#line 14525 "application-main-window.c"
	}
}

static void
application_main_window_on_folder_selected (ApplicationMainWindow* self,
                                            GearyFolder* folder)
{
#line 2344 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2344 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((folder == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (folder, GEARY_TYPE_FOLDER));
#line 2345 "../src/client/application/application-main-window.vala"
	application_main_window_select_folder (self, folder, TRUE, FALSE, NULL, NULL);
#line 14539 "application-main-window.c"
}

static void
application_main_window_on_select_inbox (ApplicationMainWindow* self,
                                         GSimpleAction* action,
                                         GVariant* parameter)
{
	GError* _inner_error0_ = NULL;
#line 2348 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2348 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (action, g_simple_action_get_type ()));
#line 2349 "../src/client/application/application-main-window.vala"
	if (parameter != NULL) {
#line 14554 "application-main-window.c"
		gint account_number = 0;
#line 2350 "../src/client/application/application-main-window.vala"
		account_number = (gint) g_variant_get_int32 (parameter);
#line 14558 "application-main-window.c"
		{
			GeeCollection* accounts = NULL;
			ApplicationClient* _tmp0_;
			ApplicationClient* _tmp1_;
			GearyEngine* _tmp2_;
			GearyEngine* _tmp3_;
			GeeCollection* _tmp4_;
			GeeCollection* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
#line 2352 "../src/client/application/application-main-window.vala"
			_tmp0_ = application_main_window_get_application (self);
#line 2352 "../src/client/application/application-main-window.vala"
			_tmp1_ = _tmp0_;
#line 2352 "../src/client/application/application-main-window.vala"
			_tmp2_ = application_client_get_engine (_tmp1_);
#line 2352 "../src/client/application/application-main-window.vala"
			_tmp3_ = _tmp2_;
#line 2352 "../src/client/application/application-main-window.vala"
			_tmp4_ = geary_engine_get_accounts (_tmp3_, &_inner_error0_);
#line 2352 "../src/client/application/application-main-window.vala"
			accounts = _tmp4_;
#line 2352 "../src/client/application/application-main-window.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 14583 "application-main-window.c"
				goto __catch0_g_error;
			}
#line 2354 "../src/client/application/application-main-window.vala"
			_tmp5_ = accounts;
#line 2354 "../src/client/application/application-main-window.vala"
			_tmp6_ = gee_collection_get_size (_tmp5_);
#line 2354 "../src/client/application/application-main-window.vala"
			_tmp7_ = _tmp6_;
#line 2354 "../src/client/application/application-main-window.vala"
			if (account_number < _tmp7_) {
#line 14594 "application-main-window.c"
				GearyAccount* account = NULL;
				GeeCollection* _tmp8_;
				gint _tmp9_ = 0;
				gpointer* _tmp10_;
				GearyAccount** _tmp11_;
				gint _tmp11__length1;
				GearyAccount* _tmp12_;
				GearyAccount* _tmp13_;
				GearyAccount* _tmp14_;
				GearyFolder* inbox = NULL;
				GearyAccount* _tmp15_;
				GearyFolder* _tmp16_;
				GearyFolder* _tmp17_;
#line 2355 "../src/client/application/application-main-window.vala"
				_tmp8_ = accounts;
#line 2355 "../src/client/application/application-main-window.vala"
				_tmp10_ = gee_collection_to_array (_tmp8_, &_tmp9_);
#line 2355 "../src/client/application/application-main-window.vala"
				_tmp11_ = _tmp10_;
#line 2355 "../src/client/application/application-main-window.vala"
				_tmp11__length1 = _tmp9_;
#line 2355 "../src/client/application/application-main-window.vala"
				_tmp12_ = _tmp11_[account_number];
#line 2355 "../src/client/application/application-main-window.vala"
				_tmp13_ = _g_object_ref0 (_tmp12_);
#line 2355 "../src/client/application/application-main-window.vala"
				_tmp14_ = _tmp13_;
#line 2355 "../src/client/application/application-main-window.vala"
				_tmp11_ = (_vala_array_free (_tmp11_, _tmp11__length1, (GDestroyNotify) g_object_unref), NULL);
#line 2355 "../src/client/application/application-main-window.vala"
				account = _tmp14_;
#line 2356 "../src/client/application/application-main-window.vala"
				_tmp15_ = account;
#line 2356 "../src/client/application/application-main-window.vala"
				_tmp16_ = geary_account_get_special_folder (_tmp15_, GEARY_FOLDER_SPECIAL_USE_INBOX);
#line 2356 "../src/client/application/application-main-window.vala"
				inbox = _tmp16_;
#line 2357 "../src/client/application/application-main-window.vala"
				_tmp17_ = inbox;
#line 2357 "../src/client/application/application-main-window.vala"
				application_main_window_select_folder (self, _tmp17_, TRUE, FALSE, NULL, NULL);
#line 2354 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (inbox);
#line 2354 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (account);
#line 14640 "application-main-window.c"
			}
#line 2351 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (accounts);
#line 14644 "application-main-window.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 2351 "../src/client/application/application-main-window.vala"
			g_clear_error (&_inner_error0_);
#line 2360 "../src/client/application/application-main-window.vala"
			g_debug ("application-main-window.vala:2360: Error getting accounts");
#line 14653 "application-main-window.c"
		}
		__finally0:
#line 2351 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2351 "../src/client/application/application-main-window.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2351 "../src/client/application/application-main-window.vala"
			g_clear_error (&_inner_error0_);
#line 2351 "../src/client/application/application-main-window.vala"
			return;
#line 14664 "application-main-window.c"
		}
	}
}

static void
application_main_window_on_search (ApplicationMainWindow* self,
                                   const gchar* text)
{
#line 2365 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2365 "../src/client/application/application-main-window.vala"
	g_return_if_fail (text != NULL);
#line 2366 "../src/client/application/application-main-window.vala"
	if (geary_string_is_empty_or_whitespace (text)) {
#line 2367 "../src/client/application/application-main-window.vala"
		application_main_window_stop_search (self, TRUE);
#line 14681 "application-main-window.c"
	} else {
#line 2369 "../src/client/application/application-main-window.vala"
		application_main_window_start_search (self, text, TRUE);
#line 14685 "application-main-window.c"
	}
}

static void
application_main_window_on_visible_conversations_changed (ApplicationMainWindow* self,
                                                          GeeSet* visible)
{
	GearyFolder* _tmp0_;
#line 2373 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2373 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (visible, GEE_TYPE_SET));
#line 2374 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2374 "../src/client/application/application-main-window.vala"
	if (_tmp0_ != NULL) {
#line 14702 "application-main-window.c"
		ApplicationController* _tmp1_;
		GearyFolder* _tmp2_;
#line 2375 "../src/client/application/application-main-window.vala"
		_tmp1_ = self->priv->controller;
#line 2375 "../src/client/application/application-main-window.vala"
		_tmp2_ = self->priv->_selected_folder;
#line 2375 "../src/client/application/application-main-window.vala"
		application_controller_clear_new_messages (_tmp1_, _tmp2_, visible);
#line 14711 "application-main-window.c"
	}
}

static void
application_main_window_on_folder_activated (ApplicationMainWindow* self,
                                             GearyFolder* folder)
{
#line 2379 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2379 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((folder == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (folder, GEARY_TYPE_FOLDER));
#line 2380 "../src/client/application/application-main-window.vala"
	if (folder != NULL) {
#line 2381 "../src/client/application/application-main-window.vala"
		application_main_window_focus_next_pane (self);
#line 14727 "application-main-window.c"
	}
}

static void
application_main_window_on_conversation_activated (ApplicationMainWindow* self,
                                                   GearyAppConversation* activated,
                                                   gboolean single)
{
#line 2384 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2384 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (activated, GEARY_APP_TYPE_CONVERSATION));
#line 2385 "../src/client/application/application-main-window.vala"
	if (single) {
#line 14742 "application-main-window.c"
		HdyLeaflet* _tmp0_;
		gboolean _tmp1_;
		gboolean _tmp2_;
#line 2386 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->outer_leaflet;
#line 2386 "../src/client/application/application-main-window.vala"
		_tmp1_ = hdy_leaflet_get_folded (_tmp0_);
#line 2386 "../src/client/application/application-main-window.vala"
		_tmp2_ = _tmp1_;
#line 2386 "../src/client/application/application-main-window.vala"
		if (_tmp2_) {
#line 2387 "../src/client/application/application-main-window.vala"
			application_main_window_focus_next_pane (self);
#line 14756 "application-main-window.c"
		}
	} else {
		GearyFolder* _tmp3_;
#line 2389 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->_selected_folder;
#line 2389 "../src/client/application/application-main-window.vala"
		if (_tmp3_ != NULL) {
#line 14764 "application-main-window.c"
			GearyFolder* _tmp4_;
			GearyFolderSpecialUse _tmp5_;
			GearyFolderSpecialUse _tmp6_;
#line 2390 "../src/client/application/application-main-window.vala"
			_tmp4_ = self->priv->_selected_folder;
#line 2390 "../src/client/application/application-main-window.vala"
			_tmp5_ = geary_folder_get_used_as (_tmp4_);
#line 2390 "../src/client/application/application-main-window.vala"
			_tmp6_ = _tmp5_;
#line 2390 "../src/client/application/application-main-window.vala"
			if (_tmp6_ != GEARY_FOLDER_SPECIAL_USE_DRAFTS) {
#line 14776 "application-main-window.c"
				ApplicationClient* _tmp7_;
				ApplicationClient* _tmp8_;
				GearyFolder* _tmp9_;
				ConversationListView* _tmp10_;
				GeeSet* _tmp11_;
				GeeSet* _tmp12_;
#line 2391 "../src/client/application/application-main-window.vala"
				_tmp7_ = application_main_window_get_application (self);
#line 2391 "../src/client/application/application-main-window.vala"
				_tmp8_ = _tmp7_;
#line 2391 "../src/client/application/application-main-window.vala"
				_tmp9_ = self->priv->_selected_folder;
#line 2391 "../src/client/application/application-main-window.vala"
				_tmp10_ = self->priv->_conversation_list_view;
#line 2391 "../src/client/application/application-main-window.vala"
				_tmp11_ = conversation_list_view_copy_selected (_tmp10_);
#line 2391 "../src/client/application/application-main-window.vala"
				_tmp12_ = _tmp11_;
#line 2391 "../src/client/application/application-main-window.vala"
				application_client_new_window (_tmp8_, _tmp9_, G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_COLLECTION, GeeCollection), NULL, NULL);
#line 2391 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_tmp12_);
#line 14799 "application-main-window.c"
			} else {
				GearyEmail* draft = NULL;
				GearyEmail* _tmp13_;
				GearyFolder* _tmp14_;
				GearyAccount* _tmp15_;
				GearyAccount* _tmp16_;
				GearyEmail* _tmp17_;
#line 2398 "../src/client/application/application-main-window.vala"
				_tmp13_ = geary_app_conversation_get_latest_recv_email (activated, GEARY_APP_CONVERSATION_LOCATION_IN_FOLDER, NULL);
#line 2398 "../src/client/application/application-main-window.vala"
				draft = _tmp13_;
#line 2399 "../src/client/application/application-main-window.vala"
				_tmp14_ = self->priv->_selected_folder;
#line 2399 "../src/client/application/application-main-window.vala"
				_tmp15_ = geary_folder_get_account (_tmp14_);
#line 2399 "../src/client/application/application-main-window.vala"
				_tmp16_ = _tmp15_;
#line 2399 "../src/client/application/application-main-window.vala"
				_tmp17_ = draft;
#line 2399 "../src/client/application/application-main-window.vala"
				application_main_window_create_composer (self, _tmp16_, COMPOSER_WIDGET_CONTEXT_TYPE_EDIT, _tmp17_, NULL, NULL, NULL);
#line 2390 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (draft);
#line 14823 "application-main-window.c"
			}
		}
	}
}

static void
application_main_window_on_find_in_conversation_action (ApplicationMainWindow* self)
{
	ConversationViewer* _tmp0_;
#line 2409 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2410 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_conversation_viewer;
#line 2410 "../src/client/application/application-main-window.vala"
	conversation_viewer_enable_find (_tmp0_);
#line 14839 "application-main-window.c"
}

static void
application_main_window_on_search_activated (ApplicationMainWindow* self)
{
#line 2413 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2414 "../src/client/application/application-main-window.vala"
	application_main_window_show_search_bar (self, NULL);
#line 14849 "application-main-window.c"
}

static void
application_main_window_on_zoom (ApplicationMainWindow* self,
                                 GSimpleAction* action,
                                 GVariant* parameter)
{
	ConversationListBox* view = NULL;
	ConversationViewer* _tmp0_;
	ConversationListBox* _tmp1_;
	ConversationListBox* _tmp2_;
	ConversationListBox* _tmp3_;
	gboolean _tmp4_ = FALSE;
	ConversationListBox* _tmp5_;
#line 2417 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2417 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (action, g_simple_action_get_type ()));
#line 2418 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_conversation_viewer;
#line 2418 "../src/client/application/application-main-window.vala"
	_tmp1_ = conversation_viewer_get_current_list (_tmp0_);
#line 2418 "../src/client/application/application-main-window.vala"
	_tmp2_ = _tmp1_;
#line 2418 "../src/client/application/application-main-window.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 2418 "../src/client/application/application-main-window.vala"
	view = _tmp3_;
#line 2419 "../src/client/application/application-main-window.vala"
	_tmp5_ = view;
#line 2419 "../src/client/application/application-main-window.vala"
	if (_tmp5_ != NULL) {
#line 2419 "../src/client/application/application-main-window.vala"
		_tmp4_ = parameter != NULL;
#line 14884 "application-main-window.c"
	} else {
#line 2419 "../src/client/application/application-main-window.vala"
		_tmp4_ = FALSE;
#line 14888 "application-main-window.c"
	}
#line 2419 "../src/client/application/application-main-window.vala"
	if (_tmp4_) {
#line 14892 "application-main-window.c"
		gchar* zoom_action = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
#line 2420 "../src/client/application/application-main-window.vala"
		_tmp6_ = g_variant_get_string (parameter, NULL);
#line 2420 "../src/client/application/application-main-window.vala"
		_tmp7_ = g_strdup (_tmp6_);
#line 2420 "../src/client/application/application-main-window.vala"
		zoom_action = _tmp7_;
#line 2421 "../src/client/application/application-main-window.vala"
		_tmp8_ = zoom_action;
#line 2421 "../src/client/application/application-main-window.vala"
		if (g_strcmp0 (_tmp8_, "in") == 0) {
#line 14907 "application-main-window.c"
			ConversationListBox* _tmp9_;
#line 2422 "../src/client/application/application-main-window.vala"
			_tmp9_ = view;
#line 2422 "../src/client/application/application-main-window.vala"
			conversation_list_box_zoom_in (_tmp9_);
#line 14913 "application-main-window.c"
		} else {
			const gchar* _tmp10_;
#line 2423 "../src/client/application/application-main-window.vala"
			_tmp10_ = zoom_action;
#line 2423 "../src/client/application/application-main-window.vala"
			if (g_strcmp0 (_tmp10_, "out") == 0) {
#line 14920 "application-main-window.c"
				ConversationListBox* _tmp11_;
#line 2424 "../src/client/application/application-main-window.vala"
				_tmp11_ = view;
#line 2424 "../src/client/application/application-main-window.vala"
				conversation_list_box_zoom_out (_tmp11_);
#line 14926 "application-main-window.c"
			} else {
				ConversationListBox* _tmp12_;
#line 2426 "../src/client/application/application-main-window.vala"
				_tmp12_ = view;
#line 2426 "../src/client/application/application-main-window.vala"
				conversation_list_box_zoom_reset (_tmp12_);
#line 14933 "application-main-window.c"
			}
		}
#line 2419 "../src/client/application/application-main-window.vala"
		_g_free0 (zoom_action);
#line 14938 "application-main-window.c"
	}
#line 2417 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (view);
#line 14942 "application-main-window.c"
}

static void
application_main_window_on_reply_conversation (ApplicationMainWindow* self)
{
#line 2430 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2431 "../src/client/application/application-main-window.vala"
	application_main_window_create_composer_from_viewer (self, COMPOSER_WIDGET_CONTEXT_TYPE_REPLY_SENDER, NULL, NULL);
#line 14952 "application-main-window.c"
}

static void
application_main_window_on_reply_all_conversation (ApplicationMainWindow* self)
{
#line 2434 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2435 "../src/client/application/application-main-window.vala"
	application_main_window_create_composer_from_viewer (self, COMPOSER_WIDGET_CONTEXT_TYPE_REPLY_ALL, NULL, NULL);
#line 14962 "application-main-window.c"
}

static void
application_main_window_on_forward_conversation (ApplicationMainWindow* self)
{
#line 2438 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2439 "../src/client/application/application-main-window.vala"
	application_main_window_create_composer_from_viewer (self, COMPOSER_WIDGET_CONTEXT_TYPE_FORWARD, NULL, NULL);
#line 14972 "application-main-window.c"
}

static void
application_main_window_on_show_window_menu (ApplicationMainWindow* self)
{
#line 2442 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2443 "../src/client/application/application-main-window.vala"
	application_main_window_show_window_menu (self);
#line 14982 "application-main-window.c"
}

static void
application_main_window_on_show_help_overlay (ApplicationMainWindow* self)
{
	GtkShortcutsWindow* overlay = NULL;
	GtkShortcutsWindow* _tmp0_;
	GtkShortcutsWindow* _tmp1_;
#line 2446 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2447 "../src/client/application/application-main-window.vala"
	_tmp0_ = gtk_application_window_get_help_overlay (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_window_get_type (), GtkApplicationWindow));
#line 2447 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 2447 "../src/client/application/application-main-window.vala"
	overlay = _tmp1_;
#line 2448 "../src/client/application/application-main-window.vala"
	g_object_set (overlay, "section-name", "conversation", NULL);
#line 2449 "../src/client/application/application-main-window.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (overlay, gtk_widget_get_type (), GtkWidget));
#line 2446 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (overlay);
#line 15005 "application-main-window.c"
}

static void
application_main_window_on_show_copy_menu (ApplicationMainWindow* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 2452 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2453 "../src/client/application/application-main-window.vala"
	_tmp1_ = application_main_window_get_is_conversation_list_shown (self);
#line 2453 "../src/client/application/application-main-window.vala"
	_tmp2_ = _tmp1_;
#line 2453 "../src/client/application/application-main-window.vala"
	if (_tmp2_) {
#line 15022 "application-main-window.c"
		GtkRevealer* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 2454 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->conversation_list_actions_revealer;
#line 2454 "../src/client/application/application-main-window.vala"
		_tmp4_ = gtk_revealer_get_child_revealed (_tmp3_);
#line 2454 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2454 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp5_;
#line 15034 "application-main-window.c"
	} else {
#line 2453 "../src/client/application/application-main-window.vala"
		_tmp0_ = FALSE;
#line 15038 "application-main-window.c"
	}
#line 2453 "../src/client/application/application-main-window.vala"
	if (_tmp0_) {
#line 15042 "application-main-window.c"
		ComponentsConversationActions* _tmp6_;
#line 2455 "../src/client/application/application-main-window.vala"
		_tmp6_ = self->priv->conversation_list_actions;
#line 2455 "../src/client/application/application-main-window.vala"
		components_conversation_actions_show_copy_menu (_tmp6_);
#line 15048 "application-main-window.c"
	} else {
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 2456 "../src/client/application/application-main-window.vala"
		_tmp7_ = application_main_window_get_is_conversation_viewer_shown (self);
#line 2456 "../src/client/application/application-main-window.vala"
		_tmp8_ = _tmp7_;
#line 2456 "../src/client/application/application-main-window.vala"
		if (_tmp8_) {
#line 15058 "application-main-window.c"
			ComponentsMainToolbar* _tmp9_;
			ComponentsConversationActions* _tmp10_;
			ComponentsConversationActions* _tmp11_;
#line 2457 "../src/client/application/application-main-window.vala"
			_tmp9_ = self->priv->_main_toolbar;
#line 2457 "../src/client/application/application-main-window.vala"
			_tmp10_ = components_main_toolbar_get_shown_actions (_tmp9_);
#line 2457 "../src/client/application/application-main-window.vala"
			_tmp11_ = _tmp10_;
#line 2457 "../src/client/application/application-main-window.vala"
			components_conversation_actions_show_copy_menu (_tmp11_);
#line 15070 "application-main-window.c"
		} else {
#line 2459 "../src/client/application/application-main-window.vala"
			gtk_widget_error_bell (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 15074 "application-main-window.c"
		}
	}
}

static void
application_main_window_on_show_move_menu (ApplicationMainWindow* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 2463 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2464 "../src/client/application/application-main-window.vala"
	_tmp1_ = application_main_window_get_is_conversation_list_shown (self);
#line 2464 "../src/client/application/application-main-window.vala"
	_tmp2_ = _tmp1_;
#line 2464 "../src/client/application/application-main-window.vala"
	if (_tmp2_) {
#line 15093 "application-main-window.c"
		GtkRevealer* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 2465 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->conversation_list_actions_revealer;
#line 2465 "../src/client/application/application-main-window.vala"
		_tmp4_ = gtk_revealer_get_child_revealed (_tmp3_);
#line 2465 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2465 "../src/client/application/application-main-window.vala"
		_tmp0_ = _tmp5_;
#line 15105 "application-main-window.c"
	} else {
#line 2464 "../src/client/application/application-main-window.vala"
		_tmp0_ = FALSE;
#line 15109 "application-main-window.c"
	}
#line 2464 "../src/client/application/application-main-window.vala"
	if (_tmp0_) {
#line 15113 "application-main-window.c"
		ComponentsConversationActions* _tmp6_;
#line 2466 "../src/client/application/application-main-window.vala"
		_tmp6_ = self->priv->conversation_list_actions;
#line 2466 "../src/client/application/application-main-window.vala"
		components_conversation_actions_show_move_menu (_tmp6_);
#line 15119 "application-main-window.c"
	} else {
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 2467 "../src/client/application/application-main-window.vala"
		_tmp7_ = application_main_window_get_is_conversation_viewer_shown (self);
#line 2467 "../src/client/application/application-main-window.vala"
		_tmp8_ = _tmp7_;
#line 2467 "../src/client/application/application-main-window.vala"
		if (_tmp8_) {
#line 15129 "application-main-window.c"
			ComponentsMainToolbar* _tmp9_;
			ComponentsConversationActions* _tmp10_;
			ComponentsConversationActions* _tmp11_;
#line 2468 "../src/client/application/application-main-window.vala"
			_tmp9_ = self->priv->_main_toolbar;
#line 2468 "../src/client/application/application-main-window.vala"
			_tmp10_ = components_main_toolbar_get_shown_actions (_tmp9_);
#line 2468 "../src/client/application/application-main-window.vala"
			_tmp11_ = _tmp10_;
#line 2468 "../src/client/application/application-main-window.vala"
			components_conversation_actions_show_move_menu (_tmp11_);
#line 15141 "application-main-window.c"
		} else {
#line 2470 "../src/client/application/application-main-window.vala"
			gtk_widget_error_bell (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 15145 "application-main-window.c"
		}
	}
}

static void
application_main_window_on_conversation_up (ApplicationMainWindow* self)
{
	ConversationListView* _tmp0_;
#line 2474 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2475 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_conversation_list_view;
#line 2475 "../src/client/application/application-main-window.vala"
	conversation_list_view_scroll (_tmp0_, GTK_SCROLL_STEP_UP);
#line 15160 "application-main-window.c"
}

static void
application_main_window_on_conversation_down (ApplicationMainWindow* self)
{
	ConversationListView* _tmp0_;
#line 2478 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2479 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_conversation_list_view;
#line 2479 "../src/client/application/application-main-window.vala"
	conversation_list_view_scroll (_tmp0_, GTK_SCROLL_STEP_DOWN);
#line 15173 "application-main-window.c"
}

static void
application_main_window_on_show_mark_menu (ApplicationMainWindow* self)
{
	gboolean unread_selected = FALSE;
	gboolean read_selected = FALSE;
	gboolean starred_selected = FALSE;
	gboolean unstarred_selected = FALSE;
	GSimpleAction* _tmp24_;
	GSimpleAction* _tmp25_;
	GSimpleAction* _tmp26_;
	GSimpleAction* _tmp27_;
	GSimpleAction* _tmp28_;
	GSimpleAction* _tmp29_;
	GSimpleAction* _tmp30_;
	GSimpleAction* _tmp31_;
	gboolean in_junk_folder = FALSE;
	GearyFolder* _tmp32_;
	GearyFolderSpecialUse _tmp33_;
	GearyFolderSpecialUse _tmp34_;
	gboolean _tmp35_ = FALSE;
	gboolean _tmp36_ = FALSE;
	GSimpleAction* _tmp43_;
	GSimpleAction* _tmp44_;
#line 2482 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2483 "../src/client/application/application-main-window.vala"
	unread_selected = FALSE;
#line 2484 "../src/client/application/application-main-window.vala"
	read_selected = FALSE;
#line 2485 "../src/client/application/application-main-window.vala"
	starred_selected = FALSE;
#line 2486 "../src/client/application/application-main-window.vala"
	unstarred_selected = FALSE;
#line 15209 "application-main-window.c"
	{
		GeeIterator* _conversation_it = NULL;
		ConversationListView* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 2487 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->_conversation_list_view;
#line 2487 "../src/client/application/application-main-window.vala"
		_tmp1_ = conversation_list_view_get_selected (_tmp0_);
#line 2487 "../src/client/application/application-main-window.vala"
		_tmp2_ = _tmp1_;
#line 2487 "../src/client/application/application-main-window.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ITERABLE, GeeIterable));
#line 2487 "../src/client/application/application-main-window.vala"
		_tmp4_ = _tmp3_;
#line 2487 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp2_);
#line 2487 "../src/client/application/application-main-window.vala"
		_conversation_it = _tmp4_;
#line 2487 "../src/client/application/application-main-window.vala"
		while (TRUE) {
#line 15233 "application-main-window.c"
			GeeIterator* _tmp5_;
			GearyAppConversation* conversation = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			GearyAppConversation* _tmp8_;
			GearyEmail* latest = NULL;
			GearyAppConversation* _tmp9_;
			GearyEmail* _tmp10_;
			gboolean _tmp11_ = FALSE;
			gboolean _tmp12_ = FALSE;
			GearyEmail* _tmp13_;
			GearyAppConversation* _tmp23_;
#line 2487 "../src/client/application/application-main-window.vala"
			_tmp5_ = _conversation_it;
#line 2487 "../src/client/application/application-main-window.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 2487 "../src/client/application/application-main-window.vala"
				break;
#line 15252 "application-main-window.c"
			}
#line 2487 "../src/client/application/application-main-window.vala"
			_tmp6_ = _conversation_it;
#line 2487 "../src/client/application/application-main-window.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 2487 "../src/client/application/application-main-window.vala"
			conversation = (GearyAppConversation*) _tmp7_;
#line 2489 "../src/client/application/application-main-window.vala"
			_tmp8_ = conversation;
#line 2489 "../src/client/application/application-main-window.vala"
			if (geary_app_conversation_is_unread (_tmp8_)) {
#line 2490 "../src/client/application/application-main-window.vala"
				unread_selected = TRUE;
#line 15266 "application-main-window.c"
			}
#line 2496 "../src/client/application/application-main-window.vala"
			_tmp9_ = conversation;
#line 2496 "../src/client/application/application-main-window.vala"
			_tmp10_ = geary_app_conversation_get_latest_sent_email (_tmp9_, GEARY_APP_CONVERSATION_LOCATION_IN_FOLDER_OUT_OF_FOLDER, NULL);
#line 2496 "../src/client/application/application-main-window.vala"
			latest = _tmp10_;
#line 2498 "../src/client/application/application-main-window.vala"
			_tmp13_ = latest;
#line 2498 "../src/client/application/application-main-window.vala"
			if (_tmp13_ != NULL) {
#line 15278 "application-main-window.c"
				GearyEmail* _tmp14_;
				GearyEmailFlags* _tmp15_;
				GearyEmailFlags* _tmp16_;
#line 2498 "../src/client/application/application-main-window.vala"
				_tmp14_ = latest;
#line 2498 "../src/client/application/application-main-window.vala"
				_tmp15_ = geary_email_get_email_flags (_tmp14_);
#line 2498 "../src/client/application/application-main-window.vala"
				_tmp16_ = _tmp15_;
#line 2498 "../src/client/application/application-main-window.vala"
				_tmp12_ = _tmp16_ != NULL;
#line 15290 "application-main-window.c"
			} else {
#line 2498 "../src/client/application/application-main-window.vala"
				_tmp12_ = FALSE;
#line 15294 "application-main-window.c"
			}
#line 2498 "../src/client/application/application-main-window.vala"
			if (_tmp12_) {
#line 15298 "application-main-window.c"
				GearyEmail* _tmp17_;
				GearyEmailFlags* _tmp18_;
				GearyEmailFlags* _tmp19_;
				GearyNamedFlag* _tmp20_;
				GearyNamedFlag* _tmp21_;
				GearyNamedFlag* _tmp22_;
#line 2499 "../src/client/application/application-main-window.vala"
				_tmp17_ = latest;
#line 2499 "../src/client/application/application-main-window.vala"
				_tmp18_ = geary_email_get_email_flags (_tmp17_);
#line 2499 "../src/client/application/application-main-window.vala"
				_tmp19_ = _tmp18_;
#line 2499 "../src/client/application/application-main-window.vala"
				_tmp20_ = geary_email_flags_get_UNREAD ();
#line 2499 "../src/client/application/application-main-window.vala"
				_tmp21_ = _tmp20_;
#line 2499 "../src/client/application/application-main-window.vala"
				_tmp22_ = _tmp21_;
#line 2499 "../src/client/application/application-main-window.vala"
				_tmp11_ = !geary_named_flags_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, GEARY_TYPE_NAMED_FLAGS, GearyNamedFlags), _tmp22_);
#line 2499 "../src/client/application/application-main-window.vala"
				_g_object_unref0 (_tmp22_);
#line 15321 "application-main-window.c"
			} else {
#line 2498 "../src/client/application/application-main-window.vala"
				_tmp11_ = FALSE;
#line 15325 "application-main-window.c"
			}
#line 2498 "../src/client/application/application-main-window.vala"
			if (_tmp11_) {
#line 2500 "../src/client/application/application-main-window.vala"
				read_selected = TRUE;
#line 15331 "application-main-window.c"
			}
#line 2502 "../src/client/application/application-main-window.vala"
			_tmp23_ = conversation;
#line 2502 "../src/client/application/application-main-window.vala"
			if (geary_app_conversation_is_flagged (_tmp23_)) {
#line 2503 "../src/client/application/application-main-window.vala"
				starred_selected = TRUE;
#line 15339 "application-main-window.c"
			} else {
#line 2505 "../src/client/application/application-main-window.vala"
				unstarred_selected = TRUE;
#line 15343 "application-main-window.c"
			}
#line 2487 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (latest);
#line 2487 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (conversation);
#line 15349 "application-main-window.c"
		}
#line 2487 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_conversation_it);
#line 15353 "application-main-window.c"
	}
#line 2508 "../src/client/application/application-main-window.vala"
	_tmp24_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_MARK_AS_READ);
#line 2508 "../src/client/application/application-main-window.vala"
	_tmp25_ = _tmp24_;
#line 2508 "../src/client/application/application-main-window.vala"
	g_simple_action_set_enabled (_tmp25_, unread_selected);
#line 2508 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp25_);
#line 2509 "../src/client/application/application-main-window.vala"
	_tmp26_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_MARK_AS_UNREAD);
#line 2509 "../src/client/application/application-main-window.vala"
	_tmp27_ = _tmp26_;
#line 2509 "../src/client/application/application-main-window.vala"
	g_simple_action_set_enabled (_tmp27_, read_selected);
#line 2509 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp27_);
#line 2510 "../src/client/application/application-main-window.vala"
	_tmp28_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_MARK_AS_STARRED);
#line 2510 "../src/client/application/application-main-window.vala"
	_tmp29_ = _tmp28_;
#line 2510 "../src/client/application/application-main-window.vala"
	g_simple_action_set_enabled (_tmp29_, unstarred_selected);
#line 2510 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp29_);
#line 2511 "../src/client/application/application-main-window.vala"
	_tmp30_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_MARK_AS_UNSTARRED);
#line 2511 "../src/client/application/application-main-window.vala"
	_tmp31_ = _tmp30_;
#line 2511 "../src/client/application/application-main-window.vala"
	g_simple_action_set_enabled (_tmp31_, starred_selected);
#line 2511 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp31_);
#line 2514 "../src/client/application/application-main-window.vala"
	_tmp32_ = self->priv->_selected_folder;
#line 2514 "../src/client/application/application-main-window.vala"
	_tmp33_ = geary_folder_get_used_as (_tmp32_);
#line 2514 "../src/client/application/application-main-window.vala"
	_tmp34_ = _tmp33_;
#line 2514 "../src/client/application/application-main-window.vala"
	in_junk_folder = _tmp34_ == GEARY_FOLDER_SPECIAL_USE_JUNK;
#line 2516 "../src/client/application/application-main-window.vala"
	if (!in_junk_folder) {
#line 15397 "application-main-window.c"
		GearyFolder* _tmp37_;
		GearyFolderSpecialUse _tmp38_;
		GearyFolderSpecialUse _tmp39_;
#line 2517 "../src/client/application/application-main-window.vala"
		_tmp37_ = self->priv->_selected_folder;
#line 2517 "../src/client/application/application-main-window.vala"
		_tmp38_ = geary_folder_get_used_as (_tmp37_);
#line 2517 "../src/client/application/application-main-window.vala"
		_tmp39_ = _tmp38_;
#line 2517 "../src/client/application/application-main-window.vala"
		_tmp36_ = _tmp39_ != GEARY_FOLDER_SPECIAL_USE_DRAFTS;
#line 15409 "application-main-window.c"
	} else {
#line 2516 "../src/client/application/application-main-window.vala"
		_tmp36_ = FALSE;
#line 15413 "application-main-window.c"
	}
#line 2516 "../src/client/application/application-main-window.vala"
	if (_tmp36_) {
#line 15417 "application-main-window.c"
		GearyFolder* _tmp40_;
		GearyFolderSpecialUse _tmp41_;
		GearyFolderSpecialUse _tmp42_;
#line 2518 "../src/client/application/application-main-window.vala"
		_tmp40_ = self->priv->_selected_folder;
#line 2518 "../src/client/application/application-main-window.vala"
		_tmp41_ = geary_folder_get_used_as (_tmp40_);
#line 2518 "../src/client/application/application-main-window.vala"
		_tmp42_ = _tmp41_;
#line 2518 "../src/client/application/application-main-window.vala"
		_tmp35_ = _tmp42_ != GEARY_FOLDER_SPECIAL_USE_OUTBOX;
#line 15429 "application-main-window.c"
	} else {
#line 2516 "../src/client/application/application-main-window.vala"
		_tmp35_ = FALSE;
#line 15433 "application-main-window.c"
	}
#line 2515 "../src/client/application/application-main-window.vala"
	_tmp43_ = application_main_window_get_window_action (self, APPLICATION_MAIN_WINDOW_ACTION_TOGGLE_JUNK);
#line 2515 "../src/client/application/application-main-window.vala"
	_tmp44_ = _tmp43_;
#line 2515 "../src/client/application/application-main-window.vala"
	g_simple_action_set_enabled (_tmp44_, _tmp35_);
#line 2515 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (_tmp44_);
#line 15443 "application-main-window.c"
}

static Block20Data*
block20_data_ref (Block20Data* _data20_)
{
#line 2522 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data20_->_ref_count_);
#line 2522 "../src/client/application/application-main-window.vala"
	return _data20_;
#line 15453 "application-main-window.c"
}

static void
block20_data_unref (void * _userdata_)
{
	Block20Data* _data20_;
	_data20_ = (Block20Data*) _userdata_;
#line 2522 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data20_->_ref_count_)) {
#line 15463 "application-main-window.c"
		ApplicationMainWindow* self;
#line 2522 "../src/client/application/application-main-window.vala"
		self = _data20_->self;
#line 2522 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data20_->location);
#line 2522 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 2522 "../src/client/application/application-main-window.vala"
		g_slice_free (Block20Data, _data20_);
#line 15473 "application-main-window.c"
	}
}

static void
___lambda197_ (Block20Data* _data20_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 2531 "../src/client/application/application-main-window.vala"
	self = _data20_->self;
#line 2531 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 2531 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 15490 "application-main-window.c"
	{
		ApplicationController* _tmp0_;
#line 2533 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->controller;
#line 2533 "../src/client/application/application-main-window.vala"
		application_controller_mark_conversations_finish (_tmp0_, res, &_inner_error0_);
#line 2533 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 15499 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolder* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAccountInformation* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GError* _tmp6_;
#line 2532 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 2532 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 2535 "../src/client/application/application-main-window.vala"
		_tmp1_ = _data20_->location;
#line 2535 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_account (_tmp1_);
#line 2535 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 2535 "../src/client/application/application-main-window.vala"
		_tmp4_ = geary_account_get_information (_tmp3_);
#line 2535 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2535 "../src/client/application/application-main-window.vala"
		_tmp6_ = err;
#line 2535 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp5_, _tmp6_);
#line 2532 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 15533 "application-main-window.c"
	}
	__finally0:
#line 2532 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2532 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2532 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 2532 "../src/client/application/application-main-window.vala"
		return;
#line 15544 "application-main-window.c"
	}
}

static void
____lambda197__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 2526 "../src/client/application/application-main-window.vala"
	___lambda197_ (self, source_object, res);
#line 2526 "../src/client/application/application-main-window.vala"
	block20_data_unref (self);
#line 15557 "application-main-window.c"
}

static void
application_main_window_on_mark_conversations (ApplicationMainWindow* self,
                                               GeeCollection* conversations,
                                               GearyNamedFlag* flag)
{
	Block20Data* _data20_;
	GearyFolder* _tmp0_;
	GearyFolder* _tmp1_;
	GearyFolder* _tmp2_;
#line 2522 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2522 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (conversations, GEE_TYPE_COLLECTION));
#line 2522 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (flag, GEARY_TYPE_NAMED_FLAG));
#line 2522 "../src/client/application/application-main-window.vala"
	_data20_ = g_slice_new0 (Block20Data);
#line 2522 "../src/client/application/application-main-window.vala"
	_data20_->_ref_count_ = 1;
#line 2522 "../src/client/application/application-main-window.vala"
	_data20_->self = g_object_ref (self);
#line 2524 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2524 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 2524 "../src/client/application/application-main-window.vala"
	_data20_->location = _tmp1_;
#line 2525 "../src/client/application/application-main-window.vala"
	_tmp2_ = _data20_->location;
#line 2525 "../src/client/application/application-main-window.vala"
	if (_tmp2_ != NULL) {
#line 15591 "application-main-window.c"
		ApplicationController* _tmp3_;
		GearyFolder* _tmp4_;
#line 2526 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->controller;
#line 2526 "../src/client/application/application-main-window.vala"
		_tmp4_ = _data20_->location;
#line 2526 "../src/client/application/application-main-window.vala"
		application_controller_mark_conversations (_tmp3_, _tmp4_, conversations, flag, TRUE, ____lambda197__gasync_ready_callback, block20_data_ref (_data20_));
#line 15600 "application-main-window.c"
	}
#line 2522 "../src/client/application/application-main-window.vala"
	block20_data_unref (_data20_);
#line 2522 "../src/client/application/application-main-window.vala"
	_data20_ = NULL;
#line 15606 "application-main-window.c"
}

static Block21Data*
block21_data_ref (Block21Data* _data21_)
{
#line 2542 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data21_->_ref_count_);
#line 2542 "../src/client/application/application-main-window.vala"
	return _data21_;
#line 15616 "application-main-window.c"
}

static void
block21_data_unref (void * _userdata_)
{
	Block21Data* _data21_;
	_data21_ = (Block21Data*) _userdata_;
#line 2542 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data21_->_ref_count_)) {
#line 15626 "application-main-window.c"
		ApplicationMainWindow* self;
#line 2542 "../src/client/application/application-main-window.vala"
		self = _data21_->self;
#line 2542 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data21_->location);
#line 2542 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 2542 "../src/client/application/application-main-window.vala"
		g_slice_free (Block21Data, _data21_);
#line 15636 "application-main-window.c"
	}
}

static void
___lambda188_ (Block21Data* _data21_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 2550 "../src/client/application/application-main-window.vala"
	self = _data21_->self;
#line 2550 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 2550 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 15653 "application-main-window.c"
	{
		ApplicationController* _tmp0_;
#line 2552 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->controller;
#line 2552 "../src/client/application/application-main-window.vala"
		application_controller_mark_conversations_finish (_tmp0_, res, &_inner_error0_);
#line 2552 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 15662 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolder* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAccountInformation* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GError* _tmp6_;
#line 2551 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 2551 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 2554 "../src/client/application/application-main-window.vala"
		_tmp1_ = _data21_->location;
#line 2554 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_account (_tmp1_);
#line 2554 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 2554 "../src/client/application/application-main-window.vala"
		_tmp4_ = geary_account_get_information (_tmp3_);
#line 2554 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2554 "../src/client/application/application-main-window.vala"
		_tmp6_ = err;
#line 2554 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp5_, _tmp6_);
#line 2551 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 15696 "application-main-window.c"
	}
	__finally0:
#line 2551 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2551 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2551 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 2551 "../src/client/application/application-main-window.vala"
		return;
#line 15707 "application-main-window.c"
	}
}

static void
____lambda188__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 2545 "../src/client/application/application-main-window.vala"
	___lambda188_ (self, source_object, res);
#line 2545 "../src/client/application/application-main-window.vala"
	block21_data_unref (self);
#line 15720 "application-main-window.c"
}

static void
application_main_window_on_mark_as_read (ApplicationMainWindow* self)
{
	Block21Data* _data21_;
	GearyFolder* _tmp0_;
	GearyFolder* _tmp1_;
	GearyFolder* _tmp2_;
#line 2542 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2542 "../src/client/application/application-main-window.vala"
	_data21_ = g_slice_new0 (Block21Data);
#line 2542 "../src/client/application/application-main-window.vala"
	_data21_->_ref_count_ = 1;
#line 2542 "../src/client/application/application-main-window.vala"
	_data21_->self = g_object_ref (self);
#line 2543 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2543 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 2543 "../src/client/application/application-main-window.vala"
	_data21_->location = _tmp1_;
#line 2544 "../src/client/application/application-main-window.vala"
	_tmp2_ = _data21_->location;
#line 2544 "../src/client/application/application-main-window.vala"
	if (_tmp2_ != NULL) {
#line 15748 "application-main-window.c"
		ApplicationController* _tmp3_;
		GearyFolder* _tmp4_;
		ConversationListView* _tmp5_;
		GeeSet* _tmp6_;
		GeeSet* _tmp7_;
		GearyNamedFlag* _tmp8_;
		GearyNamedFlag* _tmp9_;
		GearyNamedFlag* _tmp10_;
#line 2545 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->controller;
#line 2545 "../src/client/application/application-main-window.vala"
		_tmp4_ = _data21_->location;
#line 2545 "../src/client/application/application-main-window.vala"
		_tmp5_ = self->priv->_conversation_list_view;
#line 2545 "../src/client/application/application-main-window.vala"
		_tmp6_ = conversation_list_view_copy_selected (_tmp5_);
#line 2545 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 2545 "../src/client/application/application-main-window.vala"
		_tmp8_ = geary_email_flags_get_UNREAD ();
#line 2545 "../src/client/application/application-main-window.vala"
		_tmp9_ = _tmp8_;
#line 2545 "../src/client/application/application-main-window.vala"
		_tmp10_ = _tmp9_;
#line 2545 "../src/client/application/application-main-window.vala"
		application_controller_mark_conversations (_tmp3_, _tmp4_, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection), _tmp10_, FALSE, ____lambda188__gasync_ready_callback, block21_data_ref (_data21_));
#line 2545 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp10_);
#line 2545 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp7_);
#line 15779 "application-main-window.c"
	}
#line 2542 "../src/client/application/application-main-window.vala"
	block21_data_unref (_data21_);
#line 2542 "../src/client/application/application-main-window.vala"
	_data21_ = NULL;
#line 15785 "application-main-window.c"
}

static Block22Data*
block22_data_ref (Block22Data* _data22_)
{
#line 2561 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data22_->_ref_count_);
#line 2561 "../src/client/application/application-main-window.vala"
	return _data22_;
#line 15795 "application-main-window.c"
}

static void
block22_data_unref (void * _userdata_)
{
	Block22Data* _data22_;
	_data22_ = (Block22Data*) _userdata_;
#line 2561 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data22_->_ref_count_)) {
#line 15805 "application-main-window.c"
		ApplicationMainWindow* self;
#line 2561 "../src/client/application/application-main-window.vala"
		self = _data22_->self;
#line 2561 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data22_->location);
#line 2561 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 2561 "../src/client/application/application-main-window.vala"
		g_slice_free (Block22Data, _data22_);
#line 15815 "application-main-window.c"
	}
}

static void
___lambda189_ (Block22Data* _data22_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 2569 "../src/client/application/application-main-window.vala"
	self = _data22_->self;
#line 2569 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 2569 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 15832 "application-main-window.c"
	{
		ApplicationController* _tmp0_;
#line 2571 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->controller;
#line 2571 "../src/client/application/application-main-window.vala"
		application_controller_mark_conversations_finish (_tmp0_, res, &_inner_error0_);
#line 2571 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 15841 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolder* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAccountInformation* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GError* _tmp6_;
#line 2570 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 2570 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 2573 "../src/client/application/application-main-window.vala"
		_tmp1_ = _data22_->location;
#line 2573 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_account (_tmp1_);
#line 2573 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 2573 "../src/client/application/application-main-window.vala"
		_tmp4_ = geary_account_get_information (_tmp3_);
#line 2573 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2573 "../src/client/application/application-main-window.vala"
		_tmp6_ = err;
#line 2573 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp5_, _tmp6_);
#line 2570 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 15875 "application-main-window.c"
	}
	__finally0:
#line 2570 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2570 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2570 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 2570 "../src/client/application/application-main-window.vala"
		return;
#line 15886 "application-main-window.c"
	}
}

static void
____lambda189__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 2564 "../src/client/application/application-main-window.vala"
	___lambda189_ (self, source_object, res);
#line 2564 "../src/client/application/application-main-window.vala"
	block22_data_unref (self);
#line 15899 "application-main-window.c"
}

static void
application_main_window_on_mark_as_unread (ApplicationMainWindow* self)
{
	Block22Data* _data22_;
	GearyFolder* _tmp0_;
	GearyFolder* _tmp1_;
	GearyFolder* _tmp2_;
#line 2561 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2561 "../src/client/application/application-main-window.vala"
	_data22_ = g_slice_new0 (Block22Data);
#line 2561 "../src/client/application/application-main-window.vala"
	_data22_->_ref_count_ = 1;
#line 2561 "../src/client/application/application-main-window.vala"
	_data22_->self = g_object_ref (self);
#line 2562 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2562 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 2562 "../src/client/application/application-main-window.vala"
	_data22_->location = _tmp1_;
#line 2563 "../src/client/application/application-main-window.vala"
	_tmp2_ = _data22_->location;
#line 2563 "../src/client/application/application-main-window.vala"
	if (_tmp2_ != NULL) {
#line 15927 "application-main-window.c"
		ApplicationController* _tmp3_;
		GearyFolder* _tmp4_;
		ConversationListView* _tmp5_;
		GeeSet* _tmp6_;
		GeeSet* _tmp7_;
		GearyNamedFlag* _tmp8_;
		GearyNamedFlag* _tmp9_;
		GearyNamedFlag* _tmp10_;
#line 2564 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->controller;
#line 2564 "../src/client/application/application-main-window.vala"
		_tmp4_ = _data22_->location;
#line 2564 "../src/client/application/application-main-window.vala"
		_tmp5_ = self->priv->_conversation_list_view;
#line 2564 "../src/client/application/application-main-window.vala"
		_tmp6_ = conversation_list_view_copy_selected (_tmp5_);
#line 2564 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 2564 "../src/client/application/application-main-window.vala"
		_tmp8_ = geary_email_flags_get_UNREAD ();
#line 2564 "../src/client/application/application-main-window.vala"
		_tmp9_ = _tmp8_;
#line 2564 "../src/client/application/application-main-window.vala"
		_tmp10_ = _tmp9_;
#line 2564 "../src/client/application/application-main-window.vala"
		application_controller_mark_conversations (_tmp3_, _tmp4_, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection), _tmp10_, TRUE, ____lambda189__gasync_ready_callback, block22_data_ref (_data22_));
#line 2564 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp10_);
#line 2564 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp7_);
#line 15958 "application-main-window.c"
	}
#line 2561 "../src/client/application/application-main-window.vala"
	block22_data_unref (_data22_);
#line 2561 "../src/client/application/application-main-window.vala"
	_data22_ = NULL;
#line 15964 "application-main-window.c"
}

static Block23Data*
block23_data_ref (Block23Data* _data23_)
{
#line 2580 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data23_->_ref_count_);
#line 2580 "../src/client/application/application-main-window.vala"
	return _data23_;
#line 15974 "application-main-window.c"
}

static void
block23_data_unref (void * _userdata_)
{
	Block23Data* _data23_;
	_data23_ = (Block23Data*) _userdata_;
#line 2580 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data23_->_ref_count_)) {
#line 15984 "application-main-window.c"
		ApplicationMainWindow* self;
#line 2580 "../src/client/application/application-main-window.vala"
		self = _data23_->self;
#line 2580 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data23_->location);
#line 2580 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 2580 "../src/client/application/application-main-window.vala"
		g_slice_free (Block23Data, _data23_);
#line 15994 "application-main-window.c"
	}
}

static void
___lambda190_ (Block23Data* _data23_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 2588 "../src/client/application/application-main-window.vala"
	self = _data23_->self;
#line 2588 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 2588 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 16011 "application-main-window.c"
	{
		ApplicationController* _tmp0_;
#line 2590 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->controller;
#line 2590 "../src/client/application/application-main-window.vala"
		application_controller_mark_conversations_finish (_tmp0_, res, &_inner_error0_);
#line 2590 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16020 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolder* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAccountInformation* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GError* _tmp6_;
#line 2589 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 2589 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 2592 "../src/client/application/application-main-window.vala"
		_tmp1_ = _data23_->location;
#line 2592 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_account (_tmp1_);
#line 2592 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 2592 "../src/client/application/application-main-window.vala"
		_tmp4_ = geary_account_get_information (_tmp3_);
#line 2592 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2592 "../src/client/application/application-main-window.vala"
		_tmp6_ = err;
#line 2592 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp5_, _tmp6_);
#line 2589 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 16054 "application-main-window.c"
	}
	__finally0:
#line 2589 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2589 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2589 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 2589 "../src/client/application/application-main-window.vala"
		return;
#line 16065 "application-main-window.c"
	}
}

static void
____lambda190__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 2583 "../src/client/application/application-main-window.vala"
	___lambda190_ (self, source_object, res);
#line 2583 "../src/client/application/application-main-window.vala"
	block23_data_unref (self);
#line 16078 "application-main-window.c"
}

static void
application_main_window_on_mark_as_starred (ApplicationMainWindow* self)
{
	Block23Data* _data23_;
	GearyFolder* _tmp0_;
	GearyFolder* _tmp1_;
	GearyFolder* _tmp2_;
#line 2580 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2580 "../src/client/application/application-main-window.vala"
	_data23_ = g_slice_new0 (Block23Data);
#line 2580 "../src/client/application/application-main-window.vala"
	_data23_->_ref_count_ = 1;
#line 2580 "../src/client/application/application-main-window.vala"
	_data23_->self = g_object_ref (self);
#line 2581 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2581 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 2581 "../src/client/application/application-main-window.vala"
	_data23_->location = _tmp1_;
#line 2582 "../src/client/application/application-main-window.vala"
	_tmp2_ = _data23_->location;
#line 2582 "../src/client/application/application-main-window.vala"
	if (_tmp2_ != NULL) {
#line 16106 "application-main-window.c"
		ApplicationController* _tmp3_;
		GearyFolder* _tmp4_;
		ConversationListView* _tmp5_;
		GeeSet* _tmp6_;
		GeeSet* _tmp7_;
		GearyNamedFlag* _tmp8_;
		GearyNamedFlag* _tmp9_;
		GearyNamedFlag* _tmp10_;
#line 2583 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->controller;
#line 2583 "../src/client/application/application-main-window.vala"
		_tmp4_ = _data23_->location;
#line 2583 "../src/client/application/application-main-window.vala"
		_tmp5_ = self->priv->_conversation_list_view;
#line 2583 "../src/client/application/application-main-window.vala"
		_tmp6_ = conversation_list_view_copy_selected (_tmp5_);
#line 2583 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 2583 "../src/client/application/application-main-window.vala"
		_tmp8_ = geary_email_flags_get_FLAGGED ();
#line 2583 "../src/client/application/application-main-window.vala"
		_tmp9_ = _tmp8_;
#line 2583 "../src/client/application/application-main-window.vala"
		_tmp10_ = _tmp9_;
#line 2583 "../src/client/application/application-main-window.vala"
		application_controller_mark_conversations (_tmp3_, _tmp4_, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection), _tmp10_, TRUE, ____lambda190__gasync_ready_callback, block23_data_ref (_data23_));
#line 2583 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp10_);
#line 2583 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp7_);
#line 16137 "application-main-window.c"
	}
#line 2580 "../src/client/application/application-main-window.vala"
	block23_data_unref (_data23_);
#line 2580 "../src/client/application/application-main-window.vala"
	_data23_ = NULL;
#line 16143 "application-main-window.c"
}

static Block24Data*
block24_data_ref (Block24Data* _data24_)
{
#line 2599 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data24_->_ref_count_);
#line 2599 "../src/client/application/application-main-window.vala"
	return _data24_;
#line 16153 "application-main-window.c"
}

static void
block24_data_unref (void * _userdata_)
{
	Block24Data* _data24_;
	_data24_ = (Block24Data*) _userdata_;
#line 2599 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data24_->_ref_count_)) {
#line 16163 "application-main-window.c"
		ApplicationMainWindow* self;
#line 2599 "../src/client/application/application-main-window.vala"
		self = _data24_->self;
#line 2599 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data24_->location);
#line 2599 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 2599 "../src/client/application/application-main-window.vala"
		g_slice_free (Block24Data, _data24_);
#line 16173 "application-main-window.c"
	}
}

static void
___lambda191_ (Block24Data* _data24_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 2607 "../src/client/application/application-main-window.vala"
	self = _data24_->self;
#line 2607 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 2607 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 16190 "application-main-window.c"
	{
		ApplicationController* _tmp0_;
#line 2609 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->controller;
#line 2609 "../src/client/application/application-main-window.vala"
		application_controller_mark_conversations_finish (_tmp0_, res, &_inner_error0_);
#line 2609 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16199 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolder* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAccountInformation* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GError* _tmp6_;
#line 2608 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 2608 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 2611 "../src/client/application/application-main-window.vala"
		_tmp1_ = _data24_->location;
#line 2611 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_account (_tmp1_);
#line 2611 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 2611 "../src/client/application/application-main-window.vala"
		_tmp4_ = geary_account_get_information (_tmp3_);
#line 2611 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2611 "../src/client/application/application-main-window.vala"
		_tmp6_ = err;
#line 2611 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp5_, _tmp6_);
#line 2608 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 16233 "application-main-window.c"
	}
	__finally0:
#line 2608 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2608 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2608 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 2608 "../src/client/application/application-main-window.vala"
		return;
#line 16244 "application-main-window.c"
	}
}

static void
____lambda191__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 2602 "../src/client/application/application-main-window.vala"
	___lambda191_ (self, source_object, res);
#line 2602 "../src/client/application/application-main-window.vala"
	block24_data_unref (self);
#line 16257 "application-main-window.c"
}

static void
application_main_window_on_mark_as_unstarred (ApplicationMainWindow* self)
{
	Block24Data* _data24_;
	GearyFolder* _tmp0_;
	GearyFolder* _tmp1_;
	GearyFolder* _tmp2_;
#line 2599 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2599 "../src/client/application/application-main-window.vala"
	_data24_ = g_slice_new0 (Block24Data);
#line 2599 "../src/client/application/application-main-window.vala"
	_data24_->_ref_count_ = 1;
#line 2599 "../src/client/application/application-main-window.vala"
	_data24_->self = g_object_ref (self);
#line 2600 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2600 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 2600 "../src/client/application/application-main-window.vala"
	_data24_->location = _tmp1_;
#line 2601 "../src/client/application/application-main-window.vala"
	_tmp2_ = _data24_->location;
#line 2601 "../src/client/application/application-main-window.vala"
	if (_tmp2_ != NULL) {
#line 16285 "application-main-window.c"
		ApplicationController* _tmp3_;
		GearyFolder* _tmp4_;
		ConversationListView* _tmp5_;
		GeeSet* _tmp6_;
		GeeSet* _tmp7_;
		GearyNamedFlag* _tmp8_;
		GearyNamedFlag* _tmp9_;
		GearyNamedFlag* _tmp10_;
#line 2602 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->controller;
#line 2602 "../src/client/application/application-main-window.vala"
		_tmp4_ = _data24_->location;
#line 2602 "../src/client/application/application-main-window.vala"
		_tmp5_ = self->priv->_conversation_list_view;
#line 2602 "../src/client/application/application-main-window.vala"
		_tmp6_ = conversation_list_view_copy_selected (_tmp5_);
#line 2602 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 2602 "../src/client/application/application-main-window.vala"
		_tmp8_ = geary_email_flags_get_FLAGGED ();
#line 2602 "../src/client/application/application-main-window.vala"
		_tmp9_ = _tmp8_;
#line 2602 "../src/client/application/application-main-window.vala"
		_tmp10_ = _tmp9_;
#line 2602 "../src/client/application/application-main-window.vala"
		application_controller_mark_conversations (_tmp3_, _tmp4_, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection), _tmp10_, FALSE, ____lambda191__gasync_ready_callback, block24_data_ref (_data24_));
#line 2602 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp10_);
#line 2602 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp7_);
#line 16316 "application-main-window.c"
	}
#line 2599 "../src/client/application/application-main-window.vala"
	block24_data_unref (_data24_);
#line 2599 "../src/client/application/application-main-window.vala"
	_data24_ = NULL;
#line 16322 "application-main-window.c"
}

static Block25Data*
block25_data_ref (Block25Data* _data25_)
{
#line 2618 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data25_->_ref_count_);
#line 2618 "../src/client/application/application-main-window.vala"
	return _data25_;
#line 16332 "application-main-window.c"
}

static void
block25_data_unref (void * _userdata_)
{
	Block25Data* _data25_;
	_data25_ = (Block25Data*) _userdata_;
#line 2618 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data25_->_ref_count_)) {
#line 16342 "application-main-window.c"
		ApplicationMainWindow* self;
#line 2618 "../src/client/application/application-main-window.vala"
		self = _data25_->self;
#line 2618 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data25_->source);
#line 2618 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 2618 "../src/client/application/application-main-window.vala"
		g_slice_free (Block25Data, _data25_);
#line 16352 "application-main-window.c"
	}
}

static void
___lambda192_ (Block25Data* _data25_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 2629 "../src/client/application/application-main-window.vala"
	self = _data25_->self;
#line 2629 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 2629 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 16369 "application-main-window.c"
	{
		ApplicationController* _tmp0_;
#line 2631 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->controller;
#line 2631 "../src/client/application/application-main-window.vala"
		application_controller_move_conversations_special_finish (_tmp0_, res, &_inner_error0_);
#line 2631 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16378 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolder* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAccountInformation* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GError* _tmp6_;
#line 2630 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 2630 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 2633 "../src/client/application/application-main-window.vala"
		_tmp1_ = _data25_->source;
#line 2633 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_account (_tmp1_);
#line 2633 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 2633 "../src/client/application/application-main-window.vala"
		_tmp4_ = geary_account_get_information (_tmp3_);
#line 2633 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2633 "../src/client/application/application-main-window.vala"
		_tmp6_ = err;
#line 2633 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp5_, _tmp6_);
#line 2630 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 16412 "application-main-window.c"
	}
	__finally0:
#line 2630 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2630 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2630 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 2630 "../src/client/application/application-main-window.vala"
		return;
#line 16423 "application-main-window.c"
	}
}

static void
____lambda192__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 2625 "../src/client/application/application-main-window.vala"
	___lambda192_ (self, source_object, res);
#line 2625 "../src/client/application/application-main-window.vala"
	block25_data_unref (self);
#line 16436 "application-main-window.c"
}

static void
application_main_window_on_mark_as_junk_toggle (ApplicationMainWindow* self)
{
	Block25Data* _data25_;
	GearyFolder* _tmp0_;
	GearyFolder* _tmp1_;
	GearyFolder* _tmp2_;
#line 2618 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2618 "../src/client/application/application-main-window.vala"
	_data25_ = g_slice_new0 (Block25Data);
#line 2618 "../src/client/application/application-main-window.vala"
	_data25_->_ref_count_ = 1;
#line 2618 "../src/client/application/application-main-window.vala"
	_data25_->self = g_object_ref (self);
#line 2619 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2619 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 2619 "../src/client/application/application-main-window.vala"
	_data25_->source = _tmp1_;
#line 2620 "../src/client/application/application-main-window.vala"
	_tmp2_ = _data25_->source;
#line 2620 "../src/client/application/application-main-window.vala"
	if (_tmp2_ != NULL) {
#line 16464 "application-main-window.c"
		GearyFolderSpecialUse _tmp3_ = 0;
		GearyFolder* _tmp4_;
		GearyFolderSpecialUse _tmp5_;
		GearyFolderSpecialUse _tmp6_;
		GearyFolderSpecialUse destination = 0;
		ApplicationController* _tmp7_;
		GearyFolder* _tmp8_;
		ConversationListView* _tmp9_;
		GeeSet* _tmp10_;
		GeeSet* _tmp11_;
#line 2622 "../src/client/application/application-main-window.vala"
		_tmp4_ = _data25_->source;
#line 2622 "../src/client/application/application-main-window.vala"
		_tmp5_ = geary_folder_get_used_as (_tmp4_);
#line 2622 "../src/client/application/application-main-window.vala"
		_tmp6_ = _tmp5_;
#line 2622 "../src/client/application/application-main-window.vala"
		if (_tmp6_ != GEARY_FOLDER_SPECIAL_USE_JUNK) {
#line 2623 "../src/client/application/application-main-window.vala"
			_tmp3_ = GEARY_FOLDER_SPECIAL_USE_JUNK;
#line 16485 "application-main-window.c"
		} else {
#line 2624 "../src/client/application/application-main-window.vala"
			_tmp3_ = GEARY_FOLDER_SPECIAL_USE_INBOX;
#line 16489 "application-main-window.c"
		}
#line 2621 "../src/client/application/application-main-window.vala"
		destination = _tmp3_;
#line 2625 "../src/client/application/application-main-window.vala"
		_tmp7_ = self->priv->controller;
#line 2625 "../src/client/application/application-main-window.vala"
		_tmp8_ = _data25_->source;
#line 2625 "../src/client/application/application-main-window.vala"
		_tmp9_ = self->priv->_conversation_list_view;
#line 2625 "../src/client/application/application-main-window.vala"
		_tmp10_ = conversation_list_view_copy_selected (_tmp9_);
#line 2625 "../src/client/application/application-main-window.vala"
		_tmp11_ = _tmp10_;
#line 2625 "../src/client/application/application-main-window.vala"
		application_controller_move_conversations_special (_tmp7_, _tmp8_, destination, G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_COLLECTION, GeeCollection), ____lambda192__gasync_ready_callback, block25_data_ref (_data25_));
#line 2625 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp11_);
#line 16507 "application-main-window.c"
	}
#line 2618 "../src/client/application/application-main-window.vala"
	block25_data_unref (_data25_);
#line 2618 "../src/client/application/application-main-window.vala"
	_data25_ = NULL;
#line 16513 "application-main-window.c"
}

static Block26Data*
block26_data_ref (Block26Data* _data26_)
{
#line 2640 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data26_->_ref_count_);
#line 2640 "../src/client/application/application-main-window.vala"
	return _data26_;
#line 16523 "application-main-window.c"
}

static void
block26_data_unref (void * _userdata_)
{
	Block26Data* _data26_;
	_data26_ = (Block26Data*) _userdata_;
#line 2640 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data26_->_ref_count_)) {
#line 16533 "application-main-window.c"
		ApplicationMainWindow* self;
#line 2640 "../src/client/application/application-main-window.vala"
		self = _data26_->self;
#line 2640 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data26_->source);
#line 2640 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 2640 "../src/client/application/application-main-window.vala"
		g_slice_free (Block26Data, _data26_);
#line 16543 "application-main-window.c"
	}
}

static void
___lambda195_ (Block26Data* _data26_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 2648 "../src/client/application/application-main-window.vala"
	self = _data26_->self;
#line 2648 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 2648 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 16560 "application-main-window.c"
	{
		ApplicationController* _tmp0_;
#line 2650 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->controller;
#line 2650 "../src/client/application/application-main-window.vala"
		application_controller_move_conversations_finish (_tmp0_, res, &_inner_error0_);
#line 2650 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16569 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolderSupportMove* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAccountInformation* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GError* _tmp6_;
#line 2649 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 2649 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 2652 "../src/client/application/application-main-window.vala"
		_tmp1_ = _data26_->source;
#line 2652 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_account (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEARY_TYPE_FOLDER, GearyFolder));
#line 2652 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 2652 "../src/client/application/application-main-window.vala"
		_tmp4_ = geary_account_get_information (_tmp3_);
#line 2652 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2652 "../src/client/application/application-main-window.vala"
		_tmp6_ = err;
#line 2652 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp5_, _tmp6_);
#line 2649 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 16603 "application-main-window.c"
	}
	__finally0:
#line 2649 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2649 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2649 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 2649 "../src/client/application/application-main-window.vala"
		return;
#line 16614 "application-main-window.c"
	}
}

static void
____lambda195__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 2644 "../src/client/application/application-main-window.vala"
	___lambda195_ (self, source_object, res);
#line 2644 "../src/client/application/application-main-window.vala"
	block26_data_unref (self);
#line 16627 "application-main-window.c"
}

static void
application_main_window_on_move_conversation (ApplicationMainWindow* self,
                                              GearyFolder* destination)
{
	Block26Data* _data26_;
	GearyFolder* _tmp0_;
	GearyFolderSupportMove* _tmp1_;
	GearyFolderSupportMove* _tmp2_;
#line 2640 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2640 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (destination, GEARY_TYPE_FOLDER));
#line 2640 "../src/client/application/application-main-window.vala"
	_data26_ = g_slice_new0 (Block26Data);
#line 2640 "../src/client/application/application-main-window.vala"
	_data26_->_ref_count_ = 1;
#line 2640 "../src/client/application/application-main-window.vala"
	_data26_->self = g_object_ref (self);
#line 2641 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2641 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GEARY_FOLDER_SUPPORT_TYPE_MOVE) ? ((GearyFolderSupportMove*) _tmp0_) : NULL);
#line 2641 "../src/client/application/application-main-window.vala"
	_data26_->source = _tmp1_;
#line 2643 "../src/client/application/application-main-window.vala"
	_tmp2_ = _data26_->source;
#line 2643 "../src/client/application/application-main-window.vala"
	if (_tmp2_ != NULL) {
#line 16658 "application-main-window.c"
		ApplicationController* _tmp3_;
		GearyFolderSupportMove* _tmp4_;
		ConversationListView* _tmp5_;
		GeeSet* _tmp6_;
		GeeSet* _tmp7_;
#line 2644 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->controller;
#line 2644 "../src/client/application/application-main-window.vala"
		_tmp4_ = _data26_->source;
#line 2644 "../src/client/application/application-main-window.vala"
		_tmp5_ = self->priv->_conversation_list_view;
#line 2644 "../src/client/application/application-main-window.vala"
		_tmp6_ = conversation_list_view_copy_selected (_tmp5_);
#line 2644 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 2644 "../src/client/application/application-main-window.vala"
		application_controller_move_conversations (_tmp3_, _tmp4_, destination, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection), ____lambda195__gasync_ready_callback, block26_data_ref (_data26_));
#line 2644 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp7_);
#line 16678 "application-main-window.c"
	}
#line 2640 "../src/client/application/application-main-window.vala"
	block26_data_unref (_data26_);
#line 2640 "../src/client/application/application-main-window.vala"
	_data26_ = NULL;
#line 16684 "application-main-window.c"
}

static Block27Data*
block27_data_ref (Block27Data* _data27_)
{
#line 2660 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data27_->_ref_count_);
#line 2660 "../src/client/application/application-main-window.vala"
	return _data27_;
#line 16694 "application-main-window.c"
}

static void
block27_data_unref (void * _userdata_)
{
	Block27Data* _data27_;
	_data27_ = (Block27Data*) _userdata_;
#line 2660 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data27_->_ref_count_)) {
#line 16704 "application-main-window.c"
		ApplicationMainWindow* self;
#line 2660 "../src/client/application/application-main-window.vala"
		self = _data27_->self;
#line 2660 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data27_->source);
#line 2660 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 2660 "../src/client/application/application-main-window.vala"
		g_slice_free (Block27Data, _data27_);
#line 16714 "application-main-window.c"
	}
}

static void
___lambda196_ (Block27Data* _data27_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 2668 "../src/client/application/application-main-window.vala"
	self = _data27_->self;
#line 2668 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 2668 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 16731 "application-main-window.c"
	{
		ApplicationController* _tmp0_;
#line 2670 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->controller;
#line 2670 "../src/client/application/application-main-window.vala"
		application_controller_copy_conversations_finish (_tmp0_, res, &_inner_error0_);
#line 2670 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16740 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolderSupportCopy* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAccountInformation* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GError* _tmp6_;
#line 2669 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 2669 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 2672 "../src/client/application/application-main-window.vala"
		_tmp1_ = _data27_->source;
#line 2672 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_account (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEARY_TYPE_FOLDER, GearyFolder));
#line 2672 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 2672 "../src/client/application/application-main-window.vala"
		_tmp4_ = geary_account_get_information (_tmp3_);
#line 2672 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2672 "../src/client/application/application-main-window.vala"
		_tmp6_ = err;
#line 2672 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp5_, _tmp6_);
#line 2669 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 16774 "application-main-window.c"
	}
	__finally0:
#line 2669 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2669 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2669 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 2669 "../src/client/application/application-main-window.vala"
		return;
#line 16785 "application-main-window.c"
	}
}

static void
____lambda196__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 2664 "../src/client/application/application-main-window.vala"
	___lambda196_ (self, source_object, res);
#line 2664 "../src/client/application/application-main-window.vala"
	block27_data_unref (self);
#line 16798 "application-main-window.c"
}

static void
application_main_window_on_copy_conversation (ApplicationMainWindow* self,
                                              GearyFolder* destination)
{
	Block27Data* _data27_;
	GearyFolder* _tmp0_;
	GearyFolderSupportCopy* _tmp1_;
	GearyFolderSupportCopy* _tmp2_;
#line 2660 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2660 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (destination, GEARY_TYPE_FOLDER));
#line 2660 "../src/client/application/application-main-window.vala"
	_data27_ = g_slice_new0 (Block27Data);
#line 2660 "../src/client/application/application-main-window.vala"
	_data27_->_ref_count_ = 1;
#line 2660 "../src/client/application/application-main-window.vala"
	_data27_->self = g_object_ref (self);
#line 2661 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2661 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GEARY_FOLDER_SUPPORT_TYPE_COPY) ? ((GearyFolderSupportCopy*) _tmp0_) : NULL);
#line 2661 "../src/client/application/application-main-window.vala"
	_data27_->source = _tmp1_;
#line 2663 "../src/client/application/application-main-window.vala"
	_tmp2_ = _data27_->source;
#line 2663 "../src/client/application/application-main-window.vala"
	if (_tmp2_ != NULL) {
#line 16829 "application-main-window.c"
		ApplicationController* _tmp3_;
		GearyFolderSupportCopy* _tmp4_;
		ConversationListView* _tmp5_;
		GeeSet* _tmp6_;
		GeeSet* _tmp7_;
#line 2664 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->controller;
#line 2664 "../src/client/application/application-main-window.vala"
		_tmp4_ = _data27_->source;
#line 2664 "../src/client/application/application-main-window.vala"
		_tmp5_ = self->priv->_conversation_list_view;
#line 2664 "../src/client/application/application-main-window.vala"
		_tmp6_ = conversation_list_view_copy_selected (_tmp5_);
#line 2664 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 2664 "../src/client/application/application-main-window.vala"
		application_controller_copy_conversations (_tmp3_, _tmp4_, destination, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection), ____lambda196__gasync_ready_callback, block27_data_ref (_data27_));
#line 2664 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp7_);
#line 16849 "application-main-window.c"
	}
#line 2660 "../src/client/application/application-main-window.vala"
	block27_data_unref (_data27_);
#line 2660 "../src/client/application/application-main-window.vala"
	_data27_ = NULL;
#line 16855 "application-main-window.c"
}

static Block28Data*
block28_data_ref (Block28Data* _data28_)
{
#line 2680 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data28_->_ref_count_);
#line 2680 "../src/client/application/application-main-window.vala"
	return _data28_;
#line 16865 "application-main-window.c"
}

static void
block28_data_unref (void * _userdata_)
{
	Block28Data* _data28_;
	_data28_ = (Block28Data*) _userdata_;
#line 2680 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data28_->_ref_count_)) {
#line 16875 "application-main-window.c"
		ApplicationMainWindow* self;
#line 2680 "../src/client/application/application-main-window.vala"
		self = _data28_->self;
#line 2680 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data28_->source);
#line 2680 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 2680 "../src/client/application/application-main-window.vala"
		g_slice_free (Block28Data, _data28_);
#line 16885 "application-main-window.c"
	}
}

static void
___lambda185_ (Block28Data* _data28_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 2687 "../src/client/application/application-main-window.vala"
	self = _data28_->self;
#line 2687 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 2687 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 16902 "application-main-window.c"
	{
		ApplicationController* _tmp0_;
#line 2689 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->controller;
#line 2689 "../src/client/application/application-main-window.vala"
		application_controller_move_conversations_special_finish (_tmp0_, res, &_inner_error0_);
#line 2689 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16911 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolder* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAccountInformation* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GError* _tmp6_;
#line 2688 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 2688 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 2691 "../src/client/application/application-main-window.vala"
		_tmp1_ = _data28_->source;
#line 2691 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_account (_tmp1_);
#line 2691 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 2691 "../src/client/application/application-main-window.vala"
		_tmp4_ = geary_account_get_information (_tmp3_);
#line 2691 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2691 "../src/client/application/application-main-window.vala"
		_tmp6_ = err;
#line 2691 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp5_, _tmp6_);
#line 2688 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 16945 "application-main-window.c"
	}
	__finally0:
#line 2688 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2688 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2688 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 2688 "../src/client/application/application-main-window.vala"
		return;
#line 16956 "application-main-window.c"
	}
}

static void
____lambda185__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 2683 "../src/client/application/application-main-window.vala"
	___lambda185_ (self, source_object, res);
#line 2683 "../src/client/application/application-main-window.vala"
	block28_data_unref (self);
#line 16969 "application-main-window.c"
}

static void
application_main_window_on_archive_conversation (ApplicationMainWindow* self)
{
	Block28Data* _data28_;
	GearyFolder* _tmp0_;
	GearyFolder* _tmp1_;
	GearyFolder* _tmp2_;
#line 2680 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2680 "../src/client/application/application-main-window.vala"
	_data28_ = g_slice_new0 (Block28Data);
#line 2680 "../src/client/application/application-main-window.vala"
	_data28_->_ref_count_ = 1;
#line 2680 "../src/client/application/application-main-window.vala"
	_data28_->self = g_object_ref (self);
#line 2681 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2681 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 2681 "../src/client/application/application-main-window.vala"
	_data28_->source = _tmp1_;
#line 2682 "../src/client/application/application-main-window.vala"
	_tmp2_ = _data28_->source;
#line 2682 "../src/client/application/application-main-window.vala"
	if (_tmp2_ != NULL) {
#line 16997 "application-main-window.c"
		ApplicationController* _tmp3_;
		GearyFolder* _tmp4_;
		ConversationListView* _tmp5_;
		GeeSet* _tmp6_;
		GeeSet* _tmp7_;
#line 2683 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->controller;
#line 2683 "../src/client/application/application-main-window.vala"
		_tmp4_ = _data28_->source;
#line 2683 "../src/client/application/application-main-window.vala"
		_tmp5_ = self->priv->_conversation_list_view;
#line 2683 "../src/client/application/application-main-window.vala"
		_tmp6_ = conversation_list_view_copy_selected (_tmp5_);
#line 2683 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 2683 "../src/client/application/application-main-window.vala"
		application_controller_move_conversations_special (_tmp3_, _tmp4_, GEARY_FOLDER_SPECIAL_USE_ARCHIVE, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection), ____lambda185__gasync_ready_callback, block28_data_ref (_data28_));
#line 2683 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp7_);
#line 17017 "application-main-window.c"
	}
#line 2680 "../src/client/application/application-main-window.vala"
	block28_data_unref (_data28_);
#line 2680 "../src/client/application/application-main-window.vala"
	_data28_ = NULL;
#line 17023 "application-main-window.c"
}

static Block29Data*
block29_data_ref (Block29Data* _data29_)
{
#line 2698 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data29_->_ref_count_);
#line 2698 "../src/client/application/application-main-window.vala"
	return _data29_;
#line 17033 "application-main-window.c"
}

static void
block29_data_unref (void * _userdata_)
{
	Block29Data* _data29_;
	_data29_ = (Block29Data*) _userdata_;
#line 2698 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data29_->_ref_count_)) {
#line 17043 "application-main-window.c"
		ApplicationMainWindow* self;
#line 2698 "../src/client/application/application-main-window.vala"
		self = _data29_->self;
#line 2698 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data29_->source);
#line 2698 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 2698 "../src/client/application/application-main-window.vala"
		g_slice_free (Block29Data, _data29_);
#line 17053 "application-main-window.c"
	}
}

static void
___lambda186_ (Block29Data* _data29_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 2705 "../src/client/application/application-main-window.vala"
	self = _data29_->self;
#line 2705 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 2705 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 17070 "application-main-window.c"
	{
		ApplicationController* _tmp0_;
#line 2707 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->controller;
#line 2707 "../src/client/application/application-main-window.vala"
		application_controller_move_conversations_special_finish (_tmp0_, res, &_inner_error0_);
#line 2707 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17079 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolder* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAccountInformation* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GError* _tmp6_;
#line 2706 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 2706 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 2709 "../src/client/application/application-main-window.vala"
		_tmp1_ = _data29_->source;
#line 2709 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_account (_tmp1_);
#line 2709 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 2709 "../src/client/application/application-main-window.vala"
		_tmp4_ = geary_account_get_information (_tmp3_);
#line 2709 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2709 "../src/client/application/application-main-window.vala"
		_tmp6_ = err;
#line 2709 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp5_, _tmp6_);
#line 2706 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 17113 "application-main-window.c"
	}
	__finally0:
#line 2706 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2706 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2706 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 2706 "../src/client/application/application-main-window.vala"
		return;
#line 17124 "application-main-window.c"
	}
}

static void
____lambda186__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 2701 "../src/client/application/application-main-window.vala"
	___lambda186_ (self, source_object, res);
#line 2701 "../src/client/application/application-main-window.vala"
	block29_data_unref (self);
#line 17137 "application-main-window.c"
}

static void
application_main_window_on_trash_conversation (ApplicationMainWindow* self)
{
	Block29Data* _data29_;
	GearyFolder* _tmp0_;
	GearyFolder* _tmp1_;
	GearyFolder* _tmp2_;
#line 2698 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2698 "../src/client/application/application-main-window.vala"
	_data29_ = g_slice_new0 (Block29Data);
#line 2698 "../src/client/application/application-main-window.vala"
	_data29_->_ref_count_ = 1;
#line 2698 "../src/client/application/application-main-window.vala"
	_data29_->self = g_object_ref (self);
#line 2699 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2699 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 2699 "../src/client/application/application-main-window.vala"
	_data29_->source = _tmp1_;
#line 2700 "../src/client/application/application-main-window.vala"
	_tmp2_ = _data29_->source;
#line 2700 "../src/client/application/application-main-window.vala"
	if (_tmp2_ != NULL) {
#line 17165 "application-main-window.c"
		ApplicationController* _tmp3_;
		GearyFolder* _tmp4_;
		ConversationListView* _tmp5_;
		GeeSet* _tmp6_;
		GeeSet* _tmp7_;
#line 2701 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->controller;
#line 2701 "../src/client/application/application-main-window.vala"
		_tmp4_ = _data29_->source;
#line 2701 "../src/client/application/application-main-window.vala"
		_tmp5_ = self->priv->_conversation_list_view;
#line 2701 "../src/client/application/application-main-window.vala"
		_tmp6_ = conversation_list_view_copy_selected (_tmp5_);
#line 2701 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 2701 "../src/client/application/application-main-window.vala"
		application_controller_move_conversations_special (_tmp3_, _tmp4_, GEARY_FOLDER_SPECIAL_USE_TRASH, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection), ____lambda186__gasync_ready_callback, block29_data_ref (_data29_));
#line 2701 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp7_);
#line 17185 "application-main-window.c"
	}
#line 2698 "../src/client/application/application-main-window.vala"
	block29_data_unref (_data29_);
#line 2698 "../src/client/application/application-main-window.vala"
	_data29_ = NULL;
#line 17191 "application-main-window.c"
}

static Block30Data*
block30_data_ref (Block30Data* _data30_)
{
#line 2716 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data30_->_ref_count_);
#line 2716 "../src/client/application/application-main-window.vala"
	return _data30_;
#line 17201 "application-main-window.c"
}

static void
block30_data_unref (void * _userdata_)
{
	Block30Data* _data30_;
	_data30_ = (Block30Data*) _userdata_;
#line 2716 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data30_->_ref_count_)) {
#line 17211 "application-main-window.c"
		ApplicationMainWindow* self;
#line 2716 "../src/client/application/application-main-window.vala"
		self = _data30_->self;
#line 2716 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data30_->target);
#line 2716 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 2716 "../src/client/application/application-main-window.vala"
		g_slice_free (Block30Data, _data30_);
#line 17221 "application-main-window.c"
	}
}

static void
___lambda187_ (Block30Data* _data30_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 2725 "../src/client/application/application-main-window.vala"
	self = _data30_->self;
#line 2725 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 2725 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 17238 "application-main-window.c"
	{
		ApplicationController* _tmp0_;
#line 2727 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->controller;
#line 2727 "../src/client/application/application-main-window.vala"
		application_controller_delete_conversations_finish (_tmp0_, res, &_inner_error0_);
#line 2727 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17247 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolderSupportRemove* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAccountInformation* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GError* _tmp6_;
#line 2726 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 2726 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 2729 "../src/client/application/application-main-window.vala"
		_tmp1_ = _data30_->target;
#line 2729 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_account (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEARY_TYPE_FOLDER, GearyFolder));
#line 2729 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 2729 "../src/client/application/application-main-window.vala"
		_tmp4_ = geary_account_get_information (_tmp3_);
#line 2729 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2729 "../src/client/application/application-main-window.vala"
		_tmp6_ = err;
#line 2729 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp5_, _tmp6_);
#line 2726 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 17281 "application-main-window.c"
	}
	__finally0:
#line 2726 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2726 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2726 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 2726 "../src/client/application/application-main-window.vala"
		return;
#line 17292 "application-main-window.c"
	}
}

static void
____lambda187__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 2722 "../src/client/application/application-main-window.vala"
	___lambda187_ (self, source_object, res);
#line 2722 "../src/client/application/application-main-window.vala"
	block30_data_unref (self);
#line 17305 "application-main-window.c"
}

static void
application_main_window_on_delete_conversation (ApplicationMainWindow* self)
{
	Block30Data* _data30_;
	GearyFolder* _tmp0_;
	GearyFolderSupportRemove* _tmp1_;
	GeeCollection* conversations = NULL;
	ConversationListView* _tmp2_;
	GeeSet* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GearyFolderSupportRemove* _tmp5_;
#line 2716 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2716 "../src/client/application/application-main-window.vala"
	_data30_ = g_slice_new0 (Block30Data);
#line 2716 "../src/client/application/application-main-window.vala"
	_data30_->_ref_count_ = 1;
#line 2716 "../src/client/application/application-main-window.vala"
	_data30_->self = g_object_ref (self);
#line 2717 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2717 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GEARY_FOLDER_SUPPORT_TYPE_REMOVE) ? ((GearyFolderSupportRemove*) _tmp0_) : NULL);
#line 2717 "../src/client/application/application-main-window.vala"
	_data30_->target = _tmp1_;
#line 2719 "../src/client/application/application-main-window.vala"
	_tmp2_ = self->priv->_conversation_list_view;
#line 2719 "../src/client/application/application-main-window.vala"
	_tmp3_ = conversation_list_view_copy_selected (_tmp2_);
#line 2719 "../src/client/application/application-main-window.vala"
	conversations = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection);
#line 2721 "../src/client/application/application-main-window.vala"
	_tmp5_ = _data30_->target;
#line 2721 "../src/client/application/application-main-window.vala"
	if (_tmp5_ != NULL) {
#line 17343 "application-main-window.c"
		GeeCollection* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 2721 "../src/client/application/application-main-window.vala"
		_tmp6_ = conversations;
#line 2721 "../src/client/application/application-main-window.vala"
		_tmp7_ = gee_collection_get_size (_tmp6_);
#line 2721 "../src/client/application/application-main-window.vala"
		_tmp8_ = _tmp7_;
#line 2721 "../src/client/application/application-main-window.vala"
		_tmp4_ = application_main_window_prompt_delete_conversations (self, _tmp8_);
#line 17355 "application-main-window.c"
	} else {
#line 2721 "../src/client/application/application-main-window.vala"
		_tmp4_ = FALSE;
#line 17359 "application-main-window.c"
	}
#line 2721 "../src/client/application/application-main-window.vala"
	if (_tmp4_) {
#line 17363 "application-main-window.c"
		ApplicationController* _tmp9_;
		GearyFolderSupportRemove* _tmp10_;
		GeeCollection* _tmp11_;
#line 2722 "../src/client/application/application-main-window.vala"
		_tmp9_ = self->priv->controller;
#line 2722 "../src/client/application/application-main-window.vala"
		_tmp10_ = _data30_->target;
#line 2722 "../src/client/application/application-main-window.vala"
		_tmp11_ = conversations;
#line 2722 "../src/client/application/application-main-window.vala"
		application_controller_delete_conversations (_tmp9_, _tmp10_, _tmp11_, ____lambda187__gasync_ready_callback, block30_data_ref (_data30_));
#line 17375 "application-main-window.c"
	}
#line 2716 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (conversations);
#line 2716 "../src/client/application/application-main-window.vala"
	block30_data_unref (_data30_);
#line 2716 "../src/client/application/application-main-window.vala"
	_data30_ = NULL;
#line 17383 "application-main-window.c"
}

static void
application_main_window_on_email_loaded (ApplicationMainWindow* self,
                                         ConversationListBox* view,
                                         GearyEmail* loaded)
{
	ApplicationController* _tmp0_;
	GearyAppConversation* _tmp1_;
	GearyAppConversation* _tmp2_;
	GearyFolder* _tmp3_;
	GearyFolder* _tmp4_;
	GearyAccount* _tmp5_;
	GearyAccount* _tmp6_;
	GearyAccountInformation* _tmp7_;
	GearyAccountInformation* _tmp8_;
#line 2736 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2736 "../src/client/application/application-main-window.vala"
	g_return_if_fail (IS_CONVERSATION_LIST_BOX (view));
#line 2736 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (loaded, GEARY_TYPE_EMAIL));
#line 2738 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->controller;
#line 2738 "../src/client/application/application-main-window.vala"
	_tmp1_ = conversation_list_box_get_conversation (view);
#line 2738 "../src/client/application/application-main-window.vala"
	_tmp2_ = _tmp1_;
#line 2738 "../src/client/application/application-main-window.vala"
	_tmp3_ = geary_app_conversation_get_base_folder (_tmp2_);
#line 2738 "../src/client/application/application-main-window.vala"
	_tmp4_ = _tmp3_;
#line 2738 "../src/client/application/application-main-window.vala"
	_tmp5_ = geary_folder_get_account (_tmp4_);
#line 2738 "../src/client/application/application-main-window.vala"
	_tmp6_ = _tmp5_;
#line 2738 "../src/client/application/application-main-window.vala"
	_tmp7_ = geary_account_get_information (_tmp6_);
#line 2738 "../src/client/application/application-main-window.vala"
	_tmp8_ = _tmp7_;
#line 2738 "../src/client/application/application-main-window.vala"
	application_controller_email_loaded (_tmp0_, _tmp8_, loaded);
#line 17426 "application-main-window.c"
}

static Block31Data*
block31_data_ref (Block31Data* _data31_)
{
#line 2744 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data31_->_ref_count_);
#line 2744 "../src/client/application/application-main-window.vala"
	return _data31_;
#line 17436 "application-main-window.c"
}

static void
block31_data_unref (void * _userdata_)
{
	Block31Data* _data31_;
	_data31_ = (Block31Data*) _userdata_;
#line 2744 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data31_->_ref_count_)) {
#line 17446 "application-main-window.c"
		ApplicationMainWindow* self;
#line 2744 "../src/client/application/application-main-window.vala"
		self = _data31_->self;
#line 2744 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data31_->location);
#line 2744 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 2744 "../src/client/application/application-main-window.vala"
		g_slice_free (Block31Data, _data31_);
#line 17456 "application-main-window.c"
	}
}

static void
___lambda198_ (Block31Data* _data31_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 2766 "../src/client/application/application-main-window.vala"
	self = _data31_->self;
#line 2766 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 2766 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 17473 "application-main-window.c"
	{
		ApplicationController* _tmp0_;
#line 2768 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->controller;
#line 2768 "../src/client/application/application-main-window.vala"
		application_controller_mark_messages_finish (_tmp0_, res, &_inner_error0_);
#line 2768 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17482 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolder* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAccountInformation* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GError* _tmp6_;
#line 2767 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 2767 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 2770 "../src/client/application/application-main-window.vala"
		_tmp1_ = _data31_->location;
#line 2770 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_account (_tmp1_);
#line 2770 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 2770 "../src/client/application/application-main-window.vala"
		_tmp4_ = geary_account_get_information (_tmp3_);
#line 2770 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2770 "../src/client/application/application-main-window.vala"
		_tmp6_ = err;
#line 2770 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp5_, _tmp6_);
#line 2767 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 17516 "application-main-window.c"
	}
	__finally0:
#line 2767 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2767 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2767 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 2767 "../src/client/application/application-main-window.vala"
		return;
#line 17527 "application-main-window.c"
	}
}

static void
____lambda198__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 2760 "../src/client/application/application-main-window.vala"
	___lambda198_ (self, source_object, res);
#line 2760 "../src/client/application/application-main-window.vala"
	block31_data_unref (self);
#line 17540 "application-main-window.c"
}

static void
application_main_window_on_email_mark (ApplicationMainWindow* self,
                                       ConversationListBox* view,
                                       GeeCollection* messages,
                                       GearyNamedFlag* to_add,
                                       GearyNamedFlag* to_remove)
{
	Block31Data* _data31_;
	GearyFolder* _tmp0_;
	GearyFolder* _tmp1_;
	GearyFolder* _tmp2_;
#line 2744 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2744 "../src/client/application/application-main-window.vala"
	g_return_if_fail (IS_CONVERSATION_LIST_BOX (view));
#line 2744 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (messages, GEE_TYPE_COLLECTION));
#line 2744 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((to_add == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (to_add, GEARY_TYPE_NAMED_FLAG));
#line 2744 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((to_remove == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (to_remove, GEARY_TYPE_NAMED_FLAG));
#line 2744 "../src/client/application/application-main-window.vala"
	_data31_ = g_slice_new0 (Block31Data);
#line 2744 "../src/client/application/application-main-window.vala"
	_data31_->_ref_count_ = 1;
#line 2744 "../src/client/application/application-main-window.vala"
	_data31_->self = g_object_ref (self);
#line 2748 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2748 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 2748 "../src/client/application/application-main-window.vala"
	_data31_->location = _tmp1_;
#line 2749 "../src/client/application/application-main-window.vala"
	_tmp2_ = _data31_->location;
#line 2749 "../src/client/application/application-main-window.vala"
	if (_tmp2_ != NULL) {
#line 17580 "application-main-window.c"
		GearyEmailFlags* add_flags = NULL;
		GearyEmailFlags* remove_flags = NULL;
		ApplicationController* _tmp7_;
		GearyFolder* _tmp8_;
		GearyAppConversation* _tmp9_;
		GearyAppConversation* _tmp10_;
		GeeCollection* _tmp11_;
		GeeCollection* _tmp12_;
		GearyEmailFlags* _tmp13_;
		GearyEmailFlags* _tmp14_;
#line 2750 "../src/client/application/application-main-window.vala"
		add_flags = NULL;
#line 2751 "../src/client/application/application-main-window.vala"
		if (to_add != NULL) {
#line 17595 "application-main-window.c"
			GearyEmailFlags* _tmp3_;
			GearyEmailFlags* _tmp4_;
#line 2752 "../src/client/application/application-main-window.vala"
			_tmp3_ = geary_email_flags_new ();
#line 2752 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (add_flags);
#line 2752 "../src/client/application/application-main-window.vala"
			add_flags = _tmp3_;
#line 2753 "../src/client/application/application-main-window.vala"
			_tmp4_ = add_flags;
#line 2753 "../src/client/application/application-main-window.vala"
			geary_named_flags_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEARY_TYPE_NAMED_FLAGS, GearyNamedFlags), to_add);
#line 17608 "application-main-window.c"
		}
#line 2755 "../src/client/application/application-main-window.vala"
		remove_flags = NULL;
#line 2756 "../src/client/application/application-main-window.vala"
		if (to_remove != NULL) {
#line 17614 "application-main-window.c"
			GearyEmailFlags* _tmp5_;
			GearyEmailFlags* _tmp6_;
#line 2757 "../src/client/application/application-main-window.vala"
			_tmp5_ = geary_email_flags_new ();
#line 2757 "../src/client/application/application-main-window.vala"
			_g_object_unref0 (remove_flags);
#line 2757 "../src/client/application/application-main-window.vala"
			remove_flags = _tmp5_;
#line 2758 "../src/client/application/application-main-window.vala"
			_tmp6_ = remove_flags;
#line 2758 "../src/client/application/application-main-window.vala"
			geary_named_flags_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEARY_TYPE_NAMED_FLAGS, GearyNamedFlags), to_remove);
#line 17627 "application-main-window.c"
		}
#line 2760 "../src/client/application/application-main-window.vala"
		_tmp7_ = self->priv->controller;
#line 2760 "../src/client/application/application-main-window.vala"
		_tmp8_ = _data31_->location;
#line 2760 "../src/client/application/application-main-window.vala"
		_tmp9_ = conversation_list_box_get_conversation (view);
#line 2760 "../src/client/application/application-main-window.vala"
		_tmp10_ = _tmp9_;
#line 2760 "../src/client/application/application-main-window.vala"
		_tmp11_ = geary_collection_single (GEARY_APP_TYPE_CONVERSATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp10_);
#line 2760 "../src/client/application/application-main-window.vala"
		_tmp12_ = _tmp11_;
#line 2760 "../src/client/application/application-main-window.vala"
		_tmp13_ = add_flags;
#line 2760 "../src/client/application/application-main-window.vala"
		_tmp14_ = remove_flags;
#line 2760 "../src/client/application/application-main-window.vala"
		application_controller_mark_messages (_tmp7_, _tmp8_, _tmp12_, messages, _tmp13_, _tmp14_, ____lambda198__gasync_ready_callback, block31_data_ref (_data31_));
#line 2760 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp12_);
#line 2749 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (remove_flags);
#line 2749 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (add_flags);
#line 17653 "application-main-window.c"
	}
#line 2744 "../src/client/application/application-main-window.vala"
	block31_data_unref (_data31_);
#line 2744 "../src/client/application/application-main-window.vala"
	_data31_ = NULL;
#line 17659 "application-main-window.c"
}

static void
application_main_window_on_email_reply_to_sender (ApplicationMainWindow* self,
                                                  GearyEmail* target,
                                                  const gchar* quote)
{
	GearyAccount* _tmp0_;
#line 2777 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2777 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (target, GEARY_TYPE_EMAIL));
#line 2778 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_account;
#line 2778 "../src/client/application/application-main-window.vala"
	if (_tmp0_ != NULL) {
#line 17676 "application-main-window.c"
		GearyAccount* _tmp1_;
#line 2779 "../src/client/application/application-main-window.vala"
		_tmp1_ = self->priv->_selected_account;
#line 2779 "../src/client/application/application-main-window.vala"
		application_main_window_create_composer (self, _tmp1_, COMPOSER_WIDGET_CONTEXT_TYPE_REPLY_SENDER, target, quote, NULL, NULL);
#line 17682 "application-main-window.c"
	}
}

static void
application_main_window_on_email_reply_to_all (ApplicationMainWindow* self,
                                               GearyEmail* target,
                                               const gchar* quote)
{
	GearyAccount* _tmp0_;
#line 2785 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2785 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (target, GEARY_TYPE_EMAIL));
#line 2786 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_account;
#line 2786 "../src/client/application/application-main-window.vala"
	if (_tmp0_ != NULL) {
#line 17700 "application-main-window.c"
		GearyAccount* _tmp1_;
#line 2787 "../src/client/application/application-main-window.vala"
		_tmp1_ = self->priv->_selected_account;
#line 2787 "../src/client/application/application-main-window.vala"
		application_main_window_create_composer (self, _tmp1_, COMPOSER_WIDGET_CONTEXT_TYPE_REPLY_ALL, target, quote, NULL, NULL);
#line 17706 "application-main-window.c"
	}
}

static void
application_main_window_on_email_forward (ApplicationMainWindow* self,
                                          GearyEmail* target,
                                          const gchar* quote)
{
	GearyAccount* _tmp0_;
#line 2793 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2793 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (target, GEARY_TYPE_EMAIL));
#line 2794 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_account;
#line 2794 "../src/client/application/application-main-window.vala"
	if (_tmp0_ != NULL) {
#line 17724 "application-main-window.c"
		GearyAccount* _tmp1_;
#line 2795 "../src/client/application/application-main-window.vala"
		_tmp1_ = self->priv->_selected_account;
#line 2795 "../src/client/application/application-main-window.vala"
		application_main_window_create_composer (self, _tmp1_, COMPOSER_WIDGET_CONTEXT_TYPE_FORWARD, target, quote, NULL, NULL);
#line 17730 "application-main-window.c"
	}
}

static Block32Data*
block32_data_ref (Block32Data* _data32_)
{
#line 2801 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data32_->_ref_count_);
#line 2801 "../src/client/application/application-main-window.vala"
	return _data32_;
#line 17741 "application-main-window.c"
}

static void
block32_data_unref (void * _userdata_)
{
	Block32Data* _data32_;
	_data32_ = (Block32Data*) _userdata_;
#line 2801 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data32_->_ref_count_)) {
#line 17751 "application-main-window.c"
		ApplicationMainWindow* self;
#line 2801 "../src/client/application/application-main-window.vala"
		self = _data32_->self;
#line 2801 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data32_->source);
#line 2801 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 2801 "../src/client/application/application-main-window.vala"
		g_slice_free (Block32Data, _data32_);
#line 17761 "application-main-window.c"
	}
}

static void
___lambda199_ (Block32Data* _data32_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 2809 "../src/client/application/application-main-window.vala"
	self = _data32_->self;
#line 2809 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 2809 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 17778 "application-main-window.c"
	{
		ApplicationController* _tmp0_;
#line 2811 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->controller;
#line 2811 "../src/client/application/application-main-window.vala"
		application_controller_move_messages_special_finish (_tmp0_, res, &_inner_error0_);
#line 2811 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17787 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolder* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAccountInformation* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GError* _tmp6_;
#line 2810 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 2810 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 2813 "../src/client/application/application-main-window.vala"
		_tmp1_ = _data32_->source;
#line 2813 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_account (_tmp1_);
#line 2813 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 2813 "../src/client/application/application-main-window.vala"
		_tmp4_ = geary_account_get_information (_tmp3_);
#line 2813 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2813 "../src/client/application/application-main-window.vala"
		_tmp6_ = err;
#line 2813 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp5_, _tmp6_);
#line 2810 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 17821 "application-main-window.c"
	}
	__finally0:
#line 2810 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2810 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2810 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 2810 "../src/client/application/application-main-window.vala"
		return;
#line 17832 "application-main-window.c"
	}
}

static void
____lambda199__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 2804 "../src/client/application/application-main-window.vala"
	___lambda199_ (self, source_object, res);
#line 2804 "../src/client/application/application-main-window.vala"
	block32_data_unref (self);
#line 17845 "application-main-window.c"
}

static void
application_main_window_on_email_trash (ApplicationMainWindow* self,
                                        ConversationListBox* view,
                                        GearyEmail* target)
{
	Block32Data* _data32_;
	GearyFolder* _tmp0_;
	GearyFolder* _tmp1_;
	GearyFolder* _tmp2_;
#line 2801 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2801 "../src/client/application/application-main-window.vala"
	g_return_if_fail (IS_CONVERSATION_LIST_BOX (view));
#line 2801 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (target, GEARY_TYPE_EMAIL));
#line 2801 "../src/client/application/application-main-window.vala"
	_data32_ = g_slice_new0 (Block32Data);
#line 2801 "../src/client/application/application-main-window.vala"
	_data32_->_ref_count_ = 1;
#line 2801 "../src/client/application/application-main-window.vala"
	_data32_->self = g_object_ref (self);
#line 2802 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2802 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 2802 "../src/client/application/application-main-window.vala"
	_data32_->source = _tmp1_;
#line 2803 "../src/client/application/application-main-window.vala"
	_tmp2_ = _data32_->source;
#line 2803 "../src/client/application/application-main-window.vala"
	if (_tmp2_ != NULL) {
#line 17879 "application-main-window.c"
		ApplicationController* _tmp3_;
		GearyFolder* _tmp4_;
		GearyAppConversation* _tmp5_;
		GearyAppConversation* _tmp6_;
		GeeCollection* _tmp7_;
		GeeCollection* _tmp8_;
		GearyEmailIdentifier* _tmp9_;
		GearyEmailIdentifier* _tmp10_;
		GeeCollection* _tmp11_;
		GeeCollection* _tmp12_;
#line 2804 "../src/client/application/application-main-window.vala"
		_tmp3_ = self->priv->controller;
#line 2804 "../src/client/application/application-main-window.vala"
		_tmp4_ = _data32_->source;
#line 2804 "../src/client/application/application-main-window.vala"
		_tmp5_ = conversation_list_box_get_conversation (view);
#line 2804 "../src/client/application/application-main-window.vala"
		_tmp6_ = _tmp5_;
#line 2804 "../src/client/application/application-main-window.vala"
		_tmp7_ = geary_collection_single (GEARY_APP_TYPE_CONVERSATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp6_);
#line 2804 "../src/client/application/application-main-window.vala"
		_tmp8_ = _tmp7_;
#line 2804 "../src/client/application/application-main-window.vala"
		_tmp9_ = geary_email_get_id (target);
#line 2804 "../src/client/application/application-main-window.vala"
		_tmp10_ = _tmp9_;
#line 2804 "../src/client/application/application-main-window.vala"
		_tmp11_ = geary_collection_single (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp10_);
#line 2804 "../src/client/application/application-main-window.vala"
		_tmp12_ = _tmp11_;
#line 2804 "../src/client/application/application-main-window.vala"
		application_controller_move_messages_special (_tmp3_, _tmp4_, GEARY_FOLDER_SPECIAL_USE_TRASH, _tmp8_, _tmp12_, ____lambda199__gasync_ready_callback, block32_data_ref (_data32_));
#line 2804 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp12_);
#line 2804 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp8_);
#line 17916 "application-main-window.c"
	}
#line 2801 "../src/client/application/application-main-window.vala"
	block32_data_unref (_data32_);
#line 2801 "../src/client/application/application-main-window.vala"
	_data32_ = NULL;
#line 17922 "application-main-window.c"
}

static Block33Data*
block33_data_ref (Block33Data* _data33_)
{
#line 2820 "../src/client/application/application-main-window.vala"
	g_atomic_int_inc (&_data33_->_ref_count_);
#line 2820 "../src/client/application/application-main-window.vala"
	return _data33_;
#line 17932 "application-main-window.c"
}

static void
block33_data_unref (void * _userdata_)
{
	Block33Data* _data33_;
	_data33_ = (Block33Data*) _userdata_;
#line 2820 "../src/client/application/application-main-window.vala"
	if (g_atomic_int_dec_and_test (&_data33_->_ref_count_)) {
#line 17942 "application-main-window.c"
		ApplicationMainWindow* self;
#line 2820 "../src/client/application/application-main-window.vala"
		self = _data33_->self;
#line 2820 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_data33_->source);
#line 2820 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (self);
#line 2820 "../src/client/application/application-main-window.vala"
		g_slice_free (Block33Data, _data33_);
#line 17952 "application-main-window.c"
	}
}

static void
___lambda200_ (Block33Data* _data33_,
               GObject* obj,
               GAsyncResult* res)
{
	ApplicationMainWindow* self;
	GError* _inner_error0_ = NULL;
#line 2828 "../src/client/application/application-main-window.vala"
	self = _data33_->self;
#line 2828 "../src/client/application/application-main-window.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 2828 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 17969 "application-main-window.c"
	{
		ApplicationController* _tmp0_;
#line 2830 "../src/client/application/application-main-window.vala"
		_tmp0_ = self->priv->controller;
#line 2830 "../src/client/application/application-main-window.vala"
		application_controller_delete_messages_finish (_tmp0_, res, &_inner_error0_);
#line 2830 "../src/client/application/application-main-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17978 "application-main-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GearyFolderSupportRemove* _tmp1_;
		GearyAccount* _tmp2_;
		GearyAccount* _tmp3_;
		GearyAccountInformation* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GError* _tmp6_;
#line 2829 "../src/client/application/application-main-window.vala"
		err = _inner_error0_;
#line 2829 "../src/client/application/application-main-window.vala"
		_inner_error0_ = NULL;
#line 2832 "../src/client/application/application-main-window.vala"
		_tmp1_ = _data33_->source;
#line 2832 "../src/client/application/application-main-window.vala"
		_tmp2_ = geary_folder_get_account (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEARY_TYPE_FOLDER, GearyFolder));
#line 2832 "../src/client/application/application-main-window.vala"
		_tmp3_ = _tmp2_;
#line 2832 "../src/client/application/application-main-window.vala"
		_tmp4_ = geary_account_get_information (_tmp3_);
#line 2832 "../src/client/application/application-main-window.vala"
		_tmp5_ = _tmp4_;
#line 2832 "../src/client/application/application-main-window.vala"
		_tmp6_ = err;
#line 2832 "../src/client/application/application-main-window.vala"
		application_main_window_handle_error (self, _tmp5_, _tmp6_);
#line 2829 "../src/client/application/application-main-window.vala"
		_g_error_free0 (err);
#line 18012 "application-main-window.c"
	}
	__finally0:
#line 2829 "../src/client/application/application-main-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2829 "../src/client/application/application-main-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2829 "../src/client/application/application-main-window.vala"
		g_clear_error (&_inner_error0_);
#line 2829 "../src/client/application/application-main-window.vala"
		return;
#line 18023 "application-main-window.c"
	}
}

static void
____lambda200__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 2824 "../src/client/application/application-main-window.vala"
	___lambda200_ (self, source_object, res);
#line 2824 "../src/client/application/application-main-window.vala"
	block33_data_unref (self);
#line 18036 "application-main-window.c"
}

static void
application_main_window_on_email_delete (ApplicationMainWindow* self,
                                         ConversationListBox* view,
                                         GearyEmail* target)
{
	Block33Data* _data33_;
	GearyFolder* _tmp0_;
	GearyFolderSupportRemove* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GearyFolderSupportRemove* _tmp3_;
#line 2820 "../src/client/application/application-main-window.vala"
	g_return_if_fail (APPLICATION_IS_MAIN_WINDOW (self));
#line 2820 "../src/client/application/application-main-window.vala"
	g_return_if_fail (IS_CONVERSATION_LIST_BOX (view));
#line 2820 "../src/client/application/application-main-window.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (target, GEARY_TYPE_EMAIL));
#line 2820 "../src/client/application/application-main-window.vala"
	_data33_ = g_slice_new0 (Block33Data);
#line 2820 "../src/client/application/application-main-window.vala"
	_data33_->_ref_count_ = 1;
#line 2820 "../src/client/application/application-main-window.vala"
	_data33_->self = g_object_ref (self);
#line 2821 "../src/client/application/application-main-window.vala"
	_tmp0_ = self->priv->_selected_folder;
#line 2821 "../src/client/application/application-main-window.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GEARY_FOLDER_SUPPORT_TYPE_REMOVE) ? ((GearyFolderSupportRemove*) _tmp0_) : NULL);
#line 2821 "../src/client/application/application-main-window.vala"
	_data33_->source = _tmp1_;
#line 2823 "../src/client/application/application-main-window.vala"
	_tmp3_ = _data33_->source;
#line 2823 "../src/client/application/application-main-window.vala"
	if (_tmp3_ != NULL) {
#line 2823 "../src/client/application/application-main-window.vala"
		_tmp2_ = application_main_window_prompt_delete_messages (self, 1);
#line 18073 "application-main-window.c"
	} else {
#line 2823 "../src/client/application/application-main-window.vala"
		_tmp2_ = FALSE;
#line 18077 "application-main-window.c"
	}
#line 2823 "../src/client/application/application-main-window.vala"
	if (_tmp2_) {
#line 18081 "application-main-window.c"
		ApplicationController* _tmp4_;
		GearyFolderSupportRemove* _tmp5_;
		GearyAppConversation* _tmp6_;
		GearyAppConversation* _tmp7_;
		GeeCollection* _tmp8_;
		GeeCollection* _tmp9_;
		GearyEmailIdentifier* _tmp10_;
		GearyEmailIdentifier* _tmp11_;
		GeeCollection* _tmp12_;
		GeeCollection* _tmp13_;
#line 2824 "../src/client/application/application-main-window.vala"
		_tmp4_ = self->priv->controller;
#line 2824 "../src/client/application/application-main-window.vala"
		_tmp5_ = _data33_->source;
#line 2824 "../src/client/application/application-main-window.vala"
		_tmp6_ = conversation_list_box_get_conversation (view);
#line 2824 "../src/client/application/application-main-window.vala"
		_tmp7_ = _tmp6_;
#line 2824 "../src/client/application/application-main-window.vala"
		_tmp8_ = geary_collection_single (GEARY_APP_TYPE_CONVERSATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp7_);
#line 2824 "../src/client/application/application-main-window.vala"
		_tmp9_ = _tmp8_;
#line 2824 "../src/client/application/application-main-window.vala"
		_tmp10_ = geary_email_get_id (target);
#line 2824 "../src/client/application/application-main-window.vala"
		_tmp11_ = _tmp10_;
#line 2824 "../src/client/application/application-main-window.vala"
		_tmp12_ = geary_collection_single (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp11_);
#line 2824 "../src/client/application/application-main-window.vala"
		_tmp13_ = _tmp12_;
#line 2824 "../src/client/application/application-main-window.vala"
		application_controller_delete_messages (_tmp4_, _tmp5_, _tmp9_, _tmp13_, ____lambda200__gasync_ready_callback, block33_data_ref (_data33_));
#line 2824 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp13_);
#line 2824 "../src/client/application/application-main-window.vala"
		_g_object_unref0 (_tmp9_);
#line 18118 "application-main-window.c"
	}
#line 2820 "../src/client/application/application-main-window.vala"
	block33_data_unref (_data33_);
#line 2820 "../src/client/application/application-main-window.vala"
	_data33_ = NULL;
#line 18124 "application-main-window.c"
}

static void
application_main_window_class_init (ApplicationMainWindowClass * klass,
                                    gpointer klass_data)
{
	GtkBindingSet* bindings = NULL;
	GTypeClass* _tmp0_;
	GObjectClass* _tmp1_;
	GtkBindingSet* _tmp2_;
	GtkBindingSet* _tmp3_;
	GtkBindingSet* _tmp4_;
	GtkBindingSet* _tmp5_;
	GtkBindingSet* _tmp6_;
	GtkBindingSet* _tmp7_;
	GtkBindingSet* _tmp8_;
	GtkBindingSet* _tmp9_;
	GtkBindingSet* _tmp10_;
	GtkBindingSet* _tmp11_;
	GtkBindingSet* _tmp12_;
	GtkBindingSet* _tmp13_;
	GtkBindingSet* _tmp14_;
	GtkBindingSet* _tmp15_;
	GtkBindingSet* _tmp16_;
	GtkBindingSet* _tmp17_;
	GtkBindingSet* _tmp18_;
	GtkBindingSet* _tmp19_;
	GtkBindingSet* _tmp20_;
	GtkBindingSet* _tmp21_;
	GtkBindingSet* _tmp22_;
	GtkBindingSet* _tmp23_;
	GtkBindingSet* _tmp24_;
	GtkBindingSet* _tmp25_;
	GtkBindingSet* _tmp26_;
	GtkBindingSet* _tmp27_;
	GtkBindingSet* _tmp28_;
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_parent_class = g_type_class_peek_parent (klass);
#line 10 "../src/client/application/application-main-window.vala"
	g_type_class_adjust_private_offset (klass, &ApplicationMainWindow_private_offset);
#line 10 "../src/client/application/application-main-window.vala"
	((GtkWidgetClass *) klass)->destroy = (void (*) (GtkWidget*)) application_main_window_real_destroy;
#line 10 "../src/client/application/application-main-window.vala"
	((GtkWidgetClass *) klass)->window_state_event = (gboolean (*) (GtkWidget*, GdkEventWindowState*)) application_main_window_real_window_state_event;
#line 10 "../src/client/application/application-main-window.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, GtkAllocation*)) application_main_window_real_size_allocate;
#line 10 "../src/client/application/application-main-window.vala"
	((GtkWidgetClass *) klass)->key_press_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) application_main_window_real_key_press_event;
#line 10 "../src/client/application/application-main-window.vala"
	((GtkWidgetClass *) klass)->key_release_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) application_main_window_real_key_release_event;
#line 10 "../src/client/application/application-main-window.vala"
	((ApplicationMainWindowClass *) klass)->reply_conversation_sender = application_main_window_real_reply_conversation_sender;
#line 10 "../src/client/application/application-main-window.vala"
	((ApplicationMainWindowClass *) klass)->reply_conversation_all = application_main_window_real_reply_conversation_all;
#line 10 "../src/client/application/application-main-window.vala"
	((ApplicationMainWindowClass *) klass)->forward_conversation = application_main_window_real_forward_conversation;
#line 10 "../src/client/application/application-main-window.vala"
	((ApplicationMainWindowClass *) klass)->mark_conversations_read = application_main_window_real_mark_conversations_read;
#line 10 "../src/client/application/application-main-window.vala"
	((ApplicationMainWindowClass *) klass)->mark_conversations_starred = application_main_window_real_mark_conversations_starred;
#line 10 "../src/client/application/application-main-window.vala"
	((ApplicationMainWindowClass *) klass)->show_copy_menu = application_main_window_real_show_copy_menu;
#line 10 "../src/client/application/application-main-window.vala"
	((ApplicationMainWindowClass *) klass)->show_move_menu = application_main_window_real_show_move_menu;
#line 10 "../src/client/application/application-main-window.vala"
	((ApplicationMainWindowClass *) klass)->archive_conversations = application_main_window_real_archive_conversations;
#line 10 "../src/client/application/application-main-window.vala"
	((ApplicationMainWindowClass *) klass)->junk_conversations = application_main_window_real_junk_conversations;
#line 10 "../src/client/application/application-main-window.vala"
	((ApplicationMainWindowClass *) klass)->trash_conversations = application_main_window_real_trash_conversations;
#line 10 "../src/client/application/application-main-window.vala"
	((ApplicationMainWindowClass *) klass)->delete_conversations = application_main_window_real_delete_conversations;
#line 10 "../src/client/application/application-main-window.vala"
	((ApplicationMainWindowClass *) klass)->search = application_main_window_real_search;
#line 10 "../src/client/application/application-main-window.vala"
	((ApplicationMainWindowClass *) klass)->find = application_main_window_real_find;
#line 10 "../src/client/application/application-main-window.vala"
	((ApplicationMainWindowClass *) klass)->navigate = application_main_window_real_navigate;
#line 10 "../src/client/application/application-main-window.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_application_main_window_get_property;
#line 10 "../src/client/application/application-main-window.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_application_main_window_set_property;
#line 10 "../src/client/application/application-main-window.vala"
	G_OBJECT_CLASS (klass)->finalize = application_main_window_finalize;
#line 18209 "application-main-window.c"
	/** Returns the window's associated client application instance. */
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_APPLICATION_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_APPLICATION_PROPERTY] = g_param_spec_object ("application", "application", "application", APPLICATION_TYPE_CLIENT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18213 "application-main-window.c"
	/** Currently selected account, null if none selected */
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_SELECTED_ACCOUNT_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_SELECTED_ACCOUNT_PROPERTY] = g_param_spec_object ("selected-account", "selected-account", "selected-account", GEARY_TYPE_ACCOUNT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18217 "application-main-window.c"
	/** Currently selected folder, null if none selected */
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_SELECTED_FOLDER_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_SELECTED_FOLDER_PROPERTY] = g_param_spec_object ("selected-folder", "selected-folder", "selected-folder", GEARY_TYPE_FOLDER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18221 "application-main-window.c"
	/** Conversations for the current folder, null if none selected */
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_CONVERSATIONS_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_CONVERSATIONS_PROPERTY] = g_param_spec_object ("conversations", "conversations", "conversations", GEARY_APP_TYPE_CONVERSATION_MONITOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18225 "application-main-window.c"
	/** Specifies if the conversation list is currently displayed. */
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_IS_FOLDER_LIST_SHOWN_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_IS_FOLDER_LIST_SHOWN_PROPERTY] = g_param_spec_boolean ("is-folder-list-shown", "is-folder-list-shown", "is-folder-list-shown", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18229 "application-main-window.c"
	/** Specifies if the conversation list is currently displayed. */
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_IS_CONVERSATION_LIST_SHOWN_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_IS_CONVERSATION_LIST_SHOWN_PROPERTY] = g_param_spec_boolean ("is-conversation-list-shown", "is-conversation-list-shown", "is-conversation-list-shown", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18233 "application-main-window.c"
	/** Specifies if the conversation viewer is currently displayed. */
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_IS_CONVERSATION_VIEWER_SHOWN_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_IS_CONVERSATION_VIEWER_SHOWN_PROPERTY] = g_param_spec_boolean ("is-conversation-viewer-shown", "is-conversation-viewer-shown", "is-conversation-viewer-shown", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18237 "application-main-window.c"
	/** The attachment manager for this window. */
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_ATTACHMENTS_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_ATTACHMENTS_PROPERTY] = g_param_spec_object ("attachments", "attachments", "attachments", APPLICATION_TYPE_ATTACHMENT_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18241 "application-main-window.c"
	/** Determines if conversations in the selected folder can be trashed. */
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_SELECTED_FOLDER_SUPPORTS_TRASH_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_SELECTED_FOLDER_SUPPORTS_TRASH_PROPERTY] = g_param_spec_boolean ("selected-folder-supports-trash", "selected-folder-supports-trash", "selected-folder-supports-trash", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18245 "application-main-window.c"
	/** Determines if a composer is currently open in this window. */
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_HAS_COMPOSER_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_HAS_COMPOSER_PROPERTY] = g_param_spec_boolean ("has-composer", "has-composer", "has-composer", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18249 "application-main-window.c"
	/** Specifies if the Shift key is currently being held. */
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_IS_SHIFT_DOWN_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_IS_SHIFT_DOWN_PROPERTY] = g_param_spec_boolean ("is-shift-down", "is-shift-down", "is-shift-down", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_WINDOW_WIDTH_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_WINDOW_WIDTH_PROPERTY] = g_param_spec_int ("window-width", "window-width", "window-width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_WINDOW_HEIGHT_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_WINDOW_HEIGHT_PROPERTY] = g_param_spec_int ("window-height", "window-height", "window-height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_WINDOW_MAXIMIZED_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_WINDOW_MAXIMIZED_PROPERTY] = g_param_spec_boolean ("window-maximized", "window-maximized", "window-maximized", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_FOLDER_LIST_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_FOLDER_LIST_PROPERTY] = g_param_spec_object ("folder-list", "folder-list", "folder-list", FOLDER_LIST_TYPE_TREE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_MAIN_TOOLBAR_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_MAIN_TOOLBAR_PROPERTY] = g_param_spec_object ("main-toolbar", "main-toolbar", "main-toolbar", COMPONENTS_TYPE_MAIN_TOOLBAR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_SEARCH_BAR_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_SEARCH_BAR_PROPERTY] = g_param_spec_object ("search-bar", "search-bar", "search-bar", TYPE_SEARCH_BAR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_CONVERSATION_LIST_VIEW_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_CONVERSATION_LIST_VIEW_PROPERTY] = g_param_spec_object ("conversation-list-view", "conversation-list-view", "conversation-list-view", TYPE_CONVERSATION_LIST_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_CONVERSATION_VIEWER_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_CONVERSATION_VIEWER_PROPERTY] = g_param_spec_object ("conversation-viewer", "conversation-viewer", "conversation-viewer", TYPE_CONVERSATION_VIEWER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_CONVERSATION_LIST_INFO_BARS_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_CONVERSATION_LIST_INFO_BARS_PROPERTY] = g_param_spec_object ("conversation-list-info-bars", "conversation-list-info-bars", "conversation-list-info-bars", COMPONENTS_TYPE_INFO_BAR_STACK, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 10 "../src/client/application/application-main-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_MAIN_WINDOW_STATUS_BAR_PROPERTY, application_main_window_properties[APPLICATION_MAIN_WINDOW_STATUS_BAR_PROPERTY] = g_param_spec_object ("status-bar", "status-bar", "status-bar", TYPE_STATUS_BAR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Geary/application-main-window.ui");
#line 18275 "application-main-window.c"
	/** Fired when the user requests an account status be retried. */
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_signals[APPLICATION_MAIN_WINDOW_RETRY_SERVICE_PROBLEM_SIGNAL] = g_signal_new ("retry-service-problem", APPLICATION_TYPE_MAIN_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, GEARY_CLIENT_SERVICE_TYPE_STATUS);
#line 18279 "application-main-window.c"
	/** Keybinding signal for replying to sender for the current conversation. */
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_signals[APPLICATION_MAIN_WINDOW_REPLY_CONVERSATION_SENDER_SIGNAL] = g_signal_new ("reply-conversation-sender", APPLICATION_TYPE_MAIN_WINDOW, G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION, G_STRUCT_OFFSET (ApplicationMainWindowClass, reply_conversation_sender), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 18283 "application-main-window.c"
	/** Keybinding signal for replying to all for the current conversation. */
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_signals[APPLICATION_MAIN_WINDOW_REPLY_CONVERSATION_ALL_SIGNAL] = g_signal_new ("reply-conversation-all", APPLICATION_TYPE_MAIN_WINDOW, G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION, G_STRUCT_OFFSET (ApplicationMainWindowClass, reply_conversation_all), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 18287 "application-main-window.c"
	/** Keybinding signal for forwarding the current conversation. */
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_signals[APPLICATION_MAIN_WINDOW_FORWARD_CONVERSATION_SIGNAL] = g_signal_new ("forward-conversation", APPLICATION_TYPE_MAIN_WINDOW, G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION, G_STRUCT_OFFSET (ApplicationMainWindowClass, forward_conversation), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 18291 "application-main-window.c"
	/** Keybinding signal for marking the current selection read. */
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_signals[APPLICATION_MAIN_WINDOW_MARK_CONVERSATIONS_READ_SIGNAL] = g_signal_new ("mark-conversations-read", APPLICATION_TYPE_MAIN_WINDOW, G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION, G_STRUCT_OFFSET (ApplicationMainWindowClass, mark_conversations_read), NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 18295 "application-main-window.c"
	/** Keybinding signal for marking the current selection starred. */
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_signals[APPLICATION_MAIN_WINDOW_MARK_CONVERSATIONS_STARRED_SIGNAL] = g_signal_new ("mark-conversations-starred", APPLICATION_TYPE_MAIN_WINDOW, G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION, G_STRUCT_OFFSET (ApplicationMainWindowClass, mark_conversations_starred), NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 18299 "application-main-window.c"
	/** Keybinding signal for showing the copy/label menu. */
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_signals[APPLICATION_MAIN_WINDOW_SHOW_COPY_MENU_SIGNAL] = g_signal_new ("show-copy-menu", APPLICATION_TYPE_MAIN_WINDOW, G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION, G_STRUCT_OFFSET (ApplicationMainWindowClass, show_copy_menu), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 18303 "application-main-window.c"
	/** Keybinding signal for showing the move menu. */
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_signals[APPLICATION_MAIN_WINDOW_SHOW_MOVE_MENU_SIGNAL] = g_signal_new ("show-move-menu", APPLICATION_TYPE_MAIN_WINDOW, G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION, G_STRUCT_OFFSET (ApplicationMainWindowClass, show_move_menu), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 18307 "application-main-window.c"
	/** Keybinding signal for archiving the current selection. */
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_signals[APPLICATION_MAIN_WINDOW_ARCHIVE_CONVERSATIONS_SIGNAL] = g_signal_new ("archive-conversations", APPLICATION_TYPE_MAIN_WINDOW, G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION, G_STRUCT_OFFSET (ApplicationMainWindowClass, archive_conversations), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 18311 "application-main-window.c"
	/** Keybinding signal for junking the current selection. */
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_signals[APPLICATION_MAIN_WINDOW_JUNK_CONVERSATIONS_SIGNAL] = g_signal_new ("junk-conversations", APPLICATION_TYPE_MAIN_WINDOW, G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION, G_STRUCT_OFFSET (ApplicationMainWindowClass, junk_conversations), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 18315 "application-main-window.c"
	/** Keybinding signal for trashing the current selection. */
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_signals[APPLICATION_MAIN_WINDOW_TRASH_CONVERSATIONS_SIGNAL] = g_signal_new ("trash-conversations", APPLICATION_TYPE_MAIN_WINDOW, G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION, G_STRUCT_OFFSET (ApplicationMainWindowClass, trash_conversations), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 18319 "application-main-window.c"
	/** Keybinding signal for deleting the current selection. */
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_signals[APPLICATION_MAIN_WINDOW_DELETE_CONVERSATIONS_SIGNAL] = g_signal_new ("delete-conversations", APPLICATION_TYPE_MAIN_WINDOW, G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION, G_STRUCT_OFFSET (ApplicationMainWindowClass, delete_conversations), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 18323 "application-main-window.c"
	/** Keybinding signal for activating conversation search. */
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_signals[APPLICATION_MAIN_WINDOW_SEARCH_SIGNAL] = g_signal_new ("search", APPLICATION_TYPE_MAIN_WINDOW, G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION, G_STRUCT_OFFSET (ApplicationMainWindowClass, search), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 18327 "application-main-window.c"
	/** Keybinding signal for activating in-conversation find. */
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_signals[APPLICATION_MAIN_WINDOW_FIND_SIGNAL] = g_signal_new ("find", APPLICATION_TYPE_MAIN_WINDOW, G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION, G_STRUCT_OFFSET (ApplicationMainWindowClass, find), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 18331 "application-main-window.c"
	/** Keybinding signal for shifting the keyboard focus. */
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_signals[APPLICATION_MAIN_WINDOW_NAVIGATE_SIGNAL] = g_signal_new ("navigate", APPLICATION_TYPE_MAIN_WINDOW, G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION, G_STRUCT_OFFSET (ApplicationMainWindowClass, navigate), NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, gtk_scroll_type_get_type ());
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "main_layout", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, main_layout));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "outer_leaflet", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, outer_leaflet));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "inner_leaflet", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, inner_leaflet));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "folder_box", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, folder_box));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "folder_list_scrolled", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, folder_list_scrolled));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_list_box", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, conversation_list_box));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_list_scrolled", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, conversation_list_scrolled));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_list_actions_revealer", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, conversation_list_actions_revealer));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_list_actions", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, conversation_list_actions));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_viewer_box", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, conversation_viewer_box));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_viewer_actions_revealer", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, conversation_viewer_actions_revealer));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "folder_size_group", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, folder_size_group));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "folder_separator_size_group", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, folder_separator_size_group));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversations_size_group", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, conversations_size_group));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversations_separator_size_group", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, conversations_separator_size_group));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_size_group", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, conversation_size_group));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversations_swipe_group", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, conversations_swipe_group));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_swipe_group", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, conversation_swipe_group));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "overlay", FALSE, ApplicationMainWindow_private_offset + G_STRUCT_OFFSET (ApplicationMainWindowPrivate, overlay));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_map", G_CALLBACK(_application_main_window_on_map_gtk_widget_map));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_unmap", G_CALLBACK(_application_main_window_on_unmap_gtk_widget_unmap));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_focus_event", G_CALLBACK(_application_main_window_on_focus_event_gtk_widget_focus_out_event));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_delete_event", G_CALLBACK(_application_main_window_on_delete_event_gtk_widget_delete_event));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_outer_leaflet_changed", G_CALLBACK(_application_main_window_on_outer_leaflet_changed_g_object_notify));
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_inner_leaflet_changed", G_CALLBACK(_application_main_window_on_inner_leaflet_changed_g_object_notify));
#line 86 "../src/client/application/application-main-window.vala"
	_tmp0_ = g_type_class_ref (APPLICATION_TYPE_MAIN_WINDOW);
#line 86 "../src/client/application/application-main-window.vala"
	_tmp1_ = (GObjectClass*) _tmp0_;
#line 86 "../src/client/application/application-main-window.vala"
	_tmp2_ = gtk_binding_set_by_class ((gpointer) _tmp1_);
#line 86 "../src/client/application/application-main-window.vala"
	_tmp3_ = _tmp2_;
#line 86 "../src/client/application/application-main-window.vala"
	_g_type_class_unref0 (_tmp1_);
#line 86 "../src/client/application/application-main-window.vala"
	bindings = _tmp3_;
#line 92 "../src/client/application/application-main-window.vala"
	_tmp4_ = bindings;
#line 92 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp4_, GDK_KEY_R, GDK_CONTROL_MASK, "reply-conversation-sender", (guint) 0, NULL);
#line 97 "../src/client/application/application-main-window.vala"
	_tmp5_ = bindings;
#line 97 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp5_, GDK_KEY_R, GDK_CONTROL_MASK | GDK_SHIFT_MASK, "reply-conversation-all", (guint) 0, NULL);
#line 102 "../src/client/application/application-main-window.vala"
	_tmp6_ = bindings;
#line 102 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp6_, GDK_KEY_L, GDK_CONTROL_MASK, "forward-conversation", (guint) 0, NULL);
#line 112 "../src/client/application/application-main-window.vala"
	_tmp7_ = bindings;
#line 112 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp7_, GDK_KEY_U, GDK_CONTROL_MASK, "mark-conversations-read", (guint) 1, G_TYPE_BOOLEAN, TRUE, NULL);
#line 117 "../src/client/application/application-main-window.vala"
	_tmp8_ = bindings;
#line 117 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp8_, GDK_KEY_U, GDK_CONTROL_MASK | GDK_SHIFT_MASK, "mark-conversations-read", (guint) 1, G_TYPE_BOOLEAN, FALSE, NULL);
#line 123 "../src/client/application/application-main-window.vala"
	_tmp9_ = bindings;
#line 123 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp9_, GDK_KEY_D, GDK_CONTROL_MASK, "mark-conversations-starred", (guint) 1, G_TYPE_BOOLEAN, TRUE, NULL);
#line 128 "../src/client/application/application-main-window.vala"
	_tmp10_ = bindings;
#line 128 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp10_, GDK_KEY_D, GDK_CONTROL_MASK | GDK_SHIFT_MASK, "mark-conversations-starred", (guint) 1, G_TYPE_BOOLEAN, FALSE, NULL);
#line 136 "../src/client/application/application-main-window.vala"
	_tmp11_ = bindings;
#line 136 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp11_, GDK_KEY_B, GDK_CONTROL_MASK, "show-copy-menu", (guint) 0, NULL);
#line 141 "../src/client/application/application-main-window.vala"
	_tmp12_ = bindings;
#line 141 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp12_, GDK_KEY_M, GDK_CONTROL_MASK, "show-move-menu", (guint) 0, NULL);
#line 146 "../src/client/application/application-main-window.vala"
	_tmp13_ = bindings;
#line 146 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp13_, GDK_KEY_K, GDK_CONTROL_MASK, "archive-conversations", (guint) 0, NULL);
#line 151 "../src/client/application/application-main-window.vala"
	_tmp14_ = bindings;
#line 151 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp14_, GDK_KEY_J, GDK_CONTROL_MASK, "junk-conversations", (guint) 0, NULL);
#line 157 "../src/client/application/application-main-window.vala"
	_tmp15_ = bindings;
#line 157 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp15_, GDK_KEY_BackSpace, 0, "trash-conversations", (guint) 0, NULL);
#line 162 "../src/client/application/application-main-window.vala"
	_tmp16_ = bindings;
#line 162 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp16_, GDK_KEY_Delete, 0, "trash-conversations", (guint) 0, NULL);
#line 167 "../src/client/application/application-main-window.vala"
	_tmp17_ = bindings;
#line 167 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp17_, GDK_KEY_KP_Delete, 0, "trash-conversations", (guint) 0, NULL);
#line 173 "../src/client/application/application-main-window.vala"
	_tmp18_ = bindings;
#line 173 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp18_, GDK_KEY_BackSpace, GDK_SHIFT_MASK, "delete-conversations", (guint) 0, NULL);
#line 178 "../src/client/application/application-main-window.vala"
	_tmp19_ = bindings;
#line 178 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp19_, GDK_KEY_Delete, GDK_SHIFT_MASK, "delete-conversations", (guint) 0, NULL);
#line 183 "../src/client/application/application-main-window.vala"
	_tmp20_ = bindings;
#line 183 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp20_, GDK_KEY_KP_Delete, GDK_SHIFT_MASK, "delete-conversations", (guint) 0, NULL);
#line 191 "../src/client/application/application-main-window.vala"
	_tmp21_ = bindings;
#line 191 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp21_, GDK_KEY_F, GDK_CONTROL_MASK, "find", (guint) 0, NULL);
#line 196 "../src/client/application/application-main-window.vala"
	_tmp22_ = bindings;
#line 196 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp22_, GDK_KEY_S, GDK_CONTROL_MASK, "search", (guint) 0, NULL);
#line 204 "../src/client/application/application-main-window.vala"
	_tmp23_ = bindings;
#line 204 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp23_, GDK_KEY_Left, GDK_MOD1_MASK, "navigate", (guint) 1, gtk_scroll_type_get_type (), GTK_SCROLL_PAGE_LEFT, NULL);
#line 210 "../src/client/application/application-main-window.vala"
	_tmp24_ = bindings;
#line 210 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp24_, GDK_KEY_Back, 0, "navigate", (guint) 1, gtk_scroll_type_get_type (), GTK_SCROLL_PAGE_LEFT, NULL);
#line 216 "../src/client/application/application-main-window.vala"
	_tmp25_ = bindings;
#line 216 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp25_, GDK_KEY_Right, GDK_MOD1_MASK, "navigate", (guint) 1, gtk_scroll_type_get_type (), GTK_SCROLL_PAGE_RIGHT, NULL);
#line 222 "../src/client/application/application-main-window.vala"
	_tmp26_ = bindings;
#line 222 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp26_, GDK_KEY_Forward, 0, "navigate", (guint) 1, gtk_scroll_type_get_type (), GTK_SCROLL_PAGE_RIGHT, NULL);
#line 228 "../src/client/application/application-main-window.vala"
	_tmp27_ = bindings;
#line 228 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp27_, GDK_KEY_comma, GDK_CONTROL_MASK, "navigate", (guint) 1, gtk_scroll_type_get_type (), GTK_SCROLL_STEP_UP, NULL);
#line 234 "../src/client/application/application-main-window.vala"
	_tmp28_ = bindings;
#line 234 "../src/client/application/application-main-window.vala"
	gtk_binding_entry_add_signal (_tmp28_, GDK_KEY_period, GDK_CONTROL_MASK, "navigate", (guint) 1, gtk_scroll_type_get_type (), GTK_SCROLL_STEP_DOWN, NULL);
#line 18497 "application-main-window.c"
}

static void
application_main_window_geary_base_interface_interface_init (GearyBaseInterfaceIface * iface,
                                                             gpointer iface_data)
{
#line 10 "../src/client/application/application-main-window.vala"
	application_main_window_geary_base_interface_parent_iface = g_type_interface_peek_parent (iface);
#line 18506 "application-main-window.c"
}

static void
application_main_window_instance_init (ApplicationMainWindow * self,
                                       gpointer klass)
{
	FolderListTree* _tmp0_;
	ComponentsInfoBarStack* _tmp1_;
	StatusBar* _tmp2_;
	MonitoredSpinner* _tmp3_;
	GeeHashSet* _tmp4_;
	GSimpleActionGroup* _tmp5_;
	GearyAggregateProgressMonitor* _tmp6_;
	GCancellable* _tmp7_;
	GCancellable* _tmp8_;
	ComponentsConversationActions** _tmp9_;
	FolderPopover** _tmp10_;
	ComponentsInfoBarStack* _tmp11_;
#line 10 "../src/client/application/application-main-window.vala"
	self->priv = application_main_window_get_instance_private (self);
#line 285 "../src/client/application/application-main-window.vala"
	self->priv->_selected_account = NULL;
#line 288 "../src/client/application/application-main-window.vala"
	self->priv->_selected_folder = NULL;
#line 291 "../src/client/application/application-main-window.vala"
	self->priv->_conversations = NULL;
#line 348 "../src/client/application/application-main-window.vala"
	self->priv->_is_shift_down = FALSE;
#line 356 "../src/client/application/application-main-window.vala"
	_tmp0_ = folder_list_tree_new ();
#line 356 "../src/client/application/application-main-window.vala"
	g_object_ref_sink (_tmp0_);
#line 356 "../src/client/application/application-main-window.vala"
	self->priv->_folder_list = _tmp0_;
#line 362 "../src/client/application/application-main-window.vala"
	_tmp1_ = components_info_bar_stack_new (COMPONENTS_INFO_BAR_STACK_STACK_TYPE_PRIORITY_QUEUE);
#line 362 "../src/client/application/application-main-window.vala"
	g_object_ref_sink (_tmp1_);
#line 362 "../src/client/application/application-main-window.vala"
	self->priv->_conversation_list_info_bars = _tmp1_;
#line 366 "../src/client/application/application-main-window.vala"
	_tmp2_ = status_bar_new ();
#line 366 "../src/client/application/application-main-window.vala"
	g_object_ref_sink (_tmp2_);
#line 366 "../src/client/application/application-main-window.vala"
	self->priv->_status_bar = _tmp2_;
#line 370 "../src/client/application/application-main-window.vala"
	_tmp3_ = monitored_spinner_new ();
#line 370 "../src/client/application/application-main-window.vala"
	g_object_ref_sink (_tmp3_);
#line 370 "../src/client/application/application-main-window.vala"
	self->priv->spinner = _tmp3_;
#line 372 "../src/client/application/application-main-window.vala"
	_tmp4_ = gee_hash_set_new (APPLICATION_TYPE_ACCOUNT_CONTEXT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 372 "../src/client/application/application-main-window.vala"
	self->priv->accounts = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_SET, GeeSet);
#line 374 "../src/client/application/application-main-window.vala"
	_tmp5_ = g_simple_action_group_new ();
#line 374 "../src/client/application/application-main-window.vala"
	self->priv->edit_actions = _tmp5_;
#line 378 "../src/client/application/application-main-window.vala"
	self->priv->previous_selection_was_interactive = FALSE;
#line 382 "../src/client/application/application-main-window.vala"
	self->priv->previous_non_search_folder = NULL;
#line 384 "../src/client/application/application-main-window.vala"
	_tmp6_ = geary_aggregate_progress_monitor_new ();
#line 384 "../src/client/application/application-main-window.vala"
	self->priv->progress_monitor = _tmp6_;
#line 386 "../src/client/application/application-main-window.vala"
	_tmp7_ = g_cancellable_new ();
#line 386 "../src/client/application/application-main-window.vala"
	self->priv->action_update_cancellable = _tmp7_;
#line 387 "../src/client/application/application-main-window.vala"
	_tmp8_ = g_cancellable_new ();
#line 387 "../src/client/application/application-main-window.vala"
	self->priv->folder_open = _tmp8_;
#line 390 "../src/client/application/application-main-window.vala"
	self->priv->update_ui_last = (gint64) 0;
#line 421 "../src/client/application/application-main-window.vala"
	_tmp9_ = g_new0 (ComponentsConversationActions*, 0 + 1);
#line 421 "../src/client/application/application-main-window.vala"
	self->priv->folder_conversation_actions = _tmp9_;
#line 421 "../src/client/application/application-main-window.vala"
	self->priv->folder_conversation_actions_length1 = 0;
#line 421 "../src/client/application/application-main-window.vala"
	self->priv->_folder_conversation_actions_size_ = self->priv->folder_conversation_actions_length1;
#line 422 "../src/client/application/application-main-window.vala"
	_tmp10_ = g_new0 (FolderPopover*, 0 + 1);
#line 422 "../src/client/application/application-main-window.vala"
	self->priv->folder_popovers = _tmp10_;
#line 422 "../src/client/application/application-main-window.vala"
	self->priv->folder_popovers_length1 = 0;
#line 422 "../src/client/application/application-main-window.vala"
	self->priv->_folder_popovers_size_ = self->priv->folder_popovers_length1;
#line 424 "../src/client/application/application-main-window.vala"
	_tmp11_ = components_info_bar_stack_new (COMPONENTS_INFO_BAR_STACK_STACK_TYPE_SINGLE);
#line 424 "../src/client/application/application-main-window.vala"
	g_object_ref_sink (_tmp11_);
#line 424 "../src/client/application/application-main-window.vala"
	self->priv->info_bars = _tmp11_;
#line 433 "../src/client/application/application-main-window.vala"
	self->priv->service_problem_infobar = NULL;
#line 10 "../src/client/application/application-main-window.vala"
	g_type_ensure (COMPONENTS_TYPE_CONVERSATION_ACTIONS);
#line 10 "../src/client/application/application-main-window.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 18613 "application-main-window.c"
}

static void
application_main_window_finalize (GObject * obj)
{
	ApplicationMainWindow * self;
#line 10 "../src/client/application/application-main-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, APPLICATION_TYPE_MAIN_WINDOW, ApplicationMainWindow);
#line 681 "../src/client/application/application-main-window.vala"
	geary_base_interface_base_unref (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_BASE_INTERFACE, GearyBaseInterface));
#line 285 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->_selected_account);
#line 288 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->_selected_folder);
#line 291 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->_conversations);
#line 331 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->_attachments);
#line 356 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->_folder_list);
#line 357 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->_main_toolbar);
#line 358 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->_search_bar);
#line 359 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->_conversation_list_view);
#line 360 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->_conversation_viewer);
#line 362 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->_conversation_list_info_bars);
#line 366 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->_status_bar);
#line 368 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->controller);
#line 370 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->spinner);
#line 372 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->accounts);
#line 374 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->edit_actions);
#line 382 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->previous_non_search_folder);
#line 384 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->progress_monitor);
#line 386 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->action_update_cancellable);
#line 387 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->folder_open);
#line 389 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->update_ui_timeout);
#line 421 "../src/client/application/application-main-window.vala"
	self->priv->folder_conversation_actions = (_vala_array_free (self->priv->folder_conversation_actions, self->priv->folder_conversation_actions_length1, (GDestroyNotify) g_object_unref), NULL);
#line 422 "../src/client/application/application-main-window.vala"
	self->priv->folder_popovers = (_vala_array_free (self->priv->folder_popovers, self->priv->folder_popovers_length1, (GDestroyNotify) g_object_unref), NULL);
#line 424 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->info_bars);
#line 427 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->offline_infobar);
#line 429 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->cert_problem_infobar);
#line 431 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->auth_problem_infobar);
#line 433 "../src/client/application/application-main-window.vala"
	_g_object_unref0 (self->priv->service_problem_infobar);
#line 10 "../src/client/application/application-main-window.vala"
	G_OBJECT_CLASS (application_main_window_parent_class)->finalize (obj);
#line 18680 "application-main-window.c"
}

static GType
application_main_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ApplicationMainWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) application_main_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ApplicationMainWindow), 0, (GInstanceInitFunc) application_main_window_instance_init, NULL };
	static const GInterfaceInfo geary_base_interface_info = { (GInterfaceInitFunc) application_main_window_geary_base_interface_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType application_main_window_type_id;
	application_main_window_type_id = g_type_register_static (hdy_application_window_get_type (), "ApplicationMainWindow", &g_define_type_info, 0);
	g_type_add_interface_static (application_main_window_type_id, GEARY_TYPE_BASE_INTERFACE, &geary_base_interface_info);
	ApplicationMainWindow_private_offset = g_type_add_instance_private (application_main_window_type_id, sizeof (ApplicationMainWindowPrivate));
	return application_main_window_type_id;
}

GType
application_main_window_get_type (void)
{
	static volatile gsize application_main_window_type_id__once = 0;
	if (g_once_init_enter (&application_main_window_type_id__once)) {
		GType application_main_window_type_id;
		application_main_window_type_id = application_main_window_get_type_once ();
		g_once_init_leave (&application_main_window_type_id__once, application_main_window_type_id);
	}
	return application_main_window_type_id__once;
}

static void
_vala_application_main_window_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	ApplicationMainWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APPLICATION_TYPE_MAIN_WINDOW, ApplicationMainWindow);
#line 10 "../src/client/application/application-main-window.vala"
	switch (property_id) {
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_APPLICATION_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_object (value, application_main_window_get_application (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_SELECTED_ACCOUNT_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_object (value, application_main_window_get_selected_account (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_SELECTED_FOLDER_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_object (value, application_main_window_get_selected_folder (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_CONVERSATIONS_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_object (value, application_main_window_get_conversations (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_IS_FOLDER_LIST_SHOWN_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_boolean (value, application_main_window_get_is_folder_list_shown (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_IS_CONVERSATION_LIST_SHOWN_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_boolean (value, application_main_window_get_is_conversation_list_shown (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_IS_CONVERSATION_VIEWER_SHOWN_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_boolean (value, application_main_window_get_is_conversation_viewer_shown (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_ATTACHMENTS_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_object (value, application_main_window_get_attachments (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_SELECTED_FOLDER_SUPPORTS_TRASH_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_boolean (value, application_main_window_get_selected_folder_supports_trash (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_HAS_COMPOSER_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_boolean (value, application_main_window_get_has_composer (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_IS_SHIFT_DOWN_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_boolean (value, application_main_window_get_is_shift_down (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_WINDOW_WIDTH_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_int (value, application_main_window_get_window_width (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_WINDOW_HEIGHT_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_int (value, application_main_window_get_window_height (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_WINDOW_MAXIMIZED_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_boolean (value, application_main_window_get_window_maximized (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_FOLDER_LIST_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_object (value, application_main_window_get_folder_list (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_MAIN_TOOLBAR_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_object (value, application_main_window_get_main_toolbar (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_SEARCH_BAR_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_object (value, application_main_window_get_search_bar (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_CONVERSATION_LIST_VIEW_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_object (value, application_main_window_get_conversation_list_view (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_CONVERSATION_VIEWER_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_object (value, application_main_window_get_conversation_viewer (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_CONVERSATION_LIST_INFO_BARS_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_object (value, application_main_window_get_conversation_list_info_bars (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_STATUS_BAR_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		g_value_set_object (value, application_main_window_get_status_bar (self));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 18843 "application-main-window.c"
		default:
#line 10 "../src/client/application/application-main-window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 18849 "application-main-window.c"
	}
}

static void
_vala_application_main_window_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	ApplicationMainWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APPLICATION_TYPE_MAIN_WINDOW, ApplicationMainWindow);
#line 10 "../src/client/application/application-main-window.vala"
	switch (property_id) {
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_APPLICATION_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		application_main_window_set_application (self, g_value_get_object (value));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_SELECTED_ACCOUNT_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		application_main_window_set_selected_account (self, g_value_get_object (value));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_SELECTED_FOLDER_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		application_main_window_set_selected_folder (self, g_value_get_object (value));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_CONVERSATIONS_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		application_main_window_set_conversations (self, g_value_get_object (value));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_ATTACHMENTS_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		application_main_window_set_attachments (self, g_value_get_object (value));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_IS_SHIFT_DOWN_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		application_main_window_set_is_shift_down (self, g_value_get_boolean (value));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_WINDOW_WIDTH_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		application_main_window_set_window_width (self, g_value_get_int (value));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_WINDOW_HEIGHT_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		application_main_window_set_window_height (self, g_value_get_int (value));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_WINDOW_MAXIMIZED_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		application_main_window_set_window_maximized (self, g_value_get_boolean (value));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_FOLDER_LIST_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		application_main_window_set_folder_list (self, g_value_get_object (value));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_MAIN_TOOLBAR_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		application_main_window_set_main_toolbar (self, g_value_get_object (value));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_SEARCH_BAR_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		application_main_window_set_search_bar (self, g_value_get_object (value));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_CONVERSATION_LIST_VIEW_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		application_main_window_set_conversation_list_view (self, g_value_get_object (value));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_CONVERSATION_VIEWER_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		application_main_window_set_conversation_viewer (self, g_value_get_object (value));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_CONVERSATION_LIST_INFO_BARS_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		application_main_window_set_conversation_list_info_bars (self, g_value_get_object (value));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 10 "../src/client/application/application-main-window.vala"
		case APPLICATION_MAIN_WINDOW_STATUS_BAR_PROPERTY:
#line 10 "../src/client/application/application-main-window.vala"
		application_main_window_set_status_bar (self, g_value_get_object (value));
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 18959 "application-main-window.c"
		default:
#line 10 "../src/client/application/application-main-window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../src/client/application/application-main-window.vala"
		break;
#line 18965 "application-main-window.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

